import java.io.IOException;  
import javax.servlet.ServletException;  
import javax.servlet.http.HttpServlet;  
import javax.servlet.*;  
import javax.servlet.http.HttpServletRequest;  
import javax.servlet.http.HttpServletResponse;  
import java.io.FileNotFoundException;  
import java.io.*;  


public class DownloadServlet extends HttpServlet {  

	private String CONET_STORAGE_PATH;

	public void init( )
	{
		CONET_STORAGE_PATH = System.getProperty("java.io.tmpdir") + "/CONET/Storage/";
		new File(CONET_STORAGE_PATH).mkdirs(); 
	}

	/** 
	 * The doGet method of the servlet. <br> 
	 * 
	 * This method is called when a form has its tag value method equals to get. 
	 *  
	 * @param request the request send by the client to the server 
	 * @param response the response send by the server to the client 
	 * @throws ServletException if an error occurred 
	 * @throws IOException if an error occurred 
	 */  
	public void doGet(HttpServletRequest request, HttpServletResponse response)  
	throws ServletException, IOException, FileNotFoundException  {  

		String nid = request.getParameter("NID");
		String fileName = nid2FileName(nid);
		response.setContentType("application/octect-stream");  

		// A File object to represent the filename
		File f = new File(CONET_STORAGE_PATH + fileName);


		// Make sure the file or directory exists and isn't write protected
		if (!f.exists()) {
			response.sendError(HttpServletResponse.SC_NOT_FOUND);
			return;
		}

		InputStream is = new FileInputStream (f);  

		int read =0;  
		byte[] bytes = new byte[1024];  
		OutputStream os = response.getOutputStream();  
		while((read = is.read(bytes)) != -1)  
		{  
			os.write(bytes, 0, read);  
		}  
		os.flush();  
		os.close(); 
		
		is.close();
	}

	public String nid2FileName (String nid) {
		String fileName = new String();
		String principal = new String();
		String label = new String();
		if( nid.lastIndexOf('/') >= 0 ){
			principal=nid.substring(0,nid.indexOf('/')); 
			label=nid.substring(nid.indexOf('/'));
			label=label.replace( '/', '#' );
		}else{
			principal=nid; 
			label="";
		}
		fileName = principal+label;
		return fileName;
	} 
}