package eu.convergence.comid.dummy.client;

import org.apache.axiom.om.OMElement;
import org.apache.axis2.AxisFault;
import org.apache.axis2.Constants;
import org.apache.axis2.addressing.EndpointReference;
import org.apache.axis2.client.Options;
import org.apache.axis2.client.ServiceClient;

public class Client {
	private ServiceClient serviceClient;
	private OMElement request;
	
	public Client(String serviceLocation) {
		init(serviceLocation);
	}
	
	public Client(String serviceLocation, OMElement request) {
		this.request = request;
		init(serviceLocation);
	}
	
	private void init(String serviceLocation) {
		Options options = new Options();
		options.setTo(new EndpointReference(serviceLocation));
		options.setTransportInProtocol(Constants.TRANSPORT_HTTP);
		options.setProperty(Constants.Configuration.ENABLE_REST, Constants.VALUE_TRUE);
		
		try {
			serviceClient = new ServiceClient();
//			serviceClient.engageModule(Constants.MODULE_ADDRESSING);
			serviceClient.setOptions(options);			
		} catch (AxisFault e) {
			e.printStackTrace();
		}
	}
	
	public OMElement doRequest() {
		OMElement response = null;
		try {
			response = serviceClient.sendReceive(request);
		} catch (AxisFault e) {
			e.printStackTrace();
		}
		
		return response;
	}
	
	public OMElement getRequest() {
		return request;
	}

	public void setRequest(OMElement request) {
		this.request = request;
	}	
}