package eu.convergence.middleware.http;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.StringReader;
import java.net.MalformedURLException;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.List;

import org.apache.axiom.om.OMElement;
import org.apache.axiom.om.OMXMLBuilderFactory;
import org.apache.axiom.om.OMXMLParserWrapper;

import eu.convergence.comid.dummy.client.Client;

public class HttpProxy implements Runnable {
	private int port;
	private Thread thread;

	private HttpProxy(int port) {
		this.port = port;
	}
	
	private byte[] sendReceive(java.lang.String request) {
        URL url = null;
        List<Byte> buffer = new ArrayList<Byte>();
               
        try {
            url = new URL(request);
        } catch (MalformedURLException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
       
        try {
            URLConnection connection = url.openConnection();
            InputStream in = connection.getInputStream();
            int c;
            while ((c = in.read()) != -1)
            {
                buffer.add(new Byte((byte) c));
            }
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
       
        int bufferSize = buffer.size();
        byte[] buf = new byte[bufferSize];
       
        for (int i = 0; i < bufferSize; i ++)
        {
            buf[i] = buffer.get(i).byteValue();
        }
       
        return buf;
    }

	private void serveFromProxy(OutputStream out, String url) {
/*		try {
			CommunicationWrapperStub commWrapper = new CommunicationWrapperStub();
			byte[] buf = commWrapper.sendReceive(url);
			out.write(buf);
		} catch (AxisFault e) {
			e.printStackTrace();
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}*/
		
		try {
			byte[] buf = sendReceive(url);
			String headers = "HTTP/1.1 200 OK\n"
				+ "Server: Apache-Coyote/1.1\n"
				+ "Content-Type: application/xhtml+xml;charset=UTF-8\n"
				+ "Content-Length: " + buf.length + "\n"
				+ "Date: " + new java.util.Date() + "\n";
			
			byte[] headersBytes = headers.getBytes();
			int responseLength = buf.length + headersBytes.length;
			byte[] fullResponse = new byte[responseLength];
			int i;
			for (i = 0; i < responseLength; i ++)
			{
				if (i < headersBytes.length)
				{
					fullResponse[i] = headersBytes[i];
				}
				else
				{
					fullResponse[i] = buf[i - headersBytes.length];
				}
			}			
			
			String readableResponse = new String(fullResponse);
			
			out.write(fullResponse);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private String parseRequest(InputStream in) {
		int bufSize = 10240;
		StringBuffer req = new StringBuffer(2048);
		byte buf[] = new byte[bufSize];
		int c;

		try {
			c = in.read(buf);
		}
		catch (IOException e) {
			e.printStackTrace();
			c = -1;
		}
		for (int j = 0; j < c; j ++) {
			req.append((char) buf[j]);
    	}
		return req.toString();
	}
	
	private void handlePost(String request, OutputStream out) {

		int startIndex = request.indexOf("\n\r\n");
		
		String requestParams1 = request.substring(startIndex);
		
		String xmlHead = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
		
		int reqBodyIndex = requestParams1.indexOf(xmlHead);
		
		String requestParams = requestParams1.substring(reqBodyIndex+xmlHead.length());
		
		OMXMLParserWrapper wrapper = OMXMLBuilderFactory.createOMBuilder(new StringReader(requestParams));
		OMElement omElement = wrapper.getDocumentElement();
		
		Client client = new Client("http://localhost:9090/axis2/services/DummyConvergenceUserService/service", omElement);
		OMElement responseElement = client.doRequest();
		
		try {
			out.write(responseElement.toString().getBytes());
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
//		ProcessExecutor processExecutor = new ProcessExecutor();
//		System.out.println("OK with workflow");
		
	}

	private void handleRequest(Socket socket) {
		try {
			InputStream in = socket.getInputStream();
			OutputStream out = socket.getOutputStream();
			String request = parseRequest(in);
			

			int index1 = request.indexOf(' ');
			String method = request.substring(0, index1);
			if (method.equalsIgnoreCase("POST"))
			{
				handlePost(request, out);
			}
			int index2 = request.indexOf(' ', index1 + 1);
			String url = request.substring(index1 + 1, index2);
			serveFromProxy(out, url);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void run() {
		try {
			ServerSocket serverSocket = new ServerSocket(port);
			while (true) {
				Socket socket = serverSocket.accept();
				handleRequest(socket);
				socket.close();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public synchronized void start() {
		if (thread == null) {
			thread = new Thread(this);
			thread.start();
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		HttpProxy proxy = new HttpProxy(65000);
		proxy.start();
		try {
			Thread.currentThread().join();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}

}
