package eu.convergence.example.service;

import java.util.Collection;
import java.util.Iterator;

import org.apache.axiom.om.OMAbstractFactory;
import org.apache.axiom.om.OMElement;
import org.apache.axiom.om.OMFactory;
import org.apache.axiom.om.OMText;
import org.drools.runtime.process.ProcessInstance;

import eu.convergence.example.workflow.ProcessExecutor;

public class DummyUserConvergenceService implements ConvergenceService {

	public OMElement service(OMElement request) {
		try
		{
			ProcessExecutor processExecutor = new ProcessExecutor();
			Collection<ProcessInstance> processInstances = processExecutor.startMyASProcess();
			Iterator<ProcessInstance> iterator = processInstances.iterator();
			
			while (iterator.hasNext())
			{
				ProcessInstance instance = iterator.next();
				if (instance.getProcessId().equals("eu.convergence.comid.orchestrator.dummy.main"))
				{
					instance.signalEvent("UserDetailsRequest", request);
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		OMFactory factory = OMAbstractFactory.getOMFactory();
		OMElement responseElement = factory.createOMElement("Response", null);
		OMText displayStringText = factory.createOMText("SUCCESS");
		responseElement.addChild(displayStringText);
		
		return responseElement;
	}

}
