package eu.convergence.example.workflow;

import java.io.File;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.drools.KnowledgeBase;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.definition.KnowledgePackage;
import org.drools.io.ResourceFactory;
import org.drools.logger.KnowledgeRuntimeLogger;
import org.drools.logger.KnowledgeRuntimeLoggerFactory;
import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.process.ProcessInstance;

/**
 * This is a sample file to launch a process.
 */
public class ProcessExecutor {

	public Collection<ProcessInstance> startMyASProcess() {
		Collection<ProcessInstance> instances = null;
		try {
			// load up the knowledge base
			KnowledgeBase kbase = readKnowledgeBase();
			StatefulKnowledgeSession ksession = kbase.newStatefulKnowledgeSession();
			KnowledgeRuntimeLogger logger = KnowledgeRuntimeLoggerFactory.newFileLogger(ksession, "test");
			// Process Variables
			Map<String, Object> params = new HashMap<String, Object>();
			params.put("user", new eu.convergence.example.my_user.Usertype());
			params.put("userDetails", null);
			params.put("userDataDetails", new eu.convergence.example.my_user.Userdatatype());
			params.put("userPrivilegesDetails", new eu.convergence.example.my_user.Userprivilegestype());
			
			File f = new File("my_log_file.txt");
			params.put("logFile", f);
			
			// start a new process instance
			ksession.startProcess("eu.convergence.comid.orchestrator.dummy.main", params);
			instances = ksession.getProcessInstances();
			
			logger.close();
			
		} catch (Exception t) {
			t.printStackTrace();
		}
		
		return instances ;
	}

	private static KnowledgeBase readKnowledgeBase() throws Exception {
		KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();
		kbuilder.add(ResourceFactory.newClassPathResource("main_workflow.bpmn"), ResourceType.BPMN2);
		kbuilder.add(ResourceFactory.newClassPathResource("userdata_process.bpmn"), ResourceType.BPMN2);
//		kbuilder.add(ResourceFactory.newClassPathResource("orchestration.bpmn"), ResourceType.BPMN2);
		Collection<KnowledgePackage> knowledgePackages = kbuilder.getKnowledgePackages();
		Iterator<KnowledgePackage> iterator = knowledgePackages.iterator();
		while (iterator.hasNext())
		{
			KnowledgePackage knowledgePackage = iterator.next();
			System.out.println("Have process: " + knowledgePackage.getName() + ": " + knowledgePackage.toString());
		}
		return kbuilder.newKnowledgeBase();
	}
	
}