package eu.convergence.middleware.apps.CoNetHandler;

import eu.convergence.middleware.core.ConvergenceEngineName;
import eu.convergence.middleware.engine.ConetTe.ConetTE;
import eu.convergence.middleware.engine.ConetTe.exception.ConetIOException;
import eu.convergence.middleware.engine.ConetTe.services.NID;
import org.iso.mpeg.mxm.core.MXM;
import org.iso.mpeg.mxm.core.MXMException;

import java.io.File;

/**
 * Created by IntelliJ IDEA.
 * User: aca
 * Date: 7/29/11
 * Time: 2:44 PM
 */
public class CoNetRevoker
{
    public static void main(String args[])
    {
    	String reg = "urn:convergence:registry:photo";
    	if (args.length > 0)
    	{
    		reg = args[0];
    	}
//      ConetTE conetTE = new eu.convergence.middleware.conetTe.ConetTE();
		ConetTE conetTE = null;

		//this complicated approach is needed in order to create a conetTE
		//in a static context
		File f = new File(new CoNetRevoker().getClass().getClassLoader().getResource("MXMConfiguration.xml").getFile());
		try {
			MXM mxm = MXM.getInstance(f);
			mxm.listEnginesAndProperties();
			conetTE = (ConetTE) mxm.getDefaultEngine(ConvergenceEngineName.ConetTE.toString());
		} catch (MXMException e1) {
			e1.printStackTrace();
		}

        if (conetTE!=null) {
        	int code = 0;
        code = conetTE.revoke(new NID(reg), 0);
        System.out.println(code);
        	try {
        		code = conetTE.get(new NID(reg), "conet.xml");
        		
        	} catch (ConetIOException e) {
        		e.printStackTrace();
        	}
        	
//        code = conetTE.storeAndAdvertise(new NID(args[0]), 0, "/home/aca/temp/conet.xml");
        	System.out.println(code);
        }
    }
}
