package eu.convergence.middleware.apps.CoNetHandler;

import eu.convergence.middleware.conetTe.ConetTE;
import eu.convergence.middleware.core.ConvergenceEngineName;
import eu.convergence.middleware.engine.ConetTe.services.LID;
import eu.convergence.middleware.engine.ConetTe.services.NID;
import eu.convergence.middleware.engine.ConetTe.services.SAPListener;

import java.io.File;

import org.iso.mpeg.mxm.core.MXM;
import org.iso.mpeg.mxm.core.configuration.MXMConfigurationException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineNotFoundException;

/**
 * Created by IntelliJ IDEA.
 * User: aca
 * Date: 8/24/11
 * Time: 6:30 PM
 */
public class CoNetSenderReceiver implements SAPListener
{
	private ConetTE baseConetEngine;
//    private ConetTE advertiser;
//    private ConetTE sender;

    private String SAPName = "urn.convergence.overlay.sap/peer1";

    public CoNetSenderReceiver () throws MXMConfigurationException, MXMEngineException 
    {
        // initialize the receiver (daemon)
        String advertiserCfgFileName = "/home/aca/Documents/Projects/EU/CONVERGENCE/dev/updated_code/convergence/cfg/advertiser-sip.cfg";
        int procConfPathIndex = advertiserCfgFileName.lastIndexOf(File.separator);
        String procConfPath = advertiserCfgFileName.substring(0, procConfPathIndex);
        String procConfFile = advertiserCfgFileName.substring(procConfPathIndex + 1);

		File f = new File(getClass().getClassLoader().getResource("MXMConfiguration.xml").getFile());
		MXM mxm = MXM.getInstance(f);
		mxm.listEnginesAndProperties();

		baseConetEngine = (ConetTE) mxm.getDefaultEngine(ConvergenceEngineName.ConetTE.toString());

//        advertiser = baseConetEngine.getConetTE(procConfPath, procConfFile);
//        advertiser.advertiseSap(new NID(SAPName), this, ConetTE.NAMED_DATA_AS_STRING);

		baseConetEngine = baseConetEngine.getConetTE(procConfPath, procConfFile);
		baseConetEngine.advertiseSap(new NID(SAPName), this, ConetTE.NAMED_DATA_AS_STRING);

    
    }

    public void sendMessage(String message)
    {
    	
    	//SS why do you need a different configuration for the "sender"
    	
//        String senderCfgFileName = "/home/aca/Documents/Projects/EU/CONVERGENCE/dev/updated_code/convergence/cfg/sender-sip.cfg";
//        int procConfPathIndex = senderCfgFileName.lastIndexOf(File.separator);
//        String procConfPath = senderCfgFileName.substring(0, procConfPathIndex);
//        String procConfFile = senderCfgFileName.substring(procConfPathIndex + 1);

//        sender = baseConetEngine.getConetTE(procConfPath, procConfFile);
//        sender.sendToName(new NID(SAPName), message);
        baseConetEngine.sendToName(new NID(SAPName), message);
        
    }

    @Override
    public void indication(LID lid, byte[] unNamedData)
    {
        System.out.println("CoNet Receiver: " + new String(unNamedData));
    }

    @Override
    public void indication(LID lid, String unNamedDataAsString)
    {
        System.out.println("CoNet Receiver: " + unNamedDataAsString);
    }

    public static void main(String args[]) throws MXMEngineException
    {
        CoNetSenderReceiver coNetSenderReceiver;
		try {
			coNetSenderReceiver = new CoNetSenderReceiver();
	        try {
	            Thread.sleep(4000);
	        } catch (InterruptedException e) {
	            e.printStackTrace();
	        }
	        coNetSenderReceiver.sendMessage("Hello from CoNetSenderReceiver!!!");
		} catch (MXMConfigurationException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (MXMEngineNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }

}
