package eu.convergence.middleware.apps.OverlayHandler;

import eu.convergence.middleware.apps.Matcher.MatchingSubAndPubVDI;
import eu.convergence.middleware.engine.overlayTE.exceptions.OverlayEngineException;
import eu.convergence.middleware.orchestratorTE.build.OverlayEngineOrchestrator;
import eu.convergence.middleware.orchestratorTE.schedule.TimerOrchestrator;

import java.io.IOException;
import java.io.InputStream;
import java.net.Socket;
import java.util.Date;

/**
 * Created by IntelliJ IDEA.
 * User: aca
 * Date: 7/28/11
 * Time: 2:48 PM
 */
public class DaemonMessageHandler implements Runnable
{
    private Socket socket;
    private TimerOrchestrator gossipTimer;
    private TimerOrchestrator registryTimer;

    public DaemonMessageHandler(Socket socket, TimerOrchestrator gossipTimer, TimerOrchestrator registryTimer)
    {
        this.socket = socket;
        this.gossipTimer = gossipTimer;
        this.registryTimer = registryTimer;
    }

    public void run()
    {
        InputStream in = null;
        try {
            in = socket.getInputStream();
            byte[] buf = new byte[128];
            in.read(buf);
            String readMsg = new String(buf);

            System.out.println("1. Received message: " + readMsg);

            if (readMsg.contains("DAEMON_STOP"))
            {
                gossipTimer.cancel();
                registryTimer.cancel();
            }
            else if (readMsg.contains("CREATE_PUB_VDI"))
            {
                System.out.println("Captured the CREATE_PUB_VDI message");
                MatchingSubAndPubVDI matchingSubAndPubVDI = new MatchingSubAndPubVDI("PUB");
//                DIDL didl = matchingSubAndPubVDI.getGeneratedDI();
//                OverlayEngineOrchestrator overlayEngineOrchestrator = ConvergenceOrchestratorTE.dealWithOverlayEngine();
//                System.out.println("Passing control to orchestrator...");
//                overlayEngineOrchestrator.handlePublicationVDI(didl, new Date(), "fractal1");
            }
            else if (readMsg.contains("CREATE_SUB_VDI"))
            {
                MatchingSubAndPubVDI matchingSubAndPubVDI = new MatchingSubAndPubVDI("SUB");
//                DIDL didl = matchingSubAndPubVDI.getGeneratedDI();
//                OverlayEngineOrchestrator overlayEngineOrchestrator = ConvergenceOrchestratorTE.dealWithOverlayEngine();
//                overlayEngineOrchestrator.handleSubscriptionVDI(didl, new Date(), "fractal1");
            }
        } catch (IOException e) {
            e.printStackTrace();
//        } catch (OverlayEngineException e) {
//            e.printStackTrace();
        } finally {
            try {
                socket.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

}
}
