/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the Chillout Project (http://chillout.dmpf.org)
 *
 * The Initial Developer of the Original Code is CEDEO.net
 * Portions created by the Initial Developer are Copyright (C) 2006-2008
 * All Rights Reserved.
 *
 * The Initial Developer: Filippo Chiariglione 
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */

package eu.convergence.middleware.core;

/**
 * This enumeration lists the names of all possible MXMEngines so 
 * any entity can unambiguously determine the name of an MXMEngine.
 * 
 * @author Filippo Chiariglione - <filippo@cedeo.net>
 *
 */
public enum ConvergenceEngineName {
	OverlayTE,
	MatchTE,
	CDSTE,
	ConetTE,
	ConvergenceMetadataTE,
	CreateContentPE,
	RevokePE,
	MpqfTE;

	public String value() {
		return name();
	}

	public static ConvergenceEngineName fromValue(String v) {
		return valueOf(v);
	}

}
