/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * This software is developed within the CONERGENCE fp7 EU project
 * www.ict-convergence.eu
 * 
 * This software extends the MPEG Multimedia Extensible Middleware (MXM) Project 
 *
 * The initial developer of the MXM Project is CEDEO.net
 * The developer of this extension is the CONVERGENCE Consortium
 * Copyright (C) 2010-2011
 * All Rights Reserved.
 *
 * ***** END LICENSE BLOCK ***** */
package eu.convergence.middleware.engine.metadataTE.technologyhandler;

/**
 * @author Giuseppe Tropea
 *
 */
public enum MetadataKinds 
{
	CONVERGENCE ("urn:conv:metadata:schema:2011"),
	MPEG7 ("urn:mpeg:mpeg7:schema:2004"),
	RDF ("http://www.w3.org/1999/02/22-rdf-syntax-ns#");
	
	private final String uri;
	
	private MetadataKinds(String uri) {
		this.uri = uri;
	}
	
	public String getUri() {
		return uri;
	}
}
