package eu.convergence.middleware.engine.overlayTE;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMObject;
import eu.convergence.middleware.engine.overlayTE.exceptions.OverlayEngineException;

import java.util.List;

public interface MessageKeeper 
{
	public MXMEngineResponse bufferMessage(MXMObject overlayPropagationMessage) throws OverlayEngineException;
	
	public List<MXMObject> getBufferedPublicationMessages() throws OverlayEngineException;
	
	public List<MXMObject> getBufferedReadyPublicationMessages() throws OverlayEngineException;

    public void removeReadyPublicationMessages() throws OverlayEngineException;
	
	public List<MXMObject> getBufferedSubscriptionMessages() throws OverlayEngineException;
	
	public List<MXMObject> getBufferedReadySubscriptionMessages() throws OverlayEngineException;

    public void removeReadySubscriptionMessages() throws OverlayEngineException;
    
    public List<MXMObject> getBufferedRevocationMessages() throws OverlayEngineException;
	
	public List<MXMObject> getBufferedReadyRevocationMessages() throws OverlayEngineException;

    public void removeReadyRevocationMessages() throws OverlayEngineException;
	
	public List<MXMObject> getBufferedRegistrationMessages() throws OverlayEngineException;

    public void removeReadyRegistrationMessages() throws OverlayEngineException;
	
	public List<MXMObject> getBufferedReadyRegistrationMessages() throws OverlayEngineException;
	
	public MXMEngineResponse unBufferMessage(MXMObject overlayPropagationMessage, String id) throws OverlayEngineException;
}
