package eu.convergence.middleware.engine.overlayTE;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMObject;
import eu.convergence.middleware.engine.overlayTE.exceptions.OverlayEngineException;

import java.io.File;
import java.io.InputStream;
import java.util.Date;
import java.util.List;

public interface RegistryParser
{
	
	public MXMEngineResponse parseFractalRegistry(File f) throws OverlayEngineException;
	
	public MXMEngineResponse parseFractalRegistry(InputStream in) throws OverlayEngineException;
	
//	public MXMEngineResponse parseFractalRegistry(String location) throws OverlayEngineException;
	
//	public MXMEngineResponse parseFractalRegistry(MXMObject ob) throws OverlayEngineException;
	
//	public MXMEngineResponse parseFractalRegistry(Document doc) throws OverlayEngineException;
	
	public List<String> getOverlayServiceEndpoints();
	
	public String getPeerOverlayServiceEndpoint(String peerId);
	
	public MXMEngineResponse insertPeerToRegistry(String peerId, String overlayServiceEndpoint, Date leaveDate) throws OverlayEngineException;
	
	public MXMEngineResponse removePeerFromRegistry(String peerId, String overlayServiceEndpoint) throws OverlayEngineException;
	
	public MXMEngineResponse storeRegistry();
	
	public MXMObject getRegistry();
}
