package eu.convergence.middleware.event;

import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.event.management.MXMEvent;

/**
 * <p/>
 * User: <a href="mailto:bogdan.ardeleanu@uti.ro"> Bogdan Ardeleanu</a>
 * Date: 8/29/11
 * Time: 6:17 PM
 * <p/>
 * UTI Systems, TIC
 */
public class ERArrivalEvent extends MXMEvent {
    private final String publicationVdiId;
    private final String subscriptionVdiId;

    private final String erId;
    private final String errId;

    private final MXMObject er;

    /**
     * Constructs a prototypical Event.
     *
     * @param errId
     * @param source            The object on which the Event initially occurred.
     * @param er                The wrapper for the Event Report object.
     * @param publicationVdiId  The Publication VDI identifier.
     * @param subscriptionVdiId The subscription VDI identifier.
     * @param erId              The Event Report identifier
     * @throws IllegalArgumentException if source is null.
     */
    public ERArrivalEvent(MXMObject er, String publicationVdiId, String subscriptionVdiId, String erId, String errId, Object source) {
        super(source);
        this.er = er;

        this.publicationVdiId = publicationVdiId;
        this.subscriptionVdiId = subscriptionVdiId;

        this.erId = erId;
        this.errId = errId;
    }

    public String getPublicationVdiId() {
        return publicationVdiId;
    }

    public String getErId() {
        return erId;
    }

    public MXMObject getEr() {
        return er;
    }

    public String getSubscriptionVdiId() {
        return subscriptionVdiId;
    }

    public String getErrId() {
        return errId;
    }
}
