package eu.convergence.middleware.event;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;

import org.iso.mpeg.mxm.core.event.management.MXMEvent;

/**
 * @author Salvatore Signorello
 *
 */

public class MatchingPublicationReceivedEvent extends MXMEvent {
	private LinkedHashMap<String, String> resourceUrlAndMimeT;
	private String resource_url;
	private ArrayList<String> annotations;
	private String RVDI_id;
	private String SVDI_id;
	private String mime_type;
	
	public MatchingPublicationReceivedEvent(Object source, LinkedHashMap<String, String> resources, ArrayList<String> annotations, String rid, String sid) {
		super(source);
		this.resourceUrlAndMimeT = resources;
		if (resources != null)
		{
			this.resource_url = (String) resources.keySet().iterator().next();
			this.mime_type = resources.get(resource_url);
		}		
		this.annotations = annotations;
		this.RVDI_id = rid;
		this.SVDI_id = sid;
	}

	/**
	 * @return the full list of resource_url and mime type pairs
	 */
	public HashMap<String, String> getResource_url_and_mimeT() {
		return resourceUrlAndMimeT;
	}
	
	/**
	 * @param resource_url the resource_url to set
	 */
	public String getResource_url() {
		return resource_url;
	}

	/**
	 * @param resource_url the resource_url to set
	 */
	public void setResource_url(String resource_url) {
		this.resource_url = resource_url;
	}

	/**
	 * @return the annotations
	 */
	public ArrayList<String> getAnnotations() {
		return annotations;
	}

	/**
	 * @param annotations the annotations to set
	 */
	public void setAnnotations(ArrayList<String> annotations) {
		this.annotations = annotations;
	}

	/**
	 * @return the sVDI_id
	 */
	public String getSVDI_id() {
		return SVDI_id;
	}

	/**
	 * @param sVDI_id the sVDI_id to set
	 */
	public void setSVDI_id(String sVDI_id) {
		SVDI_id = sVDI_id;
	}

	/**
	 * @return the pVDI_id
	 */
	public String getRVDI_id() {
		return RVDI_id;
	}

	/**
	 * @param pVDI_id the pVDI_id to set
	 */
	public void setRVDI_id(String rVDI_id) {
		RVDI_id = rVDI_id;
	}

	/**
	 * @return the mime_type of the specified resource
	 */
	public String getMime_type(String res_url) {
		return resourceUrlAndMimeT.get(res_url);
	}

	/**
	 * @param res_url the key for identifying the resource to modify
	 * @param mime_type the mime_type to set for the resource
	 */
	public void setMime_type(String res_url, String mime_type) {
		resourceUrlAndMimeT.put(res_url, mime_type);
	}
	
	/**
	 * @return the mime_type of the first resource
	 */
	public String getMime_type() {
		return mime_type;
	}
	
	/**
	 * @param mime_type the mime_type of the first resource
	 */
	public void setMime_type(String mime_type) {
		this.mime_type = mime_type;
	}
}
