package eu.convergence.middleware.util;

import java.util.HashMap;
import java.util.Map;

import com.sun.xml.bind.marshaller.NamespacePrefixMapper;


public class ConvSchemaNamespacePrefixMapperImpl extends NamespacePrefixMapper{
	private Map<String, String> prefixs = new HashMap<String, String>();

	private static ConvSchemaNamespacePrefixMapperImpl snpm = null;
	
	public static ConvSchemaNamespacePrefixMapperImpl getInstance(){
		if(snpm == null)
			snpm = new ConvSchemaNamespacePrefixMapperImpl();
		return snpm; 
	}
	
	private ConvSchemaNamespacePrefixMapperImpl(){
		setDefaultUri();
	}
	
	private void setDefaultUri(){
		
		prefixs.put("urn:conv:relation:schema:2011", "cvr");
		prefixs.put("urn:conv:metadata:schema:2011", "conv");
		
		prefixs.put("http://www.w3.org/2001/XMLSchema-instance", "xsi");
		prefixs.put("urn:mpeg:mpeg21:2007:01-BBL-NS", "bbl");
		prefixs.put("urn:mpeg:mpeg21:2003:01-DIA-NS", "dia");
		prefixs.put("urn:mpeg:mpegm:2011:12-DIDL-NS", "mpegm-didl");
		prefixs.put("urn:mpeg:mpeg21:2002:02-DIDL-NS", "didl");
		prefixs.put("urn:mpeg:maf:schema:mediastreaming:DIDLextensions", "didl_msx");
		prefixs.put("urn:mpeg:mpeg21:2002:02-DIDMODEL-NS", "didmodel");      
		prefixs.put("urn:mpeg:mpeg21:2002:01-DII-NS", "dii");
		prefixs.put("urn:mpeg:mpeg21:2005:01-ERL-NS", "erl");
		prefixs.put("urn:mpeg:mpeg21:2004:01-IPMPDIDL-NS", "ipmpdidl");
		prefixs.put("urn:mpeg:mpeg21:2004:01-IPMPINFO-NS", "ipmpinfo");
		prefixs.put("urn:mpeg:maf:Schema:mediastreaming:IPMPINFOextensions:2007", "ipmpinfo_msx");		
		prefixs.put("urn:mpeg:mpegB:schema:IPMP-XML-MESSAGES:2007", "ipmpmsg");      
		prefixs.put("urn:mpeg:mpeg4:IPMPSchema:2002", "mpeg4ipmp");
		
		prefixs.put("urn:mpeg:mpeg7:schema:2001", "mpeg7");
		prefixs.put("urn:mpeg:mpeg7:smp:schema:2001", "mpeg7smp");
		prefixs.put("urn:mpeg:mpeg7:schema:2004", "mpeg7v2");

		prefixs.put("urn:mpeg:mpeg21:2005:01-REL-M1X-NS", "rel-m1x");
		prefixs.put("urn:mpeg:mpeg21:2006:01-REL-M2X-NS", "rel-m2x");      
		prefixs.put("urn:mpeg:mpeg21:2006:01-REL-M3X-NS", "rel-m3x");
		prefixs.put("urn:mpeg:mpeg21:2003:01-REL-MX-NS", "rel-mx");
		prefixs.put("urn:mpeg:mpeg21:2003:01-REL-R-NS", "rel-r");
		prefixs.put("urn:mpeg:mpeg21:2003:01-REL-SX-NS", "rel-sx");

		prefixs.put("urn:mpeg:mpeg-m:schema:baseprotocol:2009", "mxmbp");
		prefixs.put("urn:mpeg:mpeg-m:schema:accesscontentprotocol:2009", "mxmacp");
		prefixs.put("urn:mpeg:mpeg-m:schema:accessipmptoolprotocol:2009", "mxmaitp");
		prefixs.put("urn:mpeg:mpeg-m:schema:accesslicenseprotocol:2009", "mxmalp");
		prefixs.put("urn:mpeg:mpeg-m:schema:authenticatecontentprotocol:2009", "mxmaucp");
		prefixs.put("urn:mpeg:mpeg-m:schema:domain:2009", "mxmd");
		prefixs.put("urn:mpeg:mpeg-m:schema:domainprotocol:2009", "mxmdp");
		prefixs.put("urn:mpeg:mpeg-m:schema:identifycontentprotocol:2009", "mxmicp");
		prefixs.put("urn:mpeg:mpeg-m:schema:storecontentprotocol:2009", "mxmscp");
		prefixs.put("urn:mpeg:mpeg-m:schema:storelicenseprotocol:2009", "mxmslp");
		
		prefixs.put("urn:dmp:idp:represent:PaymentProtocol:2008", "dmprpp");

		prefixs.put("http://www.w3.org/2000/09/xmldsig#", "dsig");
		prefixs.put("http://www.w3.org/2001/04/xmlenc#", "xenc");
	}

	public String getPreferredPrefix(String namespaceUri, String suggestion, boolean requirePrefix) {
		
		if(prefixs.containsKey(namespaceUri)){
			return prefixs.get(namespaceUri);
		}
		// otherwise I don't care. Just use the default suggestion, whatever it may be.
		return suggestion;
	}

	public void addNamespaceUri(String namespaceUri, String prefix){
		if( !prefixs.containsKey(namespaceUri) )
			prefixs.put(namespaceUri, prefix);
	}
}
