package eu.convergence.middleware.cdsTE;


import java.util.List;

import org.iso.mpeg.mxm.core.MXMAbstractEngine;
import org.iso.mpeg.mxm.core.MXMEngine;
import org.iso.mpeg.mxm.core.configuration.MXMGenericParameters;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;

import eu.convergence.middleware.core.ConvergenceEngineName;
import eu.convergence.middleware.engine.cdsTE.CdsEngine;


public class CdsTE extends MXMAbstractEngine implements CdsEngine
{
	private SemanticExpander semanticExpander;
	private RepositoryManager repositoryManager;
	private InferenceManager inferenceManager;
	private CommunicationManager comManager;
	private KnowledgeManager knowledgeManager;
	private EntityExplorer entityExplorer;
	
//	public String userNS; // TODO 
	
	public CdsTE()
	{
		repositoryManager = new RepositoryManager();
		inferenceManager = new InferenceManager(repositoryManager);
		knowledgeManager = new KnowledgeManager();
		semanticExpander = new SemanticExpander(repositoryManager);
		entityExplorer = new EntityExplorer(repositoryManager);
		comManager = new CommunicationManager();
	}
	
	public void initialise(String engineID, MXMGenericParameters mxmParameters, boolean isTheDefaultEngine) 
	{
		super.initialise(engineID, mxmParameters, isTheDefaultEngine);

		repositoryManager.initRepositoryManager(mxmParameters);
		entityExplorer.initEntityExplorer();
    } 

	public eu.convergence.middleware.engine.cdsTE.KnowledgeManager getKnowledgeManager()
	{
		return (eu.convergence.middleware.engine.cdsTE.KnowledgeManager) knowledgeManager;
	}
	
	public eu.convergence.middleware.engine.cdsTE.InferenceManager getInferenceManager()
	{
		return (eu.convergence.middleware.engine.cdsTE.InferenceManager) inferenceManager;
	}
	
	public eu.convergence.middleware.engine.cdsTE.EntityExplorer getEntityExplorer()
	{
		return (eu.convergence.middleware.engine.cdsTE.EntityExplorer) entityExplorer;
	}
	
	public eu.convergence.middleware.engine.cdsTE.SemanticExpander getSemanticExpander()
	{
		return (eu.convergence.middleware.engine.cdsTE.SemanticExpander) semanticExpander;
	}
	
	public eu.convergence.middleware.engine.cdsTE.CommunicationManager getCommunicationManager()
	{
		return (eu.convergence.middleware.engine.cdsTE.CommunicationManager) comManager;
	}

	public String getEngineName()
	{
		return ConvergenceEngineName.CDSTE.value();
	}

	@Override
	public void setDependencies(List<MXMEngine> engines) throws MXMEngineException
	{
		
	}
	
}
