package eu.convergence.middleware.cdsTE;

import java.util.ArrayList;
import java.util.List;

import com.hp.hpl.jena.rdf.model.Statement;

public class SemanticExpander implements eu.convergence.middleware.engine.cdsTE.SemanticExpander
{	
	private final String WORDNET_LABEL_PROPERTY = "http://www.w3.org/2006/03/wn/wn20/schema/senseLabel";
	
	private RepositoryManager repositoryManager;

	public SemanticExpander(RepositoryManager repositoryManager)
	{
		this.repositoryManager = repositoryManager;
	}
	
	// DEMO IMPLEMENTATION
	public List<String> expandKeywordQueryByURI(List<String> uris)
	{
		List<String> toReturnList = new ArrayList<String>();
		
		for (String uri : uris)
		{
			System.out.println("Checking for expansion " + uri);
			List<Statement> statements = repositoryManager.getStatementsWithPattern(uri, WORDNET_LABEL_PROPERTY, null, "wordnet"); // TODO change
			
//			System.out.println("statements: " + statements.size());
			
			for (Statement statement : statements)
			{
//				System.out.println("new statement : " + statement.getLiteral().getString());
				toReturnList.add(statement.getLiteral().getString());
			}
		}
		
		// TODO also get equivalent URIs and their labels
		
		return toReturnList;
	}
	
//	public List<String> expandKeywordQueryByKeyword() // TODO stemming
//	{
//		return null;
//	}
//
//	public Metadata expandMetadata(Metadata metadata)
//	{
//		
//	}
//	
//	public Metadata getEquivalentMetadata(Metadata metadata, String knowledgeModelURI)
//	{
//		
//	}
//	
//	public Query getEquivalentQuery(Query query, String knowledgeModelURI)
//	{
//		
//	}
	
}
