package eu.convergence.middleware.conetTe;

import eu.convergence.middleware.conetTe.smile.SendToName.SendToNameServerImpl;
import eu.convergence.middleware.conetTe.smile.SendToName.generated.SendToNameClient;
import it.uniroma2.smile.core.Broker;
import it.uniroma2.smile.core.ProcessID;
import it.uniroma2.smile.run.BaseRunTimeContainer;
import it.uniroma2.smile.run.SmileRunUtil;
import it.uniroma2.smile.sipbinding.SipProcess;

import java.io.File;
import java.util.Vector;

public class ConetTeSmileRunTimeContainer extends BaseRunTimeContainer {

	SendToNameServerImpl sendToNameImpl;
	
	public ConetTeSmileRunTimeContainer(String procConfFile) {
		CONFIG_PATH = "cfg";
		 
		PROCESS_CONF_FILE = procConfFile==null?"alice-sip.cfg":procConfFile;
		
		YP_CONF_FILE = "ypconfig.properties";
		PIDS_CONF_FILE = "smile-pids.cfg";

		SIP_PROCESS_TIMEOUT = 32000; // (MS)
		TIMEOUT_MAIN = 5000; // (ms)
	}

    public ConetTeSmileRunTimeContainer(String procConfPath, String procConfFile) {
        CONFIG_PATH = procConfPath;

        PROCESS_CONF_FILE = procConfFile==null?"alice-sip.cfg":procConfFile;

        YP_CONF_FILE = "ypconfig.properties";
        PIDS_CONF_FILE = "smile-pids.cfg";

        SIP_PROCESS_TIMEOUT = 32000; // (MS)
        TIMEOUT_MAIN = 5000; // (ms)
    }

	
	public ConetTeSmileRunTimeContainer() {
		this(null);
	}
	
	/**
	 * Initialise and set-up
	 */
	public void init () {

		broker=Broker.getDefaultBroker();
		SipProcess.setYPConfigFile(CONFIG_PATH+File.separator+YP_CONF_FILE);
		SmileRunUtil.setRunTimeContainer(this);
		doAll();
		return;
	}

	Object doBusinessToken = new Object();

	/**
	 * Start all components
	 */
	public void doAll() {
		sendToNameImpl = new SendToNameServerImpl();
		sendToNameImpl.container = this;
		
		Vector<ProcessID> vPID = new Vector<ProcessID>();
		
		String pname = "";
		if (PROCESS_CONF_FILE.equals("alice-sip.cfg")) {
			vPID.add(SmileRunUtil.strNid2Pid("www.alice.com/label") );
			vPID.add(SmileRunUtil.strNid2Pid("www.alice1.com/label") );
			vPID.add(SmileRunUtil.strNid2Pid("www.alice.com/label-1") );
			pname="alice";
		
		} else if (PROCESS_CONF_FILE.equals("bob-sip.cfg")) {
			pname="bob";
		} else if (PROCESS_CONF_FILE.equals("carol-sip.cfg")) {
			vPID.add(SmileRunUtil.strNid2Pid("www.carol.com/label") );
			pname="carol";
		} else if (PROCESS_CONF_FILE.equals("donald-sip.cfg")) {
			vPID.add(SmileRunUtil.strNid2Pid("www.donald.com/label") );
			pname="donald";
		} else if (PROCESS_CONF_FILE.equals("advertiser-sip.cfg")) {
			pname="advertiser";
		} else if (PROCESS_CONF_FILE.equals("sender-sip.cfg")) {
			pname="sender";
		}
		
		Object [][] myObjArrArr = new Object [] [] {
				{new SendToNameClient(), "SendToName", pname}
		}; 
		SmileRunUtil.startComponentListOfServerAddr(vPID, sendToNameImpl, null, false, null, myObjArrArr 
				
		);
		
//		SmileRunUtil.startComponent("SendToName", THIS_CLIENT_NAME, sendToNameImpl,  new SMILEPeer[] {
//				//clients here
//				new SendToNameClient()
//		}
//		);
		

		
		System.out.println("*************** ALL Components Started ********************");

	}

	/**
	 * Shutdown the Smile servers.
	 */
	public static void shutdown() {
	}
	
}
