package eu.convergence.middleware.conetTe;

import java.io.File;

import org.iso.mpeg.mxm.core.MXM;
import org.iso.mpeg.mxm.core.configuration.MXMConfigurationException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineNotFoundException;

import eu.convergence.middleware.conetTe.ConetTE;
import eu.convergence.middleware.core.ConvergenceEngineName;
import eu.convergence.middleware.engine.ConetTe.services.LID;
import eu.convergence.middleware.engine.ConetTe.services.NID;
import eu.convergence.middleware.engine.ConetTe.services.SAPListener;

public class StnExample implements SAPListener {
	
	ConetTE conetTE ;

	public StnExample(String cfgFileName) throws MXMConfigurationException, MXMEngineNotFoundException {
		
//		File f = new File(getClass().getClassLoader().getResource("MXMConfiguration.xml").getFile());
//		MXM mxm = MXM.getInstance(f);
//		mxm.listEnginesAndProperties();

		conetTE = (ConetTE) MXM.getInstance().getDefaultEngine(ConvergenceEngineName.ConetTE.toString());
		
		conetTE = conetTE.getConetTE(cfgFileName);
		
		if (cfgFileName.equals("advertiser-sip.cfg")) {  //will advertise the NID
			conetTE.advertiseSap(new NID("www.advertiser.org/label-11"), this, ConetTE.NAMED_DATA_AS_STRING);
			
		} else if (cfgFileName.equals("sender-sip.cfg")) { //will send to the NID
			try {
				Thread.sleep(4000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			NID nid = new NID("www.advertiser.org/label-11");
			conetTE.sendToName(nid, "Hello Message by Sender to Advertiser");
		}
		
	}

	@Override
	public void indication(LID lid, byte[] unNamedData) {
		// TODO Auto-generated method stub

	}

	@Override
	public void indication(LID lid, String unNamedDataAsString) {
		System.out.println ("Received incoming message: "+ unNamedDataAsString);
		
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
			try {
				if (args[0].equals("advertiser-sip.cfg")) {  //will advertise the NID
					new StnExample (args[0]);
				} else if (args[0].equals("sender-sip.cfg")) { //will send to the NID
					new StnExample (args[0]);
				} else {
					System.out.println ("Argument does not match a configuration file");
				}
			} catch (MXMConfigurationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (MXMEngineNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	}

}
