// SubscribeToHelloServerImpl.java prototype code
package eu.convergence.middleware.conetTe.smile.SendToName;

import java.util.Hashtable;

import org.zoolu.sip.address.SipURL;

import eu.convergence.middleware.conetTe.ConetTeSmileRunTimeContainer;
import eu.convergence.middleware.conetTe.smile.SendToName.generated.*;
import eu.convergence.middleware.engine.ConetTe.ConetTE;
import eu.convergence.middleware.engine.ConetTe.services.NID;
import eu.convergence.middleware.engine.ConetTe.services.SAPListener;

import it.uniroma2.smile.core.*;
import it.uniroma2.smile.run.SmileRunUtil;
import it.uniroma2.smile.sipbinding.SipProcessID;
public class SendToNameServerImpl extends SendToNameServer{

	private class SapAndType {
		SAPListener listener;
		int type;
		public SapAndType (SAPListener listener, int type) {
			this.listener = listener;
			this.type =  type;
		}
		int getType () {
			return type;
		}
		SAPListener getListener () {
			return listener;
		}
	}
	
	/** the string key should be obtained with a NID.toString()*/
	private Hashtable<String, SapAndType> nid2StrListener = new Hashtable<String, SapAndType>();

	
	@Override
	protected void SendToName( ProcessID process, SendToNameOneWay request, ProcessID receiver) {
		log("Received message: "+request.getRequest()+ " from: "+process);
		
		
		SapAndType sapAndType = nid2StrListener.get(SmileRunUtil.pid2StrNid(receiver));
		
		if (sapAndType == null) {
			log("no listener available for NID: "+SmileRunUtil.pid2StrNid(receiver));
		} else {
		
			SAPListener listener = sapAndType.getListener();
			int type = sapAndType.getType();
			
			if (type==ConetTE.NAMED_DATA_AS_STRING) {
				listener.indication(null, request.getRequest());
			}
		}
		
		if (container.PROCESS_CONF_FILE.equals("alice-sip.cfg")) {
		
		} else if (container.PROCESS_CONF_FILE.equals("bob-sip.cfg")) {
			SendToNameOneWay msg = new SendToNameOneWay();
			msg.setRequest("Hello Carol! I'm Bob");
			try {
				if (sendToNameClient!=null) {
					String strNid="www.carol.com/label";
					log("SENDING MESSAGE to: "+strNid);
					sendToNameClient.sendToName(SmileRunUtil.strNid2Pid(strNid), msg);
				}
			} catch (SendingMessageException e) {
				e.printStackTrace();
			} catch (Fault e) {
				e.printStackTrace();
			}
		} else if (container.PROCESS_CONF_FILE.equals("carol-sip.cfg")) {
			SendToNameOneWay msg = new SendToNameOneWay();
			msg.setRequest("Hello Donald! I'm Carol");
			try {
				if (sendToNameClient!=null) {
					String strNid="www.donald.com/label";
					log("SENDING MESSAGE to: "+strNid);
					sendToNameClient.sendToName(SmileRunUtil.strNid2Pid(strNid), msg);
				}
			} catch (SendingMessageException e) {
				e.printStackTrace();
			} catch (Fault e) {
				e.printStackTrace();
			}
		} else if (container.PROCESS_CONF_FILE.equals("donald-sip.cfg")) {
			SendToNameOneWay msg = new SendToNameOneWay();
			msg.setRequest("Hello Alice! I'm Donald");
			try {
				if (sendToNameClient!=null) {
					String strNid="www.alice.com/label";
					log("SENDING MESSAGE to: "+strNid);
					sendToNameClient.sendToName(SmileRunUtil.strNid2Pid(strNid), msg);
				}
			} catch (SendingMessageException e) {
				e.printStackTrace();
			} catch (Fault e) {
				e.printStackTrace();
			}
		}
	}
	
	public ConetTeSmileRunTimeContainer container;
	// setup() method
	public void setup(){
    	
		d=new Descriptor();
		d.setType(SERVICE_TYPE);
		d.setOperation(OPERATIONS_TYPE);
		//PUBLICATION PROCEDURE: UNCOMMENT IF NEEDED
		//try {
		//publish(d);
		//} catch (MalformedDescriptorException e) {
		//e.printStackTrace();
		//}
		//log("Published service "+SERVICE_TYPE);
		running=true;
	}
	//takedown() method
	public void takedown() {
		//UN-PUBLICATION PROCEDURE: UNCOMMENT IF NEEDED
		//delete(d);
		//log("Service "+SERVICE_TYPE+" deleted from the YP");
	}
	//doBusiness() method
	public void doBusiness(){
		int m=0;
		while (running) {
			try {
				Thread.sleep(DEF_TIME_INTERV/5);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			log(SERVICE_TYPE+" running since "+((++m)*DEF_TIME_INTERV/5/60000)+" minutes!");

			if (container.PROCESS_CONF_FILE.equals("alice-sip.cfg")) {
				SendToNameOneWay msg = new SendToNameOneWay();
				msg.setRequest("Hello Bob, I'm Alice");
				try {
					if (sendToNameClient!=null) {
						String strNid="www.bob.com/label-25";
						log("SENDING MESSAGE to: "+strNid);
						sendToNameClient.sendToName(SmileRunUtil.strNid2Pid(strNid), msg);
					}
				} catch (SendingMessageException e) {
					e.printStackTrace();
				} catch (Fault e) {
					e.printStackTrace();
				}
			} else if (container.PROCESS_CONF_FILE.equals("bob-sip.cfg")) {
				if (m==2) {
					SmileRunUtil.advertiseNID (this, new NID("www.bob.com/label-2"));
				}
				if (m==4) {
					SmileRunUtil.advertiseNID (this, new NID("www.bob.com/label-25"));
				}
			} else if (container.PROCESS_CONF_FILE.equals("carol-sip.cfg")) {
			} else if (container.PROCESS_CONF_FILE.equals("donald-sip.cfg")) {
			}
		}
	}
	//example variable declaration:
	//YourClientPeerTypeClient yourClientPeerTypeClientPeer
		public SendToNameClient sendToNameClient;

	//Method setReference2Peers(SMILEPeer[] smilePeerArray)
	public void setReference2Peers(SMILEPeer[] smilePeerArray){
	}
	//Method setReference2activePeers(SMILEPeer[] smilePeerArray)
	public void setReference2ActivePeers(SMILEPeer[] smilePeerArray){
		//TODO implement your code here, for example:
		//yourClientPeerTypeClientPeer = (YourClientPeerTypeClient) smilePeerArray [0]
		sendToNameClient = (SendToNameClient) smilePeerArray [0];
	}

	public void advertiseSap(NID nid, SAPListener callBack, int localDeliveryType) {
		nid2StrListener.put(nid.toString(), new SapAndType(callBack,localDeliveryType));
		SmileRunUtil.advertiseNID (this, nid);
	}

}
