/*
SMILE: a Simple Middleware Independent LayEr 
Author: Giovanni Bartolomeo

Copyright (C) 2007  University of Rome Tor Vergata - Dipartimento di Ingegneria Elettronica


This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package it.uniroma2.smile.core;
/**
*
* @author Giovanni Bartolomeo
*/
public class SMILEPeer implements BasicFunctions {
	//temp. implementation for BoundProcess, to be replaced
	//with a more flexible mechanisms in order to allow 
	//running of several bindings for each boundProcess
	private String UUID;
	private final Broker defaultBroker = Broker.getDefaultBroker(); 

	public String getUUID() {
		return UUID;
	}
	
	public SMILEPeer() {
		//UUID=assignUniqueIdentifier()
		//TODO: implement a valid algorithm to assign the UUID (e.g. Java 5.0 java.util.UUID)
		UUID=""+this;
	}
	
	public ProcessID[] getPID() {
		return Broker.getPID(this);
	}
	
	public final void delete(Descriptor descriptor) {
		defaultBroker.delete(this,descriptor);			
	}

	public final void publish(Descriptor descriptor)
			throws MalformedDescriptorException {
		defaultBroker.publish(this,descriptor);
		
	}

	public final ProcessID[] search(DescriptorFilter descriptorFilter) {		
		return defaultBroker.search(this,descriptorFilter);
	}

	public final Message doRequest(Message request, ProcessID receiver) throws Fault,
			SendingMessageException {
		return defaultBroker.doRequest(this,request, receiver);		
	}

	public final void send(Message message, ProcessID receiver)
			throws SendingMessageException {
		defaultBroker.send(this,message, receiver);
		
	}

	public final void send(Message message, ProcessID[] receivers)
			throws SendingMessageException {
		defaultBroker.send(this,message, receivers);		
	}
	
    public void onReceived(ProcessID sender,Message message, ProcessID receiver) {
    	//to override - by default, do nothing
    }
    
    public Message onRequestReceived(ProcessID sender,Message request) {
    	//to override - by default, throw a new generic exception
    	return new DefaultFaultMessage("This callback has not been implemented");}

	public void doBusiness() {
		//to override - by default, do nothing
	}

	public void setup() {
		//to override - by default, do nothing
	}

	public void takedown() {
		//to override - by default, do nothing
	} 
	
	public void setReference2Peers (SMILEPeer[] spArr) {
		//to override - by default, do nothing
	}
	
	public void setReference2ActivePeers (SMILEPeer[] spArr) {
		//to override - by default, do nothing
	}
}
