/*
 * %%xxx_LICENSE_DECL_TEXT_RND_8E57C9A4B5%%
 * 
 * 
 * FILE: BaseRunExample.java 
 * DESCRIPTION: 
 * This file is used to configure and run a set of SMILE peers (it is extended by RunPerimeter.java
 * RESPONSIBLE: Stefano Salsano (CNIT, stefano.salsano@uniroma2.it) 
 * 
 * ACKNOWLEDGEMENT:
 * The PERIMETER Project (FP7 - 224024) is co-funded by the European Commission under the 7th Framework Programme for RTD.  
 * 
 * http://www.ict-perimeter.eu/
 *  
 */
package it.uniroma2.smile.run;

import it.uniroma2.smile.core.Broker;

/**
 * The base class for creating a SMILE run-time container that includes a set of peers. It
 * must be extended by the actual run-time container.
 * @author CNIT
 *
 */
public abstract class BaseRunTimeContainer {
	public String CONFIG_PATH;
	public String PROCESS_CONF_FILE;
	public String YP_CONF_FILE;
	public String PIDS_CONF_FILE;

	public int SIP_PROCESS_TIMEOUT ; //(MS)
	public int TIMEOUT_MAIN; //(ms)

	public Broker broker;

	public BaseRunTimeContainer(){
		
	}
}
