/*
SMILE: a Simple Middleware Independent LayEr 
Author: Giovanni Bartolomeo

Copyright (C) 2007  University of Rome Tor Vergata - Dipartimento di Ingegneria Elettronica


This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package it.uniroma2.smile.run;

import it.uniroma2.smile.core.SMILEPeer;

import it.uniroma2.smile.sipbinding.SipProcessID;

/**
 * runs a single Smile Peer as a process... handing the "lifecycle" of the peer:
 * setup, doBusiness and takedown
 * @author Utente
 *
 */
public class RunProcess extends Thread {

//	static Object waitForDoBusiness = new Object();
//	static int howManySetupToWait = 0;
//	static int howManySetupHaveCompleted = 0;
	private Object runDoBusinessLock = null; 
	private Object token2UnlockAfterSetup = null;
	private SMILEPeer p;
	
	public RunProcess (SMILEPeer bp) {
		p=bp;
	}		

	public RunProcess (SMILEPeer bp, Object runAfterSetup, Object token) {
		p=bp;
		runDoBusinessLock = runAfterSetup;
		token2UnlockAfterSetup = token;
	}		

	public void run() {			
		p.setup();
		if (token2UnlockAfterSetup!=null) {
			synchronized (token2UnlockAfterSetup) {
				//System.out.println("unlocking: "+((SipProcessID) p.getPID()[0]).toString());
				token2UnlockAfterSetup.notify();
			}
		}
		
		if (runDoBusinessLock!=null )
			synchronized (runDoBusinessLock) {
				try {
					//System.out.println("start waiting: "+((SipProcessID) p.getPID()[0]).toString());
					
					runDoBusinessLock.wait();
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		
		if (p.getPID()!=null){
			System.out.println("resumed : "+((SipProcessID) p.getPID()[0]).toString());
		} else {
			System.out.println("resumed process with null PID");
		}

		p.doBusiness();
		p.takedown();
	}
	
//	public static synchronized void addOneSetupToWait () {
//		howManySetupToWait++;
//	}
//
//	public static synchronized void setupCompleted () {
//		howManySetupHaveCompleted++;
//	}

//	public static synchronized void unSleepDoBusiness() {
//		synchronized (waitForDoBusiness){
//			waitForDoBusiness.notifyAll();
//		}
//	}
	
}
