/*
SMILE: a Simple Middleware Independent LayEr 
Author: Giovanni Bartolomeo

Copyright (C) 2007  University of Rome Tor Vergata - Dipartimento di Ingegneria Elettronica


This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package it.uniroma2.smile.sipbinding;

import it.uniroma2.smile.core.GenericProcessID;
import it.uniroma2.smile.core.ProcessID;
import org.zoolu.sip.address.NameAddress;

public class SipProcessID extends GenericProcessID{

	private NameAddress na;

	public SipProcessID(){	
	}

	public SipProcessID(String stringPid){
		na = new NameAddress(stringPid);
	}
	
	public void setNameAddress(NameAddress na){
		this.na=na;
	}

	public NameAddress getNameAddress(){
		return this.na;
	}

	public boolean equals(ProcessID pid){
		if (pid instanceof SipProcessID)
			if (((SipProcessID)pid).toString().equals(toString()))
					return true;
		return false;
	}
	
	public String toString() {
		return this.na.getAddress().toString();
	}

//	/**
//	 * The comparison is made based on the sip addresses associated to the ProcessID
//	 * if the sip AoRs without the parameters are equal, then the two processes are 
//	 * are assumed to be local each other  
//	 */
//	public boolean isLocalTo(ProcessID pid) {
//		if (pid instanceof SipProcessID) {
//			String[] strArr = toString().split("\\;",2);
//			if (strArr[0].equals(((SipProcessID)pid).toString().split("\\;",2)[0])){
//				return true;
//			}
//
////			System.out.println("my Pid    : "+ toString());
////			System.out.println("strArr : "+ strArr[0]);
////			System.out.println("target Pid: "+((SipProcessID)pid).toString());
////			String[] strArr1 = ((SipProcessID)pid).toString().split("\\;",2);
////			System.out.println("strArr1 : "+ strArr1[0]);
//			
//		}
//		return false;
//	}
}
