/*
SMILE: a Simple Middleware Independent LayEr 
Author: Giovanni Bartolomeo

Copyright (C) 2007  University of Rome Tor Vergata - Dipartimento di Ingegneria Elettronica


This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package it.uniroma2.smile.sipbinding.sipmessage;

import org.json.me.JSONObject;
import org.istsms.util.Javabean2JSON;

public class MessageEnvelope {
	//Message wrappedMessage;
	String fragMsg;
	
	//sequence number, fragment number, total number of fragment
	// in order to implement correlation btw request and response, a sequence
	// number is needed
	// Furthermore, since each SMILE message can be fragmented into a number of
	// JSON messages, we mark
	//json messages with fragNo and fragTot
	int seqNo, fragNo, fragTot;
	
	//refSeq is used in case of reply message tocorrelate request and response
	int refSeq=-1;
	//true if the message is a request; default FALSE;
	protected boolean isReq=false;		   

	/** Creates a new instance of Message */
	public MessageEnvelope() {	
	}

//	public String toString() {
//		try {
//			return toJSONObject(this).toString();
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
//		return null;
//	}
	
	public static JSONObject toJSONObject(MessageEnvelope jm) {
		return Javabean2JSON.toJSONObject(jm);
	}
	
	public static MessageEnvelope fromJSONObject(JSONObject jObj) {		
        return (MessageEnvelope) Javabean2JSON.fromJSONObject(jObj);		
	}

	public String toString() {
		String s = "FNo=" + fragNo + "\n";
		s = s + "FTot=" + fragTot + "\n";
		s = s + "RefS=" + refSeq + "\n";
		s = s + "SNo=" + seqNo + "\n";
		s = s + "Req=" + isReq + "\n";
		s = s + "Frag=" + fragMsg;
		return s;
	}

	public void fromString(String s) {
		String[] ss = s.split("\n");
		fragNo = Integer.parseInt(searchParam("FNo", ss));
		fragTot = Integer.parseInt(searchParam("FTot", ss));
		refSeq = Integer.parseInt(searchParam("RefS", ss));
		seqNo = Integer.parseInt(searchParam("SNo", ss));
		if (searchParam("Req", ss).contains("true")) {
			isReq = true;
		} else {
			isReq = false;
		}
		fragMsg = searchParam("Frag", ss);
	}

	public String searchParam(String param, String[] ss) {
		String valor = "";
		for (int i = 0; i < ss.length; i++) {
			if (ss[i].startsWith(param)) {
				valor = ss[i].substring(param.length() + 1);
				break;
			}
		}
		return valor;
	}

	public int getSNo() {
		return seqNo;
	}

	public void setSNo(int seqNo) {
		this.seqNo = seqNo;
	}

	public int getFNo() {
		return fragNo;
	}

	public void setFNo(int fragNo) {
		this.fragNo = fragNo;
	}

	public int getFTot() {
		return fragTot;
	}

	public void setFTot(int fragTot) {
		this.fragTot = fragTot;
	}

	public int getRefS() {
		return refSeq;
	}

	public void setRefS(int refSeq) {
		this.refSeq = refSeq;
	}

	public String getFrag() {
		return fragMsg;
	}

	public void setFrag(String fragMsg) {
		this.fragMsg = fragMsg;
	}
	
	public boolean isReq() {
		return isReq;
	}

	public void setReq(boolean isRequest) {
		this.isReq = isRequest;
	}
}

