package org.zoolu.sip.authentication;

import org.zoolu.tools.MD5;

public class SaltPassword {
	public final static int ALG_MD5=0, ALG_SHA1=1;
	
	/** the password to be salted*/
	protected String clearPassword;
	/** the salt value */
	protected String salt;
	/**the cryptografic algorithm*/
	public int algorithm;
	
	public SaltPassword(String passwd, String salt){
		this.clearPassword=passwd;
		this.salt=salt;
		this.algorithm=ALG_MD5;
	}
	public SaltPassword(String passwd, String salt, int algorithm)throws InvalidAlgorithmException{
		this.clearPassword=passwd;
		this.salt=salt;
		if (algorithm!=ALG_MD5)throw new InvalidAlgorithmException("only MD5 is supported!");
		this.algorithm=algorithm;
	}

	public String encryptPassword(){
		switch (this.algorithm){
		case ALG_MD5:{ 
			MD5 md5 = new MD5(this.clearPassword+this.salt);
			return md5.asHex();
		}
		default: return null;
		}
	}
}
