package eu.convergence.middleware.conetTE.test;

import java.io.File;

import org.junit.Before;

//import eu.convergence.ConetTeInterface;
import eu.convergence.middleware.conetTe.ConetTE;
import eu.convergence.middleware.core.ConvergenceEngineName;

import org.iso.mpeg.mxm.core.MXM;
import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMAbstractEngine;
import org.iso.mpeg.mxm.core.configuration.MXMConfigurationException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;

import eu.convergence.middleware.engine.ConetTe.exception.ConetIOException;
import eu.convergence.middleware.engine.ConetTe.services.NID;
import junit.framework.TestCase;

public class ConetTest extends TestCase {
	

	private NID nidObj;
	private String localFileName;
	private String fileName;
	
	private ConetTE conetTE;
	//private int rType;
	
//	private Logger logger;
	
	

	@Before
	public void setUp() throws Exception {
		
		nidObj = new NID("nidObject");
		
		fileName = "fileName";
		
		localFileName = "localFileName";
		
	}
	
	public void testConetCreation() throws MXMException
	{
		File f = new File(getClass().getClassLoader().getResource("MXMConfiguration.xml").getFile());
		MXM mxm = MXM.getInstance(f);
		mxm.listEnginesAndProperties();

	   conetTE = (ConetTE) mxm.getDefaultEngine(ConvergenceEngineName.ConetTE.toString());

	   if (conetTE == null) {
		   System.out.println("mxm.getDefaultEngine(MXMEngineName.ConetTE) returned NULL");
		   System.out.println("Closing test");
	   } else {
		   NID nidObj = new NID("andrea.detti/cubo.jpg");
		   //String fileName = "/home/andrea/cubo.jpg";
		   String fileName = getClass().getClassLoader().getResource("cubo.jpg").getFile();
		   
		   int response;
		   
		   // Store and Advertise the named-resource fileName with NID = nidClass
		   System.out.println("Executing Store and Advertise of named-resource "+fileName+" with NID "+nidObj.toString());
		   response = conetTE.storeAndAdvertise(nidObj, ConetTE.NAMED_DATA_RTYPE, fileName, (NID)null);
		   if (response<0) {
			   System.out.println("Store and Advertise failed\n");
		   } else {
			   System.out.println("Store and Advertise succeeded\n");
		   }
		   
		   // Get of the named-resource with NID = nidClass and store in localFileName  
		   //String localFileName = "/home/andrea/cubo_get.jpg";
		   String localFileName = System.getProperty("java.io.tmpdir") + "cubo_get.jpg";
		   
		   System.out.println("Executing Get of named-resource with NID "+nidObj.toString()+" , storing it in "+localFileName);
		   try {
			   response = conetTE.get(nidObj, localFileName);
		   } catch (ConetIOException e) {
			   // TODO Auto-generated catch block
			   e.printStackTrace();
		   }
		   if (response<0) {
			   System.out.println("Get failed\n");
		   } else {
			   System.out.println("Get succeeded\n");
		   }
		   
		   // Revoke of the named-resource with NID = nidClass  
		   System.out.println("Executing Revoke of named-resource with NID "+nidObj.toString());
		   response = conetTE.revoke(nidObj, ConetTE.NAMED_DATA_RTYPE, (NID)null);
		   if (response<0) {
			   System.out.println("Revoke failed");
		   } else {
			   System.out.println("Revoke succeeded");
		   }	
		   
	   }

	
	}

	   /*
	    * The following method tests the boot order of the lc_Server capability
	    */
//	   public void testLCServer() throws MXMConfigurationException, MXMEngineException
//	   {
//		   File f = new File(getClass().getClassLoader().getResource("LCS-MXMConfiguration.xml").getFile());
//		   MXM mxm = MXM.getInstance(f);
//		   mxm.listEnginesAndProperties();
//
//		   conetTE = (ConetTE) mxm.getDefaultEngine(ConvergenceEngineName.ConetTE.toString());   
//	   
//	   }
}
