package eu.convergence.middleware.eventreportTE.kernel;

import eu.convergence.middleware.engine.ConetTe.ConetTE;
import eu.convergence.middleware.engine.ConetTe.services.NID;
import eu.convergence.middleware.eventreportTE.service.ERService;

import org.iso.mpeg.mxm.core.MXM;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.tEngine.eventreportTE.EventReportEngine;
import org.iso.mpeg.mxm.tEngine.eventreportTE.exception.EventReportException;
import org.iso.mpeg.mxm.tEngine.eventreportTE.schemahandler.er.ER;

/**
 * <p/>
 * User: <a href="mailto:bogdan.ardeleanu@uti.ro"> Bogdan Ardeleanu</a>
 * Date: 8/29/11
 * Time: 5:25 PM
 * <p/>
 * UTI Systems, TIC
 */
public class DefaultERMessageHandler implements org.iso.mpeg.mxm.tEngine.eventreportTE.technologyhandler.ERMessageHandler {
    private final ConetTE advertiser;
    private final ConetTE sender;

    private final EventReportEngine erEngine;

    public DefaultERMessageHandler(ConetTE advertiser, ConetTE sender, EventReportEngine erEngine) {
        this.advertiser = advertiser;
        this.sender = sender;

        this.erEngine = erEngine;
    }

    @Override
    public MXMEngineResponse sendER(ER er, String SAP) throws EventReportException {
        try {

            System.out.println("Sending ER with ID=" + er.getERIdentifier() + " to " + SAP);

            String stack = MXM.getInstance().getDefaultEngine("ConetTE").getPropertyValue("NET_PROTOCOL");

            if((stack != null) && (stack.compareTo("ccnx") == 0))
            	sender.sendToName(new NID(SAP), (byte[])(er.createObject(Byte.class.getCanonicalName()).getContent()));
            else
            	sender.sendToName(new NID(SAP), new String((byte[])(er.createObject(Byte.class.getCanonicalName()).getContent())));

            System.out.println("Sending message to " + SAP + ": SUCCESS");
            return MXMEngineResponse.SUCCESS;
        } catch (Exception e) {
            e.printStackTrace();
            System.out.println("Sending message to " + SAP + ": FAILURE");
            return MXMEngineResponse.FAILURE;
        }
    }

    @Override
    public MXMEngineResponse recvERDaemon() throws MXMEngineException {
        advertiser.advertiseSap(
            new NID(erEngine.getEventReportEngineTechHandler().getEREngineParams().getSAP()),
            new ERService(erEngine),
            ConetTE.NAMED_DATA_AS_STRING);

        System.out.println("ER Daemon...");

        return MXMEngineResponse.SUCCESS;
    }
}
