package eu.convergence.middleware.eventreportTE.kernel.conet;

import eu.convergence.middleware.engine.ConetTe.ConetTE;
import eu.convergence.middleware.eventreportTE.kernel.DefaultERMessageHandler;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.tEngine.eventreportTE.technologyhandler.ERMessageHandler;

/**
 * <p/>
 * User: <a href="mailto:bogdan.ardeleanu@uti.ro"> Bogdan Ardeleanu</a>
 * Date: 4/19/12
 * Time: 11:04 PM
 * <p/>
 * UTI Systems, TIC
 */
public class EREngineTechnologyHandler extends org.iso.mpeg.mxm.eventreportTE.EREngineTechnologyHandler {
    private ConetTE advertiser = null;
    private ConetTE sender = null;

    public EREngineTechnologyHandler(org.iso.mpeg.mxm.eventreportTE.EventReportTE erEngine)
        throws MXMEngineException {
        super(erEngine);
    }

    public EREngineTechnologyHandler(org.iso.mpeg.mxm.eventreportTE.EventReportTE erEngine,
                                     ConetTE advertiser, ConetTE sender)
        throws MXMEngineException {
        super(erEngine);

        configureCoNet(advertiser, sender);
    }

    public void configureCoNet(ConetTE advertiser, ConetTE sender) {
        this.advertiser = advertiser;
        this.sender = sender;
    }

    public ConetTE getAdvertiser() {
        return advertiser;
    }

    public ConetTE getSender() {
        return sender;
    }

    @Override
    public ERMessageHandler getERMessageHandler() {
        if(null == erMessageHandler) {
            erMessageHandler = new DefaultERMessageHandler(advertiser, sender, erEngine);
        }

        return erMessageHandler;
    }
}
