package eu.convergence.middleware.eventreportTE.kernel.conet;


import eu.convergence.middleware.engine.ConetTe.ConetTE;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.tEngine.eventreportTE.EventReportEngineTechnologyHandler;
import org.iso.mpeg.mxm.tEngine.eventreportTE.exception.EventReportException;

/**
 * <p/>
 * User: <a href="mailto:bogdan.ardeleanu@uti.ro"> Bogdan Ardeleanu</a>
 * Date: 4/19/12
 * Time: 2:14 PM
 * <p/>
 * UTI Systems, TIC
 */
public class EventReportTE extends org.iso.mpeg.mxm.eventreportTE.EventReportTE {
    private ConetTE advertiser;

    private ConetTE sender;

    @Override
    public EventReportEngineTechnologyHandler getEventReportEngineTechHandler() throws MXMEngineException {
        if (null == advertiser) {
            throw new EventReportException("exception in getEventReportEngineTechnologyHandler: advertiser not set");
        }

        if (null == sender) {
            throw new EventReportException("exception in getEventReportEngineTechnologyHandler: sender not set");
        }

        return new EREngineTechnologyHandler(this, advertiser, sender);
    }

    public void configureCoNet(ConetTE advertiser, ConetTE sender) {
        this.advertiser = advertiser;
        this.sender = sender;
    }

    public ConetTE getAdvertiser() {
        return advertiser;
    }

    public ConetTE getSender() {
        return sender;
    }


}
