package eu.convergence.middleware.eventreportTE.service;

import eu.convergence.middleware.engine.ConetTe.services.LID;
import eu.convergence.middleware.engine.ConetTe.services.SAPListener;
import eu.convergence.middleware.eventreportTE.message.ERMessageConsumer;

import org.iso.mpeg.mxm.tEngine.eventreportTE.EventReportEngine;

/**
 * <p/>
 * User: <a href="mailto:bogdan.ardeleanu@uti.ro"> Bogdan Ardeleanu</a>
 * Date: 8/29/11
 * Time: 6:04 PM
 * <p/>
 * UTI Systems, TIC
 */
public class ERService implements SAPListener {
    private final EventReportEngine erEngine;

    public ERService(EventReportEngine erEngine) {
        this.erEngine = erEngine;
    }

    @Override
    public void indication(LID lid, byte[] unNamedData) {
        handleRequest(new String(unNamedData));
    }

    @Override
    public void indication(LID lid, String unNamedDataAsString) {
        handleRequest(unNamedDataAsString);
    }

    private void handleRequest(String xmlAsString) {
        ERMessageConsumer erMessageConsumer = new ERMessageConsumer(
            xmlAsString,
            erEngine
        );
        Thread thread = new Thread(erMessageConsumer);
        thread.start();
    }

}
