package eu.convergence.middleware.identifycontentPE;

import java.util.ArrayList;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ConvIdentifyContentEngineContext {

	private static ConvIdentifyContentEngineContext packages = null;

	protected Logger logger = LoggerFactory.getLogger(this.getClass());

	protected ArrayList<String> packageNames = new ArrayList<String>();

	private static JAXBContext jc = null;

	/**
	 * @return all package names in sequence
	 */
	private String getPackagesInOrder() {
		StringBuffer orderpackages = new StringBuffer();
		for (int i = 0; i < packageNames.size(); i++) {
			orderpackages.append(packageNames.get(i));
			if (i >= (packageNames.size() - 1))
				break;
			orderpackages.append(":");
		}
		return orderpackages.toString();
	}

	/**
	 * @return the JAXB Context all schemas used by the Engine
	 * @throws JAXBException
	 */
	public JAXBContext getJAXBContext() throws JAXBException {
		if (jc == null) {
			logger.debug("Generating Engine JAXB Context...");
			jc = JAXBContext.newInstance(getPackagesInOrder());
			logger.debug("Done! \n");
		}
		return jc;
	}

	private ConvIdentifyContentEngineContext() {

		// Identify package
		packageNames.add("org.iso.mpeg.mxm.engine.identifycontentPE.schema.identifycontentprotocol");
						  
		// DID packages
		packageNames.add("org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl");
		packageNames.add("org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl_msx");
		packageNames.add("org.iso.mpeg.mxm.engine.digitalitemTE.schema.dii");

		// IPMP packages
		packageNames.add("org.iso.mpeg.mxm.engine.digitalitemTE.schema.didmodel_mp21");
		packageNames.add("org.iso.mpeg.mxm.engine.ipmpTE.schema.ipmpdidl");
		packageNames.add("org.iso.mpeg.mxm.engine.ipmpTE.schema.ipmpinfo");
		packageNames.add("org.iso.mpeg.mxm.engine.ipmpTE.schema.ipmpmsg");
		packageNames.add("org.iso.mpeg.mxm.engine.ipmpTE.schema.ipmpinfo_msx");
		packageNames.add("org.iso.mpeg.mxm.engine.ipmpTE.schema.mpeg4ipmp");

		// Security packages
		packageNames.add("org.iso.mpeg.mxm.engine.securityTE.schema.dsig");
		packageNames.add("org.iso.mpeg.mxm.engine.securityTE.schema.xenc");

		//MPEG7 packages
		packageNames.add("org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3");
		
		//ER packages
		packageNames.add("org.iso.mpeg.mxm.engine.eventreportTE.schema.er");
		
		//ConvMeta packages
		packageNames.add("eu.convergence.middleware.metadataTE.schema.convMeta");
		packageNames.add("eu.convergence.middleware.relationships.schema.convRelation");
		
	}

	public static synchronized ConvIdentifyContentEngineContext getInstance() {
		if (packages == null)
			packages = new ConvIdentifyContentEngineContext();
		return packages;
	}

}
