package eu.convergence.middleware.matchTE;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.apache.lucene.index.CorruptIndexException;
import org.apache.lucene.store.LockObtainFailedException;

import org.iso.mpeg.mxm.core.MXMObject;
import eu.convergence.middleware.engine.matchTE.exception.MatchEngineException;
import eu.convergence.middleware.matchTE.metadata.FieldValueMetadata;
import eu.convergence.middleware.matchTE.metadata.MetadataObject;


public class PublicationManager implements eu.convergence.middleware.engine.matchTE.PublicationManager
{
	private RepositoryManager repositoryManager;
	
	public PublicationManager(RepositoryManager repositoryManager)
	{
		this.repositoryManager = repositoryManager;
	}

	public List<String> matchSubsWith(String PVDI_Id, MXMObject publicationMetadata, Date expiryDate)  // TODO handle expiryDates
			throws MatchEngineException
	{
		List<String> results = new ArrayList<String>();
		
		if (publicationMetadata.getContent() instanceof MetadataObject)
		{
			MetadataObject metadata = (MetadataObject) publicationMetadata.getContent();
			
			for (String coReST : metadata.getCorests())
			{
				List<String> coRestResults = new ArrayList<String>();
				
				try // TODO manage the exception here ?
				{
					repositoryManager.storePublication(coReST, PVDI_Id, metadata);
					coRestResults = repositoryManager.matchPubToSubsWith(coReST, metadata);
				} 
				catch (CorruptIndexException e)
				{
					e.printStackTrace(); // TODO make MatchTE exceptions
				} 
				catch (LockObtainFailedException e)
				{
					e.printStackTrace();
				} 
				catch (IOException e)
				{
					e.printStackTrace();
				}
				
				results.addAll(coRestResults);
			}
		}
		
		return results;
	}

	public boolean revokePublication(String PVDI_Id)
			throws MatchEngineException
	{
		return false;
	}

}
