package eu.convergence.middleware.matchTE;

import eu.convergence.middleware.matchTE.RepositoryManager;
import java.io.File;
import java.util.HashSet;
import java.util.Set;

public class RepositoryCleaner
{
	private Set<File> files;
	private Set<File> dirs;

	public RepositoryCleaner()
	{
		files = new HashSet<File>();
		dirs = new HashSet<File>();
	}
	
	public void cleanAll()
	{
		File repositoryDir = new File(RepositoryManager.MATCH_TE_DIR);

		addFilesOfDir(repositoryDir);

		for (File file : files)
		{
//			System.out.println("FILE: " + file.getName());
			file.delete();
		}

		while (!dirs.isEmpty())
		{
			for (File file : dirs)
			{
//				System.out.println("DIR: " + file.getName());
				if (file.delete())
				{
					dirs.remove(file);
					break;
				}
			}
		}
		
		System.out.println("Clean successful !!!");
	}

	public void cleanFolder(String coRest)
	{
		File repositoryDir = new File(RepositoryManager.MATCH_TE_DIR + File.separator + coRest);

		if (repositoryDir.exists())
		{
			dirs.add(repositoryDir);
			addFilesOfDir(repositoryDir);
	
			for (File file : files)
			{
//				System.out.println("FILE: " + file.getName());
				file.delete();
			}
	
			while (!dirs.isEmpty())
			{
				for (File file : dirs)
				{
//					System.out.println("DIR: " + file.getName());
					if (file.delete())
					{
						dirs.remove(file);
						break;
					}
				}
			}
		}
		
		System.out.println("Clean successful !!!");
	}
	
	private void addFilesOfDir(File file)
	{
		if (file != null && file.exists())
		{
			for (File innerFile : file.listFiles())
			{
				if (innerFile.isDirectory())
				{
					dirs.add(innerFile);
					addFilesOfDir(innerFile);
				} 
				else
				{
					files.add(innerFile);
				}
			}

		}
	}
	
	public static void main(String[] args)
	{
		new RepositoryCleaner().cleanAll();
	}

}