package eu.convergence.middleware.matchTE;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.apache.lucene.index.CorruptIndexException;
import org.apache.lucene.store.LockObtainFailedException;

import org.iso.mpeg.mxm.core.MXMObject;
import eu.convergence.middleware.engine.matchTE.exception.MatchEngineException;
import eu.convergence.middleware.matchTE.query.FieldValueQuery;
import eu.convergence.middleware.matchTE.query.QueryObject;


public class SubscriptionManager implements  eu.convergence.middleware.engine.matchTE.SubscriptionManager
{
	private RepositoryManager repositoryManager;
	
	
	public SubscriptionManager(RepositoryManager repositoryManager)
	{
		this.repositoryManager = repositoryManager;
	}
	
	public List<String> matchPubsWith(String SVDI_Id, MXMObject subscriptionQuery, Date expiryDate) // TODO manage expiryDates
			throws MatchEngineException
	{
		List<String> results = new ArrayList<String>();
		
		if (subscriptionQuery.getContent() instanceof QueryObject)
		{
			QueryObject query = (QueryObject) subscriptionQuery.getContent();
			
			for (String coReST : query.getCorests())
			{
				List<String> coRestResults = new ArrayList<String>();
				
				try // TODO manage the exception here ?
				{
					repositoryManager.storeSubscription(coReST, SVDI_Id, query);
					coRestResults = repositoryManager.matchSubToPubsWith(coReST, query);
				} 
				catch (CorruptIndexException e)
				{
					e.printStackTrace(); // TODO make MatchTE exceptions
				} 
				catch (LockObtainFailedException e)
				{
					e.printStackTrace();
				} 
				catch (IOException e)
				{
					e.printStackTrace();
				}
				
				results.addAll(coRestResults);
			}
		}
		
		return results;
	}

	public boolean revokeSubscription(String SVDI_Id)
			throws MatchEngineException
	{
		return false;
	}

}
