package eu.convergence.middleware.metadataTE;

import org.iso.mpeg.mxm.tEngine.digitalitemTE.DIEngine;

import eu.convergence.middleware.engine.metadataTE.ConvergenceMetadataEngineSchemaHandler;
import eu.convergence.middleware.engine.metadataTE.schemahandler.ConvergenceMetadata;
import eu.convergence.middleware.engine.metadataTE.schemahandler.Dimension;
import eu.convergence.middleware.engine.metadataTE.schemahandler.PublicationMetadata;
import eu.convergence.middleware.engine.metadataTE.schemahandler.ResourceMetadata;
import eu.convergence.middleware.engine.metadataTE.schemahandler.SubscriptionMetadata;
import eu.convergence.middleware.engine.mpqfTE.MpqfEngine;

public class ConvergenceMetadataSchemaHandler implements ConvergenceMetadataEngineSchemaHandler
{
	private DIEngine diEngine;
	private MpqfEngine mpqfEngine;
	
	public ConvergenceMetadataSchemaHandler(DIEngine diEngine, MpqfEngine mpqfEngine)
	{
		this.diEngine = diEngine;
		this.mpqfEngine = mpqfEngine;
	}
	
	@Override
	public ConvergenceMetadata getConvergenceMetadata()
	{
		return new eu.convergence.middleware.metadataTE.schemahandler.ConvergenceMetadata(diEngine, mpqfEngine);
	}

	@Override
	public ResourceMetadata getResourceMetadata()
	{
		return new eu.convergence.middleware.metadataTE.schemahandler.ResourceMetadata(diEngine);
	}

	@Override
	public PublicationMetadata getPublicationMetadata()
	{
		return new eu.convergence.middleware.metadataTE.schemahandler.PublicationMetadata(diEngine);
	}

	@Override
	public SubscriptionMetadata getSubscriptionMetadata()
	{
		return new eu.convergence.middleware.metadataTE.schemahandler.SubscriptionMetadata(mpqfEngine);
	}

	@Override
	public Dimension getDimension()
	{
		return new eu.convergence.middleware.metadataTE.schemahandler.Dimension();
	}

}
