/**
 * 
 */
package eu.convergence.middleware.metadataTE;

import java.util.List;

import org.iso.mpeg.mxm.core.MXMAbstractEngine;
import org.iso.mpeg.mxm.core.MXMEngine;
import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.DIEngine;

import eu.convergence.middleware.core.ConvergenceEngineName;
import eu.convergence.middleware.engine.metadataTE.ConvergenceMetadataEngine;
import eu.convergence.middleware.engine.metadataTE.ConvergenceMetadataEngineSchemaHandler;
import eu.convergence.middleware.engine.metadataTE.ConvergenceMetadataEngineTechnologyHandler;
import eu.convergence.middleware.engine.mpqfTE.MpqfEngine;

public class ConvergenceMetadataTE extends MXMAbstractEngine implements ConvergenceMetadataEngine
{
	private MpqfEngine mpqfEngine;
	private DIEngine diEngine;
	
	@Override
	public String getEngineName()
	{
		return ConvergenceEngineName.ConvergenceMetadataTE.toString();
	}
	
	@Override
	public ConvergenceMetadataEngineSchemaHandler getConvergenceMetadataSchemaHandler()
	{
		return new ConvergenceMetadataSchemaHandler(diEngine,mpqfEngine);
	}
	
	@Override
	public ConvergenceMetadataEngineTechnologyHandler getConvergenceMetadataTechnologyHandler()
	{
		return new ConvergenceMetadataTechnologyHandler(diEngine,mpqfEngine);
	}
	
	@Override
	public void setDependencies(List<MXMEngine> engines)
			throws MXMEngineException
	{
		if (engines != null)
		{
			for (MXMEngine engine : engines)
			{
				String engineName = engine.getEngineName();
				
				// Technology Engines
				if (engineName.equals(MXMEngineName.DigitalItemTE.value()))
				{
					this.diEngine = (DIEngine)engine;
				}
				else if (engineName.equals(ConvergenceEngineName.MpqfTE.value()))
				{
					this.mpqfEngine = (MpqfEngine)engine;
				}
			}
		}
	}

}
