package eu.convergence.middleware.metadataTE;

import javax.xml.bind.JAXBElement;

import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.DIEngine;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl_msx.StructuredData;
import org.iso.mpeg.mxm.tEngine.metadataTE.exceptions.MetadataParsingException;
import org.w3c.dom.Node;

import eu.convergence.middleware.engine.metadataTE.ConvergenceMetadataEngineTechnologyHandler;
import eu.convergence.middleware.engine.metadataTE.schema.convmeta.ConvergenceMetadataType;
import eu.convergence.middleware.engine.metadataTE.technologyhandler.MetadataKinds;
import eu.convergence.middleware.engine.metadataTE.technologyhandler.MetadataParser;
import eu.convergence.middleware.engine.mpqfTE.MpqfEngine;
import eu.convergence.middleware.metadataTE.technologyhandler.ConvergenceMetadataParser;
import eu.convergence.middleware.metadataTE.technologyhandler.RdfMetadataParser;

public class ConvergenceMetadataTechnologyHandler implements ConvergenceMetadataEngineTechnologyHandler
{
	private DIEngine diEngine;
	private MpqfEngine mpqfEngine;
	
	
	public 	ConvergenceMetadataTechnologyHandler(DIEngine diEngine, MpqfEngine mpqfEngine)
	{
		this.diEngine = diEngine;
		this.mpqfEngine = mpqfEngine;
	}
	
	public MetadataParser getMetadataParser(StructuredData structuredData) throws MetadataParsingException
	{
		if (structuredData!=null)
		{
			String metadataURI = structuredData.getRef();
			String cname = structuredData.getAny().getClass().getName();

//							System.out.println("------------>"+metadataURI);
//							System.out.println("------------>"+cname);

			if(metadataURI.equals(MetadataKinds.CONVERGENCE.getUri())
					&& structuredData.getAny() instanceof eu.convergence.middleware.engine.metadataTE.schema.convmeta.ConvergenceMetadataType) 
			{
				return new ConvergenceMetadataParser((ConvergenceMetadataType) (structuredData.getAny()), diEngine, mpqfEngine);
			}
			else if(metadataURI.equals(MetadataKinds.CONVERGENCE.getUri()) && structuredData.getAny() instanceof javax.xml.bind.JAXBElement) 
			{
				JAXBElement element = (JAXBElement)structuredData.getAny();

				if (element.getValue() instanceof eu.convergence.middleware.engine.metadataTE.schema.convmeta.ConvergenceMetadataType)
				{
					return new ConvergenceMetadataParser((ConvergenceMetadataType) (element.getValue()), diEngine, mpqfEngine);
				}
			}
			else if (structuredData.getAny() instanceof Node)
			{
				Node node = (Node) structuredData.getAny();
				
				if (node.getNamespaceURI().equals("http://www.w3.org/1999/02/22-rdf-syntax-ns#"))
				{
					return new RdfMetadataParser(node);
				}
			}
		}
		
		//i dont know that schema!!
		throw new MetadataParsingException("Only mpeg7 and convergence schemas are currently supported.");
	}

	@Override
	public eu.convergence.middleware.engine.metadataTE.technologyhandler.RdfMetadataParser getRdfMetadataParser()
	{
		return new RdfMetadataParser();
	}
}
