/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * This software is developed within the CONERGENCE fp7 EU project
 * www.ict-convergence.eu
 * 
 * This software extends the MPEG Multimedia Extensible Middleware (MXM) Project 
 *
 * The initial developer of the MXM Project is CEDEO.net
 * The developer of this extension is the CONVERGENCE Consortium
 * Copyright (C) 2010-2011
 * All Rights Reserved.
 *
 * ***** END LICENSE BLOCK ***** */
package eu.convergence.middleware.metadataTE.technologyhandler;

import org.iso.mpeg.mxm.tEngine.digitalitemTE.DIEngine;

import eu.convergence.middleware.engine.metadataTE.schema.convmeta.ConvergenceMetadataType;
import eu.convergence.middleware.engine.metadataTE.technologyhandler.MetadataKinds;
import eu.convergence.middleware.engine.mpqfTE.MpqfEngine;
import eu.convergence.middleware.metadataTE.schemahandler.ConvergenceMetadata;

public class ConvergenceMetadataParser implements eu.convergence.middleware.engine.metadataTE.technologyhandler.ConvergenceMetadataParser
{
	private ConvergenceMetadata convergenceMetadata = null;
	
	public ConvergenceMetadataParser(ConvergenceMetadataType convergenceMetadataType, DIEngine diEngine, MpqfEngine mpqfEngine)
	{
		convergenceMetadata = new ConvergenceMetadata(convergenceMetadataType, diEngine, mpqfEngine);
	}

	public MetadataKinds getMetadataKind() 
	{
		return MetadataKinds.CONVERGENCE;
	}
	
	public ConvergenceMetadata getConvergenceMetadata() 
	{
		return convergenceMetadata;
	}
	
}
