package eu.convergence.middleware.metadataengine.test;

import java.io.File;
import java.util.Date;

import org.iso.mpeg.mxm.core.MXM;
import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMException;

import eu.convergence.middleware.core.ConvergenceEngineName;
import eu.convergence.middleware.engine.metadataTE.ConvergenceMetadataEngine;
import eu.convergence.middleware.engine.metadataTE.schemahandler.ConvergenceMetadata;
import eu.convergence.middleware.engine.metadataTE.schemahandler.PublicationMetadata;
import junit.framework.TestCase;

public class ConvMetadataTest extends TestCase
{
	public ConvergenceMetadataEngine convMetadataEngine;
	
	public void setUp() throws Exception 
	{
		File f = new File(getClass().getClassLoader().getResource("MXMConfiguration.xml").getFile());
		MXM mxm = MXM.getInstance(f);
		mxm.listEnginesAndProperties();
		
		convMetadataEngine = (ConvergenceMetadataEngine) mxm.getDefaultEngine(ConvergenceEngineName.ConvergenceMetadataTE.name());
	}
	
	
	public void testConvergencePublicationMatadataCreation() throws MXMException
	{
		ConvergenceMetadata convMetadata = convMetadataEngine.getConvergenceMetadataSchemaHandler().getConvergenceMetadata();
		
		convMetadata.setExpiryDate(new Date());
		convMetadata.setSequenceIdentifier("AAAA");
		convMetadata.setStartDate(new Date());
		
		PublicationMetadata pubMetadata = convMetadataEngine.getConvergenceMetadataSchemaHandler().getPublicationMetadata();
		pubMetadata.addFieldValuePair("AEK", new Float("0.333"));
		
		convMetadata.setPublicationMetadata(pubMetadata);
		
		System.out.println(convMetadata.createObject(String.class.getCanonicalName()).getContent());
	}
	
	public void testConvergenceResourceMatadataParsing() throws MXMException
	{
		File f = new File(getClass().getClassLoader().getResource("convResourceMetadata.xml").getFile());
		
		ConvergenceMetadata convMetadata = convMetadataEngine.getConvergenceMetadataSchemaHandler().getConvergenceMetadata();
		convMetadata.parse(new MXMAdapter(f));
		
		System.out.println(convMetadata.createObject(String.class.getCanonicalName()).getContent());
	}
	
	
}
