package eu.convergence.middleware.mpqfTE;

import org.iso.mpeg.mxm.tEngine.searchTE.SearchEngine;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.BooleanExpression;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.InputQuery;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.OR;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.QueryBySPARQL;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.QueryCondition;

import eu.convergence.middleware.engine.mpqfTE.MpqfEngineTechnologyHandler;
import eu.convergence.middleware.engine.mpqfTE.technologyhandler.FieldValueQueryEditor;
import eu.convergence.middleware.engine.mpqfTE.technologyhandler.BooleanExpressionEditor;
import eu.convergence.middleware.engine.mpqfTE.technologyhandler.SparqlQueryEditor;

public class MpqfTechnologyHandler implements MpqfEngineTechnologyHandler
{
	private SearchEngine searchEngine;
	
	public MpqfTechnologyHandler(SearchEngine searchEngine)
	{
		this.searchEngine = searchEngine;
	}
	
	
	@Override
	public BooleanExpressionEditor getBooleanExpressionEditor(BooleanExpression booleanExpression)
	{
		try
		{
			if (booleanExpression instanceof QueryBySPARQL)
			{
				SparqlQueryEditor sparqlEditor = getSparqlQueryEditor();
				sparqlEditor.parse(booleanExpression);

				return sparqlEditor;
			}
			else
			{
				FieldValueQueryEditor fieldValueEditor = getFieldValueQueryEditor();
				fieldValueEditor.parse(booleanExpression);

				return fieldValueEditor;
			}
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
		
		return null;
	}

	@Override
	public SparqlQueryEditor getSparqlQueryEditor()
	{
		return new eu.convergence.middleware.mpqfTE.technologyhandler.SparqlQueryEditor(searchEngine);
	}

	@Override
	public FieldValueQueryEditor getFieldValueQueryEditor()
	{
		return new eu.convergence.middleware.mpqfTE.technologyhandler.FieldValueQueryEditor(searchEngine);
	}

}
