package eu.convergence.middleware.orchestratorTE.build;

import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Signature;
import org.w3c.dom.Document;

public class SecurityEngineOrchestrator
{
	private static SecurityEngineOrchestrator SECURITY_ORCHESTRATOR;
	
	private SecurityEngine securityEngine;
	
	public static SecurityEngineOrchestrator getInstance(SecurityEngine securityEngine)
	{
		if (SECURITY_ORCHESTRATOR==null)
		{
			SECURITY_ORCHESTRATOR = new SecurityEngineOrchestrator(securityEngine);
		}
		
		return SECURITY_ORCHESTRATOR;
	}
	
	private SecurityEngineOrchestrator(SecurityEngine securityEngine)
	{
		this.securityEngine = securityEngine;
	}
	
	public void bootSecurityEngine(String applicationAlias,String confPin,String authPin,String sigPin,String gakpPin)
	{
		this.securityEngine.setProperty("appAlias", applicationAlias);
		this.securityEngine.setProperty("conf", confPin);
        this.securityEngine.setProperty("auth", authPin);
        this.securityEngine.setProperty("sig", sigPin);
        this.securityEngine.setProperty("gakp", gakpPin);
	}
	
	public Signature generateSignature(Document doc)
	{
		// TODO
		return null;
	}
}
