package eu.convergence.middleware.orchestratorTE.schedule.task;

import org.iso.mpeg.mxm.core.MXM;
import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.MXMObject;
import eu.convergence.middleware.engine.overlayTE.MessageKeeper;
import eu.convergence.middleware.orchestratorTE.ConvergenceOrchestratorTE;
import eu.convergence.middleware.orchestratorTE.build.OverlayEngineOrchestrator;
import eu.convergence.middleware.overlayTE.kernel.conet.OverlayTE;

import java.util.List;
import java.util.TimerTask;

/**
 * Created by IntelliJ IDEA.
 * User: aca
 * Date: 7/26/11
 * Time: 1:34 PM
 */
public class GossipTask extends TimerTask
{
    @Override
    public void run()
    {
        OverlayTE overlayTE = new OverlayTE();
//        overlayTE.configureCoNet();
        MessageKeeper messageKeeper = overlayTE.getMessageKeeper();
        try {
            List<MXMObject> readyBufferedPublicationMessages = messageKeeper.getBufferedReadyPublicationMessages();
            List<MXMObject> readyBufferedSubscriptionMessages = messageKeeper.getBufferedReadySubscriptionMessages();
            List<MXMObject> readyBufferedRevocationMessages = messageKeeper.getBufferedReadyRevocationMessages();
            List<MXMObject> readyBufferedRegistrationMessages = messageKeeper.getBufferedReadyRegistrationMessages();

            ConvergenceOrchestratorTE orchestrator = (ConvergenceOrchestratorTE) MXM.getInstance().getDefaultEngine(MXMEngineName.Orchestrator.toString());
            
            OverlayEngineOrchestrator overlayEngineOrchestrator = orchestrator.getOverlayOrchestrator();

            for (MXMObject message : readyBufferedPublicationMessages)
            {
                overlayEngineOrchestrator.gossipMessage(message);
            }

            messageKeeper.removeReadyPublicationMessages();

            for (MXMObject message : readyBufferedSubscriptionMessages)
            {
                overlayEngineOrchestrator.gossipMessage(message);
            }

            messageKeeper.removeReadySubscriptionMessages();

            for (MXMObject message : readyBufferedRegistrationMessages)
            {
                overlayEngineOrchestrator.gossipMessage(message);
            }

            messageKeeper.removeReadyRegistrationMessages();
            
            for (MXMObject message : readyBufferedRevocationMessages)
            {
                overlayEngineOrchestrator.gossipMessage(message);
            }

            messageKeeper.removeReadyRevocationMessages();

        } catch (Exception e) {
            e.printStackTrace();
        }

    }
}
