package eu.convergence.middleware.engine.ConetTe;

import eu.convergence.middleware.engine.ConetTe.exception.ConetIOException;
import eu.convergence.middleware.engine.ConetTe.services.LID;
import eu.convergence.middleware.engine.ConetTe.services.NID;
import eu.convergence.middleware.engine.ConetTe.services.SAPListener;

import java.util.HashMap;
import java.util.Map;

/**
 * <p/>
 * User: <a href="mailto:bogdan.ardeleanu@uti.ro"> Bogdan Ardeleanu</a>
 * Date: 8/31/11
 * Time: 4:22 PM
 * <p/>
 * UTI Systems, TIC
 */
public class DummyConeTE extends eu.convergence.middleware.conetTe.ConetTE {
    private static final Map<String, SAPListener> mapping = new HashMap<String, SAPListener>();

    private static eu.convergence.middleware.conetTe.ConetTE INSTANCE = null;

    private DummyConeTE() {

    }

    public static eu.convergence.middleware.conetTe.ConetTE getInstance() {
        if (null == INSTANCE) {
            INSTANCE = new DummyConeTE();
        }

        return INSTANCE;
    }

    @Override
    public int storeAndAdvertise(NID nid, int rType, String fileName) {
        return storeAndAdvertise(nid, rType, fileName, null);
    }

    @Override
    public int storeAndAdvertise(NID nid, int rType, String fileName, NID hostingNid) {
        throw new UnsupportedOperationException("Method not implemented!");
    }

    @Override
    public int revoke(NID nid, int rType) {
        return revoke(nid, rType, null);
    }

    @Override
    public int revoke(NID nid, int rType, NID hostingNid) {
        throw new UnsupportedOperationException("Method not implemented!");
    }

    @Override
    public int get(NID nid, String localFileName) throws ConetIOException {
        throw new UnsupportedOperationException("Method not implemented!");
    }

    @Override
    public int advertiseSap(NID nid, SAPListener callBack) {
        mapping.put(nid.toString(), callBack);
        return 1;
    }

    @Override
    public int advertiseSap(NID nid, SAPListener callBack, int localDeliveryType) {
        return advertiseSap(nid, callBack);
    }

    @Override
    public int sendToName(NID nid, byte[] unNamedData) {
        return sendToName(nid, new String(unNamedData));
    }

    @Override
    public int sendToName(NID nid, String unNamedDataAsString) {
        SAPListener sap = mapping.get(nid.toString());
        if (null != sap) {
            sap.indication(new DummyLID(), unNamedDataAsString);
            return 1;
        } else {
            throw new UnsupportedOperationException("No SAP found for given NID!");
        }
    }

    @Override
    public int sendToLocation(LID lid, byte[] unNamedData) {
        return sendToLocation(lid, new String(unNamedData));
    }

    @Override
    public int sendToLocation(LID lid, String unNamedDataAsString) {
        throw new UnsupportedOperationException("Method not implemented!");
    }

    private static class DummyLID implements LID {

    }
}
