package eu.convergence.middleware.overlayTE.kernel.conet;

import java.util.List;

import org.iso.mpeg.mxm.core.MXMAbstractEngine;
import org.iso.mpeg.mxm.core.MXMEngine;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;

import eu.convergence.middleware.conetTe.ConetTE;
import eu.convergence.middleware.core.ConvergenceEngineName;
import eu.convergence.middleware.engine.overlayTE.OverlayEngine;
import eu.convergence.middleware.overlayTE.message.OverlayMessageCreator;
import eu.convergence.middleware.overlayTE.message.OverlayMessageKeeper;
import eu.convergence.middleware.overlayTE.message.OverlayMessageParser;
import eu.convergence.middleware.overlayTE.message.conet.OverlayPropagationMessageHandler;
import eu.convergence.middleware.overlayTE.registry.OverlayRegistryParser;
import eu.convergence.middleware.overlayTE.registry.conet.OverlayRegistryCreator;

public class OverlayTE extends MXMAbstractEngine implements OverlayEngine 
{		
	private OverlayRegistryParser overlayRegistryParser = null;
	private OverlayRegistryCreator overlayRegistryCreator = null;
	private OverlayMessageCreator overlayMessageCreator = null;
	private OverlayMessageKeeper overlayMessageKeeper = null;
	private OverlayPropagationMessageHandler overlayPropagationMessageHandler = null;
	private OverlayMessageParser overlayMessageParser = null;
	
	public static final String registryFormat = "urn/convergence/registry/";

    private ConetTE advertiser = null;
    private ConetTE sender = null;
	
	public OverlayTE()
	{

    }

    public void configureCoNet(ConetTE advertiser, ConetTE sender)
    {
        this.advertiser = advertiser;
        this.sender = sender;
    }

    public ConetTE getAdvertiser()
    {
        return advertiser;
    }

    public ConetTE getSender()
    {
        return sender;
    }

	@Override
	public OverlayRegistryParser getRegistryParser() 
	{
		if (overlayRegistryParser == null)
		{
			overlayRegistryParser = new OverlayRegistryParser();
		}
		return overlayRegistryParser;
	}

	@Override
	public OverlayRegistryCreator getRegistryCreator() 
	{
		if (overlayRegistryCreator == null)
		{
			overlayRegistryCreator = new OverlayRegistryCreator(this);
		}
		return overlayRegistryCreator;
	}

	@Override
	public OverlayMessageCreator getMessageCreator() 
	{
		if (overlayMessageCreator == null)
		{
			overlayMessageCreator = new OverlayMessageCreator();
		}
		return overlayMessageCreator;
	}

	@Override
	public OverlayMessageKeeper getMessageKeeper() 
	{
		if (overlayMessageKeeper == null)
		{
			overlayMessageKeeper = new OverlayMessageKeeper();
		}
		return overlayMessageKeeper;
	}

	@Override
	public OverlayMessageParser getMessageParser() 
	{
		if (overlayMessageParser == null)
		{
			overlayMessageParser = new OverlayMessageParser();
		}
		return overlayMessageParser;
	}

	@Override
	public OverlayPropagationMessageHandler getPropagationMessageHandler() 
	{
		if (overlayPropagationMessageHandler == null)
		{
			overlayPropagationMessageHandler = new OverlayPropagationMessageHandler();
		}
		return overlayPropagationMessageHandler;
	}

	@Override
	public String getEngineName() {
		return ConvergenceEngineName.OverlayTE.value();
	}

	@Override
	public void setDependencies(List<MXMEngine> engines)
			throws MXMEngineException
	{
		// TODO Auto-generated method stub
		
	}


}
