package eu.convergence.middleware.overlayTE.message;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMObject;
import eu.convergence.middleware.engine.overlayTE.MessageCreator;
import eu.convergence.middleware.overlayTE.schema.gorestMessage.GorestMessageType;
import eu.convergence.middleware.overlayTE.schema.gorestMessage.HeaderType;
import eu.convergence.middleware.overlayTE.schema.gorestMessage.PayloadType;

public class OverlayMessageCreator implements MessageCreator
{
	@Override
	public MXMObject createMessage(MXMObject header, MXMObject payload) 
	{
		GorestMessageType gorestMessage = new GorestMessageType();
		gorestMessage.setHeader((HeaderType)header.getContent());
		gorestMessage.setPayload((PayloadType)payload.getContent());
		
		return new MXMAdapter(gorestMessage);
	}

	@Override
	public MXMObject addHeader(MXMObject message, MXMObject header) 
	{
		GorestMessageType gorestMessage = (GorestMessageType)message;
		gorestMessage.setHeader((HeaderType)header);
		
		return new MXMAdapter(gorestMessage);
	}

	@Override
	public MXMObject addPayload(MXMObject message, MXMObject payload) 
	{
		GorestMessageType gorestMessage = (GorestMessageType)message;
		gorestMessage.setPayload((PayloadType)payload);
		
		return new MXMAdapter(gorestMessage);
	}
}
