package eu.convergence.middleware.overlayTE.message.conet;

import eu.convergence.middleware.conetTe.ConetTE;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMObject;
import eu.convergence.middleware.engine.ConetTe.services.NID;
import eu.convergence.middleware.engine.overlayTE.PropagationMessageHandler;
import eu.convergence.middleware.engine.overlayTE.exceptions.OverlayEngineException;
import eu.convergence.middleware.overlayTE.OverlayManager;
import eu.convergence.middleware.overlayTE.schema.gorestMessage.GorestMessageType;
import eu.convergence.middleware.overlayTE.schema.gorestMessage.ObjectFactory;
import eu.convergence.middleware.overlayTE.service.conet.OverlayService;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import java.io.StringWriter;

public class OverlayPropagationMessageHandler implements PropagationMessageHandler 
{
	private int port = 65001;
    private ConetTE advertiser;
    private ConetTE sender;
	
//	public OverlayPropagationMessageHandler(ConetTE advertiser, ConetTE sender)
//	{
//        this.advertiser = advertiser;
//        this.sender = sender;
//	}

    public OverlayPropagationMessageHandler()
    {
        advertiser = OverlayManager.getInstance().getAdvertiser();
        sender = OverlayManager.getInstance().getSender();
    }

	@Override
	public synchronized MXMEngineResponse sendPropagationMessage(MXMObject message, String SAP)
			throws OverlayEngineException 
	{
        System.out.println("Sending " + ((GorestMessageType)message.getContent()).getHeader().getOpcode() + " message to " + SAP);
        StringWriter sw = new StringWriter();
        try {
            JAXBContext jc = JAXBContext.newInstance(new Class[]{ObjectFactory.class});
			Marshaller m = jc.createMarshaller();
			m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
            m.marshal(new ObjectFactory().createGorestMessage((GorestMessageType)message.getContent()), sw);
        } catch (JAXBException e) {
            e.printStackTrace();
        }

        if (sender == null)
        {
            System.err.println("[OverlayTE] CoNet sender is NULL");
        }

        String stack = sender.getCcnx();
        if((stack != null) && (stack.compareTo("ccnx") == 0))
        	sender.sendToName(new NID(SAP), sw.toString().getBytes());
        else
        	sender.sendToName(new NID(SAP), sw.toString());

		System.out.println("Sending message to " + SAP + ": SUCCESS");
		return MXMEngineResponse.SUCCESS;
	}

	@Override
	public MXMEngineResponse recvPropagationMessageDaemon()
			throws OverlayEngineException 
	{
        advertiser.advertiseSap(new NID(OverlayManager.getInstance().getOverlaySAP()),
                new OverlayService(), ConetTE.NAMED_DATA_AS_STRING);

		return MXMEngineResponse.SUCCESS;
	}

	@Override
	public MXMEngineResponse consumePropagationMessage(MXMObject message)
			throws OverlayEngineException {
		return null;
	}

}
