package eu.convergence.middleware.overlayTE.message.tcpip;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMObject;
import eu.convergence.middleware.engine.overlayTE.PropagationMessageHandler;
import eu.convergence.middleware.engine.overlayTE.exceptions.OverlayEngineException;
import eu.convergence.middleware.overlayTE.schema.gorestMessage.GorestMessageType;
import eu.convergence.middleware.overlayTE.schema.gorestMessage.ObjectFactory;
import eu.convergence.middleware.overlayTE.service.tcpip.OverlayService;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import java.io.IOException;
import java.io.OutputStream;
import java.net.Socket;
import java.net.UnknownHostException;

public class OverlayPropagationMessageHandler implements PropagationMessageHandler
{
	private int port = 65001;

	public OverlayPropagationMessageHandler()
	{
	}

	@Override
	public synchronized MXMEngineResponse sendPropagationMessage(MXMObject message, String SAP)
			throws OverlayEngineException
	{
		try {
            System.out.println("Sending " + ((GorestMessageType)message.getContent()).getHeader().getOpcode() + " message to " + SAP);
			Socket socket = new Socket(SAP, port);
			OutputStream out = socket.getOutputStream();
			JAXBContext jc = JAXBContext.newInstance(new Class[] {ObjectFactory.class});
			Marshaller m = jc.createMarshaller();
			m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
			m.marshal(new ObjectFactory().createGorestMessage((GorestMessageType)message.getContent()), out);
		} catch (UnknownHostException e) {
			e.printStackTrace();
			return MXMEngineResponse.FAILURE;
		} catch (IOException e) {
			e.printStackTrace();
			return MXMEngineResponse.FAILURE;
		} catch (JAXBException e) {
			e.printStackTrace();
			return MXMEngineResponse.FAILURE;
		}
		System.out.println("Sending message to " + SAP + ": SUCCESS");
		return MXMEngineResponse.SUCCESS;
	}

	@Override
	public MXMEngineResponse recvPropagationMessageDaemon()
			throws OverlayEngineException 
	{
        OverlayService overlayService = new OverlayService(port);
        Thread serviceThread = new Thread(overlayService);
        serviceThread.start();

		return MXMEngineResponse.SUCCESS;
	}

	@Override
	public MXMEngineResponse consumePropagationMessage(MXMObject message)
			throws OverlayEngineException {
		return null;
	}

}
