package eu.convergence.middleware.overlayTE.schema;

import org.iso.mpeg.mxm.core.MXMObject;
import eu.convergence.middleware.overlayTE.OverlayManager;
import eu.convergence.middleware.overlayTE.schema.registry.RegistryType;

import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

public class PeerRegistry 
{
	private RegistryType registryType = null;
	
	public PeerRegistry(RegistryType registryType)
	{
		this.registryType = registryType;
	}
	
	public PeerRegistry(MXMObject registryType)
	{
		this.registryType = (RegistryType)registryType.getContent();
	}
	
	public List<String> getPeerIds()
	{
		return registryType.getPeerIds();
	}
	
	public List<String> getOverlaySAPs()
	{
		return registryType.getOverlaySAPs();
	}
	
	public void setLeaveDate(Date expirationDate)
	{
		try {
			DatatypeFactory df = DatatypeFactory.newInstance();
			GregorianCalendar gc = new GregorianCalendar();
			gc.setTime(OverlayManager.getInstance().getLatestLeaveDate());
			registryType.getLeaveDates().add(df.newXMLGregorianCalendar(gc));
		} catch (DatatypeConfigurationException e) {
			e.printStackTrace();
		}
	}
}
