/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the Chillout Project (http://chillout.dmpf.org)
 *
 * The Initial Developer of the Original Code is Joint Digital Lab (China)
 * Portions created by the Initial Developer are Copyright (C) 2006-2008
 * All Rights Reserved.
 *
 * The Initial Developer: Xueqing Liu 
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */


package convergence_pkgcontent.boxes;

/**
 * This class provides user methods to perform operations on various Boxes. 
 * It is a abstract class which implements IBox
 * 
 * @author Xueqing Liu
 *	
 */
public abstract class Box implements IBox
{
	/**
	 * Specifies the box size in bytes
	 */
	public int size;
	
	/**
     * Specifies the Box's large size in byte array which arranged with big endian.
     */
    public int largeSize;
    
    /**
     * Specifies the user type.
     */
    public String userType = "dmpf" ;

    /**
     * Specifies the Box's size in int type
     */
    protected int boxSize;
  
    
    //*************************************************************
    
    /**
     * Caculates the Box's size in bytes.
     */
    public int GetBoxSize()
    {
    	return 0;
    }
    
    /**
     * Put the all data of this box into a byte array
     */
    public int Serialize(byte[] bytes) 
    {
    	return 0;
    }
}

