/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the Chillout Project (http://chillout.dmpf.org)
 *
 * The Initial Developer of the Original Code is Joint Digital Lab (China)
 * Portions created by the Initial Developer are Copyright (C) 2006-2008
 * All Rights Reserved.
 *
 * The Initial Developer: Xueqing Liu 
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */


package convergence_pkgcontent.boxes;

/**
 * This class provides user methods to perform operations on FullBox. 
 * It is extended from Box
 * 
 * @author Xueqing Liu
 *	
 */
public class FullBox extends Box
{
	
  	 /**
	  * Specifies the version.
	  */
	 public byte version=0;
	 
	 /**
	  * Specifies the flags.
	  */
     public byte[] flags = {0,0,0};
     
     //*************************************************************
     
     /**
      * Calculates the box's size in byte
      */
     public int GetBoxSize()
     {
    	 return 0;
     }
     
     /**
      * Set flag data
      */
     public void SetFlag(String flag)
     {
    	 for (int i=0; i<3; i++)
    	 {
    		 flags[i]=(byte)flag.charAt( i);
    	 }
     }

     /**
      * Put all data of this box into a byte array
      */
     public int Serialize(byte[] bytes)
     {
    	 return 0;
     }
     
     /**
      * Get box type
      * @return Box type
      */
     public String GetBoxType()
     {
     	return null;
     }
}

