/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the Chillout Project (http://chillout.dmpf.org)
 *
 * The Initial Developer of the Original Code is Joint Digital Lab (China)
 * Portions created by the Initial Developer are Copyright (C) 2006-2008
 * All Rights Reserved.
 *
 * The Initial Developer: Xueqing Liu 
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */


package convergence_pkgcontent.boxes;

/**
 * A class represents license 
 * @author Xueqing Liu
 *
 */
public class License 
{
    /**
     * Specifies the license ID.
     */
    public String licenseID=null;
       
    /**
     * Specifies the license box which contained in the container.
     */
    public LicenseBox licenseBox;
    
    /**
     * Get license size
     * @return license size 
     */
    public int GetLicenseSize()
    {
    	int boxSize;
    	boxSize = 4 + // licenseID.length()
    	          licenseBox.GetBoxSize();

    	return boxSize;
    }
    
    /**
     * Put all data into a byte array
     * @return license size
     */
    public int Serialize(byte[] bytes)
    {
    	int n=0;
    	
    	//licenseID
		for(int  i=0; i<4; i++)
		{
			bytes[n]=(byte)licenseID.charAt(i);
			n++;
		}
	
		//licenseBox
		byte[] licenseData=new byte[licenseBox.GetBoxSize()];
		licenseBox.Serialize(licenseData);
		for(int j=0; j<licenseBox.GetBoxSize(); j++)
		{
			bytes[n]=licenseData[j];
			n++;
		}
		
		return n;
    }
}
