package convergence_pkgcontent.methods;

import eu.convergence.middleware.vdiTE.VDITE;
import eu.convergence.middleware.vdiTE.creation.DICreator;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.apache.log4j.Logger;

//import org.iso.mpeg.mxm.core.*;
//import org.iso.mpeg.mxm.engine.mpeg21fileengine.exceptions.MPEG21FileCreationException;

import eu.convergence.middleware.core.ConvergenceEngineName;
import eu.convergence.middleware.engine.ConetTe.services.NID;
//import eu.convergence.middleware.core.ConvergenceEngineName;
//import eu.convergence.middleware.core.MXM;
//import eu.convergence.middleware.core.MXMEngineName;
//import eu.convergence.middleware.core.MXMObject;
//import eu.convergence.middleware.core.configuration.MXMConfigurationException;
//import eu.convergence.middleware.core.engine.management.MXMEngineException;
import eu.convergence.middleware.engine.metadataTE.Classification;
import eu.convergence.middleware.engine.metadataTE.MetadataEngine;
import eu.convergence.middleware.engine.metadataTE.Classification.*;

import org.iso.mpeg.mxm.engine.digitalitemTE.DIEngine;
import org.iso.mpeg.mxm.engine.digitalitemTE.DIParser;
import org.iso.mpeg.mxm.engine.digitalitemTE.ItemCreator;
import org.iso.mpeg.mxm.engine.digitalitemTE.ResourceCreator;
import org.iso.mpeg.mxm.engine.digitalitemTE.exceptions.DIDEngineException;


import org.iso.mpeg.mxm.core.MXM;
import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMEngine;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;



//VDI TE
//import eu.convergence.middleware.overlayTE.OverlayManager;
/*
import eu.convergence.middleware.vdiTE.VDITE;
import eu.convergence.middleware.vdiTE.creation.DICreator;
import eu.convergence.middleware.vdiTE.creation.ItemCreator;
import eu.convergence.middleware.vdiTE.creation.ResourceCreator;
import eu.convergence.middleware.vdiTE.schema.DIDL;
*/




public class pkgcontent 
{
	/**
	 * DCF is a locgical container who will hold various boxes.
	 * The DCFMaker will create out a dmp content file from this DCF.
	 */
	//public DCF dcf = null;
	//private ArrayList<MediaDataInfo> mediaDataInfos=new ArrayList<MediaDataInfo>();
	//private XMLBox xmlBox=new XMLBox();
//	private BXMLBox bxmlBox=new BXMLBox();
	private Logger logger = Logger.getLogger(pkgcontent.class);
	private final String TEMP_FOLDER = System.getProperty("java.io.tmpdir") + File.separator;
	private final String OUTPUT_DCI_FILE_NAME = TEMP_FOLDER + "mytestDCI.xml";
	
		
    public static void main( String[] args )
    {
        System.out.println( "Hello World!" );
    }
    
    /**
	 * <HL>
	 * Package a digital item for distribution
	 * @param did The Digital Item
	 * @throws FileNotFoundException
	 * @throws MXMException 
	 */
	public boolean packageContentProcess(String did) throws MXMException, FileNotFoundException {
		
		System.out.println("PG1 - Executing packageContentProcess.");
		
		
		//1. Extract digital item content
		File f = new File(getClass().getClassLoader().getResource("MXMConfiguration.xml").getFile());
		MXM mxm = MXM.getInstance(f);
		mxm.listEnginesAndProperties();
		
		MXMEngine didEngine = mxm.getDefaultEngine(MXMEngineName.DigitalItemTE.toString());
		logger.info("Content ID: " + didEngine.getContent().toString());
		
		
		
		//2. Get the PackageFormatType
		System.out.println("PG2 - Getting the package format type.");
		
		DocumentBuilderFactory factory=javax.xml.parsers.DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;
		Document node = null;
		
		System.out.println("Assignment of the DID file.");
		try {
			builder = factory.newDocumentBuilder();
			org.w3c.dom.Document doc=builder.parse(new FileInputStream(did) );
			node=doc;  // A Document is a node
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		System.out.println("Calling the getFormatType() method.");
		String fmtType = getFormatType (node); 
		
		
		//3. Package the item in a Stream or file
		try {
		if (fmtType == "STREAM")
			storeInStream(did);
		else if (fmtType == "FILE")
			storeInFile(did);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
				
		return true;
	}
	
	
	
	/**
	 * <HL>
	 * Extracts the encoded format type
	 * @param node is the document of the DID
	 */
	public String getFormatType(Document node) {
		NodeList list=node.getElementsByTagName("PackageFormatType");
		Node firstChild = list.item(0);
		System.out.println("Node Content: "+firstChild.getTextContent() );
		for(int i=1;i<list.getLength();++i)
		{
			Node child=list.item(i);  // a child node is still a node!!
			System.out.println("Node Content: "+child.getTextContent() );
		}
		return firstChild.getTextContent();
	}
	
	
	/**
	 * <HL>
	 * Revokes a VDI from CoNet
	 * @param nid The NID has the form principal/label
	 * @throws FileNotFoundException
	 * @throws MXMException 
	 */
	public boolean storeInStream (String did) {
		System.out.println("PA1 - Executing the storeInStream() method.");
		
		//Still not implemented
		
		return true;
	}
	
	
	/**
	 * <HL>
	 * Revokes a VDI from CoNet
	 * @param nid The NID has the form principal/label
	 */
	public boolean storeInFile (String did) throws IOException{
		System.out.println("PA1 - Executing the storeInFile) method.");
		
		File f;
		f = new File (did);
		if (!f.exists())
		{
			f.createNewFile();
			System.out.println("New file \"myfile.txt\" has been created to the current directory");
		}
		
		return true;
	}
    
        
}	
	