/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the Chillout Project (http://chillout.dmpf.org)
 *
 * The Initial Developer of the Original Code is CEDEO.net
 * Portions created by the Initial Developer are Copyright (C) 2006-2009
 * All Rights Reserved.
 *
 * The Initial Developer: Filippo Chiariglione 
 * Contributor(s): Edoardo Radica
 *
 * ***** END LICENSE BLOCK ***** */

package eu.convergence.middleware.relTE;

import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.engine.relTE.ORCLicenseName;
import org.iso.mpeg.mxm.engine.relTE.exception.RELEngineException;
import eu.convergence.middleware.relTE.authorisation.AuthorisationManager;
import org.iso.mpeg.mxm.engine.relTE.schema.AllConditions;
import org.iso.mpeg.mxm.engine.relTE.schema.DiReference;
import org.iso.mpeg.mxm.engine.relTE.schema.DigitalResource;
import org.iso.mpeg.mxm.engine.relTE.schema.ForAll;
import org.iso.mpeg.mxm.engine.relTE.schema.Grant;
import org.iso.mpeg.mxm.engine.relTE.schema.GrantGroup;
import org.iso.mpeg.mxm.engine.relTE.schema.IdentityHolder;
import org.iso.mpeg.mxm.engine.relTE.schema.Inventory;
import org.iso.mpeg.mxm.engine.relTE.schema.Issuer;
import org.iso.mpeg.mxm.engine.relTE.schema.KeyHolder;
import org.iso.mpeg.mxm.engine.relTE.schema.License;
import org.iso.mpeg.mxm.engine.relTE.schema.ORCLicense;
import org.iso.mpeg.mxm.engine.relTE.schema.PropertyPossessor;
import org.iso.mpeg.mxm.engine.relTE.schema.ProtectedResource;
import org.iso.mpeg.mxm.engine.relTE.schema.ServiceReference;

// TODO: Auto-generated Javadoc
/**
 * The Class RELEngine.
 */
public class RELEngineTE extends org.iso.mpeg.mxm.relTE.RELEngine {

	/* (non-Javadoc)
	 * @see org.iso.mpeg.mxm.core.MXMEngine#getEngineName()
	 */
	public String getEngineName() {
		return MXMEngineName.RELTE.toString();
	}

	/* (non-Javadoc)
	 * @see org.iso.mpeg.mxm.engine.relTE.RELEngine#getAuthorisationManager()
	 */
	public AuthorisationManager getAuthorisationManager() {
		return new AuthorisationManager();
	}




	
}
