/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the Chillout Project (http://chillout.dmpf.org)
 *
 * The Initial Developer of the Original Code is CEDEO.net
 * Portions created by the Initial Developer are Copyright (C) 2006-2008
 * All Rights Reserved.
 *
 * The Initial Developer: Filippo Chiariglione 
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */


package eu.convergence.middleware.relTE.authorisation;

import javax.xml.bind.JAXBElement;

import org.iso.mpeg.mxm.engine.relTE.schema.relr.Condition;


public class EvaluatedCondition {

	private ConditionResultType conditionType = ConditionResultType.UNDETERMINED;

	private JAXBElement<? extends Condition> condition = null;
	
	private String displayString = null;

	//Constructor
	public EvaluatedCondition(JAXBElement<? extends Condition> condition) {
		this.condition = condition;
	}
	
	public JAXBElement<? extends Condition> getCondition() {
		return condition;
	}

	public ConditionResultType getConditionType() {
		return conditionType;
	}

	public void setConditionType(ConditionResultType conditionType) {
		this.conditionType = conditionType;
	}

	public String getDisplayString() {
		return displayString;
	}

	public void setDisplayString(String displayString) {
		this.displayString = displayString;
	}

	
}
