package eu.convergence.middleware.revokePE.methods;

import java.io.*;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.apache.log4j.Logger;

import eu.convergence.middleware.conetTe.ConetTE;

import org.iso.mpeg.mxm.core.MXM;
import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMEngineResponse;

import eu.convergence.middleware.engine.ConetTe.services.NID;
import eu.convergence.middleware.orchestratorTE.ConvergenceOrchestratorTE;
import eu.convergence.middleware.orchestratorTE.build.OverlayEngineOrchestrator;
import eu.convergence.middleware.overlayTE.OverlayManager;
import eu.convergence.middleware.overlayTE.kernel.conet.OverlayTE;
import eu.convergence.middleware.vdiTE.VDITE;
//import eu.convergence.middleware.vdiengine.test.ApplicationSpecificData;
//import eu.convergence.middleware.vdiengine.test.DIDL;
//import eu.convergence.middleware.vdiengine.test.Item;
import eu.convergence.middleware.metadataTE.ConvergenceMetadataTE;
import eu.convergence.middleware.revokePE.utils.HandleRevocationVDI;

import org.iso.mpeg.mxm.tEngine.digitalitemTE.DIEngine;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.ApplicationSpecificData;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.DIDL;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Item;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 * <HL>
 * This class implements methods to unpublish contents from Comid.
 */
public class unpublishFromComid
{
	/**
	 * DCF is a locgical container who will hold various boxes.
	 * The DCFMaker will create out a dmp content file from this DCF.
	 */
	//public DCF dcf = null;
	private ConetTE conetTE;
	private VDITE didEngine;
	
	private NID nidObj;
	private String localFileName;
	private String fileName;
	
	private final String COPYRIGHT = "\u00a9";
	
	private OverlayTE overlayEngine;
	private OverlayManager overlayManager;
    private ConetTE advertiser;
    private ConetTE sender;
    
    private static OverlayEngineOrchestrator OVERLAY_ENGINE_ORCHESTRATOR = null;
	
	
	//private ArrayList<MediaDataInfo> mediaDataInfos=new ArrayList<MediaDataInfo>();
	//private XMLBox xmlBox=new XMLBox();
    //	private BXMLBox bxmlBox=new BXMLBox();
	/*
	private Logger logger = Logger.getLogger(unpublishFromComid.class);
	private final String TEMP_FOLDER = System.getProperty("java.io.tmpdir");
	private final String OUTPUT_DCI_FILE_NAME = TEMP_FOLDER + "testDCI.xml";
	private final String OUTPUT_MXM_FILE_NAME = TEMP_FOLDER + "MXMConfiguration.xml";
	*/
	
	private Logger logger = Logger.getLogger(unpublishFromComid.class);
	
	private final String TEMP_FOLDER = System.getProperty("java.io.tmpdir") + File.separator;
	private final String OUTPUT_DCI_FILE_NAME = TEMP_FOLDER + "mytestDCI.xml";

	private final String OUTPUT_CONTENT_MPEG7_FILE_NAME = TEMP_FOLDER + "mpeg7.xml";
	private final String OUTPUT_CONTENT_PROTECTED_ASSET_FILE_NAME = TEMP_FOLDER + "contentProtectedAsset.xml";

	private final String SOURCE_DCI_FILE_NAME = "testDCI.xml";
	private final String SOURCE_DCI_FILE_NAME_WITH_RELATIONSHIPS = "testDCIwithrelationships.xml";

	private final String  SOURCE_DCI_FILE_NAME_WITH_REL = "testDCIwithREL.xml";
	private final String  SOURCE_DCI_FILE_NAME_WITH_MULTIPLE_IIS = "testDCIwithmultipleinneritems.xml";
	private final String OUTPUT_DCI_FILE_NAME_WITH_LIC = TEMP_FOLDER + "di_with_lic.xml";
	
    
	//Set up the needed objects
	public void setUp() throws Exception {
		
		nidObj = new NID("nidObject");
		
		fileName = "fileName";
		
		localFileName = "localFileName";
		
	}
	
		
	/*	
	public unpublishFromComid() 
	{
		this.dcf = new DCF();
	}
	*/
	
	
	/** Main method for test purposes */
    public static void main( String[] args )
    {
        System.out.println( "Hello World!" );
    }
    
        
    	
    /**
	 * <HL>
	 * Revokes a VDI with vdiId from CoMid
	 * @param vdiID ID of the VDI
	 * @throws FileNotFoundException
	 * @throws MXMException 
	 */
	public boolean unpublishFromComid(String vdiID) throws MXMException, FileNotFoundException {
		
		System.out.println("Executing revokeFromComidProcess.");
		
		DocumentBuilderFactory factory=javax.xml.parsers.DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;
		Document node = null;
		
		
		File f = new File(getClass().getClassLoader().getResource("MXMConfiguration.xml").getFile());
		System.out.println("BCG1");
		MXM mxm = MXM.getInstance(f);
		System.out.println("BCG2");
		mxm.listEnginesAndProperties();
		
		System.out.println("PG1 - Creation of a DIDL.");
		
		didEngine = (VDITE)mxm.getDefaultEngine(MXMEngineName.DigitalItemTE.toString());
			
		//MetadataEngine metadataEngine = (MetadataEngine)mxm.getDefaultEngine(MXMEngineName.MetadataTE.toString());
		 
		//call metadata creation
		//System.out.println("PG2 - Call the metadata creation.");
//		org.iso.mpeg.mxm.engine.metadataTE.schema.Mpeg7 mp7=createMetadata(metadataEngine);
//		
//		//Creating the Resource element for the video resource
//		
//		System.out.println("PG3 - Creating the Resource element for the video resource.");
//		ResourceCreator resourceCreator1 = didEngine.getResourceCreator();
//		System.out.println("PG3B - Creating the Resource element for the video resource.");
//		MXMObject resource = resourceCreator1.createResource("video/mpeg", "http://myVideoServer.com/videos/video1.mpg");
//		MXMObject resource2 = resourceCreator1.createResource("video/mpeg", "http://myVideoServer.com/videos/video2.mpg");
//		
//		
//		// Creating the Item elements containing the resources
//		System.out.println("PG4 - Creating the Item elements containing the resources.");
//		ItemCreator innerItem = didEngine.getItemCreator();
//		innerItem.setResource(resource);
//		innerItem.setIdentifier("urn:contentElements:012345");
//		
//		ItemCreator innerItem2 = didEngine.getItemCreator();
//		innerItem2.setResource(resource2);
//		innerItem2.setIdentifier("urn:contentElements:678901");
//		
//		List<ItemCreator> innerItems = new ArrayList<ItemCreator>();
//		innerItems.add(innerItem);
//		innerItems.add(innerItem2);
//
//		
//		// Creating the top-level Item element
//		System.out.println("PG5 - Creating the top-level Item element.");
//		ItemCreator topLevelItem = didEngine.getItemCreator();
//		topLevelItem.setIdentifier("urn:contentItems:98765");
//
//		//for testing, here we simply add an 
//		List<JAXBElement<?>> objs = new ArrayList<JAXBElement<?>>();
//		eu.convergence.middleware.relationships.schema.convRelation.ObjectFactory fact= new eu.convergence.middleware.relationships.schema.convRelation.ObjectFactory();
//        objs.add(fact.createRelationship(fact.createRelationship("ontologyURI","subjectID","RelationshipType","objectID")));
//        
//		
//        List<MXMObject> mxm_o= new ArrayList<MXMObject>();
//		for (JAXBElement<?> j:objs){
//			mxm_o.add(new MXMAdapter(j));
//		}
//		
//		topLevelItem.setCustomObjects(mxm_o);
//		
//		MXMObject mp7level0=mp7.createObject( org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.Mpeg7.class.getCanonicalName());
//		topLevelItem.setMetadata(mp7level0, "urn:mpeg:mpeg7:schema:2004");
//		
//		//ERR stuff
//		EventReportEngine erEngine = (EventReportEngine) mxm.getDefaultEngine(MXMEngineName.EventReportTE.toString());
//		
//		ERRCreator err=erEngine.getEventReportRequestCreator();
//		
//		err.addEventTriggerType(EventTriggerType.MATCH);
//		//		err.addSubscriptionVdiId("urn:ppp");
//		err.addSAP("localhost://");
//		
//		topLevelItem.setERR(err.createERR());
//		
//			
//		
		System.out.println("PG6 - Executing getDICreator().");
		DIDL di=didEngine.getDIEngineSchemaHandler().getDIDL();
		org.iso.mpeg.mxm.digitalitemTE.schemahandler.Item toplevelitem=didEngine.getDIEngineSchemaHandler().getItem();
		ApplicationSpecificData asd=didEngine.getDIEngineSchemaHandler().getApplicationSpecificData();

		toplevelitem.setId("unpublished");
//		DICreator dciCreator = didEngine.getDICreator();
//		
//		MXMObject didlObject = dciCreator.createDI(topLevelItem, innerItems);
//		
//		System.out.println("PG7 - Creating a new DIDL object.");
//		DIDL didl=(DIDL)didlObject.getContent();
//		
//		if (didlObject.getContentType().equals(DIDL.class.getCanonicalName())) 	
//		{		
//			didl.generateFile(OUTPUT_DCI_FILE_NAME);
//			
//			logger.info("The DCI file was successfully created in file: " + OUTPUT_DCI_FILE_NAME);
//		}
//		else 
//		{
//			logger.info("The Digital Item was found being of type: " + didlObject.getContentType() + " which is not supported by this engine.");						
//		}
		
		
		
		//Still not implemented
		MXMEngineResponse mxmResp;
		
		
		System.out.println("PG8 - Creating the orchestratorEngine.");
		//ConvergenceOrchestratorTE orchestratorEngine = (ConvergenceOrchestratorTE)mxm.getDefaultEngine(MXMEngineName.OrchestratorTE.toString());
		
		OverlayEngineOrchestrator overlayEngine = (OverlayEngineOrchestrator)mxm.getDefaultEngine(MXMEngineName.OrchestratorTE.toString());
		
				
		System.out.println("PG9 - New instance of EngineOrchestrator.");
		//OverlayEngineOrchestrator.getInstance(overlayEngine, advertiser, sender);
			
//		System.out.println("PG10 - DIDL is: " + didl.toString());
		System.out.println("PG10 - Calling the handleRevocationVDI.");
		
		
		HandleRevocationVDI HRVDI = new HandleRevocationVDI();
		
		
		// Extract fractals
		String fractals[] = new String[10];
				
		System.out.println("PG2A - Assignment of the DID file.");
		try {
			builder = factory.newDocumentBuilder();
			org.w3c.dom.Document doc=builder.parse(new FileInputStream(vdiID) );
			node=doc;  // A Document is a node
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		System.out.println("PG2B - Get fractals content.");
		fractals = getFractals(node);
		
		// Use some test fractals if the information is not available in VDI
		if (fractals[0]=="")
		{
			fractals[0]="teste1";
			fractals[1]="teste2";
		}
		
		
		
		//For local tests
		//MXMEngineResponse test = HRVDI.revokeComidVDI (di, fractals);
		
		MXMEngineResponse test2 = overlayEngine.handleRevocationVDI(di, fractals);
				
		System.out.println("PG11 - Handle RevocationVDI executed.");
		
		return true;
	}
	
	
//	org.iso.mpeg.mxm.engine.metadataTE.schema.Mpeg7 createMetadata(MetadataEngine metadataEngine) throws MetadataEngineException
//	{ 
//		
//		CreationInformation creationInformationCreator = metadataEngine.getCreationInformationCreator();
//		
//		Creation creationCreator = metadataEngine.getCreationCreator();
//	
//		// Create titles
//		Title titleCreator = metadataEngine.getTitleCreator();
////		titleCreator.setLang("en");
//		titleCreator.setValue("The BIG Lebowsky");
//		creationCreator.addTitle(titleCreator);
//
//		Title italianTitle = metadataEngine.getTitleCreator();
////		italianTitle.setLang("it");
//		italianTitle.setValue("Il grande Lebowsky");
//		italianTitle.setType("popular");
//		creationCreator.addTitle(italianTitle);
//
//		// Create a titlemedia
//		TitleMedia titleMediaCreator = metadataEngine.getTitleMediaCreator();
//		ImageLocator imageLocatorCreator = metadataEngine.getImageLocatorCreator();
//		imageLocatorCreator.setMediaUri("uri for thumb");
//		titleMediaCreator.setTitleImage(imageLocatorCreator);
//		creationCreator.setTitleMedia(titleMediaCreator);
//		
//		// Create an abstract
//		TextAnnotation abst = metadataEngine.getTextAnnotationCreator();
//		Textual textualCreator = metadataEngine.getTextualCreator();
////		textualCreator.setLang("en");
//		textualCreator.setValue("Her life was in their hands. Now her toe is in the mail.");
//		abst.addFreeTextAnnotation(textualCreator);
//		creationCreator.addAbstract(abst);
//
//		// Create some creators
//		Creator creator1 = metadataEngine.getCreatorCreator();
//		creator1.setCreatorName("Jeff", "Bridges", CreatorRole.actor.getValue());
//		creationCreator.addCreator(creator1);
//		
//		creator1 = metadataEngine.getCreatorCreator();
//		creator1.setCreatorName("John", "Goodman", CreatorRole.actor.getValue());
//		creationCreator.addCreator(creator1);
//		
//		creator1 = metadataEngine.getCreatorCreator();
//		creator1.setCreatorName("Joel", "Coen", CreatorRole.director.getValue());
//		creationCreator.addCreator(creator1);
//
//		// Create creationCoordinates
////		CreationCoordinates creationCoordinates = metadataEngine.getCreationCoordinatesCreator();
////		Time timeCreator = metadataEngine.getTimeCreator();
////		timeCreator.setTimePoint("1998-05-01T00:00:00");
////		creationCoordinates.setDate(timeCreator);
////
////		Place place = metadataEngine.getPlaceCreator();
////		Textual shootingPlace = metadataEngine.getTextualCreator();
////		shootingPlace.setLang("en");
////		shootingPlace.setValue("Beverly Hills");
////		place.addName(shootingPlace);
////		place.addRegion("US-CA");
////
////		TermUse placeRole = metadataEngine.getTermUseCreator();
////		org.iso.mpeg.mxm.engine.metadataTE.Name roleName = metadataEngine.getNameCreator(true, "real location", "en");
////		placeRole.addName(roleName);
////		place.setRole(placeRole);
////
////		creationCoordinates.setLocation(place);
////		creationCreator.addCreationCoordinates(creationCoordinates);
//
//		// Create a copyrightString
//		Textual copyrightString = metadataEngine.getTextualCreator();
////		copyrightString.setLang("en");
//		copyrightString.setValue(COPYRIGHT + " 1997 PolyGram Filmed Enterteinment Distribution, Inc.");
//		creationCreator.addCopyrightString(copyrightString);
//		
//		creationInformationCreator.setCreation(creationCreator);
//		
//		// Create a Genre
//		Classification classificationCreator = metadataEngine.getClassificationCreator();
//		Genre genre = metadataEngine.getGenreCreator();
//		genre.setHref("urn:mpeg:mpeg7:cs:GenreCS:2001:2.1.2");
//
//		org.iso.mpeg.mxm.engine.metadataTE.Name name1 = metadataEngine.getNameCreator(true, "Comedy", "en");
//		genre.addName(name1);
//
//		org.iso.mpeg.mxm.engine.metadataTE.Name name2 = metadataEngine.getNameCreator(false, "Crime", "en");
//		genre.addName(name2);
//		
//		classificationCreator.addGenre(genre);
//
//		// Create the ParentalGuidance
//		ParentalGuidance parental = metadataEngine.getParentalGuidanceCreator();
//		
//		ControlledTermUse parentalRating = metadataEngine.getControlledTermUseCreator();
//		parentalRating.setHref(MPAAParentalRating.R.getValue());
//		
//		parental.setParentalRating(parentalRating);
//		
//		classificationCreator.addParentalGuidance(parental);
//		
//		creationInformationCreator.setClassification(classificationCreator);
//		
//		VideoSegment videoSegmentCreator = metadataEngine.getVideoSegmentCreator();
//		
//		videoSegmentCreator.setCreationInformation(creationInformationCreator);
//		
//		Video video = metadataEngine.getVideoCreator();
//		
//		video.setVideo(videoSegmentCreator);
//		
//		ContentEntity contentEntityCreator = metadataEngine.getContentEntityCreator();
//		
//		contentEntityCreator.addMultimediaContent(video);
//		
//		contentEntityCreator.addMultimediaContent(video);
//		
//		// Create the Mpeg7 element
//		org.iso.mpeg.mxm.engine.metadataTE.schema.Mpeg7 mpeg7smp = (org.iso.mpeg.mxm.engine.metadataTE.schema.Mpeg7) metadataEngine.getMpeg7smpCreator();
//		mpeg7smp.addCompleteDescription(contentEntityCreator);
//		// Create the Mpeg7 element
//
//		
//		return mpeg7smp;
//	}
	
	/**
	 * <HL>
	 * Extracts the Fractals elements
	 * @param node is the document of the DID
	 */
	public String[] getFractals(Document node) {
		System.out.println("PA1 - Executing getFractals() method.");
		String [] tempFractals = new String[10];
		NodeList list=node.getElementsByTagName("ns21:Fractal");
		Node firstChild = list.item(0);
		System.out.println("PA2 - Identifier is: "+firstChild.getTextContent() );
		tempFractals[0] = firstChild.getTextContent();
		
		for(int i=1;i<list.getLength();++i)
		{
			Node child=list.item(i);  // a child node is still a node!!
			System.out.println("Node Content: "+child.getTextContent() );
			tempFractals[i] = child.getTextContent();
		}
		
		System.out.println("PA3 - Returning the identifier.");	
		return tempFractals;
	}
	
}
	
	
	