package eu.convergence.middleware.revokePE.workflow;

//import org.junit.Before;
import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import java.io.*;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.xml.bind.JAXBException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;


import org.apache.log4j.Logger;

import eu.convergence.middleware.conetTe.ConetTE;
import eu.convergence.middleware.core.ConvergenceEngineName;

import org.iso.mpeg.mxm.core.MXM;
import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMAbstractEngine;
import org.iso.mpeg.mxm.core.configuration.MXMConfigurationException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;

import eu.convergence.middleware.engine.ConetTe.exception.ConetIOException;
import eu.convergence.middleware.engine.ConetTe.services.NID;




//import org.apache.log4j.Logger;



//VDI TE
//import eu.convergence.middleware.overlayTE.OverlayManager;
//import eu.convergence.middleware.tool.vdi.PublicationVdiTool;
//import eu.convergence.middleware.vdiTE.VDIEngineContext;
import eu.convergence.middleware.vdiTE.VDITE;
//import eu.convergence.middleware.vdiTE.schema.DIDL;







public class PrePlannedDigFgt 
{
	/**
	 * DCF is a locgical container who will hold various boxes.
	 * The DCFMaker will create out a dmp content file from this DCF.
	 */
	//public DCF dcf = null;
	private ConetTE conetTE;
	private VDITE didEngine;
	
	private NID nidObj;
	private String localFileName;
	private String fileName;
	
	
	//private ArrayList<MediaDataInfo> mediaDataInfos=new ArrayList<MediaDataInfo>();
	//private XMLBox xmlBox=new XMLBox();
    //	private BXMLBox bxmlBox=new BXMLBox();
	private Logger logger = Logger.getLogger(PrePlannedDigFgt.class);
	private final String TEMP_FOLDER = System.getProperty("java.io.tmpdir");
	private final String OUTPUT_DCI_FILE_NAME = TEMP_FOLDER + "testDCI.xml";
	private final String OUTPUT_MXM_FILE_NAME = TEMP_FOLDER + "MXMConfiguration.xml";
	
	public void setUp() throws Exception {
		
		nidObj = new NID("nidObject");
		
		fileName = "fileName";
		
		localFileName = "localFileName";
		
	}
	
		
	/*	
	public unpublishFromComid() 
	{
		this.dcf = new DCF();
	}
	*/
	
	
    public static void main( String[] args )
    {
        System.out.println( "Hello World!" );
    }
    
        
    	
	/**
	 * <HL>
	 * Implements the workflow of the Pre Planned Digital Forgetting 
	 * @param dciFilePathName Filename of the DCI XML file
	 * @throws FileNotFoundException
	 * @throw MXMException 
	 */
	public void revokeContent(String dciFilePathName) throws MXMException, FileNotFoundException {
		
		System.out.println("Executing revokeContent.");
		logger.info("\n\n---------- Executing revokeContent ----------");
		
		//Read the file
		System.out.println("Path to file: " + OUTPUT_DCI_FILE_NAME);
		
		
		
		//1. Publisher sets the expire date
		java.sql.Date date = java.sql.Date.valueOf( "2011-11-30" );
		System.out.println("1. Date is: " + date.toString());
		try {
			setExpiryDate2(dciFilePathName, date);
		} catch (MXMConfigurationException m1) {
			System.out.println("Unable to create: " + m1.getMessage());}
		  catch (MXMEngineException m2) {
			System.out.println("Unable to create: " + m2.getMessage());}
		  catch (Exception e1) {
				System.out.println("Unable to create: " + e1.getMessage());  	
	    }
		
		   
			
		
		/*  
		//2. Calls the overlayTE to gossip metadata
		String peerId = "peerId";
		String overlaySAP = "overlaySAP";
		private static OverlayManager OVERLAY_MANAGER = null;
		OVERLAY_MANAGER = getInstance(dciFilePathName, peerId, overlaySAP);
		addLeaveDate(data);
		*/
		  
		  
		
		/*//3. Submits the VDI to CONET
		System.out.println("1. Submits the VDI to CONET.");
		//File f = new File(OUTPUT_MXM_FILE_NAME);
		File f = new File(getClass().getClassLoader().getResource("MXMConfiguration.xml").getFile());
		System.out.println("2. Submits the VDI to CONET.");
		
		MXM mxm = MXM.getInstance(f);
		
				
		System.out.println("3. Submits the VDI to CONET.");
		mxm.listEnginesAndProperties();
		
		
		//Creation of a new defEngine
		String defEngineName = ConvergenceEngineName.ConetTE.toString();
		MXMEngineName defEngine;
		defEngine.fromValue(defEngineName);
		mxm.getDefaultEngine(defEngine);
		String defaultEngine = defEngine.value();
		
		
		
		
		
		System.out.println("Creation of a Conet TE.");
		conetTE = (ConetTE) mxm.getDefaultEngine(ConvergenceEngineName.ConetTE.toString());
		
		
		
		
		

		if (conetTE == null) {
		   System.out.println("mxm.getDefaultEngine(MXMEngineName.ConetTE) returned NULL");
		   System.out.println("Closing test");
		}
		
		System.out.println("Creating the NID object.");
		NID nidObj = new NID(dciFilePathName);
		String fileName = getClass().getClassLoader().getResource(dciFilePathName).getFile();
		System.out.println("FileName is: " + fileName);
		int response;
		   
		// Store and Advertise the named-resource fileName with NID = nidClass
		System.out.println("Executing Store and Advertise of named-resource "+fileName+" with NID "+nidObj.toString());
		response = conetTE.storeAndAdvertise(nidObj, ConetTE.NAMED_DATA_RTYPE, fileName, (NID)null);
		   if (response<0) {
			   System.out.println("Store and Advertise failed\n");
		   } else {
			   System.out.println("Store and Advertise succeeded\n");
		   }*/
		   
}		
		 
		

				

	
	
	
	
	public void setExpiryDate(Date date) throws MXMConfigurationException, MXMEngineException, JAXBException {
		logger.info("\n\n---------- setExpiryDate ----------");
		
		/*
		File f = new File(getClass().getClassLoader().getResource("MXMConfiguration.xml").getFile());
		MXM mxm = MXM.getInstance(f);
		mxm.listEnginesAndProperties();
		
		File vdi = new File(getClass().getClassLoader().getResource("newSchemaTestRVDI.xml").getFile());
				
		DIDL didl = new DIDL();
		didl.initContext(VDIEngineContext.getInstance().getJAXBContext());
		didl.parse(vdi);
		
		
		PublicationVdiTool publicationTool = PublicationVdiTool.getInstance();
		publicationTool.setExpiryDate(didl, date);
		
		try
		{
			System.out.println("----------------DIDL---------------");
			System.out.println(didl.createObject(String.class.getCanonicalName()).getContent());
		} 
		catch (MXMException e) 
		{
			e.printStackTrace();
		}
		*/
	}	
	
	
	public void setExpiryDate2(String dciFilePathName, Date date) throws Exception {
		logger.info("\n\n---------- setExpiryDate2 ----------");
		
		System.out.println("PG1 - Executing main fucntion()");
		
		DocumentBuilderFactory factory=javax.xml.parsers.DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;
		Document node = null;
		
		System.out.println("PA - DCIFilePath is: " + dciFilePathName);
		
		System.out.println("PG2 - Assignment of a new XML file.");
		try {
			builder = factory.newDocumentBuilder();
			org.w3c.dom.Document doc=builder.parse(new FileInputStream(dciFilePathName) );
			node=doc;  // A Document is a node
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
			
		
		System.out.println("PG3 - Reaching the nodelist.");
		NodeList list=node.getElementsByTagName("ns29:Date"); 
		for(int i=0;i<list.getLength();++i)
		{
			Node child=list.item(i);  // a child node is still a node!!
			System.out.println("Node Content: "+child.getTextContent() );
			child.setTextContent(date.toString());
			System.out.println("Node Content: "+child.getTextContent() );		
		}
		
		System.out.println("PG4 - End service.");
		
	}
	
}
	
	
	