package eu.convergence.middleware.vdiTE;

import java.io.File;
import java.util.List;

import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMAbstractEngine;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.digitalitemTE.DigitalitemTE;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.DIDLType;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.ItemType;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.SuperDidlAbstractLevel1;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Container;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.DIDLInfo;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Item;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl_mp21.Declarations;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Signature;

import eu.convergence.middleware.engine.vdiTE.schema.VDIEngineContext;


public class DIDL extends org.iso.mpeg.mxm.digitalitemTE.schemahandler.DIDL {
	
	public DIDL(DigitalitemTE DIengine) throws MXMException {
		super(DIengine);
		// TODO Auto-generated constructor stub
	}

	@Override
	public void createFile(File f) throws MXMException {
		try {
			(new SuperDidlAbstractLevel1(didltype, VDIEngineContext.getInstance().getJAXBContext())).createFile(f);
		} catch (JAXBException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		try {
			return (new SuperDidlAbstractLevel1(didltype, VDIEngineContext.getInstance().getJAXBContext())).createObject(objectType);
		} catch (JAXBException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperDidlAbstractLevel1 level1=null;
		try {
			level1 = new SuperDidlAbstractLevel1(didltype, VDIEngineContext.getInstance().getJAXBContext());
		} catch (JAXBException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		MXMEngineResponse response = level1.parse(object);
		this.didltype=(DIDLType)(level1.createObject(DIDLType.class.getCanonicalName())).getContent();
		return response;
	}
}
