package eu.convergence.middleware.vdiTE;

import java.io.File;

import org.iso.mpeg.mxm.core.MXMCreatorAndParser;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;

import eu.convergence.middleware.engine.vdiTE.schema.convrelation.SuperDirelationAbstractLevel1;


public class Relationship implements eu.convergence.middleware.engine.vdiTE.Relationship{

	eu.convergence.middleware.engine.vdiTE.schema.convrelation.Relationship relationshiptype = null;
		
	public Relationship() throws MXMEngineException {
		super();
		this.relationshiptype = new eu.convergence.middleware.engine.vdiTE.schema.convrelation.Relationship();
	}

	public void setSubject(String subject)
	{
		relationshiptype.setSubjectVDI(subject);
	}
	
	public void setObject(String object)
	{
		relationshiptype.setObjectVDI(object);
	}
	
	public void setPredicate(String predicate)
	{	
		relationshiptype.setPredicate(predicate);
	}
	
	public String getSubject()
	{
		return relationshiptype.getSubjectVDI();
	}
	
	public String getObject()
	{
		return relationshiptype.getObjectVDI();
	}
	
	public String getPredicate()
	{
		return relationshiptype.getPredicate();
	}

	@Override
	public void createFile(File f) throws MXMException {
		(new SuperDirelationAbstractLevel1(relationshiptype)).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		return (new SuperDirelationAbstractLevel1(relationshiptype)).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperDirelationAbstractLevel1 level1=new SuperDirelationAbstractLevel1(relationshiptype);
		MXMEngineResponse response = level1.parse(object);
		this.relationshiptype=(eu.convergence.middleware.engine.vdiTE.schema.convrelation.Relationship)(level1.createObject(eu.convergence.middleware.engine.vdiTE.schema.convrelation.Relationship.class.getCanonicalName())).getContent();
		return response;
	}	
}

