package eu.convergence.middleware.vdiTE;

import java.util.List;

import org.iso.mpeg.mxm.core.MXMAbstractEngine;
import org.iso.mpeg.mxm.core.MXMEngine;
import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.digitalitemTE.DIEngineSchemaHandler;
import org.iso.mpeg.mxm.digitalitemTE.DigitalitemTE;
import org.iso.mpeg.mxm.digitalitemTE.schemahandler.Item;
import org.iso.mpeg.mxm.digitalitemTE.schemahandler.RelatedIdentifier;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.ApplicationSpecificData;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Component;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Container;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.DIDL;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.DIDLInfo;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Descriptor;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Resource;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Statement;
import org.iso.mpeg.mxm.tEngine.eventreportTE.EventReportEngine;
import org.iso.mpeg.mxm.tEngine.ipmpTE.IPMPEngine;
import org.iso.mpeg.mxm.tEngine.metadataTE.MetadataEngine;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;

public class VDIEngineSchemaHandler extends eu.convergence.middleware.engine.vdiTE.VDIEngineSchemaHandler
{
	protected DigitalitemTE DIengine;
	protected EventReportEngine ERengine;
	protected MetadataEngine METAengine;
	protected SecurityEngine SECengine;
	protected IPMPEngine IPMPengine;
	
	protected VDIEngineSchemaHandler(List<MXMEngine> engines) throws MXMEngineException
	{
		for (MXMEngine engine: engines)
		{
			
			if (engine.getEngineName().equals(MXMEngineName.DigitalItemTE.toString()))
			{
				DIengine=(DigitalitemTE)engine;
			}
			else if (engine.getEngineName().equals(MXMEngineName.EventReportTE.toString()))
			{
				ERengine=(EventReportEngine)engine;
			}
			else if (engine.getEngineName().equals(MXMEngineName.MetadataTE.toString()))
			{
				METAengine=(MetadataEngine)engine;
			}			
			else if (engine.getEngineName().equals(MXMEngineName.SecurityTE.toString()))
			{
				SECengine=(SecurityEngine)engine;
			}
			else if (engine.getEngineName().equals(MXMEngineName.IPMPTE.toString()))
			{
				IPMPengine=(IPMPEngine)engine;
			}
//			else {
//				throw new MXMEngineException("there is a dependencies here not recognized! it is the >"+engine.getEngineName());
//			}
		}
//		if (ERengine==null || SECengine==null || IPMPengine==null || METAengine==null || DIengine==null)
//			throw new MXMEngineException("dependencies not setted correctly");
	}

//	@Override
//	public ApplicationSpecificData getApplicationSpecificData() throws MXMEngineException {
//		return new eu.convergence.middleware.vdiTE.ApplicationSpecificData();
//	}
//
//	@Override
//	public Component getComponent() throws MXMEngineException {
//		return new eu.convergence.middleware.vdiTE.Component(DIengine);
//	}
//
//	@Override
//	public Descriptor getDescriptor() throws MXMEngineException {
//		return new eu.convergence.middleware.vdiTE.Descriptor(DIengine);
//	}

	// TODO add relationship here and in core
	
	@Override
	public DIDL getDIDL() throws MXMException {
		return new eu.convergence.middleware.vdiTE.DIDL(DIengine);
	}

//	@Override
//	public Item getItem() throws MXMEngineException {
//		return new eu.convergence.middleware.vdiTE.Item(DIengine);
//	}
//
//	@Override
//	public Statement getStatement() throws MXMEngineException {
//		return new eu.convergence.middleware.vdiTE.Statement(DIengine, ERengine, METAengine, IPMPengine, SECengine);
//	}
	
}
