/**
 * 
 */
package eu.convergence.middleware.CreateContentES.service;

import java.io.StringReader;
import java.io.StringWriter;

import javax.ejb.Stateless;
import javax.jws.WebService;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;
import javax.xml.transform.stream.StreamSource;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.createcontentPE.schema.CreateContentEngineContext;
import org.iso.mpeg.mxm.engine.createcontentPE.schema.CreateContentRequest;
import org.iso.mpeg.mxm.engine.createcontentPE.schema.CreateContentResponse;
import org.iso.mpeg.mxm.engine.createcontentPE.schema.createcontentprotocol.CreateContentRequestType;

import eu.convergence.middleware.createcontentPE.local.CreateContentPE;
import eu.convergence.middleware.engine.createcontentPE.CreateContentEngine;

/**
 * @author aca
 *
 */
@Stateless
@WebService(endpointInterface = "eu.convergence.middleware.es.createcontentES.CreateContentProtocolRemote")
public class CreateContentES 
{
	public String createContent(String request) 
	{
		try {
			JAXBContext jc = CreateContentEngineContext.getInstance().getJAXBContext();
			Unmarshaller u = jc.createUnmarshaller();
			JAXBElement<CreateContentRequestType> jaxbElement = 
					u.unmarshal(new StreamSource(new StringReader(request)), CreateContentRequestType.class);
			CreateContentRequestType createContentRequestType = jaxbElement.getValue();
			
			CreateContentRequest createContentRequest = new CreateContentRequest(createContentRequestType);
			//AD- here we need to retrieve the instance of the PE from MXM config file
			CreateContentEngine contentEngine = new CreateContentPE();
			MXMObject response = contentEngine.createContent(new MXMAdapter(createContentRequest));
			CreateContentResponse createContentResponse = (CreateContentResponse)response.getContent();
			
			StringWriter sw = new StringWriter();
			Marshaller m = jc.createMarshaller();
			m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
			m.marshal(createContentResponse.getLevel0(), sw);
			
			return sw.toString();
		} catch (JAXBException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (MXMEngineException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
	
}
