package eu.convergence.middleware.tool.annotation;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.UUID;

import org.iso.mpeg.mxm.core.MXM;
import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.configuration.MXMConfigurationException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineNotFoundException;
import org.iso.mpeg.mxm.ipmpTE.IPMPTE;

import eu.convergence.middleware.core.ConvergenceEngineName;
import eu.convergence.middleware.engine.metadataTE.schema.convmeta.ConvergenceMetadataType;
import eu.convergence.middleware.engine.metadataTE.technologyhandler.MetadataKinds;
import eu.convergence.middleware.metadataTE.ConvergenceMetadataTE;
import eu.convergence.middleware.metadataTE.schemahandler.ConvergenceMetadata;
import eu.convergence.middleware.orchestratorTE.ConvergenceOrchestratorTE;
import eu.convergence.middleware.vdiTE.VDITE;


public class AnnotationVdiTool {
	
	private static AnnotationVdiTool ANNOTATION_VDI_TOOL;
	
	private IPMPTE IPMP_TE;
	protected VDITE VDI_TE;
	private ConvergenceMetadataTE CONV_METADATA_TE; // TODO could be used to parse the convMetadata. VDI Context should/could not have ConvMeta.
	
	private AnnotationVdiTool()
	{
		try
		{
			IPMP_TE = (IPMPTE) MXM.getInstance().getDefaultEngine(MXMEngineName.IPMPTE.toString());
			VDI_TE = (VDITE) MXM.getInstance().getDefaultEngine(MXMEngineName.DigitalItemTE.toString());
			CONV_METADATA_TE = (ConvergenceMetadataTE) MXM.getInstance().getDefaultEngine(ConvergenceEngineName.ConvergenceMetadataTE.value());
		} 
		catch (MXMEngineNotFoundException e) 
		{
			e.printStackTrace();
		} catch (MXMConfigurationException e)
		{
			e.printStackTrace();
		}
	}
	
	public static AnnotationVdiTool getInstance(){
		if(ANNOTATION_VDI_TOOL == null){
			ANNOTATION_VDI_TOOL = new AnnotationVdiTool();
		}
		
		return ANNOTATION_VDI_TOOL;
		
	}
	
//	public DIDL addMetadata(DIDL annotationVdi, StructuredData structuredMetadata) {
//		try {
//			if (annotationVdi == null) {
//				annotationVdi = createDummyVDI();
//			}
//			
//			Metadata metadata = new Metadata();
//			metadata.addStructuredData(structuredMetadata);
//			
//			Descriptor descriptor = new Descriptor();
//			descriptor.setMetadata(metadata);
//			
//			annotationVdi.getTopLevelItem().addDescriptor(descriptor);
//			
//			return annotationVdi;
//			
//		} catch (MXMEngineException e) {
//			e.printStackTrace();
//		}
//		
//		return null;
//	}
//	
//	public static DIDL addFractal(DIDL annotationVdi, String fractal)
//	{
//		// TODO
//		return null;
//	}
//	
//	public static List<String> getFractalList(DIDL annotationVdi)
//	{
//		// TODO
//		return null;
//	}
//	
//	public static DIDL addERR(DIDL annotationVdi, ERR err)
//	{
//		// TODO
//		return null;
//	}
//	
//	public static List<ERR> getERRList(DIDL annotationVdi)
//	{
//		// TODO
//		return null;
//	}
//	
//	public static boolean publish(DIDL annotationVdi)
//	{
//		// TODO
//		return false;
//	}
//	
//	public boolean unpublish(String annotationId)
//	{
//		// TODO
//		return false;
//	}
//	
//	public boolean reply(String annotationId)
//	{
//		// TODO
//		return false;
//	}
//	
//	public DIDL retrieve(String vdiId)
//	{
//		// TODO
//		return null;
//	}
//	
//	protected DIDL createDummyVDI() {
//		try {
//			DIDL vdi = new DIDL();
//			vdi.initContext(VDIEngineContext.getInstance().getJAXBContext());
//			
//			String seq_id = "urn:sequence_identifier:temp:" + UUID.randomUUID(); // TODO is this something that the di engine should do ???
//			
//			MetadataOrchestrator metadataOrchestrator = ConvergenceOrchestratorTE.dealWithMetaDataEngine();
//			ConvergenceMetadata convergenceMetadata = metadataOrchestrator.generateResourceInfo(seq_id, null, null);
//			
//			StructuredData structuredData = new StructuredData();
//			structuredData.setAny(convergenceMetadata.getLevel0());
//			structuredData.setRef(MetadataKinds.CONVERGENCE.getUri());
//			
//			Metadata metadata = new Metadata();
//			metadata.addStructuredData(structuredData);
//			
//			String tempVdiId = "identifier:contentitem:temp:"+ UUID.randomUUID();
//			
//			Descriptor identifierDescriptor = new Descriptor();
//			identifierDescriptor.setIdentifier(tempVdiId);
//			
//			Descriptor metadataDescriptor = new Descriptor();
//			metadataDescriptor.setMetadata(metadata);
//			
//			Item topLevelItem = new Item();
//			topLevelItem.addDescriptor(identifierDescriptor);
//			topLevelItem.addDescriptor(metadataDescriptor);
//			
//			vdi.setTopLevelItem(topLevelItem);
//			
//			return vdi;
//		} 
//		catch (Exception e) 
//		{
//			e.printStackTrace();
//		}
//		
//		return null;
//	}
//	
//	public DIDL addComment(DIDL annotationVDI, String resourceURL, String mimeType) {
//		try {
//			if (annotationVDI==null) {
//				annotationVDI=createDummyVDI();
//			}
//			
//			Resource resource = new Resource();
//			resource.setMimeType(mimeType);
//			resource.setRef(resourceURL);
//			
//			
//			if (annotationVDI.getTopLevelItem().getComponents().isEmpty())
//			{
//				annotationVDI.getTopLevelItem().addComponent(new Component());
//			}
//			
//			annotationVDI.getTopLevelItem().getComponents().get(0).addResource(resource);
//			
//			return annotationVDI;
//		} 
//		catch (Exception e) 
//		{
//			e.printStackTrace();
//		}
//		
//		return null;
//	}
//	
//	public MXMEngineResponse store(DIDL rvdi, String filePath) {
//		try {
//			PublishOrchestrator pubOrchestrator = ConvergenceOrchestratorTE.dealWithPublication();
//			rvdi = pubOrchestrator.identifyAndStore(rvdi, filePath);
//			
//			return MXMEngineResponse.SUCCESS;
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
//		
//		return MXMEngineResponse.FAILURE;
//	}
//	
//	public MXMEngineResponse advertise(String filePath) {
//		try {
//			PublishOrchestrator pubOrchestrator = ConvergenceOrchestratorTE.dealWithPublication();
//			pubOrchestrator.advertise(filePath);
//			
//			return MXMEngineResponse.SUCCESS;
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
//		
//		return MXMEngineResponse.FAILURE;
//	}
//	
//	public String getIdentifier(DIDL vdi)
//	{
//		try 
//		{
//			return vdi.getTopLevelItem().getIdentifier();
//		} 
//		catch (MXMEngineException e) 
//		{
//			e.printStackTrace();
//		}
//		
//		return null;
//	}
//	
//	public DIDL addLicense(DIDL vdi, License license)
//	{
//		try
//		{
//			if (vdi ==null)
//			{
//				vdi = createDummyVDI();
//			}
//			
//			org.iso.mpeg.mxm.engine.ipmpTE.License licenseCreator = IPMP_TE.getLicenseCreator();
//			licenseCreator.addLicense(license);
//			
//			RightsDescriptor rightsDescriptor = IPMP_TE.getRightsDescriptorCreator();
//			rightsDescriptor.setLicense(licenseCreator);
//			
////			IPMPGeneralInfoDescriptor ipmpGeneralInfoDescriptorCreator = IPMP_TE.getIPMPGeneralInfoDescriptorCreator();
////			ipmpGeneralInfoDescriptorCreator.addRightsDescriptor(rightsDescriptor);
//			//  TODO if i use the ipmpTE to get the creator, then i cannot add this in the descriptor.
//			
//			IPMPGeneralInfoDescriptor ipmpGeneralInfoDescriptorCreator = new IPMPGeneralInfoDescriptor();
//			ipmpGeneralInfoDescriptorCreator.addRightsDescriptor(rightsDescriptor);
//			
//			Descriptor descriptor = new Descriptor();
//			descriptor.setIPMPGeneralInfoDescriptor(ipmpGeneralInfoDescriptorCreator);
//			// TODO cannot create a descriptor from the vdiTE.
//			
//			Item topLevelItem = vdi.getTopLevelItem();
//			topLevelItem.addDescriptor(descriptor);
//			
//			return vdi;
//		}
//		catch (Exception ex)
//		{
//			ex.printStackTrace();
//		}
//		
//		return vdi;
//	}
//	
//	public List<License> getLicenseList(DIDL vdi)
//	{
//		try 
//		{
//			List<License> licenses = new ArrayList<License>();
//			
//			DIParser diParser = VDI_TE.getDIParser();
//			diParser.parseDI(new MXMAdapter(vdi));
//		
//			org.iso.mpeg.mxm.engine.ipmpTE.IPMPGeneralInfoDescriptor ipmpGeneralInfoDescriptorParser = 
//					(org.iso.mpeg.mxm.engine.ipmpTE.IPMPGeneralInfoDescriptor) diParser.getIpmpGeneralInfoDescriptor();
//			
//			for (RightsDescriptor rightsDescriptorParser : ipmpGeneralInfoDescriptorParser.getRightsDescriptorParsers())
//			{
//				for (org.iso.mpeg.mxm.engine.relTE.License license : rightsDescriptorParser.getLicense().getLicenses())
//				{
//					licenses.add((License) license);
//				}
//			}
//			
//			return licenses;
//		} 
//		catch (Exception e)
//		{
//			e.printStackTrace();
//		}
//		
//		return null;
//	}
//	
//	public DIDL setExpiryDate(DIDL vdi, Date date)
//	{
//		try
//		{
//			if (vdi==null)
//			{
//				vdi = createDummyVDI();
//			}
//
//			Item topLevelItem = vdi.getTopLevelItem();
//			
//			for (Descriptor descriptor : topLevelItem.getDescriptors())
//			{
//				if (descriptor.getMetadata()!=null)
//				{
//					for (StructuredData structuredData : descriptor.getMetadata().getStructuredData())
//					{
//						if (structuredData.getRef().equals("urn:conv:metadata:schema:2011"))
//						{
//							Object metadataObject = structuredData.getAny();
//							if (metadataObject instanceof eu.convergence.middleware.metadataTE.schema.convMeta.ConvergenceMetadataType)
//							{
//								ConvergenceMetadata convMetadata = new ConvergenceMetadata((ConvergenceMetadataType) metadataObject);
//								convMetadata.setExpiryDate(date);
//								
//								structuredData.setAny(convMetadata.getLevel0());
//								
//								return vdi;
//							}
//							else if (metadataObject instanceof javax.xml.bind.JAXBElement)
//							{
//								Object metadataType = ((javax.xml.bind.JAXBElement)metadataObject).getValue();
//								
//								ConvergenceMetadata convMetadata = new ConvergenceMetadata((ConvergenceMetadataType) metadataType);
//								convMetadata.setExpiryDate(date);
//								
//								((javax.xml.bind.JAXBElement)metadataObject).setValue(convMetadata.getLevel0());
//								
//								return vdi;
//							}
//						}
//						else
//						{
//							System.out.println("---------------------------------------------------");
//							System.out.println(structuredData.getRef());
//							System.out.println(structuredData.getAny().getClass().getCanonicalName());
//							System.out.println("---------------------------------------------------");
//						}
//						
////						if (structuredData.getAny() instanceof org.apache.xerces.dom.ElementNSImpl) // TODO for metadata use
////						{
////							org.apache.xerces.dom.ElementNSImpl a = (org.apache.xerces.dom.ElementNSImpl)structuredData.getAny();
////							System.out.println(a);
////							
////							a.getFirstChild().getFirstChild().setTextContent("AAAAAAA");
////							a.appendChild(a.getFirstChild().getFirstChild());
////							a.getFirstChild().appendChild(a.getFirstChild().getFirstChild());
////							
////							System.out.println(structuredData.createObject(String.class.getCanonicalName()).getContent());
////						}
//					}
//				}
//			}
//		}
//		catch(Exception ex)
//		{
//			ex.printStackTrace();
//		}
//		
//		return null;
//	}
//	
//	public Date getExpiryDate(DIDL vdi)
//	{
//		try
//		{
//			Item topLevelItem = vdi.getTopLevelItem();
//			
//			for (Descriptor descriptor : topLevelItem.getDescriptors())
//			{
//				if (descriptor.getMetadata()!=null)
//				{
//					for (StructuredData structuredData : descriptor.getMetadata().getStructuredData())
//					{
//						if (structuredData.getRef().equals("urn:conv:metadata:schema:2011")) // TODO i think parsing should e done calling the metadataTE
//						{
//							Object metadataObject = structuredData.getAny();
//							if (metadataObject instanceof eu.convergence.middleware.metadataTE.schema.convMeta.ConvergenceMetadataType)
//							{
//								ConvergenceMetadata convMetadata = new ConvergenceMetadata((ConvergenceMetadataType) metadataObject);
//								
//								return convMetadata.getExpiryDate();
//							}
//							else if (metadataObject instanceof javax.xml.bind.JAXBElement)
//							{
//								Object metadataType = ((javax.xml.bind.JAXBElement)metadataObject).getValue();
//								
//								ConvergenceMetadata convMetadata = new ConvergenceMetadata((ConvergenceMetadataType) metadataType);
//								
//								return convMetadata.getExpiryDate();
//							}
//						}
//					}
//				}
//			}
//			
//			return null;
//		}
//		catch(Exception ex)
//		{
//			ex.printStackTrace();
//		}
//		
//		return null;
//	}
//	
//	public DIDL addSignature(DIDL vdi, Signature signature)
//	{
//		try
//		{
//			if (vdi==null)
//			{
//				vdi = createDummyVDI();
//			}
//			
//			DIDLInfo didlInfo = new DIDLInfo();
//			didlInfo.setDISignature(signature);
//			
//			vdi.getDIDLInfoList().add(didlInfo);
//			
//			return vdi;
//		}
//		catch (Exception e)
//		{
//			e.printStackTrace();
//		}
//		
//		return vdi;
//	}
//	
//	public List<Signature> getSignatures(DIDL vdi)
//	{
//		try 
//		{
//			List<Signature> signatures = new ArrayList<Signature>();
//			
//			if (vdi.getDIDLInfoList()!=null)
//			{
//				for (DIDLInfo didlInfo : vdi.getDIDLInfoList())
//				{
//					if (didlInfo.getDISignature()!=null)
//					{
//						signatures.add(didlInfo.getDISignature());
//					}
//				}
//			}
//			
//			return signatures;
//		}
//		catch (MXMEngineException e) 
//		{
//			e.printStackTrace();
//		}
//		
//		return null;
//	}
	
}
