package eu.convergence.middleware.tool.rel;

import java.util.Date;

import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.Condition;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.License;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.Principal;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.PropertyPossessor;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.Resource;
import org.iso.mpeg.mxm.tEngine.relTE.technologyhandler.RELRight;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.X509Data;

public interface LicenseCreator
{
	public Principal createKeyHolder(X509Data x509data);
	
	public Principal createIdentityHolder(String principalIdentifier);
	
	public PropertyPossessor createPropertyPossessor(String propertyURI);
	
	public void setLicenseIdentifier(String identifier);
	
	public Resource createDIReference(String diIdentifier);
	
	public Resource createDigitalResource(String url);
	
	public Resource createProtectedResource(String url, byte[] key);
	
	public Condition createValidityIntervalCondition(Date notBeforeDate, Date notAfterDate);
	
	public void setIssuer(Principal issuer);
	
	public void setPrincipal(Principal principal);
	
	public void setForAll(PropertyPossessor propertyPossessor);
	
	public void addGrant(RELRight right, Condition condition);
	
	public void setResource(Resource resource);
	
	public License generateLicense();
}
