package eu.convergence.middleware.tool.security;


import java.math.BigInteger;
import java.security.KeyPair;
import java.security.PublicKey;
import java.sql.Date;

import javax.security.cert.CertificateException;
import javax.security.cert.X509Certificate;

import org.iso.mpeg.mxm.core.MXM;
import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.configuration.MXMConfigurationException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineNotFoundException;


//TODO Check Java docs
/**
 * Allows the registration of users. Depending on the chosen 'engine focus' of the used
 * securityTE, the RegistratioTool provides either methods for registration to an Identity
 * Provider, a Service Provider or a general application. Some methods require the
 * CONVERGENCE smart card. Engine focus- and Smart card settings can be found in the
 * MXMConfiguration.xml.
 * 
 * @author Andreas Kohlos, Christoph Topmoeller
 */
public class RegistrationTool
{
    private static RegistrationTool REGISTRATION_TOOL = null;

//    public static synchronized RegistrationTool getInstance(
//        final String iPRootCertificatePath, final String sPRootCertificatePath)
//    {
//        REGISTRATION_TOOL = new RegistrationTool(iPRootCertificatePath,
//            sPRootCertificatePath);
//        return REGISTRATION_TOOL;
//    }
//
//    // TODO make tool credentials/settings configurable via config file (or put these
//    // information into the constructor)
//    private String            COMMON_NAME             = null;
//    private String            COUNTRY                 = null;
//    private int               HOLDER_CERT_EXPIRY_DAYS = -1;
//    private X509Certificate   IP_ROOT_CERT            = null;
//    private int               ISSUER_CERT_EXPIRY_DAYS = -1;
//    private KeyPair           ISSUER_KEY_PAIR         = null;
//    private String            ISSUER_REFERENCE        = null;
//    private String            LOCALITY                = null;
//    private String            ORGANIZATION            = null;
//    private RepositoryManager REPOSITORY              = null;
//    private SecurityEngine    securityTE              = null;
//    private X509Certificate   SP_ROOT_CERT            = null;

//    private RegistrationTool(final String iPRootCertificatePath,
//        final String sPRootCertificatePath)
//    {
//        try
//        {
//            this.securityTE = (SecurityEngine)MXM.getInstance().getDefaultEngine(
//                MXMEngineName.SecurityTE.toString());
//            // Generate or read out Identity Provider credentials.
//            this.REPOSITORY = this.securityTE.getRepositoryManager();
//            // Make distinction between securityTE Focus
//            if (this.REPOSITORY.getClass().equals(AppRepositoryManager.class))
//            {
//                this.createAppRegistrationTool(iPRootCertificatePath,
//                    sPRootCertificatePath);
//            }
//            else if (this.REPOSITORY.getClass().equals(SPRepositoryManager.class))
//            {
//                this.createSPRegistrationTool(iPRootCertificatePath,
//                    sPRootCertificatePath);
//            }
//            else if (this.REPOSITORY.getClass().equals(IPRepositoryManager.class))
//            {
//                this.createIPRegistrationTool(iPRootCertificatePath);
//            }
//            else
//            {
//                System.err
//                    .println("Couldn't retrieve the tool class type (Application, ServiceProvider or IdentityProvider)");
//                return;
//            }
//        }
//        catch (final MXMEngineNotFoundException e)
//        {
//            e.printStackTrace();
//        }
//        catch (final MXMConfigurationException e)
//        {
//            e.printStackTrace();
//        }
//        catch (final MXMEngineException e)
//        {
//            e.printStackTrace();
//        }
//        catch (final CertificateException e)
//        {
//            e.printStackTrace();
//        }
//    }
//
//    /**
//     * Activate the user means to set the active tag of the user in the database to true.
//     * 
//     * @param userID
//     */
//    public void activateUser(final String userID)
//    {
//        if (this.REPOSITORY.isUserRevoked(userID))
//        {
//            this.REPOSITORY.grantUser(userID);
//        }
//    }
//
//    private void createAppRegistrationTool(final String iPRootCertificatePath,
//        final String sPRootCertificatePath)
//    {
//    }
//
//    // TODO write ip root certificate to the input path
//    private void createIPRegistrationTool(final String iPRootCertificatePath)
//        throws MXMEngineException,CertificateException
//    {
//        // TODO make tool credentials/settings configurable via config file (or put these
//        // information into the constructor)
//        this.COMMON_NAME = "Convergence Identity Provider Root";
//        this.COUNTRY = "DE";
//        this.LOCALITY = "Berlin";
//        this.ORGANIZATION = "Convergence";
//        this.ISSUER_CERT_EXPIRY_DAYS = 1500;
//        this.HOLDER_CERT_EXPIRY_DAYS = 150;
//        this.ISSUER_KEY_PAIR = this.REPOSITORY.getIssuerKeyPair();
//        this.IP_ROOT_CERT = this.REPOSITORY.getIPRootCertificate();
//        this.ISSUER_REFERENCE = NameService.get(
//            NameService.create(this.COUNTRY, null, this.LOCALITY, this.ORGANIZATION,
//                null, this.COMMON_NAME, null, null, null)).toString();
//        if ((this.ISSUER_KEY_PAIR == null) || (this.IP_ROOT_CERT == null))
//        {
//            this.ISSUER_KEY_PAIR = this.securityTE.getCertificateManager()
//                .generateRSAKeyPair(2048, new BigInteger("10001", 16));
//            this.IP_ROOT_CERT = X509Certificate.getInstance(this.securityTE
//                .getCertificateManager()
//                .generateCVCertificate(this.ISSUER_REFERENCE, this.ISSUER_REFERENCE,
//                    this.ISSUER_CERT_EXPIRY_DAYS, this.ISSUER_KEY_PAIR.getPublic(),
//                    this.ISSUER_KEY_PAIR.getPrivate(), "SHA256withRSA")
//                .getX509Certificate());
//            this.REPOSITORY.storeIssuerCredentials(this.IP_ROOT_CERT, null,
//                this.ISSUER_KEY_PAIR);
//            // Store the issuer certificate on hard disk for distribution among the PKI
//            // structure.
//        }
//        FileAndObjectHandler.writeObjectToFile(iPRootCertificatePath, this.IP_ROOT_CERT);
//    }
//
//    private void createSPRegistrationTool(final String iPRootCertificatePath,
//        final String sPRootCertificatePath)
//    {
//        X509Certificate harddisk_ip_root_cert = null;
//        // TODO make tool credentials/settings configurable via config file (or put these
//        // information into the constructor)
//        this.COMMON_NAME = "Convergence Service Provider A";
//        this.COUNTRY = "DE";
//        this.LOCALITY = "Dortmund";
//        this.ORGANIZATION = "Convergence";
//        this.ISSUER_CERT_EXPIRY_DAYS = 1500;
//        this.HOLDER_CERT_EXPIRY_DAYS = 29;
//        // Read the provided IP root certificate from hard disk.
//        try
//        {
//            harddisk_ip_root_cert = (X509Certificate)FileAndObjectHandler
//                .readObjectFromFile(iPRootCertificatePath);
//        }
//        catch (final SecurityEngineException e1)
//        {
//            harddisk_ip_root_cert = null;
//        }
//        try
//        {
//            // Generate and read out Service Provider credentials.
//            this.REPOSITORY = this.securityTE.getRepositoryManager();
//            this.ISSUER_KEY_PAIR = this.REPOSITORY.getIssuerKeyPair();
//            this.IP_ROOT_CERT = this.REPOSITORY.getIPRootCertificate();
//            this.SP_ROOT_CERT = this.REPOSITORY.getIssuerRootCertificate();
//            this.ISSUER_REFERENCE = NameService.get(
//                NameService.create(this.COUNTRY, null, this.LOCALITY, this.ORGANIZATION,
//                    null, this.COMMON_NAME, null, null, null)).toString();
//            if (this.IP_ROOT_CERT == null)
//            {
//                if (harddisk_ip_root_cert == null)
//                {
//                    System.err
//                        .println("No IP root certificate could be located at the provided path");
//                    return;
//                }
//                else
//                {
//                    this.IP_ROOT_CERT = harddisk_ip_root_cert;
//                }
//            }
//            else
//            {
//                if (!this.IP_ROOT_CERT.equals(harddisk_ip_root_cert))
//                {
//                    // TODO provide a method to support a change of the rootCertificate.
//                    System.err
//                        .println("The provided IP root certificate doesn't match the stored certificate!");
//                }
//            }
//            if ((this.ISSUER_KEY_PAIR == null) || (this.SP_ROOT_CERT == null))
//            {
//                this.ISSUER_KEY_PAIR = this.securityTE.getCertificateManager()
//                    .generateRSAKeyPair(2048, new BigInteger("65537"));
//                // TODO let the ip provider create the sp cert with his private key
//                // (involves
//                // network communication protocols).
//                this.SP_ROOT_CERT = X509Certificate.getInstance(this.securityTE
//                    .getCertificateManager()
//                    .generateCVCertificate(this.ISSUER_REFERENCE, this.ISSUER_REFERENCE,
//                        this.ISSUER_CERT_EXPIRY_DAYS, this.ISSUER_KEY_PAIR.getPublic(),
//                        this.ISSUER_KEY_PAIR.getPrivate(), "SHA256withRSA")
//                    .getX509Certificate());
//                this.REPOSITORY.storeIssuerCredentials(this.IP_ROOT_CERT,
//                    this.SP_ROOT_CERT, this.ISSUER_KEY_PAIR);
//            }
//            // Store the issuer certificate on hard disk for distribution among the PKI
//            // structure.
//            FileAndObjectHandler.writeObjectToFile(sPRootCertificatePath,
//                this.SP_ROOT_CERT);
//        }
//        catch (final SecurityEngineException e)
//        {
//            e.printStackTrace();
//        }
//        catch (final CertificateException e)
//        {
//            e.printStackTrace();
//        }
//    }
//
//    /**
//     * Deactivate the user means to set the active tag of the user in the database to
//     * false .
//     * 
//     * @param userID
//     * @param reason
//     */
//    public void deactivateUser(final String userID, final String reason)
//    {
//        this.REPOSITORY.revokeUser(userID, reason);
//    }
//
//    /**
//     * Deletes the user irrevocable.
//     * 
//     * @param userID
//     */
//    public void deleteUser(final String userID)
//    {
//        if (this.REPOSITORY.isUserCreated(userID))
//        {
//            this.REPOSITORY.deleteUser(userID);
//        }
//    }
//
//    // TODO before signing -> challenge response with client -> user card (remote!)
//    public int identifyUserToIP(final String firstName, final String lastName,
//        final Date birthday, final String country, final String locality,
//        final String organization, final String PIN)
//    {
//        int userID = -1;
//        String userReference;
//        try
//        {
//            // Concatenate the user information into one string.
//            // TODO put the userID also into the certificate (reference)
//            userReference = NameService.get(
//                NameService.create(country, null, locality, organization, null, null,
//                    null, null, null)).toString();
//            // Create the user key pair.
//            // TODO create key pair on card and retrieve only its public key
//            final KeyPair userKeyPair = this.securityTE.getCertificateManager()
//                .generateRSAKeyPair(2048, new BigInteger("10001", 16));
//            // Create the user certificate.
//            final X509Certificate userCertificate = X509Certificate
//                .getInstance(this.securityTE
//                    .getCertificateManager()
//                    .generateCVCertificate(userReference, this.ISSUER_REFERENCE,
//                        this.HOLDER_CERT_EXPIRY_DAYS, userKeyPair.getPublic(),
//                        this.ISSUER_KEY_PAIR.getPrivate(), "SHA256withRSA")
//                    .getX509Certificate());
//            // Store everything to the data base.
//            userID = ((IPRepositoryManager)this.REPOSITORY).storeUser(userCertificate,
//                firstName, lastName, birthday, country, locality, organization);
//            // Store the certificate to the smart card.
//            // TODO RegistrationTool.REPOSITORY.storeUserCertsToCard(PIN,
//            // userCertificates);
//        }
//        catch (final Exception e)
//        {
//            e.printStackTrace();
//        }
//        return userID;
//    }
//
//    // TODO use the public keys and a distinction, also in case of null objects
//    public int identifyUserToSP(final X509Certificate iPUserCertificate,
//        final String userPseudonym, final PublicKey publicCiphKey,
//        final PublicKey publicSignKey, final PublicKey publicAuthKey)
//    {
//        int userID = -1;
//        // TODO store the designated application name inside the certificate
//        // (organizationalUnit entry?)
//        // TODO check the iPUserCertificate against the IP root certificate.
//        String userReference;
//        try
//        {
//            // Concatenate the user information into one string.
//            // TODO put the userPseudonym also into the certificate (reference) at the
//            // proper location
//            userReference = NameService.get(
//                NameService.create(null, null, null, null, "applicationName",
//                    userPseudonym, null, null, null)).toString();
//            // Create the user key pair.
//            // TODO create key pairs on card and retrieve only its public key
//            final KeyPair authKeyPair = this.securityTE.getCertificateManager()
//                .generateRSAKeyPair(2048, new BigInteger("65537"));
//            final KeyPair signKeyPair = this.securityTE.getCertificateManager()
//                .generateRSAKeyPair(2048, new BigInteger("65537"));
//            final KeyPair ciphKeyPair = this.securityTE.getCertificateManager()
//                .generateRSAKeyPair(2048, new BigInteger("65537"));
//            // Create the authentication certificate.
//            final X509Certificate authCertificate = X509Certificate
//                .getInstance(this.securityTE
//                    .getCertificateManager()
//                    .generateCVCertificate(userReference, this.ISSUER_REFERENCE,
//                        this.HOLDER_CERT_EXPIRY_DAYS, authKeyPair.getPublic(),
//                        this.ISSUER_KEY_PAIR.getPrivate(), "SHA256withRSA")
//                    .getX509Certificate());
//            // Create the sign certificate.
//            final X509Certificate signCertificate = X509Certificate
//                .getInstance(this.securityTE
//                    .getCertificateManager()
//                    .generateCVCertificate(userReference, this.ISSUER_REFERENCE,
//                        this.HOLDER_CERT_EXPIRY_DAYS, signKeyPair.getPublic(),
//                        this.ISSUER_KEY_PAIR.getPrivate(), "SHA256withRSA")
//                    .getX509Certificate());
//            // Create the encryption certificate.
//            final X509Certificate ciphCertificate = X509Certificate
//                .getInstance(this.securityTE
//                    .getCertificateManager()
//                    .generateCVCertificate(userReference, this.ISSUER_REFERENCE,
//                        this.HOLDER_CERT_EXPIRY_DAYS, ciphKeyPair.getPublic(),
//                        this.ISSUER_KEY_PAIR.getPrivate(), "SHA256withRSA")
//                    .getX509Certificate());
//            // Store everything to the data base.
//            // TODO only store the pseudonym to the certificates
//            userID = ((SPRepositoryManager)this.REPOSITORY).storeUser(userPseudonym,
//                authCertificate, signCertificate, ciphCertificate, iPUserCertificate);
//            // Store the certificates and key pairs to the smart card.
//            // TODO do that on client side
//        }
//        catch (final Exception e)
//        {
//            e.printStackTrace();
//        }
//        return userID;
//    }
}
