package eu.convergence.middleware.tools.monitoring;

import eu.convergence.middleware.event.PeerRegistrationEvent;
import org.iso.mpeg.mxm.core.MXM;
import org.iso.mpeg.mxm.core.configuration.MXMConfigurationException;
import org.iso.mpeg.mxm.core.event.management.MXMEvent;
import org.iso.mpeg.mxm.core.event.management.MXMEventHandler;
import org.iso.mpeg.mxm.core.event.management.MXMEventListener;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;

/**
 * Created by IntelliJ IDEA.
 * User: aca
 * Date: 9/3/11
 * Time: 1:53 PM
 */
public class MonitorPeerRegistrations implements MXMEventListener
{
    private String monitoringAppURL;

    public MonitorPeerRegistrations(String monitoringAppURL)
    {
        this.monitoringAppURL = monitoringAppURL;
        try {
            MXM.getInstance().getMXMEventHandler().registerMXMEventListener(PeerRegistrationEvent.class.getName(), this, MXMEventHandler.HIGH_PRIORITY);
        } catch (MXMConfigurationException e) {
            e.printStackTrace();
        }
    }

    @Override
    public void mxmEventOccurred(MXMEvent mxmEvent)
    {
        if (mxmEvent instanceof PeerRegistrationEvent)
        {
            PeerRegistrationEvent peerRegistrationEvent = (PeerRegistrationEvent) mxmEvent;
            String overlayPeerid = peerRegistrationEvent.getOverlayPeerId();
            String overlaySAP = peerRegistrationEvent.getOverlaySAP();

            try {
                URL url = new URL(monitoringAppURL + "/PeerSystemRegistration" +
                        "?overlayPeerId=" + overlayPeerid +
                        "&overlaySAP=" + overlaySAP
                );
                System.out.println("Contacting: " + url.getPath());
                URLConnection urlConnection = url.openConnection();
                BufferedReader reader = new BufferedReader(
                        new InputStreamReader(urlConnection.getInputStream())
                );
                String response;
                
                while ((response = reader.readLine()) != null)
                {
                    System.out.println(response);
                }

                reader.close();
            } catch (MalformedURLException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
