package eu.convergence.middleware.tool.metadata.test;

import java.io.File;

import junit.framework.TestCase;

import org.apache.log4j.Logger;
import org.iso.mpeg.mxm.core.MXM;
import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.configuration.MXMConfigurationException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.DIDL;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Item;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl_msx.StructuredData;
import org.w3c.dom.Node;

import eu.convergence.middleware.engine.vdiTE.VdiEngine;
import eu.convergence.middleware.orchestratorTE.ConvergenceOrchestratorTE;
import eu.convergence.middleware.tool.rel.test.LicenceToolTest;

public class MetadataToolTest extends TestCase
{

	private Logger logger = Logger.getLogger(LicenceToolTest.class);
	
	public void testMetadataTool()
	{
		try
		{
			logger.info("\n\n---------- testMetadataParsing ----------");
			
			File f = new File(getClass().getClassLoader().getResource("MXMConfiguration.xml").getFile());
			MXM mxm = MXM.getInstance(f);
			mxm.listEnginesAndProperties();
			
			ConvergenceOrchestratorTE orchestrator = (ConvergenceOrchestratorTE) MXM.getInstance().getDefaultEngine(MXMEngineName.OrchestratorTE.value());
			
			VdiEngine vdiEngine = (VdiEngine) MXM.getInstance().getDefaultEngine(MXMEngineName.DigitalItemTE.value());
			
			orchestrator.getMetadataOrchestrator();
			
			File vdi = new File(getClass().getClassLoader().getResource("newSchemaTestRVDI.xml").getFile());
			
			DIDL didl = vdiEngine.getVDIEngineSchemaHandler().getDIDL();
			didl.parse(new MXMAdapter(vdi));
		
//			metadataOrchestrator.addRDFTriple(structuredData, subject, predicate, object, ontologyURI)
		

			Item topLevelItem = didl.getMPEGMItem();
			
			if (topLevelItem.getMetadata()!=null)
			{
				StructuredData structuredData = topLevelItem.getMetadata();
				System.out.println("---------------------------------------------------");
				System.out.println(structuredData.getRef());
				System.out.println(structuredData.getAny().getClass().getCanonicalName());
				System.out.println("---------------------------------------------------");

				System.out.println(structuredData.createObject(String.class.getCanonicalName()).getContent());
				
				if (structuredData.getAny() instanceof Node)
				{
//					structuredData = metadataOrchestrator.addRDFTriple(structuredData,
//							"http://DesignIssues/Overview.html", "http://xmlns.com/foaf/0.1/maker", "AzHammer", "");

//					System.out.println(structuredData.createObject(String.class.getCanonicalName()).getContent());

//													
//							a.getFirstChild().getFirstChild().setTextContent("AAAAAAA");
//							a.appendChild(a.getFirstChild().getFirstChild());
//							a.getFirstChild().appendChild(a.getFirstChild().getFirstChild());
//													
//							System.out.println(structuredData.createObject(String.class.getCanonicalName()).getContent());
				}
			}
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
	}
	
}
