package eu.convergence.middleware.tool.security.test;


import java.io.File;
import java.math.BigInteger;
import java.security.KeyPair;

import javax.security.cert.CertificateException;
import javax.security.cert.X509Certificate;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.Marshaller;

import junit.framework.TestCase;

import org.apache.log4j.Logger;
import org.iso.mpeg.mxm.core.MXM;
import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.configuration.MXMConfigurationException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.securityTE.schema.SecurityEngineContext;
import org.iso.mpeg.mxm.tEngine.utils.SchemaNamespacePrefixMapperImpl;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;
import org.iso.mpeg.mxm.tEngine.securityTE.technologyhandler.CertificateManager;

import eu.convergence.middleware.tool.security.RegistrationTool;


public class SPRegistrationToolTest extends TestCase
{
    private final int        expiryDays        = 10;
    private final String     holderReference   = "CN=Holder,L=London,C=GB,O=Organization";
    private final String     IP_ROOT_CERT_PATH = "./ip_root.cert";
    private final String     issuerReference   = "CN=Issuer,L=London,C=GB,O=Organization";
    private JAXBContext      jc                = null;
    private final byte       keyIdentifier     = 0;
    private final int        keyLength         = 2048;
    private final Logger     logger            = Logger
                                                   .getLogger(SPRegistrationToolTest.class);
    private Marshaller       m                 = null;
    private final BigInteger PubExp            = new BigInteger("10001", 16);
    private RegistrationTool registrationTool  = null;
    private SecurityEngine   securityTE        = null;
    private final String     SignOID           = "SHA256withRSAEncryption";
    private final String     SP_ROOT_CERT_PATH = "./sp_root.cert";

//    @Override
//    public void setUp() throws Exception
//    {
//        super.setUp();
//        // Initialize JAXB Context.
//        this.jc = SecurityEngineContext.getInstance().getJAXBContext();
//        this.m = this.jc.createMarshaller();
//        this.m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
//        this.m.setProperty("com.sun.xml.bind.namespacePrefixMapper",
//            SchemaNamespacePrefixMapperImpl.getInstance());
//        // Initialize MXM.
//        this.logger.info("\n--- Setup MXMConfiguration ---");
//        final File f = new File(this.getClass().getClassLoader()
//            .getResource("MXMConfiguration_ServiceProvider.xml").getFile());
//        final MXM mxm = org.iso.mpeg.mxm.core.MXM.getInstance(f);
//        mxm.listEnginesAndProperties();
//        this.logger.info("\n--- Init SecurityEngine ---");
//        this.securityTE = (SecurityEngine)mxm.getDefaultEngine(MXMEngineName.SecurityTE
//            .toString());
//        this.logger.info("\n--- Done! ---");
//        this.logger.info("\n--- Init RegistrationTool ---");
//        this.registrationTool = RegistrationTool.getInstance(this.IP_ROOT_CERT_PATH,
//            this.SP_ROOT_CERT_PATH);
//        this.logger.info("\n--- Done! ---");
//    }
//
//    public void testSPIdentityCreation() throws MXMConfigurationException,
//        MXMEngineException
//    {
//        this.logger.info("\n---------- testSPIdentityCreation ----------");
//        // Create a dummy IP user certificate for registration to the SP.
//        CertificateManager certMngr;
//        KeyPair pair;
//        KeyPair cardPair;
//        X509Certificate X509Cert;
//        try
//        {
//            certMngr = this.securityTE.getCertificateManager();
//            pair = certMngr.generateRSAKeyPair(this.keyLength, this.PubExp);
//            cardPair = certMngr.generateRSAKeyPairCard(this.keyIdentifier,
//                this.keyLength, this.PubExp);
//            if (pair.getPublic().getAlgorithm().equalsIgnoreCase("RSA"))
//            {
//                X509Cert = X509Certificate.getInstance(certMngr.generateCertificate(
//                    this.holderReference, this.issuerReference, this.expiryDays,
//                    cardPair.getPublic(), pair.getPrivate(), this.keyIdentifier,
//                    this.SignOID).getX509Certificate());
//            }
//            else
//            {
//                X509Cert = null;
//            }
//            // Delete the user with the targeted pseudonym, in case he is already existing
//            // in the db.
//            this.securityTE.getRepositoryManager().deleteUser("testPseudonym");
//            // Register a user to the SP.
//            final int userID = this.registrationTool.identifyUserToSP(X509Cert,
//                "testPseudonym", null, null, null);
//            this.logger
//                .info("\nThe user with the pseudonym 'testPseudonym' has been created with id: "
//                    + userID + "\n");
//            assertTrue(userID > -1);
//        }
//        catch (final CertificateException e)
//        {
//            this.logger.error(e.getMessage());
//        }
//    }
//
//    public void testSPRegistrationToolInstance() throws MXMConfigurationException,
//        MXMEngineException
//    {
//        this.logger.info("\n---------- testSPRegistrationToolCreation ----------");
//        assertTrue(this.securityTE.getRepositoryManager().getClass()
//            .equals(SPRepositoryManager.class));
//        this.logger
//            .info("\nThe RepositoryManager is properly set to SPRepositoryManager\n");
//    }
}
