/*
 * Copyright (c) 2011 Safran Morpho.
 * This software is the confidential and proprietary
 * information of Safran Morpho.
 * All rights reserved.
 *
 * Safran Morpho makes no representations or
 * warranties about the suitability of the software, either
 * express or implied, including but not limited to the implied
 * warranties of merchantability, fitness for a particular
 * purpose, or non-infringement.
 * Safran Morpho shall not be liable for any damages
 * suffered by licensee as a result of using, modifying or
 * distributing this software or its derivatives.
 *
 * This copyright notice must appear in all copies of this
 * software.
 *
 * $File: //ResearchProjects/Convergence/implementation/main/SecurityLib/src/morpho/cryptomodule/convergence/CommandApduHeaders.java $
 * 
 * Last submit:
 *  $Revision: #1 $
 *  $Change: 365542 $
 *  $DateTime: 2012/05/31 20:23:21 $
 *  $Author: akohlos $
 *
 * 
 * Created on 25.10.2011
 *
 */
package morpho.cryptomodule.convergence;


public final class CommandApduHeaders
{
    // Card command APDU headers:
    protected static final String GAKP                  = "00468000000000";
    protected static final String GAKP_READ_PUBLIC      = "00468100000000";
    protected static final String INTERNAL_AUTH         = "0088000020";
    protected static final String MSE_SET_AUTH          = "002241A4058303801300";
    protected static final String MSE_SET_CONF          = "002241B8058303801200";
    protected static final String MSE_SET_SIG           = "002241B6058303801100";
    protected static final String PSO_CDS_HASHVALUE     = "002A9E9A20";
    protected static final String PSO_DECIPHER          = "002A808600010100";
    protected static final String READ_BINARY           = "00B00000000000";
    protected static final String SAMPLE_COMMAND1       = "A022000000";
    protected static final String SAMPLE_COMMAND2       = "00A404000AA00000006203010C0801";
    protected static final String SELECT_CERT_TYPE_AUTH = "80A4020C02C003";
    protected static final String SELECT_CERT_TYPE_CONF = "80A4020C02C002";
    protected static final String SELECT_CERT_TYPE_SIG  = "80A4020C02C001";
    protected static final String SELECT_DF             = "00A4040C07D2760000584C0";
    protected static final String SELECT_DF_1           = "00A4040C07D2760000584C01";
    protected static final String SELECT_OBJ_KID_AUTH   = "80A4120C03801300";
    protected static final String SELECT_OBJ_KID_CONF   = "80A4120C03801200";
    protected static final String SELECT_OBJ_KID_SIG    = "80A4120C03801100";
    protected static final String SET_ATTR_F_4          = "801642000400010001";
    protected static final String SET_ATTR_P            = "80164300020080";
    protected static final String SET_ATTR_Q            = "80164400020080";
    protected static final String UPDATE_BINARY         = "00D6000000";
    protected static final String VERIFY_PIN_AUTH       = "002000830826";
    protected static final String VERIFY_PIN_CONF       = "002000820826";
    protected static final String VERIFY_PIN_GAKP       = "002000840828";
    protected static final String VERIFY_PIN_SIG        = "002000810826";
}
