/*
 * Copyright (c) 2011 Safran Morpho.
 * This software is the confidential and proprietary
 * information of Safran Morpho.
 * All rights reserved.
 *
 * Safran Morpho makes no representations or
 * warranties about the suitability of the software, either
 * express or implied, including but not limited to the implied
 * warranties of merchantability, fitness for a particular
 * purpose, or non-infringement.
 * Safran Morpho shall not be liable for any damages
 * suffered by licensee as a result of using, modifying or
 * distributing this software or its derivatives.
 *
 * This copyright notice must appear in all copies of this
 * software.
 *
 * $File: //ResearchProjects/Convergence/implementation/main/SecurityLib/src/morpho/cryptomodule/convergence/ResponseStatusBytes.java $
 * 
 * Last submit:
 *  $Revision: #1 $
 *  $Change: 365542 $
 *  $DateTime: 2012/05/31 20:23:21 $
 *  $Author: akohlos $
 *
 * 
 * Created on 25.10.2011
 *
 */
package morpho.cryptomodule.convergence;


public final class ResponseStatusBytes
{
    protected enum StatusType
    {
        AUTHENTICATION_FAILED("6700"), INCORRECT_PARAMETERS("6A80"), NO_ERROR("9000");
        public static StatusType fromString(final String text)
        {
            if (text != null)
            {
                for (final StatusType b : StatusType.values())
                {
                    if (text.equalsIgnoreCase(b.text))
                    {
                        return b;
                    }
                }
            }
            throw new IllegalArgumentException("No status code with " + text + " found");
        }

        private final String text;

        StatusType(final String text)
        {
            this.text = text;
        }

        public String getText()
        {
            return this.text;
        }
    }
}
