/*
 * Copyright (c) 2011 Safran Morpho.
 * This software is the confidential and proprietary
 * information of Safran Morpho.
 * All rights reserved.
 *
 * Safran Morpho makes no representations or
 * warranties about the suitability of the software, either
 * express or implied, including but not limited to the implied
 * warranties of merchantability, fitness for a particular
 * purpose, or non-infringement.
 * Safran Morpho shall not be liable for any damages
 * suffered by licensee as a result of using, modifying or
 * distributing this software or its derivatives.
 *
 * This copyright notice must appear in all copies of this
 * software.
 *
 * $File: //ResearchProjects/Convergence/implementation/main/SecurityLib/src/morpho/cryptomodule/convergence/ResponseValidator.java $
 * 
 * Last submit:
 *  $Revision: #1 $
 *  $Change: 365542 $
 *  $DateTime: 2012/05/31 20:23:21 $
 *  $Author: akohlos $
 *
 * 
 * Created on 25.10.2011
 *
 */
package morpho.cryptomodule.convergence;


import javax.smartcardio.CardException;

import morpho.util.Converter;


public class ResponseValidator
{
    public static String checkStatusBytes(final int responseLength,
        final byte[] responseBytes) throws CardException
    {
        final byte[] statusBytes = new byte[2];
        System.arraycopy(responseBytes, (responseLength - 2), statusBytes, 0, 2);
        final ResponseStatusBytes.StatusType responseStatus = ResponseStatusBytes.StatusType
            .fromString(Converter.toHex(statusBytes));
        switch (responseStatus)
        {
            case NO_ERROR:
                return responseStatus.getText();
            case AUTHENTICATION_FAILED:
                System.err.println("Card response status: 0x" + responseStatus.getText());
                throw new CardException(
                    "Authentication failed! A wrong PIN could be the problem.");
            case INCORRECT_PARAMETERS:
                System.err.println("Card response status: 0x" + responseStatus.getText());
                throw new CardException(
                    "Incorrect Parameters. Maybe a wrog application alias could be the problem.");
            default:
                System.err.println("Card response status: 0x" + responseStatus.getText());
                throw new CardException("Unknown Exception returned by the card.");
        }
    }
}
