/*
 * Copyright (c) 2012 Safran Morpho.
 * This software is the confidential and proprietary
 * information of Safran Morpho.
 * All rights reserved.
 *
 * Safran Morpho makes no representations or
 * warranties about the suitability of the software, either
 * express or implied, including but not limited to the implied
 * warranties of merchantability, fitness for a particular
 * purpose, or non-infringement.
 * Safran Morpho shall not be liable for any damages
 * suffered by licensee as a result of using, modifying or
 * distributing this software or its derivatives.
 *
 * This copyright notice must appear in all copies of this
 * software.
 *
 * $File: //ResearchProjects/Convergence/implementation/main/SecurityLib/src/morpho/securityengine/AuthenticationManager.java $
 * 
 * Last submit:
 *  $Revision: #1 $
 *  $Change: 365542 $
 *  $DateTime: 2012/05/31 20:23:21 $
 *  $Author: akohlos $
 *
 * 
 * Created on 31.05.2012
 *
 */
package morpho.securityengine;


import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.PublicKey;
import java.security.SignatureException;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;

import morpho.cryptomodule.convergence.CommandDispatcher;
import morpho.securityengine.exceptions.SecurityEngineException;


public class AuthenticationManager
{
    public AuthenticationManager(final CommandDispatcher cryptoModuleManager)
    {
    }

    public String clientAuth(final String serverChallenge, final String keyIdentifier,
        final String PIN) throws SecurityEngineException
    {
        throw new SecurityEngineException("METHOD_NOT_IMPLEMENTED");
    }

    public boolean clientTokenVerify(final String cardAuthToken, final String keyAlias)
        throws SecurityEngineException
    {
        throw new SecurityEngineException("METHOD_NOT_IMPLEMENTED");
    }

    public String getCardChallenge() throws SecurityEngineException
    {
        throw new SecurityEngineException("METHOD_NOT_IMPLEMENTED");
    }

    public String getCertificate(final String keyIdentifier)
        throws SecurityEngineException
    {
        throw new SecurityEngineException("METHOD_NOT_IMPLEMENTED");
    }

    public String getChallenge() throws SecurityEngineException
    {
        throw new SecurityEngineException("METHOD_NOT_IMPLEMENTED");
    }

    public String serverAuth(final String cardChallenge, final String keyAlias,
        final String password) throws SecurityEngineException
    {
        throw new SecurityEngineException("METHOD_NOT_IMPLEMENTED");
    }

    public boolean verifyCertificate(final X509Certificate certificate,
        final PublicKey pubKey) throws SecurityEngineException
    {
        boolean result = true;
        try
        {
            certificate.verify(pubKey);
        }
        catch (final InvalidKeyException e)
        {
            result = false;
        }
        catch (final CertificateException e)
        {
            result = false;
        }
        catch (final NoSuchAlgorithmException e)
        {
            throw new SecurityEngineException(e.getMessage());
        }
        catch (final NoSuchProviderException e)
        {
            throw new SecurityEngineException(e.getMessage());
        }
        catch (final SignatureException e)
        {
            result = false;
        }
        return result;
    }

    public boolean verifyCVCertificate(final X509Certificate CVcertificate,
        final PublicKey pubKey) throws SecurityEngineException
    {
        boolean result = true;
        try
        {
            CVcertificate.verify(pubKey);
        }
        catch (final InvalidKeyException e)
        {
            result = false;
        }
        catch (final CertificateException e)
        {
            result = false;
        }
        catch (final NoSuchAlgorithmException e)
        {
            throw new SecurityEngineException(e.getMessage());
        }
        catch (final NoSuchProviderException e)
        {
            throw new SecurityEngineException(e.getMessage());
        }
        catch (final SignatureException e)
        {
            result = false;
        }
        return result;
    }
}
