/*
 * Copyright (c) 2012 Safran Morpho.
 * This software is the confidential and proprietary
 * information of Safran Morpho.
 * All rights reserved.
 *
 * Safran Morpho makes no representations or
 * warranties about the suitability of the software, either
 * express or implied, including but not limited to the implied
 * warranties of merchantability, fitness for a particular
 * purpose, or non-infringement.
 * Safran Morpho shall not be liable for any damages
 * suffered by licensee as a result of using, modifying or
 * distributing this software or its derivatives.
 *
 * This copyright notice must appear in all copies of this
 * software.
 *
 * $File: //ResearchProjects/Convergence/implementation/main/SecurityLib/src/morpho/securityengine/SecurityEngine.java $
 * 
 * Last submit:
 *  $Revision: #1 $
 *  $Change: 365799 $
 *  $DateTime: 2012/06/01 14:17:13 $
 *  $Author: akohlos $
 *
 * 
 * Created on 31.05.2012
 *
 */
package morpho.securityengine;


import java.security.Security;

import morpho.cryptomodule.CryptoModuleException;
import morpho.cryptomodule.convergence.CommandDispatcher;
import morpho.securityengine.exceptions.SecurityEngineException;


public class SecurityEngine
{
    protected AuthenticationManager authenticationManager;
    protected CertificateManager    certificateManager;
    protected CommandDispatcher     cryptoModuleManager;
    protected KeyManager            keyManager;
    protected SignatureManager      signatureManager;

    public SecurityEngine() throws CryptoModuleException
    {
        Security.addProvider(new org.bouncycastle.jce.provider.BouncyCastleProvider());
        this.cryptoModuleManager = new CommandDispatcher("1", "OMNIKEY CardMan");
    }

    public AuthenticationManager getAuthenticationManager()
        throws SecurityEngineException
    {
        return this.authenticationManager = new AuthenticationManager(
            this.cryptoModuleManager);
    }

    public CertificateManager getCertificateManager() throws SecurityEngineException
    {
        return this.certificateManager = new CertificateManager(this.cryptoModuleManager);
    }

    public CommandDispatcher getCryptoModuleManager() throws SecurityEngineException
    {
        return this.cryptoModuleManager;
    }

    public KeyManager getKeyManager() throws SecurityEngineException
    {
        return this.keyManager = new KeyManager(this.cryptoModuleManager);
    }

    public SignatureManager getSignatureManager() throws SecurityEngineException
    {
        return this.signatureManager = new SignatureManager(this.cryptoModuleManager);
    }
}
