package morpho.securitylib.demo;


/*
 * Copyright (c) 2012 Safran Morpho.
 * This software is the confidential and proprietary
 * information of Safran Morpho.
 * All rights reserved.
 *
 * Safran Morpho makes no representations or
 * warranties about the suitability of the software, either
 * express or implied, including but not limited to the implied
 * warranties of merchantability, fitness for a particular
 * purpose, or non-infringement.
 * Safran Morpho shall not be liable for any damages
 * suffered by licensee as a result of using, modifying or
 * distributing this software or its derivatives.
 *
 * This copyright notice must appear in all copies of this
 * software.
 *
 * $File: //ResearchProjects/Convergence/implementation/main/SecurityLib/src/morpho/securitylib/demo/EncryptDecryptTest.java $
 * 
 * Last submit:
 *  $Revision: #2 $
 *  $Change: 365799 $
 *  $DateTime: 2012/06/01 14:17:13 $
 *  $Author: akohlos $
 *
 * 
 * Created on 31.05.2012
 *
 */
import java.math.BigInteger;
import java.security.PublicKey;
import java.security.cert.X509Certificate;

import morpho.securityengine.obj.EncryptedDataObj;
import morpho.securitylib.exceptions.SecurityLibException;
import morpho.securitylib.interfaces.JavaSecurityModule;
import morpho.util.Converter;
import morpho.util.FileAndObjectHandler;


public class EncryptDecryptTest
{
    public static void main(final String[] args)
    {
        final String uHome = System.getProperty("user.home");
        JavaSecurityModule module = null;
        X509Certificate myIssuerCert = null;
        try
        {
            module = new JavaSecurityModule();
            // TODO correct certificate location path
            myIssuerCert = (X509Certificate)FileAndObjectHandler.readObjectFromFile(uHome
                + "/workspace/SecurityLib_v2_linux/certificate/SecurityLib_root.cert");
        }
        catch (final SecurityLibException e)
        {
            e.printStackTrace();
        }
        final PublicKey pubKey = module.generateRSAKeyPairCard("12345678");
        final BigInteger userSerialNumber = new BigInteger("3");
        final String userID = "345";
        final String userReference = "C=DE,O=Company";
        final int expiryDays = 23;
        final X509Certificate userCert = module.generateCertificate(userID,
            userSerialNumber, userReference, expiryDays, pubKey);
        System.out.println(userCert.toString());
        final X509Certificate[] userCerts = new X509Certificate[1];
        userCerts[0] = userCert;
        System.out.println(myIssuerCert.toString());
        System.out.println(userCert.toString());
        final byte[] byteArray = {4, 4, 3};
        System.out.println("Plaintext: " + Converter.toHex(byteArray));
        final EncryptedDataObj result = module
            .encrypt(byteArray, userCerts, myIssuerCert);
        module.initCardStreamDecrypt("223456");
        final byte[] secondResult = module.cardStreamDecrypt("345", result);
        System.out.println("Decrypted Plaintext: " + Converter.toHex(secondResult));
    }
}
