/*
 * Copyright (c) 2012 Safran Morpho.
 * This software is the confidential and proprietary
 * information of Safran Morpho.
 * All rights reserved.
 *
 * Safran Morpho makes no representations or
 * warranties about the suitability of the software, either
 * express or implied, including but not limited to the implied
 * warranties of merchantability, fitness for a particular
 * purpose, or non-infringement.
 * Safran Morpho shall not be liable for any damages
 * suffered by licensee as a result of using, modifying or
 * distributing this software or its derivatives.
 *
 * This copyright notice must appear in all copies of this
 * software.
 *
 * $File: //ResearchProjects/Convergence/implementation/main/SecurityLib/src/morpho/securitylib/demo/GetCardModulusForDecrypt.java $
 * 
 * Last submit:
 *  $Revision: #2 $
 *  $Change: 365799 $
 *  $DateTime: 2012/06/01 14:17:13 $
 *  $Author: akohlos $
 *
 * 
 * Created on 31.05.2012
 *
 */
package morpho.securitylib.demo;


import morpho.securityengine.SecurityTool;
import morpho.securityengine.exceptions.SecurityEngineException;
import morpho.util.Converter;
import morpho.util.FileAndObjectHandler;


public class GetCardModulusForDecrypt
{
    // private static final String APP_ALIAS1 = "1";
    // private static final String KEY_IDENTIFIER = "conf";
    // private static final String PIN_GAKP = "12345678";
    public static void main(final String[] args)
    {
        System.out.println("***********************************");
        System.out.println("GET CARD MODULUS FROM CARD (FOR ENCRYPTION):");
        System.out.println("***********************************");
        System.out.println("");
        String cardModulus = "";
        try
        {
            final SecurityTool securityTool = new SecurityTool();
            // Get the public key from the card.
            System.out.println("Get the public key from the card:");
            cardModulus = securityTool.getCardModulus(args[1], args[0], args[2]);
            System.out.println("Resulting Modulus: " + cardModulus);
            System.out.println("");
            // Write modulus to hard disk.
            System.out.println("Write 'modulus_conf.bin' to hard disk:");
            FileAndObjectHandler.writeBytesToFile(Converter.toByteArray(cardModulus),
                "./modulus_conf.bin");
        }
        catch (final SecurityEngineException e)
        {
            System.err.println(e.getMessage());
            return;
        }
        System.out.println("done");
        System.out.println("");
    }
}
