/*
 * Copyright (c) 2012 Safran Morpho.
 * This software is the confidential and proprietary
 * information of Safran Morpho.
 * All rights reserved.
 *
 * Safran Morpho makes no representations or
 * warranties about the suitability of the software, either
 * express or implied, including but not limited to the implied
 * warranties of merchantability, fitness for a particular
 * purpose, or non-infringement.
 * Safran Morpho shall not be liable for any damages
 * suffered by licensee as a result of using, modifying or
 * distributing this software or its derivatives.
 *
 * This copyright notice must appear in all copies of this
 * software.
 *
 * $File: //ResearchProjects/Convergence/implementation/main/SecurityLib/src/morpho/securitylib/demo/HybridDecryption.java $
 * 
 * Last submit:
 *  $Revision: #2 $
 *  $Change: 365799 $
 *  $DateTime: 2012/06/01 14:17:13 $
 *  $Author: akohlos $
 *
 * 
 * Created on 31.05.2012
 *
 */
package morpho.securitylib.demo;


import morpho.securityengine.SecurityTool;
import morpho.securityengine.exceptions.SecurityEngineException;
import morpho.util.Converter;
import morpho.util.FileAndObjectHandler;


public class HybridDecryption
{
    // private static final String APP_ALIAS1 = "1";
    // private static final String PIN_CONF = "223456";
    public static void main(final String[] args)
    {
        System.out.println("**********************************");
        System.out.println("Decrypt VDI USING THE WRAPPED KEY:");
        System.out.println("**********************************");
        System.out.println("");
        byte[] wrappedKey = null;
        byte[] plaintext = null;
        byte[] encrypted_VDI = null;
        try
        {
            final SecurityTool securityTool = new SecurityTool();
            // Read the encrypted VDI from hard disk.
            System.out.println("Read the encrypted VDI from hard disk:");
            encrypted_VDI = FileAndObjectHandler.readBytesFromFile("./encryptedVDI.bin");
            System.out.println("done");
            System.out.println("");
            // Read the wrapped key from hard disk.
            System.out.println("Read the wrapped key from hard disk:");
            wrappedKey = FileAndObjectHandler.readBytesFromFile("./wrappedKey.bin");
            System.out.println("done");
            System.out.println("Resulting Wrapped Key: " + Converter.toHex(wrappedKey));
            System.out.println("");
            // Decipher the encrypted VDI by using the wrapped key.
            System.out.println("Decipher the encrypted VDI by using the wrapped key:");
            // plaintext = securityTool
            // .decipher(encrypted_VDI, wrappedKey, APP_ALIAS1, PIN_CONF);
            plaintext = securityTool
                .decipher(encrypted_VDI, wrappedKey, args[0], args[1]);
            System.out.println("");
            // Write decrypted VDI to hard disk.
            System.out.println("Write 'decryptedVDI.bin' to hard disk:");
            FileAndObjectHandler.writeBytesToFile1(plaintext, "./decryptedVDI.bin");
        }
        catch (final SecurityEngineException e)
        {
            System.err.println(e.getMessage());
            return;
        }
        System.out.println("done");
        System.out.println("");
        //
        // // Read the original VDI from hard disk.
        // System.out.println("Read the VDI from hard disk:");
        // original_VDI = FileAndObjectHandler.readBytesFromFile1("./test.bin");
        // System.out.println("done");
        // System.out.println("");
        // // Compare original VDI to the extracted VDI.
        // System.out.println("Compare original VDI to the extracted VDI");
        // if (plaintext.equals(original_VDI))
        // {
        // System.out.println(">>>> THE ORIGINAL VDI MATCHES THE EXTRACTED VDI <<<<");
        // }
        // else
        // {
        // System.out
        // .println(">>>> THE ORIGINAL VDI DOESN'T MATCH THE EXTRACTED VDI <<<<");
        // }
    }
}
