/*
 * Copyright (c) 2012 Safran Morpho.
 * This software is the confidential and proprietary
 * information of Safran Morpho.
 * All rights reserved.
 *
 * Safran Morpho makes no representations or
 * warranties about the suitability of the software, either
 * express or implied, including but not limited to the implied
 * warranties of merchantability, fitness for a particular
 * purpose, or non-infringement.
 * Safran Morpho shall not be liable for any damages
 * suffered by licensee as a result of using, modifying or
 * distributing this software or its derivatives.
 *
 * This copyright notice must appear in all copies of this
 * software.
 *
 * $File: //ResearchProjects/Convergence/implementation/main/SecurityLib/src/morpho/securitylib/demo/HybridEncryption.java $
 * 
 * Last submit:
 *  $Revision: #2 $
 *  $Change: 365799 $
 *  $DateTime: 2012/06/01 14:17:13 $
 *  $Author: akohlos $
 *
 * 
 * Created on 31.05.2012
 *
 */
package morpho.securitylib.demo;


import morpho.securityengine.SecurityTool;
import morpho.securityengine.exceptions.SecurityEngineException;
import morpho.util.Converter;
import morpho.util.FileAndObjectHandler;


public class HybridEncryption
{
    public static void main(final String[] args)
    {
        if (args.length == 0)
        {
            System.err.println("Please provide an input file name!");
            return;
        }
        else if ((args[0] == null) || (args[0] == ""))
        {
            System.err.println("Please provide an input file name!");
            return;
        }
        System.out.println("*************************");
        System.out.println("HYBRID ENCRYPTION OF VDI:");
        System.out.println("*************************");
        System.out.println("");
        byte[] example_VDI = null;
        byte[] ciphertext = null;
        String cardModulus = "";
        try
        {
            final SecurityTool securityTool = new SecurityTool();
            // Read the VDI from hard disk.
            System.out.println("Read the file '" + args[0] + "' from hard disk:");
            // example_VDI = FileAndObjectHandler.readBytesFromFile("./" + args[0]);
            example_VDI = FileAndObjectHandler.readBytesFromFile(args[0]);
            System.out.println("done");
            System.out.println("");
            // Read the modulus from hard disk.
            System.out.println("Read the modulus from hard disk:");
            cardModulus = Converter.toHex(FileAndObjectHandler
                .readBytesFromFile("./modulus_conf.bin"));
            System.out.println("done");
            System.out.println("Resulting Modulus: " + cardModulus);
            System.out.println("");
            // Encipher the VDI (and wrap the key and store it on hard disk).
            System.out.println("Encipher the VDI & Write the card modulus to hard disk:");
            ciphertext = securityTool.encipher(example_VDI, cardModulus);
            System.out.println("done");
            System.out.println("");
            // Write encrypted VDI to hard disk.
            System.out.println("Write 'encryptedVDI.bin' to hard disk:");
            FileAndObjectHandler.writeBytesToFile1(ciphertext, "./encryptedVDI.bin");
        }
        catch (final SecurityEngineException e)
        {
            System.err.println(e.getMessage());
            return;
        }
        System.out.println("done");
        System.out.println("");
    }
}
