/*
 * Copyright (c) 2012 Safran Morpho.
 * This software is the confidential and proprietary
 * information of Safran Morpho.
 * All rights reserved.
 *
 * Safran Morpho makes no representations or
 * warranties about the suitability of the software, either
 * express or implied, including but not limited to the implied
 * warranties of merchantability, fitness for a particular
 * purpose, or non-infringement.
 * Safran Morpho shall not be liable for any damages
 * suffered by licensee as a result of using, modifying or
 * distributing this software or its derivatives.
 *
 * This copyright notice must appear in all copies of this
 * software.
 *
 * $File: //ResearchProjects/Convergence/implementation/main/SecurityLib/src/morpho/securitylib/demo/gui/Controlpanel.java $
 * 
 * Last submit:
 *  $Revision: #1 $
 *  $Change: 365799 $
 *  $DateTime: 2012/06/01 14:17:13 $
 *  $Author: akohlos $
 *
 * 
 * Created on 31.05.2012
 *
 */
package morpho.securitylib.demo.gui;


import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.text.DefaultCaret;


public class Controlpanel extends JFrame
{
    private static Controlpanel instance         = null;
    /**
	 * 
	 */
    private static final long   serialVersionUID = 1L;

    public static Controlpanel getControlPanelInstance()
    {
        if (instance == null)
        {
            instance = new Controlpanel();
        }
        return instance;
    }

    private final JPanel         buttonpanel       = new JPanel();
    private final JButton        chooseFile        = new JButton("Select file");
    private final JButton        decrypt           = new JButton("Decrypt");
    private final JButton        encrypt           = new JButton("Encrypt");
    private String               enteredPIN        = "";
    private final JFileChooser   fc                = new JFileChooser();
    private File                 fileDirectory     = null;
    private final JLabel         fileLocation      = new JLabel();
    private final JButton        generateKeyOnCard = new JButton("Generate key on card");
    private final JButton        generateSignature = new JButton("Generate signature");
    private final ButtonListener listener          = ButtonListener
                                                       .getButtonListenerInstance();
    private final JTextArea      logArea           = new JTextArea();
    private final JPanel         pathPanel         = new JPanel();
    private final JScrollPane    scrollPane        = new JScrollPane();
    private final JButton        verifySignature   = new JButton("Verify signature");
    private File                 workingFile       = null;

    private Controlpanel()
    {
        super("Security Demo");
        instance = this;
        this.setLayout(new BorderLayout());
        this.buttonpanel.setLayout(new GridLayout(3, 2));
        this.generateSignature.addActionListener(this.listener);
        this.chooseFile.addActionListener(this.listener);
        this.generateKeyOnCard.addActionListener(this.listener);
        this.verifySignature.addActionListener(this.listener);
        this.encrypt.addActionListener(this.listener);
        this.decrypt.addActionListener(this.listener);
        this.generateSignature.setActionCommand("genSignature");
        this.generateKeyOnCard.setActionCommand("genKeyOnCard");
        this.chooseFile.setActionCommand("chooseFile");
        this.verifySignature.setActionCommand("verifySig");
        this.encrypt.setActionCommand("encrypt");
        this.decrypt.setActionCommand("decrypt");
        this.buttonpanel.add(this.generateSignature);
        this.buttonpanel.add(this.generateKeyOnCard);
        this.buttonpanel.add(this.verifySignature);
        this.buttonpanel.add(this.chooseFile);
        this.buttonpanel.add(this.encrypt);
        this.buttonpanel.add(this.decrypt);
        this.fileLocation.setText("All generated files are being stored to "
            + new File("SecDemoFiles").getAbsolutePath());
        this.pathPanel.add(this.fileLocation);
        this.buttonpanel.setSize(600, 180);
        final DefaultCaret caret = (DefaultCaret)this.logArea.getCaret();
        caret.setUpdatePolicy(DefaultCaret.ALWAYS_UPDATE);
        this.logArea.setAutoscrolls(true);
        this.logArea.setLineWrap(true);
        this.logArea.setEditable(false);
        this.scrollPane.getViewport().add(this.logArea);
        this.scrollPane.setAutoscrolls(true);
        this.getContentPane().add(this.buttonpanel, BorderLayout.NORTH);
        this.getContentPane().add(this.pathPanel, BorderLayout.SOUTH);
        this.getContentPane().add(this.scrollPane, BorderLayout.CENTER);
        this.setVisible(true);
        this.setSize(650, 400);
        this.setLocation(400, 400);
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);
    }

    public void createFileDir()
    {
        this.fileDirectory = new File("./SecDemoFiles");
        try
        {
            if (this.fileDirectory.mkdir())
            {
                System.out.println("Directory Created");
            }
            else
            {
                System.out.println("Directory is not created");
            }
        }
        catch (final Exception e)
        {
            e.printStackTrace();
        }
    }

    public String getEnteredPIN()
    {
        return this.enteredPIN;
    }

    public JFileChooser getFileChooser()
    {
        return this.fc;
    }

    public File getFileDir()
    {
        return this.fileDirectory;
    }

    public JTextArea getLogArea()
    {
        return this.logArea;
    }

    public File getWorkingFile()
    {
        return this.workingFile;
    }

    public void setEnteredPIN(final String enteredPIN)
    {
        this.enteredPIN = enteredPIN;
    }

    public void setWorkingFile(final File file)
    {
        this.workingFile = file;
    }
}