package DIReader;

import java.io.File;

import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.orchestratorTE.OrchestratorTE;
import org.iso.mpeg.mxm.tEngine.mp21ffTE.MPEG21FileParser;

public class DIReader {

	private static final String TEMP_FOLDER = System.getProperty("java.io.tmpdir") + File.separator;
	private static String DEFAULT_INPUT_VDI_FILE_NAME = TEMP_FOLDER + "first_test.di";
	//on windows7 point to C:\Users\<username>\AppData\Local\Temp\first_test.di	
	
	private final static String MEDIA_RESOURCE_ITEM_ID="B0";
	private final static String DEFAULT_INTPUT_DCF_FILE_NAME= TEMP_FOLDER +  "testDCF.mp21";
	private static final String OUTPUT_MEDIA_RESOURCE_FILE_NAME="c:\\jfp.png_ret";
	private static String DEFAULT_OUTPUT_VDI_FILE_NAME = TEMP_FOLDER + "first_test.di_ret";
	
	public static void main(String[] args) {
		
		try {
			
			//extract from mp21 every data in it
			try {
				MPEG21FileParser dcfParser = OrchestratorTE.getMP21FileEngine().getMPEG21FileParser();
				
				dcfParser.getDCI(DEFAULT_INTPUT_DCF_FILE_NAME, DEFAULT_OUTPUT_VDI_FILE_NAME);
				dcfParser.getMediaData(MEDIA_RESOURCE_ITEM_ID, OUTPUT_MEDIA_RESOURCE_FILE_NAME);
			} catch (MXMException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			String URLResource = OrchestratorTE.dealWithDIDEngine().readDI(DEFAULT_INPUT_VDI_FILE_NAME);
				
			System.out.println("RESOURCE URL is: "+URLResource);
			
			//OrchestratorTE.dealWithMFEngine().openAndPlay("http://research.cedeo.net/angelo/trailer_720p.mov");
			//OrchestratorTE.dealWithMFEngine().openAndPlay("trailer_720p.mov"); //VLC
			OrchestratorTE.dealWithMFEngine().openAndPlay("file://trailer_720p.mov"); //FIXME TODO GST
			//OrchestratorTE.dealWithMFEngine().openAndPlay(URLResource);

		} catch (MXMEngineException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 		
	}
}
