/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the Chillout Project (http://chillout.dmpf.org)
 *
 * The Initial Developer of the Original Code is CEDEO.net
 * Portions created by the Initial Developer are Copyright (C) 2006-2008
 * All Rights Reserved.
 *
 * The Initial Developer: Filippo Chiariglione 
 * Contributor(s): Angelo Difino <angelo@cedeo.net>
 *
 * ***** END LICENSE BLOCK ***** */

package org.iso.mpeg.mxm.core;

/**
 * This enumeration lists the names of all possible MPEGM Engines so 
 * any entity can unambiguously determine the name of an MPEGM Engine.
 * 
 * @author Filippo Chiariglione <filippo@cedeo.net>
 * @author Angelo Difino <angelo@cedeo.net>
 */

public enum MXMEngineName {
	Orchestrator,
	DigitalItemTE,				//7.2, 8.2.1
	MPEG21FileTE,				//7.3, 8.2.2
	RELTE,						//7.4, 8.2.3
	IPMPTE,						//7.5, 8.2.4
	MediaFrameworkTE,			//7.6, 8.2.5
	MetadataTE,					//7.7, 8.2.6
	EventReportTE,				//7.8, 8.2.7
	SecurityTE,					//7.9, 8.2.8
	SearchTE,					//7.10, 8.2.9
	CELTE,						//7.11, 8.2.10
	OrchestratorTE,
	OverlayTE,
	IdentifyContentPE,
	IdentifyUserPE,
	IdentifyDevicePE,
	AuthenticateContentPE,
	AuthenticateUserPE,
	AuthorizeUserPE,
	PostContentPE,
	RequestEventPE,
	StoreEventPE,
	CreateLicensePE,
	CreateContentPE,
	CheckWithLicensePE,
	DescribeContentPE,
	StoreLicensePE,
	RevokeLicensePE,
	SearchLicensePE,
	PackageContentPE,
	RevokeContentPE,
	UnpublishContentPE
	;

	public String value() {
		return name();
	}

	public static MXMEngineName fromValue(String v) {
		return valueOf(v);
	}

}
