/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the MPEG Multimedia Extensible Middleware (MXM) Project 
 *
 * The Initial Developer of the Original Code is CEDEO.net  
 * Portions created by the Initial Developer are Copyright (C) 2009
 * All Rights Reserved.
 *
 * The Initial Developer: Filippo Chiariglione  
 * Contributor(s): Angelo Difino <angelo@cedeo.net>
 * 
 * ***** END LICENSE BLOCK ***** */

package org.iso.mpeg.mxm.core;

/**
 * This enumeration is used as a general-purpose return value for a number of methods.
 * The following values are allowed:
 * <ul>
 * 	<li>SUCCESS: The method terminated successfully</li>
 * 	<li>FAILURE: The method failed</li>
 * 	<li>METHOD_NOT_IMPLEMENTED: The method has not been implemented</li>
 * </ul> 
 * 
 * @author filippo
 * @author Angelo Difino <angelo@cedeo.net>
 */

public enum MXMEngineResponse {

	SUCCESS,
	FAILURE,
	METHOD_NOT_IMPLEMENTED;

	public String value() {
		return name();
	}

	public static MXMEngineResponse fromValue(String v) {
		return valueOf(v);
	}

}
