/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the MPEG Multimedia Extensible Middleware (MXM) Project 
 *
 * The Initial Developer of the Original Code is CEDEO.net  
 * Portions created by the Initial Developer are Copyright (C) 2009
 * All Rights Reserved.
 *
 * The Initial Developer: Filippo Chiariglione  
 * Contributor(s): Angelo Difino <angelo@cedeo.net>
 *
 * ***** END LICENSE BLOCK ***** */

package org.iso.mpeg.mxm.core;

/**
 * This is the highest level of exception thrown by MPEGM. All other exceptions in 
 * MPEGM extends this abstract class.
 * 
 * @author filippo
 * @author Angelo Difino <angelo@cedeo.net>
 */

public abstract class MXMException extends Exception implements MXMObject {

	private static final long serialVersionUID = 4776463189194352326L;

	private Object content = null;
	
	private String contentType = null;

	public MXMException(String s) { 
		super(s); 
	}

	public MXMException(String s, MXMException e) {
		super(s,e); 
	}

	public MXMException(String message, Exception e) {
		super(message,e); 
	}

	public Object getContent() {
		return content;
	}

	public String getMxmVersion() {
		return mxmVersion;
	}

	public String getContentType() {
		return contentType;
	}

	public boolean hasContent() {
		return (content != null) ? true : false;
	}

}
