/**
 * The copyright in this software is being made available under the BSD License,
 * included below. This software may be subject to other third party and contributor 
 * rights, including patent rights, and no such rights are granted under this license.
 * 
 * Copyright (c) 2012, CEDEO
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 *     - Redistributions of source code must retain the above copyright notice, this 
 *     list of conditions and the following disclaimer.
 *     - Redistributions in binary form must reproduce the above copyright notice, 
 *     this list of conditions and the following disclaimer in the documentation 
 *     and/or other materials provided with the distribution.
 *     - Neither the name of the CEDEO nor the names of its contributors may be used 
 *     to endorse or promote products derived from this software without specific 
 *     prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS AS IS AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT 
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, 
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE.
*/

package org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl;

import java.util.List;

import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;

/**
 * Profiled version of the standard MP21 DIDL structure, defined in the progress of MPEG-M (and MSAF)
 * Component etends the standard MP21 version avaialbe in the package didl_mp21
 * 
 * @author Angelo Difino <angelo@cedeo.net>
 */
public interface Component extends org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didmodel_mp21.Component
{
	//removed due name clash on shortcut methods
	//public List<Object> getResource();
	
	/*********************************************************************************************************************************************PARTICULAR METHODS*/
	
	/** 
	 * <b>***PARTICULAR METOD</b>
	 * Set specific Resource of the DIDL (MPWEG/M PROFILE)
	 * This particular method avoid to cast the Resource as managed as Object, instead of using MPEGM PFILED Resource
	 * @param  <code>List<Resource></code> with all the information contained in the XML fragment
	 */		
	public List<org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Resource> getResource() throws MXMEngineException;
	
	/** 
	 * <b>***PARTICULAR METOD</b>
	 * Set specific Resource of the DIDL (MPWEG/M PROFILE)
	 * This particular method avoid to cast the Resource as managed as Object, instead of using MPEGM PFILED Resource	 * 
	 * @param  <code>List<Resource></code> with all the information contained in the XML fragment
	 */			
	public void addResource(org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Resource r) throws MXMException;
}