/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the MPEG Multimedia Extensible Middleware (MXM) Project 
 *
 * The Initial Developer of the Original Code is CEDEO.net  
 * Portions created by the Initial Developer are Copyright (C) 2009
 * All Rights Reserved.
 *
 * The Initial Developer: Filippo Chiariglione  
 * Contributor(s): Angelo Difino
 * Contributor(s): Bogdan Ardeleanu
 *
 * ***** END LICENSE BLOCK ***** */

package org.iso.mpeg.mxm.tEngine.eventreportTE.technologyhandler;

/**
 * This class is used to retreive the structural parameters that event report engine uses.
 * <p/>
 * User: <a href="mailto:bogdan.ardeleanu@uti.ro"> Bogdan Ardeleanu</a>
 * Date: 9/12/11
 * Time: 11:04 AM
 * <p/>
 * UTI Systems, TIC
 */
public interface EREngineParams {
    /**
     * @return The peer identifier.
     */
    String getPeerId();

    /**
     * @return the SAP in the format: peerX.peers.ict-convergence.eu/<service>
     */
    String getSAP();

    /**
     * @return the root location for the ERR repository (ER is stored on the running peer when ERArrivalEvent occur)
     */
    String getRootERRStorageLocation();

    /**
     * @return the root location for the ER repository (ERR is stored on the running peer when MXMMatchEvent occur)
     */
    String getRootERStorageLocation();
}
