/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the MPEG Multimedia Extensible Middleware (MXM) Project 
 *
 * The Initial Developer of the Original Code is CEDEO.net  
 * Portions created by the Initial Developer are Copyright (C) 2009
 * All Rights Reserved.
 *
 * The Initial Developer: Filippo Chiariglione  
 * Contributor(s):  Angelo Difino
 *
 * ***** END LICENSE BLOCK ***** */

package org.iso.mpeg.mxm.tEngine.mediaframeworkTE;

import java.awt.Canvas;

import org.iso.mpeg.mxm.core.MXMEngine;
import org.iso.mpeg.mxm.tEngine.mediaframeworkTE.access.AccessMediaFramework;
import org.iso.mpeg.mxm.tEngine.mediaframeworkTE.creation.CreationMediaFramework;
import org.iso.mpeg.mxm.tEngine.mediaframeworkTE.exception.MediaFrameworkEngineException;

/**
 * @author Angelo Difino <angelo@cedeo.net>
 *
 */
public interface  MediaFrameworkEngine extends MXMEngine {

	/**
	 * This method returns an instance of class <code>AccessMediaFramework</code> which is 
	 * needed to access (play) a resource 
	 * It render on the passed Canvas
	 * @return an object of class <code>AccessMediaFramework</code> or null if this method 
	 * has not been implemented by the specific MediaFrameworkEngine.
	 * @throws MediaFrameworkEngineException 
	 */
	public AccessMediaFramework getAccessMediaFramework(Canvas canvas) throws MediaFrameworkEngineException ;
	
	/**
	 * This method returns an instance of class <code>CreationMediaFramework</code> which is 
	 * needed to create (record) a resource
	 * @return an object of class <code>CreationMediaFramework</code> or null if this method 
	 * has not been implemented by the specific MediaFrameworkEngine.
	 */
	public CreationMediaFramework getCreationMediaFramework() throws MediaFrameworkEngineException  ;

}
