/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the MPEG Multimedia Extensible Middleware (MXM) Project 
 *
 * The Initial Developer of the Original Code is CEDEO.net  
 * Portions created by the Initial Developer are Copyright (C) 2009
 * All Rights Reserved.
 *
 * The Initial Developer: Filippo Chiariglione  
 * Contributor(s):  Angelo Difino
 *
 * ***** END LICENSE BLOCK ***** */

package org.iso.mpeg.mxm.tEngine.mediaframeworkTE.creation;

import java.net.URL;
import java.util.List;

import org.iso.mpeg.mxm.core.MXMObject;

/**
 * @author Angelo Difino <angelo@cedeo.net>
 *
 */
public interface CreationMediaFramework {

	/** this is a very high level interface that simply ask to the media framework to create and instantiate a new chain to manage
	 * the passed resource and to create the output resource.
	 * The mediaframework has also to take care to instantiate the passed list of protectedtool (here speficied as MXMObject)
	 */
	public boolean manageResource(List<MXMObject> tools, URL locationResource, URL newLocationResource);
	
}
