package org.iso.mpeg.mxm.tEngine.metadataTE;

import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.fru.FRU;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.fru.Query;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.fru.Src;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.fru.XmlPull;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.fru.XmlPullCommand;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.*;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.Object;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.Package;

public interface MetadataEngineSchemaHandler
{
	// FRU
	public FRU getFRU() throws MXMEngineException;
	public Query getQuery() throws MXMEngineException;
	public Src getSrc() throws MXMEngineException;
	public XmlPull getXmlPull() throws MXMEngineException;
	public XmlPullCommand getXmlPullCommand() throws MXMEngineException;
	
	// MPEG7_v3
	public AbstractionLevel getAbstractionLevel() throws MXMEngineException;
	public AccessUnit getAccessUnit() throws MXMEngineException;
	public Acquaintance getAcquaintance() throws MXMEngineException;
	public AdvancedFaceRecognition getAdvancedFaceRecognition() throws MXMEngineException;
	public Affective getAffective() throws MXMEngineException;
	public AffectiveScore getAffectiveScore() throws MXMEngineException;
	public Affiliation getAffiliation() throws MXMEngineException;
	public Agent getAgent() throws MXMEngineException;
	public AgentObject getAgentObject() throws MXMEngineException;
	public AggregatedMediaReviewDescription getAggregatedMediaReviewDescription() throws MXMEngineException;
	public AnalyticClip getAnalyticClip() throws MXMEngineException;
	public AnalyticEditedVideo getAnalyticEditedVideo() throws MXMEngineException;
	public AnalyticEditedVideoSegment getAnalyticEditedVideoSegment() throws MXMEngineException;
	public AnalyticEditedVideoSegmentSpatioTemporalDecomposition getAnalyticEditedVideoSegmentSpatioTemporalDecomposition() throws MXMEngineException;
	public AnalyticModel getAnalyticModel() throws MXMEngineException;
	public AnalyticModelLabel getAnalyticModelLabel() throws MXMEngineException;
	public AnalyticModelSemantics getAnalyticModelSemantics() throws MXMEngineException;
	public AnalyticTransition getAnalyticTransition() throws MXMEngineException;
	public Audio getAudio() throws MXMEngineException;
	public AudioBPM getAudioBPM() throws MXMEngineException;
	public AudioChordPatternDS getAudioChordPatternDS() throws MXMEngineException;
	public AudioChordPatternDSChord getAudioChordPatternDSChord() throws MXMEngineException;
	public AudioD getAudioD() throws MXMEngineException;
	public AudioDS getAudioDS() throws MXMEngineException;
	public AudioFundamentalFrequency getAudioFundamentalFrequency() throws MXMEngineException;
	public AudioHarmonicity getAudioHarmonicity() throws MXMEngineException;
	public AudioLLDScalar getAudioLLDScalar() throws MXMEngineException;
	public AudioLLDScalarSeriesOfScalar getAudioLLDScalarSeriesOfScalar() throws MXMEngineException;
	public AudioLLDVector getAudioLLDVector() throws MXMEngineException;
	public AudioLLDVectorSeriesOfVector getAudioLLDVectorSeriesOfVector() throws MXMEngineException;
	public AudioPower getAudioPower() throws MXMEngineException;
	public AudioRhythmicPatternDS getAudioRhythmicPatternDS() throws MXMEngineException;
	public AudioRhythmicPatternDSSinglePattern getAudioRhythmicPatternDSSinglePattern() throws MXMEngineException;
	public AudioSegment getAudioSegment() throws MXMEngineException;
	public AudioSegmentMediaSourceDecomposition getAudioSegmentMediaSourceDecomposition() throws MXMEngineException;
	public AudioSegmentTemporalDecomposition getAudioSegmentTemporalDecomposition() throws MXMEngineException;
	public AudioSignalQuality getAudioSignalQuality() throws MXMEngineException;
	public AudioSignalQualityErrorEventList getAudioSignalQualityErrorEventList() throws MXMEngineException;
	public AudioSignature getAudioSignature() throws MXMEngineException;
	public AudioSpectrumBasis getAudioSpectrumBasis() throws MXMEngineException;
	public AudioSpectrumCentroid getAudioSpectrumCentroid() throws MXMEngineException;
	public AudioSpectrumEnvelope getAudioSpectrumEnvelope() throws MXMEngineException;
	public AudioSpectrumFlatness getAudioSpectrumFlatness() throws MXMEngineException;
	public AudioSpectrumProjection getAudioSpectrumProjection() throws MXMEngineException;
	public AudioSpectrumSpread getAudioSpectrumSpread() throws MXMEngineException;
	public AudioSummaryComponent getAudioSummaryComponent() throws MXMEngineException;
	public AudioTempo getAudioTempo() throws MXMEngineException;
	public AudioVisual getAudioVisual() throws MXMEngineException;
	public AudioVisualRegion getAudioVisualRegion() throws MXMEngineException;
	public AudioVisualRegionMediaSourceDecomposition getAudioVisualRegionMediaSourceDecomposition() throws MXMEngineException;
	public AudioVisualRegionSpatialDecomposition getAudioVisualRegionSpatialDecomposition() throws MXMEngineException;
	public AudioVisualRegionSpatioTemporalDecomposition getAudioVisualRegionSpatioTemporalDecomposition() throws MXMEngineException;
	public AudioVisualRegionTemporalDecomposition getAudioVisualRegionTemporalDecomposition() throws MXMEngineException;
	public AudioVisualSegment getAudioVisualSegment() throws MXMEngineException;
	public AudioVisualSegmentMediaSourceDecomposition getAudioVisualSegmentMediaSourceDecomposition() throws MXMEngineException;
	public AudioVisualSegmentSpatialDecomposition getAudioVisualSegmentSpatialDecomposition() throws MXMEngineException;
	public AudioVisualSegmentSpatioTemporalDecomposition getAudioVisualSegmentSpatioTemporalDecomposition() throws MXMEngineException;
	public AudioVisualSegmentTemporalDecomposition getAudioVisualSegmentTemporalDecomposition() throws MXMEngineException;
	public AudioWaveform getAudioWaveform() throws MXMEngineException;
	public Availability getAvailability() throws MXMEngineException;
	public AvailabilityAvailabilityPeriod getAvailabilityAvailabilityPeriod() throws MXMEngineException;
	public BackgroundNoiseLevel getBackgroundNoiseLevel() throws MXMEngineException;
	public Balance getBalance() throws MXMEngineException;
	public Bandwidth getBandwidth() throws MXMEngineException;
	public BinomialDistribution getBinomialDistribution() throws MXMEngineException;
	public BoxList getBoxList() throws MXMEngineException;
	public BrowsingPreferences getBrowsingPreferences() throws MXMEngineException;
	public BrowsingPreferencesPreferenceCondition getBrowsingPreferencesPreferenceCondition() throws MXMEngineException;
	public CameraMotion getCameraMotion() throws MXMEngineException;
	public CameraMotionSegment getCameraMotionSegment() throws MXMEngineException;
	public ChordBase getChordBase() throws MXMEngineException;
	public Classification getClassification() throws MXMEngineException;
	public ClassificationCaptionLanguage getClassificationCaptionLanguage() throws MXMEngineException;
	public ClassificationGenre getClassificationGenre() throws MXMEngineException;
	public ClassificationModel getClassificationModel() throws MXMEngineException;
	public ClassificationPerceptualAttribute getClassificationPerceptualAttribute() throws MXMEngineException;
	public ClassificationPreferences getClassificationPreferences() throws MXMEngineException;
	public ClassificationPreferencesAssociatedData getClassificationPreferencesAssociatedData() throws MXMEngineException;
	public ClassificationPreferencesCaptionLanguage getClassificationPreferencesCaptionLanguage() throws MXMEngineException;
	public ClassificationPreferencesCountry getClassificationPreferencesCountry() throws MXMEngineException;
	public ClassificationPreferencesDatePeriod getClassificationPreferencesDatePeriod() throws MXMEngineException;
	public ClassificationPreferencesForm getClassificationPreferencesForm() throws MXMEngineException;
	public ClassificationPreferencesGenre getClassificationPreferencesGenre() throws MXMEngineException;
	public ClassificationPreferencesLanguage getClassificationPreferencesLanguage() throws MXMEngineException;
	public ClassificationPreferencesLanguageFormat getClassificationPreferencesLanguageFormat() throws MXMEngineException;
	public ClassificationPreferencesParentalGuidance getClassificationPreferencesParentalGuidance() throws MXMEngineException;
	public ClassificationPreferencesReview getClassificationPreferencesReview() throws MXMEngineException;
	public ClassificationPreferencesSubject getClassificationPreferencesSubject() throws MXMEngineException;
	public ClassificationRelease getClassificationRelease() throws MXMEngineException;
	public ClassificationScheme getClassificationScheme() throws MXMEngineException;
	public ClassificationSchemeAlias getClassificationSchemeAlias() throws MXMEngineException;
	public ClassificationSchemeBase getClassificationSchemeBase() throws MXMEngineException;
	public ClassificationSchemeDescription getClassificationSchemeDescription() throws MXMEngineException;
	public ClassificationSignLanguage getClassificationSignLanguage() throws MXMEngineException;
	public ClassificationTarget getClassificationTarget() throws MXMEngineException;
	public ClassificationTargetAge getClassificationTargetAge() throws MXMEngineException;
	public ClusterClassificationModel getClusterClassificationModel() throws MXMEngineException;
	public ClusterModel getClusterModel() throws MXMEngineException;
	public Collection getCollection() throws MXMEngineException;
	public CollectionModel getCollectionModel() throws MXMEngineException;
	public ColorLayout getColorLayout() throws MXMEngineException;
	public ColorQuantization getColorQuantization() throws MXMEngineException;
	public ColorSampling getColorSampling() throws MXMEngineException;
	public ColorSamplingField getColorSamplingField() throws MXMEngineException;
	public ColorSamplingFieldComponent getColorSamplingFieldComponent() throws MXMEngineException;
	public ColorSamplingFieldComponentOffset getColorSamplingFieldComponentOffset() throws MXMEngineException;
	public ColorSamplingFieldComponentPeriod getColorSamplingFieldComponentPeriod() throws MXMEngineException;
	public ColorSamplingLattice getColorSamplingLattice() throws MXMEngineException;
	public ColorSpace getColorSpace() throws MXMEngineException;
	public ColorStructure getColorStructure() throws MXMEngineException;
	public ColorTemperature getColorTemperature() throws MXMEngineException;
	public CompleteDescription getCompleteDescription() throws MXMEngineException;
	public CompositionShot getCompositionShot() throws MXMEngineException;
	public CompositionShotEditingTemporalDecomposition getCompositionShotEditingTemporalDecomposition() throws MXMEngineException;
	public CompositionTransition getCompositionTransition() throws MXMEngineException;
	public Concept getConcept() throws MXMEngineException;
	public ConceptCollection getConceptCollection() throws MXMEngineException;
	public ConfusionCount getConfusionCount() throws MXMEngineException;
	public ConnectionBase getConnectionBase() throws MXMEngineException;
	public Connections getConnections() throws MXMEngineException;
	public ContentAbstraction getContentAbstraction() throws MXMEngineException;
	public ContentCollection getContentCollection() throws MXMEngineException;
	public ContentDescription getContentDescription() throws MXMEngineException;
	public ContentEntity getContentEntity() throws MXMEngineException;
	public ContentManagement getContentManagement() throws MXMEngineException;
	public ContinuousDistribution getContinuousDistribution() throws MXMEngineException;
	public ContinuousHiddenMarkovModel getContinuousHiddenMarkovModel() throws MXMEngineException;
	public ContinuousUniformDistribution getContinuousUniformDistribution() throws MXMEngineException;
	public ContourShape getContourShape() throws MXMEngineException;
	public ContourShapePeak getContourShapePeak() throws MXMEngineException;
	public ControlledTermUse getControlledTermUse() throws MXMEngineException;
	public Creation getCreation() throws MXMEngineException;
	public CreationCreationCoordinates getCreationCreationCoordinates() throws MXMEngineException;
	public CreationDescription getCreationDescription() throws MXMEngineException;
	public CreationInformation getCreationInformation() throws MXMEngineException;
	public CreationPreferences getCreationPreferences() throws MXMEngineException;
	public CreationPreferencesCreator getCreationPreferencesCreator() throws MXMEngineException;
	public CreationPreferencesDatePeriod getCreationPreferencesDatePeriod() throws MXMEngineException;
	public CreationPreferencesKeyword getCreationPreferencesKeyword() throws MXMEngineException;
	public CreationPreferencesLocation getCreationPreferencesLocation() throws MXMEngineException;
	public CreationPreferencesTitle getCreationPreferencesTitle() throws MXMEngineException;
	public CreationPreferencesTool getCreationPreferencesTool() throws MXMEngineException;
	public CreationTool getCreationTool() throws MXMEngineException;
	public CreationToolSetting getCreationToolSetting() throws MXMEngineException;
	public Creator getCreator() throws MXMEngineException;
	public CrossChannelCorrelation getCrossChannelCorrelation() throws MXMEngineException;
	public D getD() throws MXMEngineException;
	public DcOffset getDcOffset() throws MXMEngineException;
	public DecoderInit getDecoderInit() throws MXMEngineException;
	public DegreeAccidental getDegreeAccidental() throws MXMEngineException;
	public DegreeNote getDegreeNote() throws MXMEngineException;
	public DependencyStructure getDependencyStructure() throws MXMEngineException;
	public DependencyStructurePhrase getDependencyStructurePhrase() throws MXMEngineException;
	public DescriptionMetadata getDescriptionMetadata() throws MXMEngineException;
	public DescriptionProfile getDescriptionProfile() throws MXMEngineException;
	public DescriptorCollection getDescriptorCollection() throws MXMEngineException;
	public DescriptorModel getDescriptorModel() throws MXMEngineException;
	public DiscreteDistribution getDiscreteDistribution() throws MXMEngineException;
	public DiscreteHiddenMarkovModel getDiscreteHiddenMarkovModel() throws MXMEngineException;
	public DiscreteUniformDistribution getDiscreteUniformDistribution() throws MXMEngineException;
	public Dissemination getDissemination() throws MXMEngineException;
	public DistributionPerceptualAttribute getDistributionPerceptualAttribute() throws MXMEngineException;
	public DominantColor getDominantColor() throws MXMEngineException;
	public DominantColorValue getDominantColorValue() throws MXMEngineException;
	public DoubleDiagonalMatrix getDoubleDiagonalMatrix() throws MXMEngineException;
	public DoubleMatrix getDoubleMatrix() throws MXMEngineException;
	public DoublePullbackDefinition getDoublePullbackDefinition() throws MXMEngineException;
	public DoublePushoutDefinition getDoublePushoutDefinition() throws MXMEngineException;
	public DS getDS() throws MXMEngineException;
	public EdgeHistogram getEdgeHistogram() throws MXMEngineException;
	public EditedMovingRegion getEditedMovingRegion() throws MXMEngineException;
	public EditedVideo getEditedVideo() throws MXMEngineException;
	public EditedVideoEditingTemporalDecomposition getEditedVideoEditingTemporalDecomposition() throws MXMEngineException;
	public ElectronicAddress getElectronicAddress() throws MXMEngineException;
	public ElectronicAddressTelephone getElectronicAddressTelephone() throws MXMEngineException;
	public EnhancedAudioSignature getEnhancedAudioSignature() throws MXMEngineException;
	public ErrorEvent getErrorEvent() throws MXMEngineException;
	public Event getEvent() throws MXMEngineException;
	public ExponentialDistribution getExponentialDistribution() throws MXMEngineException;
	public ExtendedElectronicAddress getExtendedElectronicAddress() throws MXMEngineException;
	public ExtendedLanguage getExtendedLanguage() throws MXMEngineException;
	public Extent getExtent() throws MXMEngineException;
	public FaceRecognition getFaceRecognition() throws MXMEngineException;
	public FigureTrajectory getFigureTrajectory() throws MXMEngineException;
	public Filter getFilter() throws MXMEngineException;
	public Filter1D getFilter1D() throws MXMEngineException;
	public Filter2D getFilter2D() throws MXMEngineException;
	public Filtering getFiltering() throws MXMEngineException;
	public FilteringAndSearchPreferences getFilteringAndSearchPreferences() throws MXMEngineException;
	public FilterSeparable getFilterSeparable() throws MXMEngineException;
	public Financial getFinancial() throws MXMEngineException;
	public FinancialAccountItem getFinancialAccountItem() throws MXMEngineException;
	public FiniteStateModel getFiniteStateModel() throws MXMEngineException;
	public FloatDiagonalMatrix getFloatDiagonalMatrix() throws MXMEngineException;
	public FloatMatrix getFloatMatrix() throws MXMEngineException;
	public FocusOfExpansion getFocusOfExpansion() throws MXMEngineException;
	public FractionalPresence getFractionalPresence() throws MXMEngineException;
	public FragmentReference getFragmentReference() throws MXMEngineException;
	public FragmentUpdateContext getFragmentUpdateContext() throws MXMEngineException;
	public FragmentUpdatePayload getFragmentUpdatePayload() throws MXMEngineException;
	public FragmentUpdateUnit getFragmentUpdateUnit() throws MXMEngineException;
	public FrequencyTree getFrequencyTree() throws MXMEngineException;
	public FrequencyView getFrequencyView() throws MXMEngineException;
	public GammaDistribution getGammaDistribution() throws MXMEngineException;
	public GaussianDistribution getGaussianDistribution() throws MXMEngineException;
	public GaussianMixtureModel getGaussianMixtureModel() throws MXMEngineException;
	public GeneralizedGaussianDistribution getGeneralizedGaussianDistribution() throws MXMEngineException;
	public GeographicPoint getGeographicPoint() throws MXMEngineException;
	public GeometricDistribution getGeometricDistribution() throws MXMEngineException;
	public GlobalTransition getGlobalTransition() throws MXMEngineException;
	public GoFGoPColor getGoFGoPColor() throws MXMEngineException;
	public GofGopFeature getGofGopFeature() throws MXMEngineException;
	public Graph getGraph() throws MXMEngineException;
	public GraphicalClassificationScheme getGraphicalClassificationScheme() throws MXMEngineException;
	public GraphicalRuleDefinition getGraphicalRuleDefinition() throws MXMEngineException;
	public GraphicalTermDefinition getGraphicalTermDefinition() throws MXMEngineException;
	public GraphNode getGraphNode() throws MXMEngineException;
	public GridLayout getGridLayout() throws MXMEngineException;
	public HandWritingRecogInformation getHandWritingRecogInformation() throws MXMEngineException;
	public HandWritingRecogInformationInkLexicon getHandWritingRecogInformationInkLexicon() throws MXMEngineException;
	public HandWritingRecogInformationInkLexiconEntry getHandWritingRecogInformationInkLexiconEntry() throws MXMEngineException;
	public HandWritingRecogInformationRecognizer getHandWritingRecogInformationRecognizer() throws MXMEngineException;
	public HandWritingRecogResult getHandWritingRecogResult() throws MXMEngineException;
	public HandWritingRecogResultResult getHandWritingRecogResultResult() throws MXMEngineException;
	public HarmonicInstrumentTimbre getHarmonicInstrumentTimbre() throws MXMEngineException;
	public HarmonicSpectralCentroid getHarmonicSpectralCentroid() throws MXMEngineException;
	public HarmonicSpectralDeviation getHarmonicSpectralDeviation() throws MXMEngineException;
	public HarmonicSpectralSpread getHarmonicSpectralSpread() throws MXMEngineException;
	public HarmonicSpectralVariation getHarmonicSpectralVariation() throws MXMEngineException;
	public Header getHeader() throws MXMEngineException;
	public HierarchicalSummary getHierarchicalSummary() throws MXMEngineException;
	public HistogramProbability getHistogramProbability() throws MXMEngineException;
	public HomogeneousTexture getHomogeneousTexture() throws MXMEngineException;
	public HyperGeometricDistribution getHyperGeometricDistribution() throws MXMEngineException;
	public IlluminationInvariantColor getIlluminationInvariantColor() throws MXMEngineException;
	public Image getImage() throws MXMEngineException;
	public ImageLocator getImageLocator() throws MXMEngineException;
	public ImageLocatorBytePosition getImageLocatorBytePosition() throws MXMEngineException;
	public ImageSignature getImageSignature() throws MXMEngineException;
	public ImageSignatureLocalSignature getImageSignatureLocalSignature() throws MXMEngineException;
	public ImageSignatureLocalSignatureFeaturePoint getImageSignatureLocalSignatureFeaturePoint() throws MXMEngineException;
	public ImageText getImageText() throws MXMEngineException;
	public IncrDuration getIncrDuration() throws MXMEngineException;
	public IndividualMediaReviewDescription getIndividualMediaReviewDescription() throws MXMEngineException;
	public InkContent getInkContent() throws MXMEngineException;
	public InkMediaInformation getInkMediaInformation() throws MXMEngineException;
	public InkMediaInformationBrush getInkMediaInformationBrush() throws MXMEngineException;
	public InkMediaInformationInputDevice getInkMediaInformationInputDevice() throws MXMEngineException;
	public InkMediaInformationOverlaidMedia getInkMediaInformationOverlaidMedia() throws MXMEngineException;
	public InkMediaInformationParam getInkMediaInformationParam() throws MXMEngineException;
	public InkMediaInformationWritingFieldLayout getInkMediaInformationWritingFieldLayout() throws MXMEngineException;
	public InkSegment getInkSegment() throws MXMEngineException;
	public InkSegmentSpatialDecomposition getInkSegmentSpatialDecomposition() throws MXMEngineException;
	public InkSegmentTemporalDecomposition getInkSegmentTemporalDecomposition() throws MXMEngineException;
	public InlineMedia getInlineMedia() throws MXMEngineException;
	public InlineTermDefinition getInlineTermDefinition() throws MXMEngineException;
	public InlineTermDefinitionName getInlineTermDefinitionName() throws MXMEngineException;
	public InlineTermDefinitionTerm getInlineTermDefinitionTerm() throws MXMEngineException;
	public InstantMessagingScreenName getInstantMessagingScreenName() throws MXMEngineException;
	public InstrumentTimbre getInstrumentTimbre() throws MXMEngineException;
	public IntegerDiagonalMatrix getIntegerDiagonalMatrix() throws MXMEngineException;
	public IntegerMatrix getIntegerMatrix() throws MXMEngineException;
	public InternalTransition getInternalTransition() throws MXMEngineException;
	public IntraCompositionShot getIntraCompositionShot() throws MXMEngineException;
	public IntraCompositionShotEditingTemporalDecomposition getIntraCompositionShotEditingTemporalDecomposition() throws MXMEngineException;
	public IrregularVisualTimeSeries getIrregularVisualTimeSeries() throws MXMEngineException;
	public Key getKey() throws MXMEngineException;
	public KeyKeyNote getKeyKeyNote() throws MXMEngineException;
	public KeywordAnnotation getKeywordAnnotation() throws MXMEngineException;
	public KeywordAnnotationKeyword getKeywordAnnotationKeyword() throws MXMEngineException;
	public Lexicon getLexicon() throws MXMEngineException;
	public LinearPerceptualAttribute getLinearPerceptualAttribute() throws MXMEngineException;
	public Linguistic getLinguistic() throws MXMEngineException;
	public LinguisticDocument getLinguisticDocument() throws MXMEngineException;
	public LinguisticEntity getLinguisticEntity() throws MXMEngineException;
	public LogAttackTime getLogAttackTime() throws MXMEngineException;
	public LogicalUnitLocator getLogicalUnitLocator() throws MXMEngineException;
	public LogicalUnitLocatorLogicalUnit getLogicalUnitLocatorLogicalUnit() throws MXMEngineException;
	public LogicalUnitLocatorReferenceUnit getLogicalUnitLocatorReferenceUnit() throws MXMEngineException;
	public LognormalDistribution getLognormalDistribution() throws MXMEngineException;
	public Mask getMask() throws MXMEngineException;
	public MatchingHint getMatchingHint() throws MXMEngineException;
	public MatchingHintHint getMatchingHintHint() throws MXMEngineException;
	public MediaAgent getMediaAgent() throws MXMEngineException;
	public MediaDescription getMediaDescription() throws MXMEngineException;
	public MediaFormat getMediaFormat() throws MXMEngineException;
	public MediaFormatAudioCoding getMediaFormatAudioCoding() throws MXMEngineException;
	public MediaFormatAudioCodingAudioChannels getMediaFormatAudioCodingAudioChannels() throws MXMEngineException;
	public MediaFormatAudioCodingSample getMediaFormatAudioCodingSample() throws MXMEngineException;
	public MediaFormatBitRate getMediaFormatBitRate() throws MXMEngineException;
	public MediaFormatVisualCoding getMediaFormatVisualCoding() throws MXMEngineException;
	public MediaFormatVisualCodingFormat getMediaFormatVisualCodingFormat() throws MXMEngineException;
	public MediaFormatVisualCodingFrame getMediaFormatVisualCodingFrame() throws MXMEngineException;
	public MediaFormatVisualCodingPixel getMediaFormatVisualCodingPixel() throws MXMEngineException;
	public MediaIdentification getMediaIdentification() throws MXMEngineException;
	public MediaIncrDuration getMediaIncrDuration() throws MXMEngineException;
	public MediaInformation getMediaInformation() throws MXMEngineException;
	public MediaInstance getMediaInstance() throws MXMEngineException;
	public MediaLocator getMediaLocator() throws MXMEngineException;
	public MediaProfile getMediaProfile() throws MXMEngineException;
	public MediaQuality getMediaQuality() throws MXMEngineException;
	public MediaQualityPerceptibleDefects getMediaQualityPerceptibleDefects() throws MXMEngineException;
	public MediaQualityQualityRating getMediaQualityQualityRating() throws MXMEngineException;
	public MediaRelIncrTimePoint getMediaRelIncrTimePoint() throws MXMEngineException;
	public MediaRelTimePoint getMediaRelTimePoint() throws MXMEngineException;
	public MediaReview getMediaReview() throws MXMEngineException;
	public MediaReviewDescription getMediaReviewDescription() throws MXMEngineException;
	public MediaSourceSegmentDecomposition getMediaSourceSegmentDecomposition() throws MXMEngineException;
	public MediaSpaceMask getMediaSpaceMask() throws MXMEngineException;
	public MediaSpaceMaskSubInterval getMediaSpaceMaskSubInterval() throws MXMEngineException;
	public MediaTime getMediaTime() throws MXMEngineException;
	public MediaTranscodingHints getMediaTranscodingHints() throws MXMEngineException;
	public MediaTranscodingHintsCodingHints getMediaTranscodingHintsCodingHints() throws MXMEngineException;
	public MediaTranscodingHintsMotionHint getMediaTranscodingHintsMotionHint() throws MXMEngineException;
	public MediaTranscodingHintsMotionHintMotionRange getMediaTranscodingHintsMotionHintMotionRange() throws MXMEngineException;
	public MediaTranscodingHintsShapeHint getMediaTranscodingHintsShapeHint() throws MXMEngineException;
	public Melody getMelody() throws MXMEngineException;
	public MelodyContour getMelodyContour() throws MXMEngineException;
	public MelodySequence getMelodySequence() throws MXMEngineException;
	public MelodySequenceNoteArray getMelodySequenceNoteArray() throws MXMEngineException;
	public MelodySequenceNoteArrayNote getMelodySequenceNoteArrayNote() throws MXMEngineException;
	public MelodySequenceStartingNote getMelodySequenceStartingNote() throws MXMEngineException;
	public MelodySequenceStartingNoteStartingPitch getMelodySequenceStartingNoteStartingPitch() throws MXMEngineException;
	public MelodySequenceStartingNoteStartingPitchPitchNote getMelodySequenceStartingNoteStartingPitchPitchNote() throws MXMEngineException;
	public Meter getMeter() throws MXMEngineException;
	public MinusOneToOneMatrix getMinusOneToOneMatrix() throws MXMEngineException;
	public MixedCollection getMixedCollection() throws MXMEngineException;
	public MixtureAmountOfMotion getMixtureAmountOfMotion() throws MXMEngineException;
	public MixtureCameraMotionSegment getMixtureCameraMotionSegment() throws MXMEngineException;
	public Model getModel() throws MXMEngineException;
	public ModelDescription getModelDescription() throws MXMEngineException;
	public ModelState getModelState() throws MXMEngineException;
	public MorphismGraph getMorphismGraph() throws MXMEngineException;
	public Mosaic getMosaic() throws MXMEngineException;
	public MosaicWarpingParam getMosaicWarpingParam() throws MXMEngineException;
	public MotionActivity getMotionActivity() throws MXMEngineException;
	public MotionActivitySpatialDistributionParams getMotionActivitySpatialDistributionParams() throws MXMEngineException;
	public MotionActivitySpatialLocalizationParams getMotionActivitySpatialLocalizationParams() throws MXMEngineException;
	public MotionTrajectory getMotionTrajectory() throws MXMEngineException;
	public MotionTrajectoryCoordDef getMotionTrajectoryCoordDef() throws MXMEngineException;
	public MotionTrajectoryCoordDefRepr getMotionTrajectoryCoordDefRepr() throws MXMEngineException;
	public MotionTrajectoryCoordRef getMotionTrajectoryCoordRef() throws MXMEngineException;
	public MovingRegion getMovingRegion() throws MXMEngineException;
	public MovingRegionFeature getMovingRegionFeature() throws MXMEngineException;
	public MovingRegionMediaSourceDecomposition getMovingRegionMediaSourceDecomposition() throws MXMEngineException;
	public MovingRegionSpatialDecomposition getMovingRegionSpatialDecomposition() throws MXMEngineException;
	public MovingRegionSpatioTemporalDecomposition getMovingRegionSpatioTemporalDecomposition() throws MXMEngineException;
	public MovingRegionTemporalDecomposition getMovingRegionTemporalDecomposition() throws MXMEngineException;
	public Mpeg7 getMpeg7() throws MXMEngineException;
	public Mpeg7Base getMpeg7Base() throws MXMEngineException;
	public Multimedia getMultimedia() throws MXMEngineException;
	public MultimediaCollection getMultimediaCollection() throws MXMEngineException;
	public MultimediaContent getMultimediaContent() throws MXMEngineException;
	public MultimediaSegment getMultimediaSegment() throws MXMEngineException;
	public MultimediaSegmentMediaSourceDecomposition getMultimediaSegmentMediaSourceDecomposition() throws MXMEngineException;
	public MultipleView getMultipleView() throws MXMEngineException;
	public MultiResolutionPyramid getMultiResolutionPyramid() throws MXMEngineException;
	public NameComponent getNameComponent() throws MXMEngineException;
	public NonDependencyStructurePhrase getNonDependencyStructurePhrase() throws MXMEngineException;
	public NonMixtureAmountOfMotion getNonMixtureAmountOfMotion() throws MXMEngineException;
	public NonMixtureAmountOfMotionFixed getNonMixtureAmountOfMotionFixed() throws MXMEngineException;
	public NonMixtureCameraMotionSegment getNonMixtureCameraMotionSegment() throws MXMEngineException;
	public Object getObject() throws MXMEngineException;
	public OrderedGroupDataSetMask getOrderedGroupDataSetMask() throws MXMEngineException;
	public OrderedGroupDataSetMaskSubInterval getOrderedGroupDataSetMaskSubInterval() throws MXMEngineException;
	public OrderingKey getOrderingKey() throws MXMEngineException;
	public OrderingKeyField getOrderingKeyField() throws MXMEngineException;
	public OrderingKeySelector getOrderingKeySelector() throws MXMEngineException;
	public Organization getOrganization() throws MXMEngineException;
	public OrganizationName getOrganizationName() throws MXMEngineException;
	public OrganizationNameTerm getOrganizationNameTerm() throws MXMEngineException;
	public Package getPackage() throws MXMEngineException;
	public PackageScheme getPackageScheme() throws MXMEngineException;
	public ParameterTrajectory getParameterTrajectory() throws MXMEngineException;
	public ParametricMotion getParametricMotion() throws MXMEngineException;
	public ParametricMotionCoordDef getParametricMotionCoordDef() throws MXMEngineException;
	public ParametricMotionCoordRef getParametricMotionCoordRef() throws MXMEngineException;
	public ParentalGuidance getParentalGuidance() throws MXMEngineException;
	public Partition getPartition() throws MXMEngineException;
	public Perceptual3DShape getPerceptual3DShape() throws MXMEngineException;
	public PerceptualAttributeDS getPerceptualAttributeDS() throws MXMEngineException;
	public PerceptualBeat getPerceptualBeat() throws MXMEngineException;
	public PerceptualEnergy getPerceptualEnergy() throws MXMEngineException;
	public PerceptualGenreDistribution getPerceptualGenreDistribution() throws MXMEngineException;
	public PerceptualGenreDistributionElement getPerceptualGenreDistributionElement() throws MXMEngineException;
	public PerceptualInstrumentationDistribution getPerceptualInstrumentationDistribution() throws MXMEngineException;
	public PerceptualInstrumentationDistributionElement getPerceptualInstrumentationDistributionElement() throws MXMEngineException;
	public PerceptualLanguage getPerceptualLanguage() throws MXMEngineException;
	public PerceptualLyricsDistribution getPerceptualLyricsDistribution() throws MXMEngineException;
	public PerceptualLyricsDistributionElement getPerceptualLyricsDistributionElement() throws MXMEngineException;
	public PerceptualMoodDistribution getPerceptualMoodDistribution() throws MXMEngineException;
	public PerceptualMoodDistributionElement getPerceptualMoodDistributionElement() throws MXMEngineException;
	public PerceptualRecording getPerceptualRecording() throws MXMEngineException;
	public PerceptualSound getPerceptualSound() throws MXMEngineException;
	public PerceptualTempo getPerceptualTempo() throws MXMEngineException;
	public PerceptualValence getPerceptualValence() throws MXMEngineException;
	public PerceptualVocals getPerceptualVocals() throws MXMEngineException;
	public PercussiveInstrumentTimbre getPercussiveInstrumentTimbre() throws MXMEngineException;
	public Person getPerson() throws MXMEngineException;
	public PersonAffiliation getPersonAffiliation() throws MXMEngineException;
	public PersonalInterests getPersonalInterests() throws MXMEngineException;
	public PersonGroup getPersonGroup() throws MXMEngineException;
	public PersonGroupName getPersonGroupName() throws MXMEngineException;
	public PersonGroupNameTerm getPersonGroupNameTerm() throws MXMEngineException;
	public PersonName getPersonName() throws MXMEngineException;
	public PhoneLexicon getPhoneLexicon() throws MXMEngineException;
	public PhoneticAlphabet getPhoneticAlphabet() throws MXMEngineException;
	public PhoneticTranscriptionLexicon getPhoneticTranscriptionLexicon() throws MXMEngineException;
	public PhoneticTranscriptionLexiconToken getPhoneticTranscriptionLexiconToken() throws MXMEngineException;
	public PitchProfileDS getPitchProfileDS() throws MXMEngineException;
	public Pixel getPixel() throws MXMEngineException;
	public Place getPlace() throws MXMEngineException;
	public PlaceAdministrativeUnit getPlaceAdministrativeUnit() throws MXMEngineException;
	public PlaceGeographicPosition getPlaceGeographicPosition() throws MXMEngineException;
	public PlacePostalAddress getPlacePostalAddress() throws MXMEngineException;
	public PlaceStructuredInternalCoordinates getPlaceStructuredInternalCoordinates() throws MXMEngineException;
	public PlaceStructuredPostalAddress getPlaceStructuredPostalAddress() throws MXMEngineException;
	public PointOfView getPointOfView() throws MXMEngineException;
	public PointOfViewImportance getPointOfViewImportance() throws MXMEngineException;
	public PoissonDistribution getPoissonDistribution() throws MXMEngineException;
	public Position getPosition() throws MXMEngineException;
	public PreferenceCondition getPreferenceCondition() throws MXMEngineException;
	public PreferenceConditionTime getPreferenceConditionTime() throws MXMEngineException;
	public ProbabilityClassificationModel getProbabilityClassificationModel() throws MXMEngineException;
	public ProbabilityDistribution getProbabilityDistribution() throws MXMEngineException;
	public ProbabilityDistributionCumulant getProbabilityDistributionCumulant() throws MXMEngineException;
	public ProbabilityDistributionCumulantValue getProbabilityDistributionCumulantValue() throws MXMEngineException;
	public ProbabilityDistributionMoment getProbabilityDistributionMoment() throws MXMEngineException;
	public ProbabilityDistributionMomentValue getProbabilityDistributionMomentValue() throws MXMEngineException;
	public ProbabilityMatrix getProbabilityMatrix() throws MXMEngineException;
	public ProbabilityModel getProbabilityModel() throws MXMEngineException;
	public ProbabilityModelClass getProbabilityModelClass() throws MXMEngineException;
	public PullbackDefinition getPullbackDefinition() throws MXMEngineException;
	public PushoutDefinition getPushoutDefinition() throws MXMEngineException;
	public Rating getRating() throws MXMEngineException;
	public RatingRatingScheme getRatingRatingScheme() throws MXMEngineException;
	public RecordingPreferences getRecordingPreferences() throws MXMEngineException;
	public RecordingRequest getRecordingRequest() throws MXMEngineException;
	public RecordingRequestRecordAssociatedData getRecordingRequestRecordAssociatedData() throws MXMEngineException;
	public RecordingRequestRecordingPeriod getRecordingRequestRecordingPeriod() throws MXMEngineException;
	public RecordingRequestRecordingSourcePreferences getRecordingRequestRecordingSourcePreferences() throws MXMEngineException;
	public Reference getReference() throws MXMEngineException;
	public ReferencePitch getReferencePitch() throws MXMEngineException;
	public RegionLocator getRegionLocator() throws MXMEngineException;
	public RegionLocatorBox getRegionLocatorBox() throws MXMEngineException;
	public RegionLocatorCoordRef getRegionLocatorCoordRef() throws MXMEngineException;
	public RegionLocatorPolygon getRegionLocatorPolygon() throws MXMEngineException;
	public RegionShape getRegionShape() throws MXMEngineException;
	public RegularVisualTimeSeries getRegularVisualTimeSeries() throws MXMEngineException;
	public RelatedMaterial getRelatedMaterial() throws MXMEngineException;
	public Relation getRelation() throws MXMEngineException;
	public RelativeDelay getRelativeDelay() throws MXMEngineException;
	public RelIncrTimePoint getRelIncrTimePoint() throws MXMEngineException;
	public RelTimePoint getRelTimePoint() throws MXMEngineException;
	public ResolutionView getResolutionView() throws MXMEngineException;
	public RhythmicBase getRhythmicBase() throws MXMEngineException;
	public Rights getRights() throws MXMEngineException;
	public ScalableColor getScalableColor() throws MXMEngineException;
	public ScalableSeries getScalableSeries() throws MXMEngineException;
	public ScalableSeriesScaling getScalableSeriesScaling() throws MXMEngineException;
	public SceneGraphMask getSceneGraphMask() throws MXMEngineException;
	public SchemaReference getSchemaReference() throws MXMEngineException;
	public Segment getSegment() throws MXMEngineException;
	public SegmentCollection getSegmentCollection() throws MXMEngineException;
	public SegmentDecomposition getSegmentDecomposition() throws MXMEngineException;
	public SegmentTextAnnotation getSegmentTextAnnotation() throws MXMEngineException;
	public Semantic getSemantic() throws MXMEngineException;
	public SemanticBag getSemanticBag() throws MXMEngineException;
	public SemanticBase getSemanticBase() throws MXMEngineException;
	public SemanticBaseMediaOccurrence getSemanticBaseMediaOccurrence() throws MXMEngineException;
	public SemanticDescription getSemanticDescription() throws MXMEngineException;
	public SemanticPlace getSemanticPlace() throws MXMEngineException;
	public SemanticPlaceSemanticPlaceInterval getSemanticPlaceSemanticPlaceInterval() throws MXMEngineException;
	public SemanticState getSemanticState() throws MXMEngineException;
	public SemanticStateAttributeValuePair getSemanticStateAttributeValuePair() throws MXMEngineException;
	public SemanticTime getSemanticTime() throws MXMEngineException;
	public SemanticTimeSemanticTimeInterval getSemanticTimeSemanticTimeInterval() throws MXMEngineException;
	public Sentences getSentences() throws MXMEngineException;
	public SequentialSummary getSequentialSummary() throws MXMEngineException;
	public SeriesOfScalar getSeriesOfScalar() throws MXMEngineException;
	public SeriesOfScalarBinary getSeriesOfScalarBinary() throws MXMEngineException;
	public SeriesOfVector getSeriesOfVector() throws MXMEngineException;
	public SeriesOfVectorBinary getSeriesOfVectorBinary() throws MXMEngineException;
	public Shape3D getShape3D() throws MXMEngineException;
	public ShapeVariation getShapeVariation() throws MXMEngineException;
	public Shot getShot() throws MXMEngineException;
	public ShotEditingTemporalDecomposition getShotEditingTemporalDecomposition() throws MXMEngineException;
	public Signal getSignal() throws MXMEngineException;
	public SignalPlane getSignalPlane() throws MXMEngineException;
	public SignalPlaneFraction getSignalPlaneFraction() throws MXMEngineException;
	public SignalPlaneOrigin getSignalPlaneOrigin() throws MXMEngineException;
	public SignalPlaneSample getSignalPlaneSample() throws MXMEngineException;
	public Silence getSilence() throws MXMEngineException;
	public SilenceHeader getSilenceHeader() throws MXMEngineException;
	public SoundClassificationModel getSoundClassificationModel() throws MXMEngineException;
	public SoundModel getSoundModel() throws MXMEngineException;
	public SoundModelStateHistogram getSoundModelStateHistogram() throws MXMEngineException;
	public SoundModelStatePath getSoundModelStatePath() throws MXMEngineException;
	public SourcePreferences getSourcePreferences() throws MXMEngineException;
	public SourcePreferencesDisseminationDate getSourcePreferencesDisseminationDate() throws MXMEngineException;
	public SourcePreferencesDisseminationFormat getSourcePreferencesDisseminationFormat() throws MXMEngineException;
	public SourcePreferencesDisseminationLocation getSourcePreferencesDisseminationLocation() throws MXMEngineException;
	public SourcePreferencesDisseminationSource getSourcePreferencesDisseminationSource() throws MXMEngineException;
	public SourcePreferencesDisseminator getSourcePreferencesDisseminator() throws MXMEngineException;
	public SourcePreferencesMediaFormat getSourcePreferencesMediaFormat() throws MXMEngineException;
	public SpaceFrequencyGraph getSpaceFrequencyGraph() throws MXMEngineException;
	public SpaceFrequencyView getSpaceFrequencyView() throws MXMEngineException;
	public SpaceResolutionView getSpaceResolutionView() throws MXMEngineException;
	public SpaceTree getSpaceTree() throws MXMEngineException;
	public SpaceView getSpaceView() throws MXMEngineException;
	public Spatial2DCoordinateSystem getSpatial2DCoordinateSystem() throws MXMEngineException;
	public Spatial2DCoordinateSystemIntegratedCoordinateSystem getSpatial2DCoordinateSystemIntegratedCoordinateSystem() throws MXMEngineException;
	public Spatial2DCoordinateSystemLocalCoordinateSystem getSpatial2DCoordinateSystemLocalCoordinateSystem() throws MXMEngineException;
	public SpatialMask getSpatialMask() throws MXMEngineException;
	public SpatialSegmentDecomposition getSpatialSegmentDecomposition() throws MXMEngineException;
	public SpatioTemporalLocator getSpatioTemporalLocator() throws MXMEngineException;
	public SpatioTemporalLocatorCoordRef getSpatioTemporalLocatorCoordRef() throws MXMEngineException;
	public SpatioTemporalMask getSpatioTemporalMask() throws MXMEngineException;
	public SpatioTemporalSegmentDecomposition getSpatioTemporalSegmentDecomposition() throws MXMEngineException;
	public SpeakerInfo getSpeakerInfo() throws MXMEngineException;
	public SpeakerInfoPhoneIndex getSpeakerInfoPhoneIndex() throws MXMEngineException;
	public SpeakerInfoPhoneIndexPhoneIndexEntry getSpeakerInfoPhoneIndexPhoneIndexEntry() throws MXMEngineException;
	public SpeakerInfoWordIndex getSpeakerInfoWordIndex() throws MXMEngineException;
	public SpeakerInfoWordIndexWordIndexEntry getSpeakerInfoWordIndexWordIndexEntry() throws MXMEngineException;
	public SpectralCentroid getSpectralCentroid() throws MXMEngineException;
	public SpokenContentHeader getSpokenContentHeader() throws MXMEngineException;
	public SpokenContentIndexEntry getSpokenContentIndexEntry() throws MXMEngineException;
	public SpokenContentLattice getSpokenContentLattice() throws MXMEngineException;
	public SpokenContentLatticeBlock getSpokenContentLatticeBlock() throws MXMEngineException;
	public SpokenContentLatticeBlockNode getSpokenContentLatticeBlockNode() throws MXMEngineException;
	public SpokenContentLatticeBlockNodePhoneLink getSpokenContentLatticeBlockNodePhoneLink() throws MXMEngineException;
	public SpokenContentLatticeBlockNodeWordLink getSpokenContentLatticeBlockNodeWordLink() throws MXMEngineException;
	public SpokenContentLink getSpokenContentLink() throws MXMEngineException;
	public StateTransitionModel getStateTransitionModel() throws MXMEngineException;
	public StillRegion getStillRegion() throws MXMEngineException;
	public StillRegion3D getStillRegion3D() throws MXMEngineException;
	public StillRegion3DSpatialDecomposition getStillRegion3DSpatialDecomposition() throws MXMEngineException;
	public StillRegionFeature getStillRegionFeature() throws MXMEngineException;
	public StillRegionSpatialDecomposition getStillRegionSpatialDecomposition() throws MXMEngineException;
	public StreamLocator getStreamLocator() throws MXMEngineException;
	public StreamMask getStreamMask() throws MXMEngineException;
	public StreamSection getStreamSection() throws MXMEngineException;
	public StructuredAnnotation getStructuredAnnotation() throws MXMEngineException;
	public StructuredCollection getStructuredCollection() throws MXMEngineException;
	public SubjectClassificationScheme getSubjectClassificationScheme() throws MXMEngineException;
	public SubjectTermDefinition getSubjectTermDefinition() throws MXMEngineException;
	public SubjectTermDefinitionNote getSubjectTermDefinitionNote() throws MXMEngineException;
	public SubjectTermDefinitionTerm getSubjectTermDefinitionTerm() throws MXMEngineException;
	public Summarization getSummarization() throws MXMEngineException;
	public Summary getSummary() throws MXMEngineException;
	public SummaryDescription getSummaryDescription() throws MXMEngineException;
	public SummaryPreferences getSummaryPreferences() throws MXMEngineException;
	public SummaryPreferencesSummary getSummaryPreferencesSummary() throws MXMEngineException;
	public SummaryPreferencesSummaryTheme getSummaryPreferencesSummaryTheme() throws MXMEngineException;
	public SummarySegment getSummarySegment() throws MXMEngineException;
	public SummarySegmentGroup getSummarySegmentGroup() throws MXMEngineException;
	public SummaryThemeList getSummaryThemeList() throws MXMEngineException;
	public SummaryThemeListSummaryTheme getSummaryThemeListSummaryTheme() throws MXMEngineException;
	public SyntacticConstituent getSyntacticConstituent() throws MXMEngineException;
	public Synthesis getSynthesis() throws MXMEngineException;
	public TemporalCentroid getTemporalCentroid() throws MXMEngineException;
	public TemporalInterpolation getTemporalInterpolation() throws MXMEngineException;
	public TemporalInterpolationInterpolationFunctions getTemporalInterpolationInterpolationFunctions() throws MXMEngineException;
	public TemporalInterpolationInterpolationFunctionsKeyValue getTemporalInterpolationInterpolationFunctionsKeyValue() throws MXMEngineException;
	public TemporalInterpolationKeyTimePoint getTemporalInterpolationKeyTimePoint() throws MXMEngineException;
	public TemporalInterpolationWholeInterval getTemporalInterpolationWholeInterval() throws MXMEngineException;
	public TemporalMask getTemporalMask() throws MXMEngineException;
	public TemporalSegmentDecomposition getTemporalSegmentDecomposition() throws MXMEngineException;
	public TemporalSegmentLocator getTemporalSegmentLocator() throws MXMEngineException;
	public TemporalSegmentLocatorBytePosition getTemporalSegmentLocatorBytePosition() throws MXMEngineException;
	public TermDefinition getTermDefinition() throws MXMEngineException;
	public TermDefinitionBase getTermDefinitionBase() throws MXMEngineException;
	public TermDefinitionBaseName getTermDefinitionBaseName() throws MXMEngineException;
	public TermDefinitionTerm getTermDefinitionTerm() throws MXMEngineException;
	public TermUse getTermUse() throws MXMEngineException;
	public Text getText() throws MXMEngineException;
	public TextAnnotation getTextAnnotation() throws MXMEngineException;
	public TextDecomposition getTextDecomposition() throws MXMEngineException;
	public TextSegment getTextSegment() throws MXMEngineException;
	public Textual getTextual() throws MXMEngineException;
	public TextualBase getTextualBase() throws MXMEngineException;
	public TextualSummaryComponent getTextualSummaryComponent() throws MXMEngineException;
	public TextureBrowsing getTextureBrowsing() throws MXMEngineException;
	public Time getTime() throws MXMEngineException;
	public TimeZone getTimeZone() throws MXMEngineException;
	public Title getTitle() throws MXMEngineException;
	public TitleMedia getTitleMedia() throws MXMEngineException;
	public TransmissionTechnology getTransmissionTechnology() throws MXMEngineException;
	public UniqueID getUniqueID() throws MXMEngineException;
	public Unit getUnit() throws MXMEngineException;
	public URIFragmentReference getURIFragmentReference() throws MXMEngineException;
	public UsageDescription getUsageDescription() throws MXMEngineException;
	public UsageHistory getUsageHistory() throws MXMEngineException;
	public UsageInformation getUsageInformation() throws MXMEngineException;
	public UsageRecord getUsageRecord() throws MXMEngineException;
	public UserAction getUserAction() throws MXMEngineException;
	public UserActionActionTime getUserActionActionTime() throws MXMEngineException;
	public UserActionHistory getUserActionHistory() throws MXMEngineException;
	public UserActionList getUserActionList() throws MXMEngineException;
	public UserChoice getUserChoice() throws MXMEngineException;
	public UserDescription getUserDescription() throws MXMEngineException;
	public UserIdentifier getUserIdentifier() throws MXMEngineException;
	public UserPreferences getUserPreferences() throws MXMEngineException;
	public UserProfile getUserProfile() throws MXMEngineException;
	public Variation getVariation() throws MXMEngineException;
	public VariationDescription getVariationDescription() throws MXMEngineException;
	public VariationSet getVariationSet() throws MXMEngineException;
	public Video getVideo() throws MXMEngineException;
	public VideoSegment getVideoSegment() throws MXMEngineException;
	public VideoSegmentFeature getVideoSegmentFeature() throws MXMEngineException;
	public VideoSegmentMediaSourceDecomposition getVideoSegmentMediaSourceDecomposition() throws MXMEngineException;
	public VideoSegmentSpatialDecomposition getVideoSegmentSpatialDecomposition() throws MXMEngineException;
	public VideoSegmentSpatioTemporalDecomposition getVideoSegmentSpatioTemporalDecomposition() throws MXMEngineException;
	public VideoSegmentTemporalDecomposition getVideoSegmentTemporalDecomposition() throws MXMEngineException;
	public VideoSignature getVideoSignature() throws MXMEngineException;
	public VideoSignatureVideoSignatureRegion getVideoSignatureVideoSignatureRegion() throws MXMEngineException;
	public VideoSignatureVideoSignatureRegionMediaTimeOfSpatialRegion getVideoSignatureVideoSignatureRegionMediaTimeOfSpatialRegion() throws MXMEngineException;
	public VideoSignatureVideoSignatureRegionVideoFrame getVideoSignatureVideoSignatureRegionVideoFrame() throws MXMEngineException;
	public VideoSignatureVideoSignatureRegionVideoSignatureSpatialRegion getVideoSignatureVideoSignatureRegionVideoSignatureSpatialRegion() throws MXMEngineException;
	public VideoSignatureVideoSignatureRegionVSVideoSegment getVideoSignatureVideoSignatureRegionVSVideoSegment() throws MXMEngineException;
	public VideoSignatureVideoSignatureRegionVSVideoSegmentMediaTimeOfSegment getVideoSignatureVideoSignatureRegionVSVideoSegmentMediaTimeOfSegment() throws MXMEngineException;
	public VideoText getVideoText() throws MXMEngineException;
	public VideoViewGraph getVideoViewGraph() throws MXMEngineException;
	public View getView() throws MXMEngineException;
	public ViewDecomposition getViewDecomposition() throws MXMEngineException;
	public ViewDescription getViewDescription() throws MXMEngineException;
	public ViewSet getViewSet() throws MXMEngineException;
	public VisualD getVisualD() throws MXMEngineException;
	public VisualDS getVisualDS() throws MXMEngineException;
	public VisualSummaryComponent getVisualSummaryComponent() throws MXMEngineException;
	public VisualTimeSeries getVisualTimeSeries() throws MXMEngineException;
	public WordForm getWordForm() throws MXMEngineException;
	public WordLexicon getWordLexicon() throws MXMEngineException;
	public WordLexiconToken getWordLexiconToken() throws MXMEngineException;

}
