/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the MPEG Multimedia Extensible Middleware (MXM) Project 
 *
 * The Initial Developer of the Original Code is CEDEO.net  
 * Portions created by the Initial Developer are Copyright (C) 2009
 * All Rights Reserved.
 *
 * The Initial Developer: Filippo Chiariglione  
 * Contributor(s): Edoardo Radica
 *
 * ***** END LICENSE BLOCK ***** */

package org.iso.mpeg.mxm.tEngine.relTE;

import org.iso.mpeg.mxm.core.MXMEngine;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;

// TODO: Auto-generated Javadoc
/**
 * Classes implementing this interface are entry point classes for operating over ISO/IEC 21000-5
 * Rights Expression Language (REL) data structures. Classes implementing the RELEngine interface
 * act as factories creating instances of classes performing the main functionalities of
 * this MXM Engine:
 * 
 * <ul>
 * <li>classes to create Rights Expressions</li>
 * <li>classes to access data contained in Rights Expression</li>
 * <li>classes to authorise users to exercise rights</li>
 * </ul>
 * 
 * @author Filippo Chiariglione <filippo@cedeo.net>
 */

public interface RELEngine extends MXMEngine
{
	public RELEngineSchemaHandler getRELEngineSchemaHandler() throws MXMEngineException;
	
	public RELEngineTechnologyHandler getRELEngineTechnologyHandler() throws MXMEngineException;
}
