package org.iso.mpeg.mxm.tEngine.relTE.schemahandler;

import java.util.List;

import javax.xml.datatype.Duration;
import javax.xml.datatype.XMLGregorianCalendar;
import javax.xml.namespace.QName;

import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relm2x.SecuritySystem;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relm3x.CopyrightNotice;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relm3x.NonCommercialUse;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.AllConditions;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.Condition;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.ValidityInterval;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relsx.AccountPayable;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relsx.FeeFlat;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relsx.FeeMetered;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relsx.FeePerInterval;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relsx.FeePerUse;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relsx.FeePerUsePrePay;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relsx.Rate;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relsx.Territory;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relsx.ValidityTimeMetered;

public interface ConditionBuilder
{
	public AllConditions buildAllConditions(List<Condition> conditions);
	
	public Territory buildTerritoryLocation(QName conditionCountry, QName conditionRegion);
	
	public Territory buildTerritoryDomain(String domainURI);
	
	public ValidityInterval buildValidityInterval(XMLGregorianCalendar conditionNotBeforeDate, XMLGregorianCalendar conditionNotAfterDate);
	
	public ValidityTimeMetered buildValidityTimeMeteredDuration(Duration validTimeMeteredDuration);
	
	public ValidityTimeMetered buildValidityTimeMeteredQuantum(Duration validTimeMeteredQuantum);
	
	public SecuritySystem buildSecuritySystem(String securityIdentifier, String securityLevel);
	
	public CopyrightNotice buildCopyrightNotice(String copyrightString, String noticeType);
	
	public NonCommercialUse buildNonCommercialUse();
	
	public FeeFlat buildFeeFlatPaymentCondition(Rate rate, AccountPayable to);
	
	public FeeMetered buildFeeMeteredPaymentCondition(Rate rate, AccountPayable to);
	
	public FeePerInterval buildFeePerIntervalPaymentCondition(Rate rate, AccountPayable to);
	
	public FeePerUse buildFeePerUsePaymentCondition(Rate rate, AccountPayable to);
	
	public FeePerUsePrePay buildFeePerUsePrePayPaymentCondition(Rate rate, AccountPayable to);
}
