/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the MPEG Multimedia Extensible Middleware (MXM) Project 
 *
 * The Initial Developer of the Original Code is CEDEO.net  
 * Portions created by the Initial Developer are Copyright (C) 2009
 * All Rights Reserved.
 *
 * The Initial Developer: Filippo Chiariglione  
 * Contributor(s): 
 *
 * ***** END LICENSE BLOCK ***** */


package org.iso.mpeg.mxm.tEngine.relTE.technologyhandler;

/**
 * This enum is used to define the possible results of a license authorisation procedure. 
 * Starting from the top and moving down to the bottom, the level of denial increases.
 * 
 * @author Filippo Chiariglione <filippo@cedeo.net>
 *
 */
public enum AuthorisationResult {

	AUTHORISATION_SUCCEEDED,
	ORC_CONDITIONS_FOUND,
	PAYMENT_CONDITIONS_FOUND,
	CONDITIONS_ARE_NOT_MET,
	RIGHT_IS_NOT_MET,
	PRINCIPAL_IS_NOT_MET,
	PRINCIPAL_DOMAIN_IS_NOT_MET,
	RESOURCE_IS_NOT_MET,
	GENERIC_AUTHORISATION_FAILURE;
	
}
