/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the MPEG Multimedia Extensible Middleware (MXM) Project 
 *
 * The Initial Developer of the Original Code is CEDEO.net  
 * Portions created by the Initial Developer are Copyright (C) 2009
 * All Rights Reserved.
 *
 * The Initial Developer: Filippo Chiariglione  
 * Contributor(s): 
 *
 * ***** END LICENSE BLOCK ***** */

package org.iso.mpeg.mxm.tEngine.relTE.technologyhandler;


/**
 * This enum defines all possible rights that can be inserted in an ISO/IEC 21000-5 license.
 * 
 * @author Filippo Chiariglione <filippo@cedeo.net>
 */

public enum RELRight {

	adapt, 
	aggregate,
	delete,
	delist,
	diminish,
	embed,
	enhance,
	enlarge,
	enlist,
	execute,
	export,
	extendRights,
	governedAdapt,
	governedAggregate, 
	governedCopy,
	governedEmbed,
	governedMove,
	install,
	issue,
	modify,
	move,
	obtain,
	play,
	possessProperty,
	print,
	reduce,
	revoke,
	uninstall;
	
}

