package org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf;

import org.iso.mpeg.mxm.core.MXMCreatorAndParser;

import java.math.BigInteger;
import java.util.List;

public interface OutputDescription extends MXMCreatorAndParser
{
	public List<Field> getRequestedFieldList();
	
	public void addRequestedField(Field field);

	public List<String> getReqAggregateIDList();
	
	public void addReqAggregateID(String id);

	public List<String> getRequestedSemanticFieldList();
	
	public void addRequestedSemanticField(String semanticField);

	public OutputDescriptionGroupBy getGroupBy();

	public void setGroupBy(OutputDescriptionGroupBy groupBy);

	public List<AbstractSortBy> getSortByList();
	
	public void addSortBy(AbstractSortBy sortBy);

	public BigInteger getMaxPageEntries();

	public void setMaxPageEntries(BigInteger bigInteger);

	public BigInteger getMaxItemCount();

	public void setMaxItemCount(BigInteger bigInteger);

	public Boolean isFreeTextUse();

	public void setFreeTextUse(Boolean b);

	public Boolean isThumbnailUse();

	public void setThumbnailUse(Boolean b);

	public Boolean isMediaResourceUse();

	public void setMediaResourceUse(Boolean b);

	public String getOutputNameSpace();

	public void setOutputNameSpace(String string);

	public boolean isDistinct();

	public void setDistinct(Boolean b);
}