package org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig;

import org.iso.mpeg.mxm.core.MXMCreatorAndParser;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.tEngine.relTE.exception.RELEngineException;

public interface KeyInfo extends MXMCreatorAndParser
{
	public void setId(String string);

	public String getId();

	public void setKeyValue(KeyValue keyValue) throws MXMException;
	
	public KeyValue getKeyValue() throws MXMEngineException;
	
	public void setRetrievalMethod(RetrievalMethod retrievalMethod) throws MXMException;
	
	public RetrievalMethod getRetrievalMethod() throws MXMEngineException;
	
	public void setX509Data(X509Data x509data) throws MXMException;
	
	public X509Data getX509Data() throws MXMEngineException;
	
	public void setKeyName(String keyName);
	
	public String getKeyName();
	
	public void setPGPData(PGPData pgpData);
	
	public PGPData getPGPData();
	
	public void setMgmtData(String mgmtData);
	
	public String getMgmtData();
	
	public void setSPKIData(SPKIData pgpData);
	
	public SPKIData getSPKIData();
	
	public void setOther(Object other);
	
	public Object getOther();
	
	public boolean equals(KeyInfo keyInfo) throws MXMEngineException;
}