package org.iso.mpeg.mxm.tEngine.securityTE.technologyhandler;


import java.io.IOException;
import java.security.Key;
import java.security.NoSuchAlgorithmException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.spec.InvalidKeySpecException;

import javax.xml.datatype.XMLGregorianCalendar;

import org.iso.mpeg.mxm.tEngine.securityTE.exceptions.SecurityEngineException;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.RSAKeyValue;


public interface FileAndObjectHandler
{
    public Object blobToObject(final byte[] blob) throws SecurityEngineException;

    public void deleteFile(final String filePath) throws SecurityEngineException;

    public XMLGregorianCalendar getCurrentInstant();

    public String getString(final Key key) throws IOException;

    public byte[] objectToBlob(final Object object) throws SecurityEngineException;

    public PrivateKey privateKeyAdapter(final RSAKeyValue privateKey)
        throws SecurityEngineException;

    public PublicKey publicKeyAdapter(final RSAKeyValue publicKey)
        throws SecurityEngineException;

    public byte[] readBytesFromFile(final String filePath) throws SecurityEngineException;

    public Object readObjectFromFile(final String filePath)
        throws SecurityEngineException;

    public PublicKey toPublicKey(final String string, final String algorithmForKey)
        throws IOException,NoSuchAlgorithmException,InvalidKeySpecException;

    public XMLGregorianCalendar toXMLGregorianCalendar(long timeInMilliSecond);

    public void writeBytesToFile(final byte[] data, final String filePath)
        throws SecurityEngineException;

    public void writeObjectToFile(final String filePath, final Object object)
        throws SecurityEngineException;
}
