/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the MPEG Multimedia Extensible Middleware (MXM) Project 
 *
 * The Initial Developer of the Original Code is CEDEO.net  
 * Portions created by the Initial Developer are Copyright (C) 2009
 * All Rights Reserved.
 *
 * The Initial Developer: Filippo Chiariglione  
 * Contributor(s): Angelo Difino
 * Contributor(s): Andreas Kohlos
 *
 * ***** END LICENSE BLOCK ***** */
package org.iso.mpeg.mxm.tEngine.securityTE.technologyhandler;


import org.iso.mpeg.mxm.core.MXMKeys;


public interface SecurityEngineKeys extends MXMKeys
{
    public static final String ASYMMETRIC_ENCRYPTION_ALGORITHM  = "org.iso.mpeg.mxm.engine.securityTE.asymmetric.encryption.algorithm";
    public static final String ASYMMETRIC_ENCRYPTION_KEY_LENGTH = "org.iso.mpeg.mxm.engine.securityTE.asymmetric.encryption.key.length";
    public static final String CERTIFICATE_DURATION             = "org.iso.mpeg.mxm.engine.securityTE.certificate.duration";
    public static final String COMMERCIAL_ENTITY                = "org.iso.mpeg.mxm.engine.securityTE.commercial.entity";
    public static final String COUNTRY                          = "org.iso.mpeg.mxm.engine.securityTE.country";
    public static final String COUNTRY_NAMESPACE_URI            = "urn:mpeg:mpeg21:2003:01-REL-SX-NS:country";
    public static final String KEY_STORE_PATH                   = "org.iso.mpeg.mxm.engine.securityTE.key.store.path";
    public static final String ORG_NAME                         = "org.iso.mpeg.mxm.engine.securityTE.org.name";
    public static final String ORG_UNIT                         = "org.iso.mpeg.mxm.engine.securityTE.org.unit";
    public static final String REGION                           = "org.iso.mpeg.mxm.engine.securityTE.region";
    public static final String REGION_NAMESPACE_URI             = "urn:mpeg:mpeg21:2003:01-REL-SX-NS:region";
    public static final String SECURE_INFO_STORAGE_PATH         = "org.iso.mpeg.mxm.engine.securityTE.secure.info.storage.path";
    public static final String SECURE_LICENSE_STORAGE_PATH      = "org.iso.mpeg.mxm.engine.securityTE.secure.license.storage.path";
    public static final String SIGNATURE_ALGORITHM              = "org.iso.mpeg.mxm.engine.securityTE.signature.algorithm";
    public static final String SYMMETRIC_ENCRYPTION_ALGORITHM   = "org.iso.mpeg.mxm.engine.securityTE.symmetric.encryption.algorithm";
    public static final String SYMMETRIC_ENCRYPTION_KEY_LENGTH  = "org.iso.mpeg.mxm.engine.securityTE.symmetric.encryption.key.length";
    public static final String USER_EMAIL                       = "org.iso.mpeg.mxm.engine.securityTE.user.email";
    public static final String USER_FIRST_NAME                  = "org.iso.mpeg.mxm.engine.securityTE.user.first.name";
    public static final String USER_LAST_NAME                   = "org.iso.mpeg.mxm.engine.securityTE.user.last.name";
}
