package org.iso.mpeg.mxm.engine.eventreportTE.schema;

import java.util.ArrayList;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class EREngineContext {

	private static EREngineContext packages = null;
	
	protected Logger logger = LoggerFactory.getLogger(this.getClass());

	protected ArrayList<String> packageNames = new ArrayList<String>();

	private static JAXBContext jc = null;

	/**
	 * @return all package names in sequence
	 */
	private String getPackagesInOrder() {
		StringBuffer orderpackages = new StringBuffer();
		for (int i = 0; i < packageNames.size(); i++) {
			orderpackages.append(packageNames.get(i));
			if (i >= (packageNames.size() - 1))
				break;
			orderpackages.append(":");
		}
		return orderpackages.toString();
	}

	/**
	 * @return the JAXB Context all schemas used by the Engine
	 * @throws JAXBException
	 */
	public JAXBContext getJAXBContext() throws JAXBException {
		if (jc == null) {
			logger.debug("Generating Engine JAXB Context...");
			jc = JAXBContext.newInstance(getPackagesInOrder());
			logger.debug("Done!");
		}
		return jc;
	}

	private EREngineContext() {

		// DI packages
				packageNames.add("org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl");
				packageNames.add("org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl_mp21");
				packageNames.add("org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl_msx");
				packageNames.add("org.iso.mpeg.mxm.engine.digitalitemTE.schema.dii");
				packageNames.add("org.iso.mpeg.mxm.engine.digitalitemTE.schema.didmodel_mp21");
				
				// ER packages
				packageNames.add("org.iso.mpeg.mxm.engine.eventreportTE.schema.er");
				
				// IPMP packages
				packageNames.add("org.iso.mpeg.mxm.engine.ipmpTE.schema.ipmpinfo");
				packageNames.add("org.iso.mpeg.mxm.engine.ipmpTE.schema.ipmpinfo_msx");		
				packageNames.add("org.iso.mpeg.mxm.engine.ipmpTE.schema.ipmpmsg");
				packageNames.add("org.iso.mpeg.mxm.engine.ipmpTE.schema.mpeg4ipmp");
				packageNames.add("org.iso.mpeg.mxm.engine.ipmpTE.schema.mpegmipmpdidl");
				packageNames.add("org.iso.mpeg.mxm.engine.ipmpTE.schema.mpegmipmpinfo");

				// MPEG7 packages
				packageNames.add("org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3");
				packageNames.add("org.iso.mpeg.mxm.engine.metadataTE.schema.fru");
				
				//REL packages
				packageNames.add("org.iso.mpeg.mxm.engine.relTE.schema.relr");
				packageNames.add("org.iso.mpeg.mxm.engine.relTE.schema.relsx");
				packageNames.add("org.iso.mpeg.mxm.engine.relTE.schema.relmx");
				packageNames.add("org.iso.mpeg.mxm.engine.relTE.schema.relm1x");
				packageNames.add("org.iso.mpeg.mxm.engine.relTE.schema.relm2x");
				packageNames.add("org.iso.mpeg.mxm.engine.relTE.schema.relm3x");
				
				// Security packages
				packageNames.add("org.iso.mpeg.mxm.engine.securityTE.schema.dsig");
				packageNames.add("org.iso.mpeg.mxm.engine.securityTE.schema.xenc");
				packageNames.add("org.iso.mpeg.mxm.engine.securityTE.schema.saml.assertion");
				packageNames.add("org.iso.mpeg.mxm.engine.securityTE.schema.saml.protocol");
		


	}

	public static synchronized EREngineContext getInstance() {
		if (packages == null)
			packages = new EREngineContext();
		return packages;
	}
	
}
