/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the MPEG Multimedia Extensible Middleware (MXM) Project 
 *
 * The Initial Developer of the Original Code is CEDEO.net  
 * Portions created by the Initial Developer are Copyright (C) 2009-2012
 * All Rights Reserved.
 *
 * The Initial Developer: Angelo Difino <angelo@cedeo.net> 
 * Contributors: Bogdan Ardeleanu

 *
 * ***** END LICENSE BLOCK ***** */

package org.iso.mpeg.mxm.engine.eventreportTE.schema.er;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;

import org.iso.mpeg.mxm.baseprotocol.schema.SuperAbstractLevel1;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.eventreportTE.schema.EREngineContext;

/**
 * @author Angelo Difino <angelo@cedeo.net> 
 * @author Bogdan Ardeleanu
 *
 */
public class SuperErAbstractLevel1 extends SuperAbstractLevel1 {

	public SuperErAbstractLevel1(Object type) throws MXMEngineException {
		super(type);
	}
	
	@Override
	protected void config(JAXBContext jc) throws MXMEngineException, JAXBException 
	{
		this.factory = new ObjectFactory();
		
		if(jc == null)
		{
			this.jc = EREngineContext.getInstance().getJAXBContext();
		} else {
			this.jc = jc;
		}
	}	
	
	@Override
	protected void throwEngineSpecificException(String message, Exception exception) throws MXMEngineException
	{
		// TODO create engine specific exception
	}
}
