/**
 * 
 */
package org.iso.mpeg.mxm.engine.protocol;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;

import org.iso.mpeg.mxm.baseprotocol.BaseProtocolEngineContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author Angelos-Christos Anadiotis
 *
 */
public class ProtocolEngineContext extends BaseProtocolEngineContext
{
	private static ProtocolEngineContext packages = null;
	protected Logger logger = LoggerFactory.getLogger(this.getClass());
	protected List<Class> protocolEnginePackages;
	private static JAXBContext jc = null;
	
	protected ProtocolEngineContext()
	{
		super();
		
		protocolEnginePackages = new ArrayList<Class>();
		protocolEnginePackages.addAll(packageNames);
//		protocolEnginePackages.add(org.iso.mpeg.mxm.engine.protocol.ExtendedObjectFactory.class);
		protocolEnginePackages.add(org.iso.mpeg.mxm.engine.protocol.ObjectFactory.class);
	}
	
	/**
	 * @return all package names in sequence
	 */
	private String getPackagesInOrder() {
		StringBuffer orderpackages = new StringBuffer();
		for (int i = 0; i < protocolEnginePackages.size(); i++) {
			orderpackages.append(protocolEnginePackages.get(i));
			if (i >= (protocolEnginePackages.size() - 1))
				break;
			orderpackages.append(":");
		}
		return orderpackages.toString();
	}
	
	/**
	 * @return the JAXB Context all schemas used by the Engine
	 * @throws JAXBException
	 */
	public JAXBContext getJAXBContext() throws JAXBException {
		if (jc == null) {
			logger.debug("Generating Protocol Engine JAXB Context...");
			jc = JAXBContext.newInstance(protocolEnginePackages.toArray(new Class[protocolEnginePackages.size()]));
			logger.debug("Done!");
		}
		return jc;
	}
	
	public static synchronized ProtocolEngineContext getInstance()
	{
		if (packages == null)
		{
			packages = new ProtocolEngineContext();
		}
		return packages;
	}
}
