/**
 * 
 */
package org.iso.mpeg.mxm.engine.protocol;

import java.lang.reflect.Method;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;

import org.iso.mpeg.mxm.baseprotocol.schema.SuperAbstractLevel1;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;

/**
 * @author Angelos-Christos Anadiotis
 *
 */
public class SuperProtocolEngineAbstractLevel1 extends SuperAbstractLevel1
{
	private String initialType;
	/**
	 * @param type
	 * @throws MXMEngineException
	 */
	public SuperProtocolEngineAbstractLevel1(Object type)
			throws MXMEngineException
	{
		super(type);
		initialType = type.getClass().getSimpleName();
	}

	/* (non-Javadoc)
	 * @see org.iso.mpeg.mxm.baseprotocol.schema.SuperAbstractLevel1#config(javax.xml.bind.JAXBContext)
	 */
	@Override
	protected void config(JAXBContext context) throws MXMEngineException,
			JAXBException
	{
		this.factory = new ObjectFactory();
		if (context == null)
		{
			this.jc = ProtocolEngineContext.getInstance().getJAXBContext();
		}
		else
		{
			this.jc = context;
		}
	}

	/* (non-Javadoc)
	 * @see org.iso.mpeg.mxm.baseprotocol.schema.SuperAbstractLevel1#throwEngineSpecificException(java.lang.String, java.lang.Exception)
	 */
	@Override
	protected void throwEngineSpecificException(String message,
			Exception exception) throws MXMEngineException
	{
		throw new MXMEngineException(message, exception);
	}
	
	/* (non-Javadoc)
	 * @see org.iso.mpeg.mxm.baseprotocol.schema.SuperAbstractLevel1#createJAXBElement()
	 */
	@Override
	protected JAXBElement<?> createJAXBElement() throws MXMEngineException
	{
		String methodName = new String();
		try
		{
			methodName = "create"+initialType;
			
			int indexOfType = methodName.indexOf("Type");
			
			if (indexOfType!=-1)
			{
				methodName = methodName.substring(0,indexOfType);
			}			
			Method[] methods = getFactory().getClass().getMethods();
			for (Method method : methods)
			{
				if (method.getName().equals(methodName))
				{
					JAXBElement<?> jaxbElement = (JAXBElement<?>)method.invoke(getFactory(),getLevel0());
					return jaxbElement;
				}
			}			
			throw new MXMEngineException("It was impossibe to find the method "+methodName);
		}
		catch (Exception e) 
		{
			throw new MXMEngineException("It was impossibe to call the method "+methodName,e); 
		}
	}
}
