/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the Chillout Project (http://chillout.dmpf.org)
 *
 * The Initial Developer of the Original Code is CEDEO.net
 * Portions created by the Initial Developer are Copyright (C) 2006-2008
 * All Rights Reserved.
 *
 * The Initial Developer: Filippo Chiariglione 
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */


//usefull import
import java.io.File;
import java.util.ArrayList;
import java.util.List;

import junit.framework.TestCase;

import org.apache.log4j.Logger;
import org.iso.mpeg.mxm.basePE.BaseProtocolEngine;
import org.iso.mpeg.mxm.core.MXM;
import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMAbstractEngine;
import org.iso.mpeg.mxm.core.MXMEngine;
import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.configuration.MXMConfigurationException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.pEngine.basePE.schemahandler.ContentEntity;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.DIEngine;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.DIDL;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Item;

//TODO: Test needs to be align with new MXMConfiguration file

public class BasePETest extends TestCase {

	private Logger logger = Logger.getLogger(BasePETest.class);
	
	private final String TEMP_FOLDER = System.getProperty("java.io.tmpdir") + File.separator;

	private final String SOURCE_CE_FILE_NAME = "testCE.xml";
	
	private final String OUTPUT_CE_FILE_NAME =TEMP_FOLDER + "myCE.xml";
	
	public void testDIParsing() throws MXMConfigurationException, MXMEngineException {
		logger.info("\n\n---------- testDIParsing ----------");
//		
//		File f = new File(getClass().getClassLoader().getResource("MXMConfiguration.xml").getFile());
//		MXM mxm = MXM.getInstance(f);
//		mxm.listEnginesAndProperties();
//		
//		DIEngine diEngine = (DIEngine) mxm.getDefaultEngine(MXMEngineName.DigitalItemTE.toString());
//		
//		//to retrieve a BaseProtocol we need a PE instantiate, otherwise it does not work!!!
//		org.iso.mpeg.mxm.pEngine.basePE.BaseProtocolEngine bpe=new BaseProtocolEngine()
//		{
//
//			@Override
//			public String getEngineName()
//			{
//				return null;
//			}
//			
//		};
//		DIDL di= diEngine.getDIEngineSchemaHandler().getDIDL();
//		ContentEntity ce=bpe.getBaseProtocolSchemaHandler().getContentEntity();
//		
//		try {	
//			ce.parse(new MXMAdapter(new File(getClass().getClassLoader().getResource(SOURCE_CE_FILE_NAME).getFile())));
//
//			di=(DIDL)ce.getDIDL();
//			
//			Item topLevelItem=(Item)di.getMPEGMItem();
//		
//			logger.info("ID is:"+topLevelItem.getId());
//
//			logger.info("Identifier is:"+topLevelItem.getIdentifier());
//
//		} catch (MXMException e) {
//			e.printStackTrace();
//		}
//			
		logger.info("The DI file was successfully parsed");
	}

			public void testCECreation() throws MXMConfigurationException, MXMEngineException {
				logger.info("\n\n---------- testCECreation ----------");
//				
//				File f = new File(getClass().getClassLoader().getResource("MXMConfiguration.xml").getFile());
//				MXM mxm = MXM.getInstance(f);
//				mxm.listEnginesAndProperties();
//					
//				DIEngine diEngine = (DIEngine)mxm.getDefaultEngine(MXMEngineName.DigitalItemTE.toString());	
//				
//				DIDL di=diEngine.getDIEngineSchemaHandler().getDIDL();
//				Item item=diEngine.getDIEngineSchemaHandler().getItem();
//				
//				BaseProtocolEngine bpe= new BaseProtocolEngine()
//				{
//					@Override
//					public String getEngineName()
//					{
//						return null;
//					}
//					
//				};
//
//				try {
//					
//					di.setMPEGMItem(item);
//
//					ContentEntity ce=bpe.getBaseProtocolSchemaHandler().getContentEntity();
//					
//					ce.setDIDL(di);
//
//					ce.createFile(new File(OUTPUT_CE_FILE_NAME));
//						
//					logger.info("The ContentEntity was successfully created in file: " + OUTPUT_CE_FILE_NAME);
//					
//				} catch (MXMException e) {
//					e.printStackTrace();
//				}
		}	
}