/** ***** BEGIN LICENSE BLOCK *****
 * 
 * The copyright in this software is being made available under the BSD License, 
 * included below. This software may be subject to other third party and contributor 
 * rights, including patent rights, and no such rights are granted under this license.
 *
 * Copyright (c) 2012, ICBNet Lab, ICCS
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 *
 *    - Redistributions of source code must retain the above copyright notice, 
 *    	this list of conditions and the following disclaimer.
 *    - Redistributions in binary form must reproduce the above copyright notice, 
 *    	this list of conditions and the following disclaimer in the documentation 
 *    	and/or other materials provided with the distribution.
 *    - Neither the name of the ICBNet Lab, ICCS nor the names of its contributors 
 *    	may be used to endorse or promote products derived from this software 
 *    	without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, 
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
***** END LICENSE BLOCK ***** */

package org.iso.mpeg.mxm.describecontentPE.technology;

import org.iso.mpeg.mxm.orchestratorEngine.OrchestratorEngine;
import org.iso.mpeg.mxm.pEngine.basePE.BaseProtocolEngine;
import org.iso.mpeg.mxm.pEngine.describecontentPE.technologyhandler.GetDescribeContentProtocol;
import org.iso.mpeg.mxm.pEngine.describecontentPE.technologyhandler.SetDescribeContentProtocol;
import org.iso.mpeg.mxm.tEngine.metadataTE.MetadataEngine;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;

/**
 * @author Angelos-Christos Anadiotis <aca@icbnet.ntua.gr>
 *
 */
public class DescribeContentTechnologyHandler 
				extends org.iso.mpeg.mxm.pEngine.describecontentPE.technologyhandler.DescribeContentTechnologyHandler
{
	private OrchestratorEngine orchestratorEngine;
	private BaseProtocolEngine baseProtocolEngine;
	private MetadataEngine metadataEngine;
	private SecurityEngine securityEngine;
	
	public DescribeContentTechnologyHandler(BaseProtocolEngine baseProtocolEngine, 
			OrchestratorEngine orchestratorEngine, MetadataEngine metadataEngine, SecurityEngine securityEngine)
	{
		this.orchestratorEngine = orchestratorEngine;
		this.baseProtocolEngine = baseProtocolEngine;
		this.metadataEngine = metadataEngine;
		this.securityEngine = securityEngine;
	}

	/* (non-Javadoc)
	 * @see org.iso.mpeg.mxm.pEngine.describecontentPE.technologyhandler.DescribeContentTechnologyHandler#getLocalGetDescribeContentProtocol()
	 */
	@Override
	public GetDescribeContentProtocol getLocalGetDescribeContentProtocol()
	{
		return new org.iso.mpeg.mxm.describecontentPE.technology.local.GetDescribeContentProtocol(orchestratorEngine);
	}

	/* (non-Javadoc)
	 * @see org.iso.mpeg.mxm.pEngine.describecontentPE.technologyhandler.DescribeContentTechnologyHandler#getRemoteGetDescribeContentProtocol()
	 */
	@Override
	public GetDescribeContentProtocol getRemoteGetDescribeContentProtocol()
	{
		return new org.iso.mpeg.mxm.describecontentPE.technology.remote.GetDescribeContentProtocol(
								baseProtocolEngine, metadataEngine, securityEngine);
	}

	/* (non-Javadoc)
	 * @see org.iso.mpeg.mxm.pEngine.describecontentPE.technologyhandler.DescribeContentTechnologyHandler#getLocalSetDescribeContentProtocol()
	 */
	@Override
	public SetDescribeContentProtocol getLocalSetDescribeContentProtocol()
	{
		return new org.iso.mpeg.mxm.describecontentPE.technology.local.SetDescribeContentProtocol(orchestratorEngine);
	}

	/* (non-Javadoc)
	 * @see org.iso.mpeg.mxm.pEngine.describecontentPE.technologyhandler.DescribeContentTechnologyHandler#getRemoteSetDescribeContentProtocol()
	 */
	@Override
	public SetDescribeContentProtocol getRemoteSetDescribeContentProtocol()
	{
		return new org.iso.mpeg.mxm.describecontentPE.technology.remote.SetDescribeContentProtocol(
				baseProtocolEngine, securityEngine);
	}

}
