package org.iso.mpeg.mxm.digitalitemTE;

import java.util.List;

import org.iso.mpeg.mxm.core.MXMEngine;
import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.digitalitemTE.schemahandler.Item;
import org.iso.mpeg.mxm.digitalitemTE.schemahandler.RelatedIdentifier;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.ApplicationSpecificData;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Component;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Container;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.DIDL;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.DIDLInfo;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Descriptor;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Resource;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Statement;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl_msx.StructuredData;
import org.iso.mpeg.mxm.tEngine.eventreportTE.EventReportEngine;
import org.iso.mpeg.mxm.tEngine.ipmpTE.IPMPEngine;
import org.iso.mpeg.mxm.tEngine.metadataTE.MetadataEngine;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;

public class DIEngineSchemaHandler implements
		org.iso.mpeg.mxm.tEngine.digitalitemTE.DIEngineSchemaHandler {

	protected DigitalitemTE DIengine;
	protected EventReportEngine ERengine;
	protected MetadataEngine METAengine;
	protected SecurityEngine SECengine;
	protected IPMPEngine IPMPengine;
	
	protected DIEngineSchemaHandler(List<MXMEngine> engines) throws MXMEngineException
	{
		for (MXMEngine engine: engines)
		{
			
			if (engine.getEngineName().equals(MXMEngineName.DigitalItemTE.toString()))
			{
				DIengine=(DigitalitemTE)engine;
			}
			else if (engine.getEngineName().equals(MXMEngineName.EventReportTE.toString()))
			{
				ERengine=(EventReportEngine)engine;
			}
			else if (engine.getEngineName().equals(MXMEngineName.MetadataTE.toString()))
			{
				METAengine=(MetadataEngine)engine;
			}			
			else if (engine.getEngineName().equals(MXMEngineName.SecurityTE.toString()))
			{
				SECengine=(SecurityEngine)engine;
			}
			else if (engine.getEngineName().equals(MXMEngineName.IPMPTE.toString()))
			{
				IPMPengine=(IPMPEngine)engine;
			}
//			else {
//				throw new MXMEngineException("there is a dependencies here not recognized! it is the >"+engine.getEngineName());
//			}
		}
//		if (ERengine==null || SECengine==null || IPMPengine==null || METAengine==null || DIengine==null)
//			throw new MXMEngineException("dependencies not setted correctly");
	}
	
	@Override
	public ApplicationSpecificData getApplicationSpecificData() throws MXMEngineException {
		return new org.iso.mpeg.mxm.digitalitemTE.schemahandler.ApplicationSpecificData();
	}

	@Override
	public Component getComponent() throws MXMEngineException {
		return new org.iso.mpeg.mxm.digitalitemTE.schemahandler.Component(DIengine);
	}

	@Override
	public Container getContainer() throws MXMEngineException {
		return null;
	}

	@Override
	public Descriptor getDescriptor() throws MXMEngineException {
		return new org.iso.mpeg.mxm.digitalitemTE.schemahandler.Descriptor(DIengine);
	}

	@Override
	public DIDL getDIDL() throws MXMEngineException, MXMException {
		return new org.iso.mpeg.mxm.digitalitemTE.schemahandler.DIDL(DIengine);
	}

	@Override
	public DIDLInfo getDIDLInfo() throws MXMEngineException {
		return new org.iso.mpeg.mxm.digitalitemTE.schemahandler.DIDLInfo(DIengine, SECengine);
	}

	@Override
	public Item getItem() throws MXMEngineException {
		return 	new org.iso.mpeg.mxm.digitalitemTE.schemahandler.Item(DIengine);
	}

	@Override
	public Resource getResource() throws MXMEngineException {
		return new org.iso.mpeg.mxm.digitalitemTE.schemahandler.Resource();
	}

	@Override
	public Statement getStatement() throws MXMEngineException {
		return new org.iso.mpeg.mxm.digitalitemTE.schemahandler.Statement(DIengine, ERengine, METAengine, IPMPengine, SECengine);
	}

	@Override
	public RelatedIdentifier getRelatedIdentifier() throws MXMEngineException {
		return new org.iso.mpeg.mxm.digitalitemTE.schemahandler.RelatedIdentifier();
	}

	@Override
	public StructuredData getStructuredData() throws MXMEngineException {
		return new org.iso.mpeg.mxm.digitalitemTE.schemahandler.StructuredData();
	}
}
