package org.iso.mpeg.mxm.digitalitemTE.schemahandler;

import java.io.File;

import org.iso.mpeg.mxm.core.MXMEngine;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.digitalitemTE.DigitalitemTE;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.ApplicationSpecificDataType;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.SuperDidlAbstractLevel1;

public class ApplicationSpecificData implements org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.ApplicationSpecificData {

	protected ApplicationSpecificDataType asdttype;

	public ApplicationSpecificData() throws MXMEngineException{
		asdttype=new ApplicationSpecificDataType();
	}

	@Override
	public void createFile(File f) throws MXMException {
		(new SuperDidlAbstractLevel1(asdttype)).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		return (new SuperDidlAbstractLevel1(asdttype)).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperDidlAbstractLevel1 level1=new SuperDidlAbstractLevel1(asdttype);
		MXMEngineResponse response = level1.parse(object);
		if (response.equals(MXMEngineResponse.SUCCESS))
		{
			this.asdttype=(ApplicationSpecificDataType)(level1.createObject(ApplicationSpecificDataType.class.getCanonicalName())).getContent();
		}
		return response;
	}

	@Override
	public Object getAny() {
		return asdttype.getAny();
	}

	@Override
	public void setAny(Object object) {
		asdttype.setAny(object);
	}
}
