package org.iso.mpeg.mxm.digitalitemTE.schemahandler;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBElement;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngine;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.digitalitemTE.DigitalitemTE;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.ComponentType;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.SuperDidlAbstractLevel1;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Resource;


public class Component implements org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Component {

	protected ComponentType componenttype;
	
	DigitalitemTE DIengine;

	
	public Component(DigitalitemTE DIengine) throws MXMEngineException{
		this.DIengine = DIengine;
		
		componenttype=new ComponentType();
	}

	@Override
	public void createFile(File f) throws MXMException {
		(new SuperDidlAbstractLevel1(componenttype)).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		return (new SuperDidlAbstractLevel1(componenttype)).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperDidlAbstractLevel1 level1=new SuperDidlAbstractLevel1(componenttype);
		MXMEngineResponse response = level1.parse(object);
		if (response.equals(MXMEngineResponse.SUCCESS))
		{
			this.componenttype=(ComponentType)(level1.createObject(ComponentType.class.getCanonicalName())).getContent();
		}
		return response;
	}

	@Override
	public List<org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Resource> getResource() throws MXMEngineException {
		List<org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Resource> toreturn=new ArrayList();
		
		List<JAXBElement<? extends org.iso.mpeg.mxm.engine.digitalitemTE.schema.didmodel_mp21.ResourceType>> resources = componenttype.getResource();
		
		for (JAXBElement<? extends org.iso.mpeg.mxm.engine.digitalitemTE.schema.didmodel_mp21.ResourceType> resource : resources){
			org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Resource r=DIengine.getDIEngineSchemaHandler().getResource();
			r.parse(new MXMAdapter(resource));
			toreturn.add(r);
		}
				
		return toreturn;		
	}

	@Override
	public void addResource(Resource r) throws MXMException {
		componenttype.getResource().add((JAXBElement<? extends org.iso.mpeg.mxm.engine.digitalitemTE.schema.didmodel_mp21.ResourceType>) r.createObject(JAXBElement.class.getCanonicalName()).getContent());
	}
}
