package org.iso.mpeg.mxm.digitalitemTE.schemahandler;

import java.io.File;

import javax.xml.bind.JAXBElement;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.digitalitemTE.DigitalitemTE;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.DIDLInfoType;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.SuperDidlAbstractLevel1;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.SignatureType;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.DIEngine;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Signature;


public class DIDLInfo extends DIDLInfo_mp21 implements org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.DIDLInfo {

	protected DIDLInfoType ditype;	
	protected DIEngine DIengine;
	protected SecurityEngine secengine;

	public DIDLInfo(DigitalitemTE DIengine, SecurityEngine secengine) throws MXMEngineException{
		this.DIengine = DIengine;
		this.secengine=secengine;

		ditype=new DIDLInfoType();
	}
	
	@Override
	public void createFile(File f) throws MXMException {
		(new SuperDidlAbstractLevel1(ditype)).createFile(f);
		
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		return (new SuperDidlAbstractLevel1(ditype)).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperDidlAbstractLevel1 level1=new SuperDidlAbstractLevel1(ditype);
		MXMEngineResponse response = level1.parse(object);
		if (response.equals(MXMEngineResponse.SUCCESS))
		{
			this.ditype=(DIDLInfoType)(level1.createObject(DIDLInfoType.class.getCanonicalName())).getContent();
		}
		return response;
	}
	
	@Override
	public Signature getSignature() throws MXMEngineException {
		SignatureType signa= ditype.getDISignature();
		org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Signature st=secengine.getSecurityEngineSchemaHandler().getSignature();
		st.parse(new MXMAdapter(signa));
		return st;
	}

	@Override
	public void setSignature(Signature object) throws MXMException {
		
		
		
		
		ditype.setDISignature((SignatureType)(object.createObject(SignatureType.class.getCanonicalName()).getContent()));	

	}	
}
