package org.iso.mpeg.mxm.digitalitemTE.schemahandler;

import java.io.File;

import javax.xml.bind.JAXBElement;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngine;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.digitalitemTE.DigitalitemTE;

import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.DescriptorType;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.StatementType;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.SuperDidlAbstractLevel1;

public class Descriptor extends org.iso.mpeg.mxm.digitalitemTE.schemahandler.Descriptor_mp21
	implements org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Descriptor 
	 {

	protected DescriptorType descriptortype;	

	DigitalitemTE DIengine;
	
	
	public Descriptor(DigitalitemTE DIengine) throws MXMEngineException{
		this.DIengine = DIengine;

		descriptortype=new DescriptorType();
	}

	@Override
	public void createFile(File f) throws MXMException {
		(new SuperDidlAbstractLevel1(descriptortype)).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		return (new SuperDidlAbstractLevel1(descriptortype)).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperDidlAbstractLevel1 level1=new SuperDidlAbstractLevel1(descriptortype);
		MXMEngineResponse response = level1.parse(object);
		if (response.equals(MXMEngineResponse.SUCCESS))
		{
			this.descriptortype=(DescriptorType)(level1.createObject(DescriptorType.class.getCanonicalName())).getContent();
		}
		return response;
	}

	@Override
	public Object getStatementMPEGM() throws MXMEngineException {
		JAXBElement<?> statement = descriptortype.getStatement();
		org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Statement st=DIengine.getDIEngineSchemaHandler().getStatement();
		st.parse(new MXMAdapter(statement));
		return st;
	}

	@Override
	public void setStatementMPEGM(Object object) throws MXMException {
		descriptortype.setStatement((JAXBElement<StatementType>)((org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Statement)object).createObject(JAXBElement.class.getCanonicalName()).getContent());	
	}
}
