package org.iso.mpeg.mxm.digitalitemTE.schemahandler;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBElement;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngine;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.digitalitemTE.DigitalitemTE;

import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.DIDLType;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.ItemType;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.SuperDidlAbstractLevel1;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didmodel_mp21.DIDBaseType;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.ApplicationSpecificData;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Component;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl_msx.StructuredData;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didmodel_mp21.DIDBase;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.dii.RelatedIdentifier;
import org.iso.mpeg.mxm.tEngine.eventreportTE.schemahandler.er.ERR;
import org.iso.mpeg.mxm.tEngine.ipmpTE.schemahandler.ipmpinfo.IPMPGeneralInfoDescriptor;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.Mpeg7;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Signature;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Descriptor;

public class Item implements org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Item {

	protected ItemType itemtype;
	
	DigitalitemTE DIengine;
//	MXMEngine ERengine;
//	MXMEngine SECengine;
//	MXMEngine IPMPengine;	
	
	public Item(DigitalitemTE DIengine) throws MXMEngineException{
		this.DIengine = DIengine;
//		this.ERengine = ERengine;
//		this.SECengine = SECengine;
//		this.IPMPengine = IPMPengine;
		
		itemtype = new ItemType();
	}
	
	@Override
	public void createFile(File f) throws MXMException {
		(new SuperDidlAbstractLevel1(itemtype)).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		return (new SuperDidlAbstractLevel1(itemtype)).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException{
		SuperDidlAbstractLevel1 level1=new SuperDidlAbstractLevel1(itemtype);
		MXMEngineResponse response = level1.parse(object);
		if (response.equals(MXMEngineResponse.SUCCESS))
		{
			this.itemtype=(ItemType)(level1.createObject(ItemType.class.getCanonicalName())).getContent();			//FORCE to ITem from MPEGM
		}
		
		return response;
	}

	@Override
	public void setId(String string) {
		itemtype.setId(string);
	}
	
	@Override
	public String getId() {
		return itemtype.getId();
	}

	@Override
	public List<Descriptor> getDescriptor() throws MXMException {
		List<Descriptor> toreturn=new ArrayList();	
		List<JAXBElement<? extends org.iso.mpeg.mxm.engine.digitalitemTE.schema.didmodel_mp21.DescriptorType>> descriptors = itemtype.getDescriptor();
		for (JAXBElement<? extends org.iso.mpeg.mxm.engine.digitalitemTE.schema.didmodel_mp21.DescriptorType> je : descriptors){
			Descriptor desc=(Descriptor)DIengine.getDIEngineSchemaHandler().getDescriptor();
			desc.parse(new MXMAdapter(je));
			toreturn.add(desc);
		}
		return toreturn;
	}

	@Override
	public List<DIDBase> getItemOrComponent() {
		// TODO Auto-generated method stub
		return null;
	}

	
	//---------------------------------shortcut
	
	@Override
	/**
	 * return null if not found
	 */
	public String getIdentifier() throws MXMException {
		List<Descriptor> descriptors = getDescriptor();
		for (Descriptor d: descriptors){
			if (((Statement)d.getStatementMPEGM()).getIdentifier()!=null)
				return ((Statement)d.getStatementMPEGM()).getIdentifier();
		}
		return null;
	}

	@Override
	public void setIdentifier(String value) throws MXMException {
		List<Descriptor> descriptors = getDescriptor();
		for (Descriptor d: descriptors){
			if (((Statement)d.getStatementMPEGM()).getIdentifier()!=null){
				((Statement)d.getStatementMPEGM()).setIdentifier(value);
				return;
			}
		}
		
		//if i arrive here, there was no identier set, so i create a new one 
		
		org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Statement newSt=DIengine.getDIEngineSchemaHandler().getStatement();
		newSt.setIdentifier(value);
		
		Descriptor newId=(Descriptor)DIengine.getDIEngineSchemaHandler().getDescriptor();
		newId.setStatementMPEGM(newSt);
		itemtype.getDescriptor().add((JAXBElement)newId.createObject(JAXBElement.class.getCanonicalName()).getContent());
	}
		

	@Override
	public List<ERR> getERR() throws MXMException {
		List<Descriptor> descriptors = getDescriptor();
		for (Descriptor d: descriptors){
			if (!((Statement)d.getStatementMPEGM()).getERR().isEmpty()){
				return ((Statement)d.getStatementMPEGM()).getERR();
			}
		}
		return null;
	}

	@Override
	public void addERR(ERR err) throws MXMException {
		org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Statement newSt=DIengine.getDIEngineSchemaHandler().getStatement();
		newSt.addERR(err);
		
		Descriptor newId=(Descriptor)DIengine.getDIEngineSchemaHandler().getDescriptor();
		newId.setStatementMPEGM(newSt);
		itemtype.getDescriptor().add((JAXBElement)newId.createObject(JAXBElement.class.getCanonicalName()).getContent());
	}

	@Override
	public List<org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Item> getItem() throws MXMException {
		List<org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Item> toreturn=new ArrayList();
		for (JAXBElement<? extends DIDBaseType>  o : itemtype.getItemOrComponent()){
			if (o.getValue().getClass().getName().equals("org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.ItemType")){
					org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Item new_it=DIengine.getDIEngineSchemaHandler().getItem();
					new_it.parse(new MXMAdapter(o.getValue()));
					toreturn.add(new_it);
			}
		}
		return toreturn;
	}

	@Override
	public List<Component> getComponent() throws MXMException {
		List<org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Component> toreturn=new ArrayList();
		for (JAXBElement<? extends DIDBaseType>  o : itemtype.getItemOrComponent()){
			if (o.getValue().getClass().getName().equals("org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.ComponentType")){
					org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Component new_it=DIengine.getDIEngineSchemaHandler().getComponent();
					new_it.parse(new MXMAdapter(o.getValue()));
					toreturn.add(new_it);
			}
		}
		return toreturn;
	}

	@Override
	public void addItem(org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Item i) throws MXMException {
		itemtype.getItemOrComponent().add((JAXBElement)i.createObject(JAXBElement.class.getCanonicalName()).getContent());
	}

	@Override
	public void addComponent(Component i) throws MXMException {
		itemtype.getItemOrComponent().add((JAXBElement)i.createObject(JAXBElement.class.getCanonicalName()).getContent());
	}

	@Override
	public List<RelatedIdentifier> getRelatedIdentifier() throws MXMException{
		List<Descriptor> descriptors = getDescriptor();
		for (Descriptor d: descriptors){
			if (!((Statement)d.getStatementMPEGM()).getRelatedIdentifier().isEmpty()){
				return ((Statement)d.getStatementMPEGM()).getRelatedIdentifier();
			}
		}
		return null;
	}

	@Override
	public void addRelatedIdentifier(RelatedIdentifier id) throws MXMException {
		org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Statement newSt=DIengine.getDIEngineSchemaHandler().getStatement();
		newSt.addRelatedIdentifier(id);
		
		Descriptor newId=(Descriptor)DIengine.getDIEngineSchemaHandler().getDescriptor();
		newId.setStatementMPEGM(newSt);
		itemtype.getDescriptor().add((JAXBElement)newId.createObject(JAXBElement.class.getCanonicalName()).getContent());
	}

	@Override
	public IPMPGeneralInfoDescriptor getIPMPGeneralInfoDescriptor()
			throws MXMException {
		List<Descriptor> descriptors = getDescriptor();
		for (Descriptor d: descriptors){
			if (((Statement)d.getStatementMPEGM()).getIPMPGeneralInfoDescriptor()!=null)
				return ((Statement)d.getStatementMPEGM()).getIPMPGeneralInfoDescriptor();
		}
		return null;
	}

	@Override
	public void addIPMPGeneralInfoDescriptor(IPMPGeneralInfoDescriptor i)
			throws MXMException {
		org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Statement newSt=DIengine.getDIEngineSchemaHandler().getStatement();
		newSt.addIPMPGeneralInfoDescriptor(i);
		
		Descriptor newId=(Descriptor)DIengine.getDIEngineSchemaHandler().getDescriptor();
		newId.setStatementMPEGM(newSt);
		itemtype.getDescriptor().add((JAXBElement)newId.createObject(JAXBElement.class.getCanonicalName()).getContent());
	}

	@Override
	public Signature getContentElementSignature() throws MXMException {
		List<Descriptor> descriptors = getDescriptor();
		for (Descriptor d: descriptors){
			if (((Statement)d.getStatementMPEGM()).getContentElementSignature()!=null)
				return ((Statement)d.getStatementMPEGM()).getContentElementSignature();
		}
		return null;
	}

	@Override
	public void addContentElementSignature(Signature c) throws MXMException {
		org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Statement newSt=DIengine.getDIEngineSchemaHandler().getStatement();
		newSt.addContentElementSignature(c);
		
		Descriptor newId=(Descriptor)DIengine.getDIEngineSchemaHandler().getDescriptor();
		newId.setStatementMPEGM(newSt);
		itemtype.getDescriptor().add((JAXBElement)newId.createObject(JAXBElement.class.getCanonicalName()).getContent());
	}

	@Override
	public byte[] getLaserObj() throws MXMEngineException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void addLaserObj(byte[] l) throws MXMException {
		// TODO Auto-generated method stub
		
	}

	@Override
	public List<ApplicationSpecificData> getApplicationSpecificData() throws MXMException {
		List<Descriptor> descriptors = getDescriptor();
		for (Descriptor d: descriptors){
			if (!(((Statement)d.getStatementMPEGM()).getApplicationSpecificData()).isEmpty()){
				return ((Statement)d.getStatementMPEGM()).getApplicationSpecificData();
			}
		}
		return null;
	}

	@Override
	public void addApplicationSpecificData(ApplicationSpecificData l) throws MXMException{
		org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Statement newSt=DIengine.getDIEngineSchemaHandler().getStatement();
		newSt.addApplicationSpecificData(l);
		
		Descriptor newId=(Descriptor)DIengine.getDIEngineSchemaHandler().getDescriptor();
		newId.setStatementMPEGM(newSt);
		itemtype.getDescriptor().add((JAXBElement)newId.createObject(JAXBElement.class.getCanonicalName()).getContent());
	}

	@Override
	public void addMetadata(StructuredData sd) throws MXMException {
		org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Statement newSt=DIengine.getDIEngineSchemaHandler().getStatement();
		newSt.addMetadata(sd);
		
		Descriptor newId=(Descriptor)DIengine.getDIEngineSchemaHandler().getDescriptor();
		newId.setStatementMPEGM(newSt);
		itemtype.getDescriptor().add((JAXBElement)newId.createObject(JAXBElement.class.getCanonicalName()).getContent());
		
	}

	@Override
	public StructuredData getMetadata() throws MXMException {
		List<Descriptor> descriptors = getDescriptor();
		for (Descriptor d: descriptors){
			if (((Statement)d.getStatementMPEGM()).getMetadata()!=null)
				return (((Statement)d.getStatementMPEGM()).getMetadata());
		}
		return null;
	}
	
	@Override
	public void addMetadataDescriptor(org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didmodel_mp21.Descriptor d) throws MXMException {
//		org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Statement newSt=DIengine.getDIEngineSchemaHandler().getStatement();
//		newSt.addMetadata(sd);
		
//		Descriptor newId=DIengine.getDIEngineSchemaHandler().getDescriptor();
//		newId.setStatement(newSt);
		
	
		if ( ! (d instanceof org.iso.mpeg.mxm.digitalitemTE.schemahandler.Descriptor))
			throw new MXMEngineException("descriptor contains a DecriptorType not in line with mpegm profile");
		else
			itemtype.getDescriptor().add((JAXBElement)d.createObject(JAXBElement.class.getCanonicalName()).getContent());
		
	}

	@Override
	public org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didmodel_mp21.Descriptor getMetadataDescriptor() throws MXMException {
		List<Descriptor> descriptors = getDescriptor();
		for (Descriptor d: descriptors){
			if (((Statement)d.getStatementMPEGM()).getMetadata()!=null)
				return d;
		}
		return null;
	}
}
