package org.iso.mpeg.mxm.digitalitemTE.schemahandler;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl_msx.StructuredDataType;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl_msx.SuperDidl_msxAbstractLevel1;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl_msx.StructuredData;


public class Metadata implements org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl_msx.Metadata{

	org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl_msx.MetadataType metatype;

	public Metadata() throws MXMEngineException{
		metatype=new org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl_msx.MetadataType();
	}

	@Override
	public void createFile(File f) throws MXMException {
		(new SuperDidl_msxAbstractLevel1(metatype)).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		return (new SuperDidl_msxAbstractLevel1(metatype)).createObject(objectType);	
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperDidl_msxAbstractLevel1 level1=new SuperDidl_msxAbstractLevel1(metatype);
		MXMEngineResponse response = level1.parse(object);
		if (response.equals(MXMEngineResponse.SUCCESS))
		{
			this.metatype=(org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl_msx.MetadataType)(level1.createObject(org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl_msx.MetadataType.class.getCanonicalName())).getContent();
		}
		return response;
	}

	@Override
	public void setId(String string) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public String getId() {
		// TODO Auto-generated method stub
		return null;
	}
	
	
	@Override
	public List<StructuredData> getStructuredData() throws MXMEngineException {
		List<StructuredData> toreturn = new ArrayList();
		
		for (StructuredDataType std:this.metatype.getStructuredData()){
			StructuredData st=new org.iso.mpeg.mxm.digitalitemTE.schemahandler.StructuredData();
			st.parse(new MXMAdapter(std));
			toreturn.add(st);
		}
		
		return toreturn;
	}


	@Override
	public void setStructuredData(StructuredData s) throws MXMException {
		this.metatype.getStructuredData().add((StructuredDataType)s.createObject(StructuredDataType.class.getCanonicalName()).getContent());
		
	}

	
}
