package org.iso.mpeg.mxm.digitalitemTE.schemahandler;

import java.io.File;
import java.util.List;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.dii.SuperDiiAbstractLevel1;


public class RelatedIdentifier implements org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.dii.RelatedIdentifier{

	org.iso.mpeg.mxm.engine.digitalitemTE.schema.dii.RelatedIdentifier reltype;

	public RelatedIdentifier() throws MXMEngineException{
		reltype=new org.iso.mpeg.mxm.engine.digitalitemTE.schema.dii.RelatedIdentifier();
	}

	@Override
	public void createFile(File f) throws MXMException {
		(new SuperDiiAbstractLevel1(reltype)).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		return (new SuperDiiAbstractLevel1(reltype)).createObject(objectType);	
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperDiiAbstractLevel1 level1=new SuperDiiAbstractLevel1(reltype);
		MXMEngineResponse response = level1.parse(object);
		if (response.equals(MXMEngineResponse.SUCCESS))
		{
			this.reltype=(org.iso.mpeg.mxm.engine.digitalitemTE.schema.dii.RelatedIdentifier)(level1.createObject(org.iso.mpeg.mxm.engine.digitalitemTE.schema.dii.RelatedIdentifier.class.getCanonicalName())).getContent();
		}
		return response;
	}

	@Override
	public String getRelationship() {
		return this.reltype.getRelationshipType();
	}

	@Override
	public void setRelationship(String string) {
		this.reltype.setRelationshipType(string);
	}

	@Override
	public String getValue() {
		return this.reltype.getValue();
	}

	@Override
	public void setValue(String string) {
		 this.reltype.setValue(string);
	}

}
