package org.iso.mpeg.mxm.digitalitemTE.schemahandler;

import java.io.File;
import java.io.Serializable;
import java.util.List;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.ResourceType;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.SuperDidlAbstractLevel1;


public class Resource implements org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Resource {

	ResourceType resourcetype;

	public Resource() throws MXMEngineException{
		resourcetype=new ResourceType();
	}

	@Override
	public void createFile(File f) throws MXMException {
		(new SuperDidlAbstractLevel1(resourcetype)).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		return (new SuperDidlAbstractLevel1(resourcetype)).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperDidlAbstractLevel1 level1=new SuperDidlAbstractLevel1(resourcetype);
		MXMEngineResponse response = level1.parse(object);
		if (response.equals(MXMEngineResponse.SUCCESS))
		{
			this.resourcetype=(ResourceType)(level1.createObject(ResourceType.class.getCanonicalName())).getContent();
		}
		return response;
	}

	@Override
	public void setRef(String string) {
		resourcetype.setRef(string);
	}

	@Override
	public void setMime(String string) {
		resourcetype.setMimeType(string);	
	}

	@Override
	public String getEncoding() {
		return resourcetype.getEncoding();	
	}

	@Override
	public String getRef() {
		return resourcetype.getRef();
	}

	@Override
	public List<Serializable> getContent() {
		return resourcetype.getContent();
	}

	@Override
	public List<String> getContentEncoding() {
		return resourcetype.getContentEncoding();
	}

	@Override
	public void setEncoding(String string) {
		resourcetype.setEncoding(string);
	}

	@Override
	public String getMime() {
		return resourcetype.getMimeType();
	}
}
