package org.iso.mpeg.mxm.digitalitemTE.schemahandler;

import java.io.File;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBElement;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.digitalitemTE.DigitalitemTE;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.ApplicationSpecificDataType;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.ObjectFactory;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.StatementType;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.SuperDidlAbstractLevel1;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl_msx.StructuredDataType;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.SignatureType;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.ApplicationSpecificData;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl_msx.StructuredData;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.dii.RelatedIdentifier;
import org.iso.mpeg.mxm.tEngine.eventreportTE.EventReportEngine;
import org.iso.mpeg.mxm.tEngine.eventreportTE.schemahandler.er.ERR;
import org.iso.mpeg.mxm.tEngine.ipmpTE.IPMPEngine;
import org.iso.mpeg.mxm.tEngine.ipmpTE.schemahandler.ipmpinfo.IPMPGeneralInfoDescriptor;
import org.iso.mpeg.mxm.tEngine.metadataTE.MetadataEngine;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.Mpeg7;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Signature;

public class Statement implements org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.Statement {

	private final String MPEG7_METADATA_URI = "urn:mpeg:mpeg7:schema:2004";
	
	protected StatementType statementtype;

	DigitalitemTE DIengine;
	EventReportEngine ERengine;
	MetadataEngine METAengine;
	SecurityEngine SECengine;
	IPMPEngine IPMPengine;	
	
	
	public Statement(DigitalitemTE DIengine, EventReportEngine ERengine, MetadataEngine METAengine, IPMPEngine IPMPengine, SecurityEngine SECengine) throws MXMEngineException{
		this.DIengine = DIengine;
		this.ERengine = ERengine;
		this.METAengine = METAengine;
		this.SECengine = SECengine;
		this.IPMPengine = IPMPengine;

		statementtype=new StatementType();
	}

	@Override
	public void createFile(File f) throws MXMException {
		(new SuperDidlAbstractLevel1(statementtype)).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		return (new SuperDidlAbstractLevel1(statementtype)).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperDidlAbstractLevel1 level1=new SuperDidlAbstractLevel1(statementtype);
		MXMEngineResponse response = level1.parse(object);
		if (response.equals(MXMEngineResponse.SUCCESS))
		{
			this.statementtype=(StatementType)(level1.createObject(StatementType.class.getCanonicalName())).getContent();
		}
		return response;
	}

	@Override
	public void setRef(String string) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void setMime(String string) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public String getRef() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public List<Object> getContent() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getMime() {
		// TODO Auto-generated method stub
		return null;
	}

	//-----------------shortcut
	
	
	@Override
	/**
	 * return null if not present
	 */
	public String getIdentifier() {
		for (Object o : statementtype.getContent()){
			if (o instanceof JAXBElement)
				if ((((JAXBElement)o).getValue().getClass().getCanonicalName()).contains("String"))
					return ((String)((JAXBElement)o).getValue()).trim();
		}
		return null;
	}

	@Override
	public void setIdentifier(String value) {
		org.iso.mpeg.mxm.engine.digitalitemTE.schema.dii.ObjectFactory o=new org.iso.mpeg.mxm.engine.digitalitemTE.schema.dii.ObjectFactory();
		statementtype.getContent().clear();
		statementtype.getContent().add(o.createIdentifier(value));
	}
	
	
	@Override
	public List<ERR> getERR() throws MXMEngineException {
    	List<ERR> errs = new ArrayList<ERR>();
    	for (Object o : statementtype.getContent()){
    		if (o instanceof JAXBElement && ((JAXBElement)o).getValue() instanceof  org.iso.mpeg.mxm.engine.eventreportTE.schema.er.ERRType){
    				ERR err = ERengine.getEventReportEngineSchemaHandler().getERR();
    				err.parse(new MXMAdapter((org.iso.mpeg.mxm.engine.eventreportTE.schema.er.ERRType)((JAXBElement)o).getValue()));
    				errs.add( err);
    		}

		}
    	return errs;
	}

	@Override
	public void addERR(ERR err) throws MXMException {
    	statementtype.getContent().add((Serializable)(err.createObject(JAXBElement.class.getCanonicalName())).getContent());
	}

	@Override
	public List<RelatedIdentifier> getRelatedIdentifier()throws MXMEngineException {
		List<RelatedIdentifier> toreturn=new ArrayList();
		for (Object o : statementtype.getContent()){
			if (o instanceof org.iso.mpeg.mxm.engine.digitalitemTE.schema.dii.RelatedIdentifier){
				RelatedIdentifier ri = DIengine.getDIEngineSchemaHandler().getRelatedIdentifier();
				ri.parse(new MXMAdapter((org.iso.mpeg.mxm.engine.digitalitemTE.schema.dii.RelatedIdentifier)o));
				toreturn.add(ri);
			}
		}
		return toreturn;
	}

	@Override
	public void addRelatedIdentifier(RelatedIdentifier id) throws MXMException {
		statementtype.getContent().add((Serializable) (id.createObject(org.iso.mpeg.mxm.engine.digitalitemTE.schema.dii.RelatedIdentifier.class.getCanonicalName())).getContent());
		//statementtype.getContent().add((org.iso.mpeg.mxm.engine.digitalitemTE.schema.dii.RelatedIdentifier) (id.createObject(JAXBElement.class.getCanonicalName())).getContent());
	}


	@Override
	public IPMPGeneralInfoDescriptor getIPMPGeneralInfoDescriptor()throws MXMEngineException {
		for (Object o : statementtype.getContent()){
    		if (o instanceof JAXBElement && ((JAXBElement)o).getValue() instanceof  org.iso.mpeg.mxm.engine.ipmpTE.schema.ipmpinfo.IPMPGeneralInfoDescriptorType){
    			IPMPGeneralInfoDescriptor igid=IPMPengine.getIPMPEngineSchemaHandler().getIPMPGeneralInfoDescriptor();
    			igid.parse(new MXMAdapter((org.iso.mpeg.mxm.engine.ipmpTE.schema.ipmpinfo.IPMPGeneralInfoDescriptorType)((JAXBElement)o).getValue()));
    			return igid;
    		}
		}
    	return null;
	}

	@Override
	public void addIPMPGeneralInfoDescriptor(IPMPGeneralInfoDescriptor i)throws MXMException {
		statementtype.getContent().add((Serializable)(i.createObject(JAXBElement.class.getCanonicalName())).getContent());
	}

	@Override
	public Signature getContentElementSignature() throws MXMEngineException {
		for (Object o : statementtype.getContent()){
			if (o instanceof JAXBElement){
				if (((JAXBElement)o).getValue() instanceof  org.iso.mpeg.mxm.engine.securityTE.schema.dsig.SignatureType){
					Signature s = SECengine.getSecurityEngineSchemaHandler().getSignature();
					s.parse(new MXMAdapter(( org.iso.mpeg.mxm.engine.securityTE.schema.dsig.SignatureType)((JAXBElement)o).getValue()));
					return s;
				}
			}
		}
    	return null;
	}

	@Override
	public void addContentElementSignature(Signature c) throws MXMException {
		//TODO here we need to create the container, from ObjectFactory
		ObjectFactory o=new ObjectFactory();
		JAXBElement<SignatureType> st=o.createStatementTypeContentElementSignature((SignatureType)(c.createObject(SignatureType.class.getCanonicalName())).getContent());
		statementtype.getContent().add(st);
	}

	@Override
	public byte[] getLaserObj() throws MXMEngineException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void addLaserObj(byte[] l) throws MXMException {
		// TODO Auto-generated method stub
	}

	@Override
	public List<ApplicationSpecificData> getApplicationSpecificData()throws MXMEngineException {
		List<ApplicationSpecificData> toreturn=new ArrayList();
		for (Object o : statementtype.getContent()){
			if (o instanceof JAXBElement){
				if (((JAXBElement)o).getValue() instanceof  org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.ApplicationSpecificDataType){
					ApplicationSpecificData a = DIengine.getDIEngineSchemaHandler().getApplicationSpecificData();
					a.parse(new MXMAdapter((org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl.ApplicationSpecificDataType)((JAXBElement)o).getValue()));
					toreturn.add(a);
				}
			}
		}

    	return toreturn;
	}

	@Override
	public void addApplicationSpecificData(ApplicationSpecificData l) throws MXMException {
		//TODO here we need to create the container, from ObjectFactory
		ObjectFactory o=new ObjectFactory();
		JAXBElement<ApplicationSpecificDataType> st=
				o.createStatementTypeApplicationSpecificData((ApplicationSpecificDataType)
						(l.createObject(ApplicationSpecificDataType.class.getCanonicalName())).getContent());
		statementtype.getContent().add(st);
	}

	@Override
	public void addMetadata(StructuredData sd) throws MXMException {	
		Metadata mt=new Metadata();
		mt.setStructuredData(sd);
		
		statementtype.getContent().add((Serializable)(mt.createObject(JAXBElement.class.getCanonicalName())).getContent());		
	}

	@Override
	public StructuredData getMetadata() throws MXMException {
    	for (Object o : statementtype.getContent()){
		if (o instanceof JAXBElement){
			JAXBElement<?> p=(JAXBElement<?>)o;
			if (p.getValue().getClass().getName().equals("org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl_msx.MetadataType")){
				for (StructuredDataType	sdt:((org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl_msx.MetadataType)p.getValue()).getStructuredData()){

					StructuredData sd=DIengine.getDIEngineSchemaHandler().getStructuredData();
					sd.parse(new MXMAdapter(sdt));
					return sd;
				}
			}
		}
	}
	return null;	
	}
}
