package org.iso.mpeg.mxm.digitalitemTE.schemahandler;

import java.io.File;
import java.util.List;

import javax.xml.bind.JAXBElement;

import org.iso.mpeg.mxm.core.MXMCreatorAndParser;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl_msx.SuperDidl_msxAbstractLevel1;
import org.w3c.dom.Document;


public class StructuredData implements org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl_msx.StructuredData{

	org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl_msx.StructuredDataType stdtype;

	public StructuredData() throws MXMEngineException{
		stdtype=new org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl_msx.StructuredDataType();
	}

	@Override
	public void createFile(File f) throws MXMException {
		(new SuperDidl_msxAbstractLevel1(stdtype)).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		return (new SuperDidl_msxAbstractLevel1(stdtype)).createObject(objectType);	
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperDidl_msxAbstractLevel1 level1=new SuperDidl_msxAbstractLevel1(stdtype);
		MXMEngineResponse response = level1.parse(object);
		if (response.equals(MXMEngineResponse.SUCCESS))
		{
			this.stdtype=(org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl_msx.StructuredDataType)(level1.createObject(org.iso.mpeg.mxm.engine.digitalitemTE.schema.didl_msx.StructuredDataType.class.getCanonicalName())).getContent();
		}
		return response;
	}

	@Override
	public Object getAny() {
		return stdtype.getAny();
	}

	@Override
	public void setAny(MXMCreatorAndParser object) throws MXMException {
		if (!(object instanceof JAXBElement)) 
			stdtype.setAny(object.createObject(JAXBElement.class.getCanonicalName()).getContent());
		else
			stdtype.setAny(object);
	}
	
	public void setAny(Document doc)
	{
		stdtype.setAny(doc.getDocumentElement());
	}

	@Override
	public void setRef(String string) {
		stdtype.setRef(string);
	}

	@Override
	public String getRef() {
		return stdtype.getRef();
	}
}
