package org.iso.mpeg.mxm.eventreportTE;

import java.io.File;
import java.util.List;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.eventreportTE.schema.er.ERDataType;
import org.iso.mpeg.mxm.engine.eventreportTE.schema.er.ERDescriptorType;
import org.iso.mpeg.mxm.engine.eventreportTE.schema.er.ERSourceType;
import org.iso.mpeg.mxm.engine.eventreportTE.schema.er.ERType;
import org.iso.mpeg.mxm.engine.eventreportTE.schema.er.SuperErAbstractLevel1;
import org.iso.mpeg.mxm.eventreportTE.technologyhandler.kernel.keeper.IDGenerator;
import org.iso.mpeg.mxm.tEngine.eventreportTE.schemahandler.er.ERData;
import org.iso.mpeg.mxm.tEngine.eventreportTE.schemahandler.er.ERDescriptor;
import org.iso.mpeg.mxm.tEngine.eventreportTE.schemahandler.er.EmbeddedERR;


public class ER implements org.iso.mpeg.mxm.tEngine.eventreportTE.schemahandler.er.ER{

	ERType ertype;
	
	public ER() throws MXMEngineException{
		ertype=new ERType();
		
		setERIdentifier(IDGenerator.generateUsingUUID(IDGenerator.ER_IDENTIFIER_PREFIX));
	}

	@Override
	public void createFile(File f) throws MXMException {
		(new SuperErAbstractLevel1(ertype)).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		return (new SuperErAbstractLevel1(ertype)).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperErAbstractLevel1 level1=new SuperErAbstractLevel1(ertype);
		MXMEngineResponse response = level1.parse(object);
		this.ertype=(ERType)(level1.createObject(ERType.class.getCanonicalName())).getContent();
		return response;
	}

	@Override
	public ERDescriptor getERDescriptor() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setERDescriptor(ERDescriptor eRDescriptor) {
		// TODO Auto-generated method stub
	}

	@Override
	public ERData getERData() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setERData(ERData eRData) {
		// TODO Auto-generated method stub
	}

	@Override
	public List<EmbeddedERR> getEmbeddedERR() {
		// TODO Auto-generated method stub
		return null;
	}

	//shorcut-----------------------------------
	
	@Override
	public void setERRIdentifier(String errIdentifier) {
		ERDescriptorType ed;
        if ((ed = ertype.getERDescriptor()) == null) {
            ed = new ERDescriptorType();
        }

        ERSourceType es;
        if ((es = ed.getERSource()) == null) {
            es = new ERSourceType();
        }

        es.setERRReference(errIdentifier);
        ed.setERSource(es);
        ertype.setERDescriptor(ed);	
	}

	@Override
	public void setDIIId(String id) {
        ERDataType ed;
        if ((ed = ertype.getERData()) == null) {
            ed = new ERDataType();
        }

        ed.setDII(id);

        ertype.setERData(ed);
	}

	@Override
	public String getERRIdentifier() {
        ERDescriptorType ed = ertype.getERDescriptor();
        ERSourceType es = ed.getERSource();
        return es.getERRReference();
	}

	@Override
	public String getDIIId() {
        ERDataType ed = ertype.getERData();
        return ed.getDII();
	}

	@Override
	public String getERIdentifier() {
		return ertype.getERDescriptor().getDescription();
	}

	@Override
	public void setERIdentifier(String erIdentifier) {
	   	ERDescriptorType ed;
    	if ((ed = ertype.getERDescriptor())==null){
    		ed = new ERDescriptorType();
    	}
    	ed.setDescription(erIdentifier);
    	ertype.setERDescriptor(ed);
	}
}
