package org.iso.mpeg.mxm.eventreportTE;

import org.iso.mpeg.mxm.core.MXMAbstractEngine;
import org.iso.mpeg.mxm.core.MXMEngine;
import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.tEngine.eventreportTE.EventReportEngine;
import org.iso.mpeg.mxm.tEngine.eventreportTE.EventReportEngineSchemaHandler;
import org.iso.mpeg.mxm.tEngine.eventreportTE.EventReportEngineTechnologyHandler;

import java.util.ArrayList;
import java.util.List;

/**
 * <p/>
 * User: <a href="mailto:bogdan.ardeleanu@uti.ro"> Bogdan Ardeleanu</a>
 * Date: 8/29/11
 * Time: 6:48 PM
 * <p/>
 * UTI Systems, TIC
 */
public class EventReportTE extends MXMAbstractEngine implements EventReportEngine {

    protected List<MXMEngine> engines = new ArrayList<MXMEngine>();

    @Override
    public EventReportEngineSchemaHandler getEventReportEngineSchemaHandler() throws MXMEngineException {
        return new EREngineSchemaHandler(engines);
    }

    @Override
    public EventReportEngineTechnologyHandler getEventReportEngineTechHandler() throws MXMEngineException {
        return new EREngineTechnologyHandler(this);
    }

    @Override
    public String getEngineName() {
        return MXMEngineName.EventReportTE.toString();
    }

    @Override
    public void setDependencies(List<MXMEngine> engines)
        throws MXMEngineException {
        this.engines.addAll(engines);
    }

}
