package org.iso.mpeg.mxm.eventreportTE.technologyhandler.kernel.util;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.StreamException;

import java.io.*;
import java.util.HashMap;
import java.util.Map;

/**
 * <p/>
 * User: <a href="mailto:bogdan.ardeleanu@uti.ro"> Bogdan Ardeleanu</a>
 * Date: 9/5/11
 * Time: 5:20 PM
 * <p/>
 * UTI Systems, TIC
 */
public class GenericMappingSerializer<K, V> {
    private final String absFilePath;

    private final XStream xstream = new XStream();

    public GenericMappingSerializer(String absFilePath) {
        this.absFilePath = absFilePath;

        try {
            File f = new File(absFilePath);
            if (!f.exists()) {
                boolean created = f.createNewFile();
                if (!created) {
                    throw new RuntimeException("Can not create GenericMappingSerializer.absFilePath to: " + absFilePath);
                }
            }
        } catch (IOException e) {
            throw new RuntimeException("Can not create GenericMappingSerializer.absFilePath to: " + absFilePath);
        }
    }

    public void marshall(Map<K, V> mapping) {
        try {
            xstream.toXML(mapping, new FileOutputStream(absFilePath));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        }
    }

    @SuppressWarnings("unchecked")
    public Map<K, V> unmarshall() {
        try {
            return (Map<K, V>) xstream.fromXML(new FileInputStream(absFilePath));
        } catch (StreamException e) {
            return new HashMap<K, V>();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        }
    }
}
