/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the MPEG Multimedia Extensible Middleware (MXM) Project 
 *
 * The Initial Developer of the Original Code is CEDEO.net  
 * Portions created by the Initial Developer are Copyright (C) 2009
 * All Rights Reserved.
 *
 * The Initial Developer: Angelo Difino
 * Contributor(s): 
 *
 * ***** END LICENSE BLOCK ***** */

package org.iso.mpeg.mxm.identifycontentPE.schema;

import java.io.File;

import org.iso.mpeg.mxm.basePE.ProtocolRequest;
import org.iso.mpeg.mxm.baseprotocol.schema.ContentEntityType;
import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.protocol.SuperProtocolEngineAbstractLevel1;
import org.iso.mpeg.mxm.engine.protocol.identifycontentPE.schema.identifycontentprotocol.IdentifyContentRequestType;
import org.iso.mpeg.mxm.pEngine.basePE.BaseProtocolEngine;
import org.iso.mpeg.mxm.pEngine.basePE.schemahandler.ContentEntity;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;

/**
 * @author Angelo Difino
 *
 */
public class IdentifyContentRequest extends ProtocolRequest
									implements org.iso.mpeg.mxm.pEngine.identifycontentPE.schemahandler.IdentifyContentRequest
{	
	private BaseProtocolEngine baseProtocolEngine;	
	
	/**
	 * @throws MXMEngineException
	 */
	public IdentifyContentRequest(BaseProtocolEngine baseProtocolEngine, SecurityEngine securityEngine) throws MXMEngineException 
	{
		super(new IdentifyContentRequestType(), securityEngine);
		this.baseProtocolEngine=baseProtocolEngine;
	}
//	
//	/**
//	 * @throws MXMEngineException
//	 */
//	public IdentifyContentRequest(IdentifyContentRequestType identifyContentRequestType) throws MXMEngineException 
//	{
//		super(identifyContentRequestType);
//	}
//
//	/* (non-Javadoc)
//	 * @see org.iso.mpeg.mxm.engine.basePE.ProtocolBase#setTransactionIdentifier(java.lang.String)
//	 */
//	@Override
//	public void setTransactionIdentifier(String transactionID) 
//	{
//		identifyContentRequestType.setTransactionIdentifier(transactionID);
//	}
//
//	/* (non-Javadoc)
//	 * @see org.iso.mpeg.mxm.engine.basePE.ProtocolBase#getTransactionIdentifier()
//	 */
//	@Override
//	public String getTransactionIdentifier()
//	{
//		return identifyContentRequestType.getTransactionIdentifier();
//	}
//
//	/* (non-Javadoc)
//	 * @see org.iso.mpeg.mxm.engine.basePE.ProtocolBase#setTimestamp(java.util.Date)
//	 */
//	@Override
//	public void setTimestamp(Date date) 
//	{
//		GregorianCalendar c = new GregorianCalendar();
//		c.setTime(date);
//		XMLGregorianCalendar xmlGregorianCalendar = null;
//		try {
//			xmlGregorianCalendar = DatatypeFactory.newInstance().newXMLGregorianCalendar(c);
//		} catch (DatatypeConfigurationException e) {
//			e.printStackTrace();
//		}
//		
//		identifyContentRequestType.setTimestamp(xmlGregorianCalendar);
//	}
//
//	/* (non-Javadoc)
//	 * @see org.iso.mpeg.mxm.engine.basePE.ProtocolBase#getTimestamp()
//	 */
//	@Override
//	public Date getTimestamp() 
//	{
//		XMLGregorianCalendar xmlGregorianCalendar = identifyContentRequestType.getTimestamp();
//		return xmlGregorianCalendar.toGregorianCalendar().getTime();
//	}
//
//	/* (non-Javadoc)
//	 * @see org.iso.mpeg.mxm.engine.basePE.ProtocolBase#addKeyValueData(org.iso.mpeg.mxm.engine.basePE.KeyValueData)
//	 */
//	@Override
//	public void addKeyValueData(KeyValueData keyValueData) 
//	{
//		try {
//			identifyContentRequestType.getEntry().add(
//					(KeyValueDataType)(keyValueData.createObject(KeyValueDataType.class.getName())).getContent());
//		} catch (MXMException e) {
//			e.printStackTrace();
//		}
//	}
//
//	/* (non-Javadoc)
//	 * @see org.iso.mpeg.mxm.engine.basePE.ProtocolBase#getKeyValueData()
//	 */
//	@Override
//	public List<KeyValueData> getKeyValueData() 
//	{
//		List<KeyValueData> keyValueDatas = new ArrayList<KeyValueData>();
//		List<KeyValueDataType> keyValueDataTypes = identifyContentRequestType.getEntry();
//		
//		if (keyValueDataTypes != null)
//		{
//			for (KeyValueDataType keyValueDataType : keyValueDataTypes)
//			{
//				try {
//					keyValueDatas.add(new KeyValyueData(keyValueDataType));
//				} catch (MXMEngineException e) {
//					e.printStackTrace();
//				}
//			}
//		}
//		
//		return null;
//	}
//
//	/* (non-Javadoc)
//	 * @see org.iso.mpeg.mxm.engine.basePE.ProtocolBase#addApplicationSpecificData(org.iso.mpeg.mxm.engine.basePE.ApplicationSpecificData)
//	 */
//	@Override
//	public void addApplicationSpecificData(
//			ApplicationSpecificData applicationSpecificData) 
//	{
//		try {
//			identifyContentRequestType.getApplicationSpecificData().add(
//					(ApplicationSpecificDataType)(applicationSpecificData.createObject(ApplicationSpecificDataType.class.getName())).getContent());
//		} catch (MXMException e) {
//			e.printStackTrace();
//		}
//	}
//
//	/* (non-Javadoc)
//	 * @see org.iso.mpeg.mxm.engine.basePE.ProtocolBase#getApplicationSpecificData()
//	 */
//	@Override
//	public ApplicationSpecificData getApplicationSpecificData() 
//	{
//		List<ApplicationSpecificData> applicationSpecificDatas = new ArrayList<ApplicationSpecificData>();
//		List<ApplicationSpecificDataType> applicationSpecificDataTypes = identifyContentRequestType.getApplicationSpecificData();
//		
//		if (applicationSpecificDataTypes != null)
//		{
//			for (ApplicationSpecificDataType applicationSpecificDataType : applicationSpecificDataTypes)
//			{
//				try {
//					applicationSpecificDatas.add(
//							new org.iso.mpeg.mxm.basePE.ApplicationSpecificData(applicationSpecificDataType));
//				} catch (MXMEngineException e) {
//					e.printStackTrace();
//				}
//			}
//		}
//		
//		return null;
//	}
//
//	/* (non-Javadoc)
//	 * @see org.iso.mpeg.mxm.engine.basePE.ProtocolBase#setSignature(org.iso.mpeg.mxm.engine.securityTE.data.Signature)
//	 */
//	@Override
//	public void setSignature(Signature signature) 
//	{
//		try {
//			identifyContentRequestType.setSignature((SignatureType)(signature.createObject(SignatureType.class.getName())).getContent());
//		} catch (MXMException e) {
//			e.printStackTrace();
//		}
//	}
//
//	/* (non-Javadoc)
//	 * @see org.iso.mpeg.mxm.engine.basePE.ProtocolBase#getSignature()
//	 */
//	@Override
//	public Signature getSignature() 
//	{
//		try {
//			return new org.iso.mpeg.mxm.engine.securityTE.schema.Signature(identifyContentRequestType.getSignature());
//		} catch (MXMEngineException e) {
//			e.printStackTrace();
//		}
//		return null;
//	}
//
//	/* (non-Javadoc)
//	 * @see org.iso.mpeg.mxm.engine.identifyuserPE.IdentifyUserRequest#setContentEntity(org.iso.mpeg.mxm.engine.basePE.ContentEntity)
//	 */
//	@Override
//	public void setContentEntity(ContentEntity contentEntity) 
//	{
//		try {
//			identifyContentRequestType.setContentEntity(
//					(ContentEntityType)(contentEntity.createObject(ContentEntityType.class.getName())).getContent());
//		} catch (MXMException e) {
//			e.printStackTrace();
//		}
//	}
//
//	/* (non-Javadoc)
//	 * @see org.iso.mpeg.mxm.engine.identifyuserPE.IdentifyUserRequest#getContentEntity()
//	 */
//	@Override
//	public ContentEntity getContentEntity() 
//	{
//		try {
//			return new org.iso.mpeg.mxm.basePE.ContentEntity(identifyContentRequestType.getContentEntity());
//		} catch (MXMEngineException e) {
//			e.printStackTrace();
//		}
//		return null;
//	}

	@Override
	public void createFile(File f) throws MXMException {
		SuperProtocolEngineAbstractLevel1 level1 = new SuperProtocolEngineAbstractLevel1((IdentifyContentRequestType)protocolBaseType);
		level1.createFile(f);
		
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		SuperProtocolEngineAbstractLevel1 level1 = new SuperProtocolEngineAbstractLevel1((IdentifyContentRequestType)protocolBaseType);
		return level1.createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperProtocolEngineAbstractLevel1 level1 = new SuperProtocolEngineAbstractLevel1((IdentifyContentRequestType)protocolBaseType);
		MXMEngineResponse response = level1.parse(object);
		if (response.equals(MXMEngineResponse.SUCCESS))
		{
			protocolBaseType = (IdentifyContentRequestType)
					(level1.createObject(IdentifyContentRequestType.class.getName()).getContent());			
		}
		return response;
	}

	@Override
	public ContentEntity getContentEntity() throws MXMEngineException {
		ContentEntityType contentEntityType = ((IdentifyContentRequestType)protocolBaseType).getIdentificationContent();
		ContentEntity contentEntity = baseProtocolEngine.getBaseProtocolSchemaHandler().getContentEntity();
		contentEntity.parse(new MXMAdapter(contentEntityType));
		return contentEntity;
	}

	@Override
	public void setContentEntity(ContentEntity contentEntity) throws MXMException {
		ContentEntityType contentEntityType = (ContentEntityType)
				(contentEntity.createObject(ContentEntityType.class.getName()).getContent());
		((IdentifyContentRequestType)protocolBaseType).setIdentificationContent(contentEntityType);	
	}

}
