/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the MPEG Multimedia Extensible Middleware (MXM) Project 
 *
 * The Initial Developer of the Original Code is CEDEO.net  
 * Portions created by the Initial Developer are Copyright (C) 2009
 * All Rights Reserved.
 *
 * The Initial Developer: Angelo Difino  
 * Contributor(s): 
 *
 * ***** END LICENSE BLOCK ***** */

package org.iso.mpeg.mxm.identifycontentPE.technology.local;

import java.net.URL;

import javax.xml.namespace.QName;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.orchestratorEngine.OrchestratorEngine;
import org.iso.mpeg.mxm.pEngine.identifycontentPE.exceptions.IdentifyContentEngineException;
import org.iso.mpeg.mxm.pEngine.identifycontentPE.schemahandler.IdentifyContentRequest;
import org.iso.mpeg.mxm.pEngine.identifycontentPE.schemahandler.IdentifyContentResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author Angelo Difino
 *
 */
public class IdentifyContentProtocol  implements org.iso.mpeg.mxm.pEngine.identifycontentPE.technologyhandler.IdentifyContentProtocol
{
	Logger logger = LoggerFactory.getLogger(this.getClass());

	private OrchestratorEngine orchestratorEngine;

	public IdentifyContentProtocol(OrchestratorEngine orchestratorEngine)
	{
		this.orchestratorEngine=orchestratorEngine;
	}

	@Override
	public MXMEngineResponse initServiceParams(URL serviceURL, QName serviceName) {
		return MXMEngineResponse.METHOD_NOT_IMPLEMENTED;
	}

	@Override
	public IdentifyContentResponse identifyContent(
			IdentifyContentRequest request) throws IdentifyContentEngineException {
		return orchestratorEngine.getIdentifyContentEngineOrchestrator().identifyContent(request);
	}
}
