/** ***** BEGIN LICENSE BLOCK *****
 * 
 * The copyright in this software is being made available under the BSD License, 
 * included below. This software may be subject to other third party and contributor 
 * rights, including patent rights, and no such rights are granted under this license.
 *
 * Copyright (c) 2012, ICBNet Lab, ICCS
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 *
 *    - Redistributions of source code must retain the above copyright notice, 
 *    	this list of conditions and the following disclaimer.
 *    - Redistributions in binary form must reproduce the above copyright notice, 
 *    	this list of conditions and the following disclaimer in the documentation 
 *    	and/or other materials provided with the distribution.
 *    - Neither the name of the ICBNet Lab, ICCS nor the names of its contributors 
 *    	may be used to endorse or promote products derived from this software 
 *    	without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, 
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
***** END LICENSE BLOCK ***** */

package org.iso.mpeg.mxm.identifydevicePE.schemahandler;

import org.iso.mpeg.mxm.pEngine.basePE.BaseProtocolEngine;
import org.iso.mpeg.mxm.pEngine.identifydevicePE.schemahandler.IdentifyDeviceRequest;
import org.iso.mpeg.mxm.pEngine.identifydevicePE.schemahandler.IdentifyDeviceResponse;
import org.iso.mpeg.mxm.pEngine.identifydevicePE.schemahandler.IdentifyDeviceSuccess;
import org.iso.mpeg.mxm.tEngine.ipmpTE.IPMPEngine;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;

/**
 * @author Angelos-Christos Anadiotis
 *
 */
public class IdentifyDeviceSchemaHandler extends org.iso.mpeg.mxm.pEngine.identifydevicePE.schemahandler.IdentifyDeviceSchemaHandler
{
	private SecurityEngine securityEngine;
	private IPMPEngine ipmpEngine;
	private BaseProtocolEngine baseProtocolEngine;
	
	public IdentifyDeviceSchemaHandler(BaseProtocolEngine baseProtocolEngine, IPMPEngine ipmpEngine, SecurityEngine securityEngine)
	{
		this.baseProtocolEngine = baseProtocolEngine;
		this.ipmpEngine = ipmpEngine;
		this.securityEngine = securityEngine;
	}

	/* (non-Javadoc)
	 * @see org.iso.mpeg.mxm.pEngine.identifydevicePE.schemahandler.IdentifyDeviceSchemaHandler#getIdentifyDeviceRequest()
	 */
	@Override
	public IdentifyDeviceRequest getIdentifyDeviceRequest()
	{
		return new org.iso.mpeg.mxm.identifydevicePE.schemahandler.IdentifyDeviceRequest(securityEngine, ipmpEngine);
	}

	/* (non-Javadoc)
	 * @see org.iso.mpeg.mxm.pEngine.identifydevicePE.schemahandler.IdentifyDeviceSchemaHandler#getIdentifyDeviceResponse()
	 */
	@Override
	public IdentifyDeviceResponse getIdentifyDeviceResponse()
	{
		return new org.iso.mpeg.mxm.identifydevicePE.schemahandler.IdentifyDeviceResponse(baseProtocolEngine, securityEngine);
	}

	/* (non-Javadoc)
	 * @see org.iso.mpeg.mxm.pEngine.identifydevicePE.schemahandler.IdentifyDeviceSchemaHandler#getIdentifyDeviceSuccess()
	 */
	@Override
	public IdentifyDeviceSuccess getIdentifyDeviceSuccess()
	{
		return new org.iso.mpeg.mxm.identifydevicePE.schemahandler.IdentifyDeviceSuccess(securityEngine);
	}

}
