package org.iso.mpeg.mxm.ipmpTE;

import java.util.List;

import org.iso.mpeg.mxm.core.MXMEngine;
import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.tEngine.ipmpTE.schemahandler.ipmpinfo.IPMPGeneralInfoDescriptor;
import org.iso.mpeg.mxm.tEngine.ipmpTE.schemahandler.ipmpinfo.IPMPInfoDescriptor;
import org.iso.mpeg.mxm.tEngine.ipmpTE.schemahandler.ipmpinfo.License;
import org.iso.mpeg.mxm.tEngine.ipmpTE.schemahandler.mpegmipmpinfo.RightsDescriptor;
import org.iso.mpeg.mxm.tEngine.relTE.RELEngine;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;

public class IPMPEngineSchemaHandler implements org.iso.mpeg.mxm.tEngine.ipmpTE.IPMPEngineSchemaHandler{

	RELEngine RELengine;
	
	IPMPEngineSchemaHandler(List<MXMEngine> engines) throws MXMEngineException
	{
		for (MXMEngine engine: engines)
		{
			if (engine.getEngineName().equals(MXMEngineName.RELTE.toString()))
			{
				RELengine=(RELEngine)engine;
			}
//			else {
//				throw new MXMEngineException("there is a dependencies here not recognized! it is the >"+engine.getEngineName());
//			}
		}
//		if (RELengine==null /*|| SECengine==null*/)
//			throw new MXMEngineException("dependencies not setted correctly");
	}
	
	@Override
	public IPMPGeneralInfoDescriptor getIPMPGeneralInfoDescriptor() throws MXMEngineException {
		return new org.iso.mpeg.mxm.ipmpTE.schemahandler.IPMPGeneralInfoDescriptor(RELengine/*, SECengine*/);
	}
	
	@Override
	public org.iso.mpeg.mxm.tEngine.ipmpTE.schemahandler.ipmpinfo.LicenseCollection getLicenseCollection() throws MXMEngineException {
		return new org.iso.mpeg.mxm.ipmpTE.schemahandler.LicenseCollection(RELengine/*, SECengine*/);
	}

	@Override
	public IPMPInfoDescriptor getIPMPInfoDescriptor() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public RightsDescriptor getRightsDescriptor() throws MXMEngineException {
		return new org.iso.mpeg.mxm.ipmpTE.schemahandler.RightsDescriptor(RELengine/*, SECengine*/);
	}

	@Override
	public License getIPMPLicense() throws MXMEngineException {
		return new org.iso.mpeg.mxm.ipmpTE.schemahandler.License(RELengine/*, SECengine*/);

	}
}
