package org.iso.mpeg.mxm.ipmpTE.schemahandler;

import java.io.File;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.ipmpTE.schema.ipmpinfo.IPMPGeneralInfoDescriptorType;
import org.iso.mpeg.mxm.engine.ipmpTE.schema.ipmpinfo.LicenseCollectionType;
import org.iso.mpeg.mxm.engine.ipmpTE.schema.ipmpinfo.SuperIpmpinfoAbstractLevel1;
import org.iso.mpeg.mxm.tEngine.ipmpTE.schemahandler.ipmpinfo.LicenseCollection;
import org.iso.mpeg.mxm.tEngine.ipmpTE.schemahandler.ipmpinfo.ToolList;
import org.iso.mpeg.mxm.tEngine.relTE.RELEngine;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Signature;

public class IPMPGeneralInfoDescriptor implements org.iso.mpeg.mxm.tEngine.ipmpTE.schemahandler.ipmpinfo.IPMPGeneralInfoDescriptor {

	IPMPGeneralInfoDescriptorType ipmpgentype;

	RELEngine RELengine;
	//SecurityEngine SECengine; 
	
	public IPMPGeneralInfoDescriptor(RELEngine RELengine/*, SecurityEngine SECengine*/) throws MXMEngineException{
		this.RELengine = RELengine;
		//this.SECengine = SECengine;

		ipmpgentype=new IPMPGeneralInfoDescriptorType();
	}
	
	@Override
	public void createFile(File f) throws MXMException {
		(new SuperIpmpinfoAbstractLevel1(ipmpgentype)).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		return (new SuperIpmpinfoAbstractLevel1(ipmpgentype)).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperIpmpinfoAbstractLevel1 level1=new SuperIpmpinfoAbstractLevel1(ipmpgentype);
		MXMEngineResponse response = level1.parse(object);
		if (response.equals(MXMEngineResponse.SUCCESS))
		{
			this.ipmpgentype=(IPMPGeneralInfoDescriptorType)(level1.createObject(IPMPGeneralInfoDescriptorType.class.getCanonicalName())).getContent();
		}
		return response;
	}

	@Override
	public void setSignature(Signature signature) {
		// TODO Auto-generated method stub
	}

	@Override
	public ToolList getToolList() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setToolList(ToolList toolList) {
		// TODO Auto-generated method stub
	}

	@Override
	public LicenseCollection getLicenseCollection() throws MXMEngineException {
		LicenseCollection lc=new org.iso.mpeg.mxm.ipmpTE.schemahandler.LicenseCollection(RELengine/*, SECengine*/);//ipmpengine.getIPMPEngineSchemaHandler().getLicenseCollection();
		lc.parse(new MXMAdapter(ipmpgentype.getLicenseCollection()));
		return lc;
	}

	@Override
	public void setLicenseCollection(LicenseCollection licenseCollection) throws MXMException {
		ipmpgentype.setLicenseCollection((LicenseCollectionType)(licenseCollection.createObject(LicenseCollectionType.class.getCanonicalName()).getContent()));
	}

	@Override
	public Signature getSignature() {
		// TODO Auto-generated method stub
		return null;
	}

//	//shorcut---------------------------------------------
//	
//	@Override
//	public List<License> getLicense() throws MXMEngineException {
//		return null;
//		//TODO add this shortcut?
//	}
//
//	@Override
//	public void setLicense(License l) throws MXMException {		
//	}
}
