package org.iso.mpeg.mxm.ipmpTE.schemahandler;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBElement;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.ipmpTE.schema.ipmpinfo.LicenseType;
import org.iso.mpeg.mxm.engine.ipmpTE.schema.ipmpinfo.SuperIpmpinfoAbstractLevel1;
import org.iso.mpeg.mxm.tEngine.relTE.RELEngine;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;

public class License implements org.iso.mpeg.mxm.tEngine.ipmpTE.schemahandler.ipmpinfo.License {

	LicenseType ltype;

	RELEngine RELengine;
	//SecurityEngine SECengine; 
	
	public License(RELEngine RELengine/*, SecurityEngine SECengine*/) throws MXMEngineException{
		this.RELengine = RELengine;
		//this.SECengine = SECengine;

		ltype=new LicenseType();
	}
	
	@Override
	public void createFile(File f) throws MXMException {
		(new SuperIpmpinfoAbstractLevel1(ltype)).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		return (new SuperIpmpinfoAbstractLevel1(ltype)).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperIpmpinfoAbstractLevel1 level1=new SuperIpmpinfoAbstractLevel1(ltype);
		MXMEngineResponse response = level1.parse(object);
		if (response.equals(MXMEngineResponse.SUCCESS))
		{
			this.ltype=(LicenseType)(level1.createObject(LicenseType.class.getCanonicalName())).getContent();
		}
		return response;
	}

	@Override
	public List<org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.License> getLicense() throws MXMEngineException {
		List<org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.License> toreturn=new ArrayList();
		for (Object o : ltype.getContent()){
    		if (o instanceof JAXBElement && ((JAXBElement)o).getValue() instanceof  org.iso.mpeg.mxm.engine.relTE.schema.relr.License){
    			org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.License l=RELengine.getRELEngineSchemaHandler().getLicense();
    			l.parse(new MXMAdapter((org.iso.mpeg.mxm.engine.relTE.schema.relr.License)((JAXBElement)o).getValue()));
    			toreturn.add(l);
    		}			
			else if (o instanceof org.iso.mpeg.mxm.engine.relTE.schema.relr.License)
			{
				org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.License l=RELengine.getRELEngineSchemaHandler().getLicense();
				l.parse(new MXMAdapter((org.iso.mpeg.mxm.engine.relTE.schema.relr.License)o));
				toreturn.add(l);
			}
			
		}
    	return toreturn;
	}

	@Override
	public void addLicense(org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.License l) throws MXMException {
		this.ltype.getContent().add((org.iso.mpeg.mxm.engine.relTE.schema.relr.License)l.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relr.License.class.getCanonicalName()).getContent());
	}
}
