package org.iso.mpeg.mxm.ipmpTE.schemahandler;

import java.io.File;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBElement;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.ipmpTE.schema.ipmpinfo.LicenseCollectionType;
import org.iso.mpeg.mxm.engine.ipmpTE.schema.ipmpinfo.SuperIpmpinfoAbstractLevel1;
import org.iso.mpeg.mxm.tEngine.ipmpTE.schemahandler.ipmpinfo.RightsDescriptor;
import org.iso.mpeg.mxm.tEngine.relTE.RELEngine;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;

public class LicenseCollection implements org.iso.mpeg.mxm.tEngine.ipmpTE.schemahandler.ipmpinfo.LicenseCollection {

	LicenseCollectionType lctype;

	RELEngine RELengine;
	//SecurityEngine SECengine; 

	public LicenseCollection(RELEngine RELengine/*, SecurityEngine SECengine*/) throws MXMEngineException{
		this.RELengine = RELengine;
		//this.SECengine = SECengine;

		lctype=new LicenseCollectionType();
	}
	
	@Override
	public void createFile(File f) throws MXMException {
		(new SuperIpmpinfoAbstractLevel1(lctype)).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		return (new SuperIpmpinfoAbstractLevel1(lctype)).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperIpmpinfoAbstractLevel1 level1=new SuperIpmpinfoAbstractLevel1(lctype);
		MXMEngineResponse response = level1.parse(object);
		if (response.equals(MXMEngineResponse.SUCCESS))
		{
			this.lctype=(LicenseCollectionType)(level1.createObject(LicenseCollectionType.class.getCanonicalName())).getContent();
		}
		return response;
	}

	@Override
	public List<Serializable> getContent() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public List<RightsDescriptor> getRightsDescriptor() throws MXMEngineException {
		List<RightsDescriptor> toreturn=new ArrayList();
		for (Serializable s: this.lctype.getContent()){
			if (s instanceof JAXBElement)
				if ((((JAXBElement)s).getName().getLocalPart()=="RightsDescriptor") && (((JAXBElement)s).getName().getNamespaceURI()=="urn:mpeg:mpeg21:2004:01-IPMPINFO-NS")){
					RightsDescriptor r=new org.iso.mpeg.mxm.ipmpTE.schemahandler.RightsDescriptor(RELengine/*, SECengine*/);
					r.parse(new MXMAdapter(((JAXBElement)s).getValue()));
					toreturn.add(r);
				}
		}
		return toreturn;
	}

	@Override
	public void setRightsDescriptor(RightsDescriptor rd) throws MXMException {
		this.lctype.getContent().add((Serializable)rd.createObject(JAXBElement.class.getCanonicalName()).getContent());
	}
}
