package org.iso.mpeg.mxm.ipmpTE.schemahandler;

import java.io.File;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.ipmpTE.schema.ipmpinfo.LicenseType;
import org.iso.mpeg.mxm.engine.ipmpTE.schema.ipmpinfo.RightsDescriptorType;
import org.iso.mpeg.mxm.engine.ipmpTE.schema.ipmpinfo.SuperIpmpinfoAbstractLevel1;
import org.iso.mpeg.mxm.tEngine.ipmpTE.schemahandler.ipmpinfo.IPMPInfoDescriptor;
import org.iso.mpeg.mxm.tEngine.ipmpTE.schemahandler.ipmpinfo.License;
import org.iso.mpeg.mxm.tEngine.ipmpTE.schemahandler.ipmpinfo.LicenseReference;
import org.iso.mpeg.mxm.tEngine.ipmpTE.schemahandler.ipmpinfo.LicenseService;
import org.iso.mpeg.mxm.tEngine.relTE.RELEngine;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;

public class RightsDescriptor implements org.iso.mpeg.mxm.tEngine.ipmpTE.schemahandler.mpegmipmpinfo.RightsDescriptor {

	RightsDescriptorType rdtype;

	RELEngine RELengine;
	//SecurityEngine SECengine; 
	
	public RightsDescriptor(RELEngine RELengine/*, SecurityEngine SECengine*/) throws MXMEngineException{
		this.RELengine = RELengine;
		//this.SECengine = SECengine;

		rdtype=new RightsDescriptorType();
	}
	
	@Override
	public void createFile(File f) throws MXMException {
		(new SuperIpmpinfoAbstractLevel1(rdtype)).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		return (new SuperIpmpinfoAbstractLevel1(rdtype)).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperIpmpinfoAbstractLevel1 level1=new SuperIpmpinfoAbstractLevel1(rdtype);
		MXMEngineResponse response = level1.parse(object);
		if (response.equals(MXMEngineResponse.SUCCESS))
		{
			this.rdtype=(RightsDescriptorType)(level1.createObject(RightsDescriptorType.class.getCanonicalName())).getContent();
		}
		return response;
	}

	/**
	 * return null if there are no license
	 */
	@Override
	public License getLicense() throws MXMEngineException {
		License l = new org.iso.mpeg.mxm.ipmpTE.schemahandler.License(RELengine/*, SECengine*/);
		if (this.rdtype.getLicense()==null)
			return null;
		l.parse(new MXMAdapter(this.rdtype.getLicense()));
		return l;
	}

	@Override
	public void setLicense(License license) throws MXMException {
		this.rdtype.setLicense((LicenseType)license.createObject(LicenseType.class.getCanonicalName()).getContent());
	}

	@Override
	public IPMPInfoDescriptor getIPMPInfoDescriptor() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setIPMPInfoDescriptor(IPMPInfoDescriptor iPMPInfoDescriptor) {
		// TODO Auto-generated method stub
	}

	@Override
	public LicenseReference getLicenseReference() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setLicenseReference(LicenseReference licenseReference) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public LicenseService getLicenseService() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setLicenseService(LicenseService licenseService) {
		// TODO Auto-generated method stub
		
	}
}
