/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the Chillout Project (http://chillout.dmpf.org)
 *
 * The Initial Developer of the Original Code is CEDEO.net
 * Portions created by the Initial Developer are Copyright (C) 2006-2008
 * All Rights Reserved.
 *
 * The Initial Developer: Filippo Chiariglione 
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */
package org.iso.mpeg.mxm.metadataTE;

import java.util.List;

import org.iso.mpeg.mxm.core.MXMAbstractEngine;
import org.iso.mpeg.mxm.core.MXMEngine;
import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.tEngine.metadataTE.MetadataEngineSchemaHandler;
import org.iso.mpeg.mxm.tEngine.metadataTE.MetadataEngineTechnologyHandler;

public class MetadataTE extends MXMAbstractEngine implements org.iso.mpeg.mxm.tEngine.metadataTE.MetadataEngine
{
	private MetadataEngineSchemaHandler metadataEngineSchemaHandler;
	private MetadataEngineTechnologyHandler metadataEngineTechnologyHandler;
	
	public MetadataTE()
	{
		metadataEngineSchemaHandler = new MetadataSchemaHandler();
		metadataEngineTechnologyHandler = new MetadataTechnologyHandler();
	}
	
	public MetadataEngineSchemaHandler getMetadataEngineSchemaHandler() throws MXMEngineException 
	{
		return metadataEngineSchemaHandler;
	}
	
	public MetadataEngineTechnologyHandler getMetadataEngineTechnologyHandler()
			throws MXMEngineException
	{
		return metadataEngineTechnologyHandler;
	}

	public String getEngineName() 
	{
		return MXMEngineName.MetadataTE.toString();
	}

	public void setDependencies(List<MXMEngine> engines) throws MXMEngineException 
	{
		
	}
}
