package org.iso.mpeg.mxm.metadataTE.schemahandler.fru;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.metadataTE.schema.fru.QueryType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.fru.SuperFruAbstractLevel1;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.fru.Query;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.fru.Src;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.fru.XmlPull;

public class FRU implements org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.fru.FRU
{
	protected org.iso.mpeg.mxm.engine.metadataTE.schema.fru.FRU fruType;
	
	public FRU()
	{
		fruType = new org.iso.mpeg.mxm.engine.metadataTE.schema.fru.FRU();
	}
	
	public FRU(org.iso.mpeg.mxm.engine.metadataTE.schema.fru.FRU fru)
	{
		this.fruType = fru;
	}
	
	@Override
	public Src getSrc()
	{
		if (fruType.getSrc()!=null)
		{
			return new org.iso.mpeg.mxm.metadataTE.schemahandler.fru.Src(fruType.getSrc());
		}
			
		return null;
	}

	@Override
	public void setSrc(Src src)
	{
		try
		{
			fruType.setSrc((org.iso.mpeg.mxm.engine.metadataTE.schema.fru.SrcType) 
					src.createObject(org.iso.mpeg.mxm.engine.metadataTE.schema.fru.SrcType.class.getCanonicalName()).getContent());
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}

	@Override
	public List<XmlPull> getXMLPull()
	{
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public List<Query> getQuery()
	{
		List<Query> queries = new ArrayList<Query>();
		
		for (QueryType query : fruType.getQuery())
		{
			queries.add(new org.iso.mpeg.mxm.metadataTE.schemahandler.fru.Query(query));
		}
		
		return queries;
	}
	
	// MXM CREATOR AND PARSER METHODS
	
	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperFruAbstractLevel1(fruType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperFruAbstractLevel1(fruType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperFruAbstractLevel1 superAbstract = new SuperFruAbstractLevel1(fruType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		fruType = (org.iso.mpeg.mxm.engine.metadataTE.schema.fru.FRU) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.metadataTE.schema.fru.FRU.class.getCanonicalName()).getContent();

		return repsonse;
	}

}
