package org.iso.mpeg.mxm.metadataTE.schemahandler.fru;

import java.io.File;
import java.math.BigInteger;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.metadataTE.schema.fru.QueryType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.fru.SuperFruAbstractLevel1;

public class Query implements org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.fru.Query
{
	protected QueryType queryType;
	
	public Query()
	{
		queryType = new QueryType();
	}
	
	public Query(QueryType query)
	{
		this.queryType = query;
	}

	@Override
	public boolean isNavMode()
	{
		return queryType.isNavMode();
	}

	@Override
	public void setNavMode(Boolean b)
	{
		queryType.setNavMode(b);
	}

	@Override
	public BigInteger getLevelDepth()
	{
		return queryType.getLevelDepth();
	}

	@Override
	public void setLevelDepth(BigInteger bigInteger)
	{
		queryType.setLevelDepth(bigInteger);
	}

	@Override
	public String getValue()
	{
		return queryType.getValue();
	}

	@Override
	public void setValue(String string)
	{
		queryType.setValue(string);
	}
	
	// MXM CREATOR AND PARSER METHODS
	
	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperFruAbstractLevel1(queryType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperFruAbstractLevel1(queryType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperFruAbstractLevel1 superAbstract = new SuperFruAbstractLevel1(queryType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		queryType = (org.iso.mpeg.mxm.engine.metadataTE.schema.fru.QueryType) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.metadataTE.schema.fru.QueryType.class.getCanonicalName()).getContent();

		return repsonse;
	}
	
}
