package org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.AccessUnitType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.FragmentUpdateUnitType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.SuperMpe7v3AbstractLevel1;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.FragmentUpdateUnit;

public class AccessUnit implements org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.AccessUnit
{
	protected AccessUnitType accessUnitType;
	
	public AccessUnit()
	{
		accessUnitType = new AccessUnitType();
	}
	
	public AccessUnit(AccessUnitType accessUnit)
	{
		this.accessUnitType = accessUnit;
	}

	@Override
	public List<FragmentUpdateUnit> getFragmentUpdateUnitList()
	{
		List<FragmentUpdateUnit> fuul = new ArrayList<FragmentUpdateUnit>();

		for (FragmentUpdateUnitType fuu : accessUnitType.getFragmentUpdateUnit())
		{
			fuul.add(new org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3.FragmentUpdateUnit(fuu));
		}
		
		return fuul;
	}

	@Override
	public void addFragmentUpdateUnit(FragmentUpdateUnit fragmentUpdateUnit)
	{
		try
		{
			accessUnitType.getFragmentUpdateUnit().add((FragmentUpdateUnitType) 
					fragmentUpdateUnit.createObject(FragmentUpdateUnitType.class.getCanonicalName()).getContent());
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}
	
	// MXM CREATOR AND PARSER METHODS
	
	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperMpe7v3AbstractLevel1(accessUnitType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperMpe7v3AbstractLevel1(accessUnitType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperMpe7v3AbstractLevel1 superAbstract = new SuperMpe7v3AbstractLevel1(accessUnitType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		accessUnitType = (AccessUnitType) 
				superAbstract.createObject(AccessUnitType.class.getCanonicalName()).getContent();

		return repsonse;
	}
}
