package org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3;

import java.io.File;
import java.util.List;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.ContentEntityType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.SuperMpe7v3AbstractLevel1;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.MultimediaContent;

public class ContentEntity extends ContentDescription implements org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.ContentEntity
{
	private ContentEntityType contentEntityType;
	
	public ContentEntity()
	{
		this(new ContentEntityType());
	}
	
	public ContentEntity(ContentEntityType contentEntity)
	{
		super(contentEntity);
		this.contentEntityType = contentEntity;
	}
	
	@Override
	public List<MultimediaContent> getMultimediaContent()
	{
		// TODO Auto-generated method stub
		return null;
	}

	// MXM CREATOR AND PARSER METHODS
	
	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperMpe7v3AbstractLevel1(contentEntityType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperMpe7v3AbstractLevel1(contentEntityType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperMpe7v3AbstractLevel1 superAbstract = new SuperMpe7v3AbstractLevel1(contentEntityType);
		
		MXMEngineResponse repsonse = superAbstract.parse(object);
		
		contentEntityType = (ContentEntityType) superAbstract.createObject(ContentEntityType.class.getCanonicalName()).getContent();
		
		return repsonse;
	}

}
