package org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.CompleteDescriptionType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.ContentEntityType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.CreationDescriptionType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.CreationInformationType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.CreationType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.SuperMpe7v3AbstractLevel1;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.TitleType;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.Classification;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.CreationCreationCoordinates;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.CreationInformation;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.CreationTool;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.Creator;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.DescriptionMetadata;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.Graph;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.Header;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.OrderingKey;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.RelatedMaterial;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.TextAnnotation;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.Textual;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.Title;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.TitleMedia;

public class CreationDescription implements org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.CreationDescription
{
	private CreationDescriptionType creationDescriptionType;
	
	public CreationDescription()
	{
		this(new CreationDescriptionType());
	}
	
	public CreationDescription(CreationDescriptionType creationDescriptionType)
	{
		this.creationDescriptionType = creationDescriptionType;
	}

	@Override
	public List<Graph> getRelationships() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public DescriptionMetadata getDescriptionMetadata() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setDescriptionMetadata(DescriptionMetadata descriptionMetadata) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public List<OrderingKey> getOrderingKey() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void createFile(File f) throws MXMException {
		new SuperMpe7v3AbstractLevel1(creationDescriptionType).createFile(f);
		
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		return new SuperMpe7v3AbstractLevel1(creationDescriptionType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperMpe7v3AbstractLevel1 superAbstract = new SuperMpe7v3AbstractLevel1(creationDescriptionType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		creationDescriptionType = (CreationDescriptionType) superAbstract.createObject(CreationDescriptionType.class.getCanonicalName()).getContent();

		return repsonse;
	}

	@Override
	public List<CreationInformation> getCreationInformation() {
		List<CreationInformation> ciList = new ArrayList<CreationInformation>();
		
		for (CreationInformationType creationInformation: creationDescriptionType.getCreationInformation())
		{
			if (creationInformation instanceof org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.CreationInformationType)
			{
				ciList.add(new org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3.CreationInformation((CreationInformationType) creationInformation));
			}
		}
		return ciList;
	}

	@Override
	public void addCreationInformation(CreationInformation creationInformation) throws MXMException {
		creationDescriptionType.getCreationInformation().add((CreationInformationType)creationInformation.createObject(CreationInformationType.class.getCanonicalName()).getContent());

		
	}

	
}
