package org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3;

import java.io.File;
import java.util.List;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.DSType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.SuperMpe7v3AbstractLevel1;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.Header;

public abstract class DS implements org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.DS
{
	protected DSType dsType;
	
	public DS(DSType dsType)
	{
		this.dsType = dsType;
	}
	
	@Override
	public List<Header> getHeader()
	{
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setId(String string)
	{
		dsType.setId(string);
	}

	@Override
	public String getTimeBase()
	{
		return dsType.getTimeBase();
	}

	@Override
	public void setTimeBase(String string)
	{
		dsType.setTimeBase(string);
	}

	@Override
	public String getTimeUnit()
	{
		return dsType.getTimeUnit();
	}

	@Override
	public void setTimeUnit(String string)
	{
		dsType.setTimeUnit(string);
	}

	@Override
	public String getMediaTimeBase()
	{
		return dsType.getMediaTimeBase();
	}

	@Override
	public void setMediaTimeBase(String string)
	{
		dsType.setMediaTimeBase(string);
	}

	@Override
	public String getMediaTimeUnit()
	{
		return dsType.getMediaTimeUnit();
	}

	@Override
	public void setMediaTimeUnit(String string)
	{
		dsType.setMediaTimeUnit(string);
	}

	@Override
	public String getId()
	{
		return dsType.getId();
	}
	
	// MXM CREATOR AND PARSER METHODS
	
	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperMpe7v3AbstractLevel1(dsType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperMpe7v3AbstractLevel1(dsType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperMpe7v3AbstractLevel1 superAbstract = new SuperMpe7v3AbstractLevel1(dsType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		dsType = (org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.DSType) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.DSType.class.getCanonicalName()).getContent();

		return repsonse;
	}

}
