package org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3;

import java.io.File;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.FragmentUpdateContextType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.FragmentUpdatePayloadType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.FragmentUpdateUnitType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.SuperMpe7v3AbstractLevel1;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.FragmentUpdateContext;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.FragmentUpdatePayload;

public class FragmentUpdateUnit implements org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.FragmentUpdateUnit
{
	protected FragmentUpdateUnitType fragmentUpdateUnitType;
	
	public FragmentUpdateUnit()
	{
		fragmentUpdateUnitType = new FragmentUpdateUnitType();
	}
	
	public FragmentUpdateUnit(FragmentUpdateUnitType fragmentUpdateUnit)
	{
		this.fragmentUpdateUnitType = fragmentUpdateUnit;
	}

	@Override
	public String getFUCommand()
	{
		return fragmentUpdateUnitType.getFUCommand();
	}

	@Override
	public void setFUCommand(String string)
	{
		fragmentUpdateUnitType.setFUCommand(string);
	}

	@Override
	public FragmentUpdateContext getFUContext()
	{
		if (fragmentUpdateUnitType.getFUContext()!=null)
		{
			return new org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3.FragmentUpdateContext(fragmentUpdateUnitType.getFUContext());
		}
		
		return null;
	}

	@Override
	public void setFUContext(FragmentUpdateContext fragmentUpdateContext)
	{
		try
		{
			fragmentUpdateUnitType.setFUContext((FragmentUpdateContextType)
					fragmentUpdateContext.createObject(FragmentUpdateContextType.class.getCanonicalName()).getContent());
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}

	@Override
	public FragmentUpdatePayload getFUPayload()
	{
		if (fragmentUpdateUnitType.getFUPayload()!=null)
		{
			return new org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3.FragmentUpdatePayload(fragmentUpdateUnitType.getFUPayload());
		}
		
		return null;
	}

	@Override
	public void setFUPayload(FragmentUpdatePayload fragmentUpdatePayload)
	{
		try
		{
			fragmentUpdateUnitType.setFUPayload((FragmentUpdatePayloadType)
					fragmentUpdatePayload.createObject(FragmentUpdatePayloadType.class.getCanonicalName()).getContent());
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}
	
	// MXM CREATOR AND PARSER METHODS
	
	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperMpe7v3AbstractLevel1(fragmentUpdateUnitType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperMpe7v3AbstractLevel1(fragmentUpdateUnitType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperMpe7v3AbstractLevel1 superAbstract = new SuperMpe7v3AbstractLevel1(fragmentUpdateUnitType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		fragmentUpdateUnitType = (FragmentUpdateUnitType) 
				superAbstract.createObject(FragmentUpdateUnitType.class.getCanonicalName()).getContent();

		return repsonse;
	}
}
