package org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.CompleteDescriptionType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.ContentEntityType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.CreationDescriptionType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.SuperMpe7v3AbstractLevel1;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.TitleType;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.CompleteDescription;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.CreationDescription;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.DescriptionMetadata;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.DescriptionProfile;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.Mpeg7Base;

public class Mpeg7 implements org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.Mpeg7
{
	private org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.Mpeg7 mpeg7;
	
	public Mpeg7()
	{
		mpeg7 = new org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.Mpeg7();
	}
	
	public Mpeg7(org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.Mpeg7 mpeg7)
	{
		this.mpeg7 = mpeg7;
	}
	
	@Override
	public Mpeg7Base getDescriptionUnit()
	{
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setDescriptionUnit(Mpeg7Base mpeg7Base)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public List<CompleteDescription> getDescription()
	{
		List<CompleteDescription> completeDescriptionList = new ArrayList<CompleteDescription>();
		
		for (CompleteDescriptionType completeDescriptionType: mpeg7.getDescription())
		{
			if (completeDescriptionType instanceof org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.ContentEntityType)
			{
				completeDescriptionList.add(new org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3.ContentEntity((ContentEntityType) completeDescriptionType));
			}
			else if (completeDescriptionType instanceof org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.CreationDescriptionType)
			{
				completeDescriptionList.add(new org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3.CreationDescription((CreationDescriptionType) completeDescriptionType));
			}
			// TODO add more
		}
		
		return completeDescriptionList;
	}

	@Override
	public DescriptionProfile getDescriptionProfile()
	{
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setDescriptionProfile(DescriptionProfile value)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public DescriptionMetadata getDescriptionMetadata()
	{
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setDescriptionMetadata(DescriptionMetadata value)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public String getMediaTimeBase()
	{
		return mpeg7.getMediaTimeBase();
	}

	@Override
	public void setMediaTimeBase(String value)
	{
		mpeg7.setMediaTimeBase(value);
	}

	@Override
	public String getMediaTimeUnit()
	{
		return mpeg7.getMediaTimeUnit();
	}

	@Override
	public void setMediaTimeUnit(String value)
	{
		mpeg7.setMediaTimeUnit(value);
	}

	@Override
	public String getTimeBase()
	{
		return mpeg7.getTimeBase();
	}

	@Override
	public void setTimeBase(String value)
	{
		mpeg7.setTimeBase(value);
	}

	@Override
	public String getTimeUnit()
	{
		return mpeg7.getTimeUnit();
	}

	@Override
	public void setTimeUnit(String value)
	{
		mpeg7.setTimeUnit(value);
	}
	
	// MXM CREATOR AND PARSER METHODS
	
	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperMpe7v3AbstractLevel1(mpeg7).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperMpe7v3AbstractLevel1(mpeg7).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperMpe7v3AbstractLevel1 superAbstract = new SuperMpe7v3AbstractLevel1(mpeg7);
		
		MXMEngineResponse repsonse = superAbstract.parse(object);
		
		mpeg7 = (org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.Mpeg7) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.Mpeg7.class.getCanonicalName()).getContent();
		
		return repsonse;
	}

	@Override
	public void addDescription(CreationDescription cd) throws MXMException {
		mpeg7.getDescription().add((CreationDescriptionType)cd.createObject(CreationDescriptionType.class.getCanonicalName()).getContent());		
	}

}
