package org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3;

import java.io.File;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.NameComponentType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.SuperMpe7v3AbstractLevel1;

public class NameComponent extends TextualBase implements org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.NameComponent
{
	protected NameComponentType nameComponentType;
	
	public NameComponent()
	{
		this(new NameComponentType());
	}

	public NameComponent(NameComponentType nameComponent)
	{
		super(nameComponent);
		nameComponentType = nameComponent;
	}

	@Override
	public String getInitial()
	{
		return nameComponentType.getInitial();
	}

	@Override
	public void setInitial(String string)
	{
		nameComponentType.setInitial(string);
	}

	@Override
	public String getAbbrev()
	{
		return nameComponentType.getAbbrev();
	}

	@Override
	public void setAbbrev(String string)
	{
		nameComponentType.setAbbrev(string);
	}
	
	// MXM CREATOR AND PARSER METHODS
	
	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperMpe7v3AbstractLevel1(nameComponentType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperMpe7v3AbstractLevel1(nameComponentType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperMpe7v3AbstractLevel1 superAbstract = new SuperMpe7v3AbstractLevel1(nameComponentType);
		
		MXMEngineResponse repsonse = superAbstract.parse(object);
		
		nameComponentType = (NameComponentType) superAbstract.createObject(NameComponentType.class.getCanonicalName());
		
		return repsonse;
	}

}