package org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBElement;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.NameComponentType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.PersonNameType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.PersonType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.SuperMpe7v3AbstractLevel1;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.NameComponent;

public class PersonName implements org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.PersonName 
{
	protected PersonNameType personNameType;
	
	public PersonName()
	{
		this(new PersonNameType());
	}
	
	public PersonName(PersonNameType personName)
	{
		personNameType = personName;
	}
	
	@Override
	public String getDateFrom()
	{
		return personNameType.getDateFrom();
	}

	@Override
	public void setDateFrom(String string)
	{
		personNameType.setDateFrom(string);
	}

	@Override
	public String getDateTo()
	{
		return personNameType.getDateTo();
	}

	@Override
	public void setDateTo(String string)
	{
		personNameType.setDateTo(string);
	}

	@Override
	public List<NameComponent> getGivenName()
	{
	    List<NameComponent> list = new ArrayList<NameComponent>();
        for (JAXBElement element : personNameType.getGivenNameOrLinkingNameOrFamilyName())
        {
            if (element.getName().getLocalPart().equals("GivenName"))
            {
                NameComponentType type = (NameComponentType)element.getValue();
                NameComponent personName = new org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3.NameComponent(type);
                list.add(personName);
            }
        }
        return list;
	}

	@Override
	public void addGivenName(NameComponent givenName)
	{
		try
		{
			personNameType.getGivenNameOrLinkingNameOrFamilyName().add((JAXBElement<?>) givenName.createObject(JAXBElement.class.getCanonicalName()).getContent());
		}
		catch (Exception ex)
		{
			
		}
	}

	@Override
	public List<NameComponent> getLinkingName()
	{
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void addLinkingName(NameComponent linkingName)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public List<NameComponent> getFamilyName()
	{
	    List<NameComponent> list = new ArrayList<NameComponent>();
        for (JAXBElement element : personNameType.getGivenNameOrLinkingNameOrFamilyName())
        {
            if (element.getName().getLocalPart().equals("FamilyName"))
            {
                NameComponentType type = (NameComponentType)element.getValue();
                NameComponent personName = new org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3.NameComponent(type);
                list.add(personName);
            }
        }
        return list;
	}

	@Override
	public void addFamilyName(NameComponent familyName)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public String getType()
	{
		return personNameType.getType();
	}

	@Override
	public void setType(String string)
	{
		personNameType.setType(string);
	}
	
	// MXM CREATOR AND PARSER METHODS
	
	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperMpe7v3AbstractLevel1(personNameType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperMpe7v3AbstractLevel1(personNameType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperMpe7v3AbstractLevel1 superAbstract = new SuperMpe7v3AbstractLevel1(personNameType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		personNameType = (org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.PersonNameType) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.PersonNameType.class.getCanonicalName()).getContent();

		return repsonse;
	}

}
