package org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.CompleteDescriptionType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.ContentEntityType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.CreationDescriptionType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.CreationType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.SuperMpe7v3AbstractLevel1;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.TextAnnotationType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.TextualType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.TitleType;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.CompleteDescription;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.DependencyStructure;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.PhoneticAlphabet;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.StructuredAnnotation;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.Textual;

public class TextAnnotation implements org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.TextAnnotation
{
	private TextAnnotationType textAnnotationType;
	
	public TextAnnotation()
	{
		this(new TextAnnotationType());
	}
	
	public TextAnnotation(TextAnnotationType textAnnotationType)
	{
		this.textAnnotationType = textAnnotationType;
	}

	@Override
	public void createFile(File f) throws MXMException {
		new SuperMpe7v3AbstractLevel1(textAnnotationType).createFile(f);
		
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		return new SuperMpe7v3AbstractLevel1(textAnnotationType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperMpe7v3AbstractLevel1 superAbstract = new SuperMpe7v3AbstractLevel1(textAnnotationType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		textAnnotationType = (TextAnnotationType) superAbstract.createObject(TextAnnotationType.class.getCanonicalName()).getContent();

		return repsonse;
	}

	@Override
	public Float getConfidence() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setConfidence(Float value) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public List<Textual> getFreeTextAnnotation() {
		List<Textual> txtList = new ArrayList<Textual>();
		
		for (Object objType: textAnnotationType.getFreeTextAnnotationOrStructuredAnnotationOrDependencyStructure())
		{
			if (objType instanceof org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.TextualType)
			{
				txtList.add(new org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3.Textual((TextualType) objType));
			}

		}
		
		return txtList;
	}

	@Override
	public void addFreeTextAnnotation(Textual textual) throws MXMException {
		textAnnotationType.getFreeTextAnnotationOrStructuredAnnotationOrDependencyStructure().add((TextualType)textual.createObject(TextualType.class.getCanonicalName()).getContent());

		
	}

	@Override
	public List<StructuredAnnotation> getStructuredAnnotation() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void addStructuredAnnotation(
			StructuredAnnotation structuredAnnotation) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public List<DependencyStructure> getDependencyStructure() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void addDependencyStructure(DependencyStructure dependencyStructure) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public Float getRelevance() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setRelevance(Float value) {
		// TODO Auto-generated method stub
		
	}
}
