package org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3;

import java.io.File;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.SuperMpe7v3AbstractLevel1;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.TextualType;

public class Textual extends TextualBase implements org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.Textual
{
	private TextualType textualType;
	
	public Textual()
	{
		this(new TextualType());
	}
	
	public Textual(TextualType textualType)
	{
		super(textualType);
		this.textualType = textualType;
	}
	
	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperMpe7v3AbstractLevel1(textualType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperMpe7v3AbstractLevel1(textualType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperMpe7v3AbstractLevel1 superAbstract = new SuperMpe7v3AbstractLevel1(textualType);
		
		MXMEngineResponse repsonse = superAbstract.parse(object);
		
		textualType = (TextualType) superAbstract.createObject(TextualType.class.getCanonicalName());
		
		return repsonse;
	}

}
