package org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3;

import java.io.File;
import java.util.List;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.CreationType;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.SuperMpe7v3AbstractLevel1;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.TitleType;
import org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.PhoneticAlphabet;

public class Title implements org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.Title
{
	private TitleType titleType;
	
	public Title()
	{
		this(new TitleType());
	}
	
	public Title(TitleType titleType)
	{
		this.titleType = titleType;
	}

	@Override
	public void createFile(File f) throws MXMException {
		new SuperMpe7v3AbstractLevel1(titleType).createFile(f);
		
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		return new SuperMpe7v3AbstractLevel1(titleType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperMpe7v3AbstractLevel1 superAbstract = new SuperMpe7v3AbstractLevel1(titleType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		titleType = (TitleType) superAbstract.createObject(TitleType.class.getCanonicalName()).getContent();

		return repsonse;
	}

	@Override
	public PhoneticAlphabet getPhoneticAlphabet() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setPhoneticAlphabet(PhoneticAlphabet phoneticAlphabet) {
		// TODO Auto-generated method stub
	}

	@Override
	public List<String> getPhoneticTranscription() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getValue() {
		return titleType.getValue();
	}

	@Override
	public void setValue(String string) {
		titleType.setValue(string);
	}

	@Override
	public String getType() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setType(String string) {
		// TODO Auto-generated method stub	
	}
}
