package org.iso.mpeg.mxm.metadataTE.schemahandler.mpeg7_v3;

import java.io.File;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.SuperMpe7v3AbstractLevel1;
import org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.UniqueIDType;

public class UniqueID implements org.iso.mpeg.mxm.tEngine.metadataTE.schemahandler.mpeg7_v3.UniqueID
{
	private UniqueIDType uniqueIdType;
	
	public UniqueID(UniqueIDType uniqueId)
	{
		this.uniqueIdType = uniqueId;
	}
	
	public UniqueID()
	{
		this(new UniqueIDType());
	}
	
	@Override
	public String getOrganization()
	{
		return uniqueIdType.getOrganization();
	}

	@Override
	public void setOrganization(String string)
	{
		uniqueIdType.setOrganization(string);
	}

	@Override
	public void setAuthority(String string)
	{
		uniqueIdType.setAuthority(string);
	}

	@Override
	public String getValue()
	{
		return uniqueIdType.getValue();
	}

	@Override
	public String getType()
	{
		return uniqueIdType.getType();
	}

	@Override
	public void setValue(String string)
	{
		uniqueIdType.setValue(string);
	}

	@Override
	public String getAuthority()
	{
		return uniqueIdType.getAuthority();
	}

	@Override
	public String getEncoding()
	{
		return uniqueIdType.getEncoding();
	}

	@Override
	public void setEncoding(String string)
	{
		uniqueIdType.setEncoding(string);
	}

	@Override
	public void setType(String string)
	{
		uniqueIdType.setType(string);
	}
	
	// MXM CREATOR AND PARSER METHODS
	
	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperMpe7v3AbstractLevel1(uniqueIdType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperMpe7v3AbstractLevel1(uniqueIdType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperMpe7v3AbstractLevel1 superAbstract = new SuperMpe7v3AbstractLevel1(uniqueIdType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		uniqueIdType = (org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.UniqueIDType) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.metadataTE.schema.mpeg7_v3.UniqueIDType.class.getCanonicalName()).getContent();

		return repsonse;
	}

}