/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the Chillout Project (http://chillout.dmpf.org)
 *
 * The Initial Developer of the Original Code is CEDEO.net
 * Portions created by the Initial Developer are Copyright (C) 2006-2008
 * All Rights Reserved.
 *
 * The Initial Developer: Filippo Chiariglione 
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */

package org.iso.mpeg.mxm.metadataTE.util;


public enum CreatorRole {
	
		anchor("ANCHOR"),
		reporter("REPORTER"),
		interviewer("INTERVIEWER"),
		narrator("NARRATOR"),
		actor("ACTOR"),
		dancer("DANCER"),
		musician("MUSICIAN"),
		singer("SINGER"),
		performer("PERFORMER"),
		executiveproducer("EXECUTIVE-PRODUCER"),
		producer("PRODUCER"),
		scriptwriter("SCRIPTWRITER"),
		director("DIRECTOR"),
		asistantDirector("ASSISTANT-DIRECTOR"),
		productionAssistat("PRODUCTION-ASSISTANT"),
		continuityperson("CONTINUITY-PERSON"),
		timekeeper("TIMEKEEPER"),
		musicSupervisor("MUSIC-SUPERVISOR"),
		composer("COMPOSER"),
		productionDesigner("PRODUCTION-DESIGNER"),
		artDirector("ART-DIRECTOR"),
		setDesigner("SET-DESIGNER"),
		setMaker("SET-MAKER"),
		propertymaster("PROPERTY-MASTER"),
		propertyAssistant("PROPERTY-ASSISTANT"),
		soundEffectPerson("SOUND-EFFECTS-PERSON"),
		sfxSupervisor("SFX-SUPERVISOR"),
		sfxAssistant("SFX-ASSISTANT"),
		animator("ANIMATOR"),
		cdArtist("CG-ARTIST"),
		makeupSupervisor("MAKEUP-SUPERVISOR"),
		makeupArtist("MAKEUP-ARTIST"),
		costumeSupervisor("COSTUME-SUPERVISOR"),
		costumer("COSTUMER"),
		technicalDirector("TECHNICAL-DIRECTOR"),
		switcher("SWITCHER"),
		cameraOperator("CAMERA-OPERATOR"),
		cameraAssistant("CAMERA-ASSISTANT"),
		lightingSupervisor("LIGHTING-SUPERVISOR"),
		lightingOperator("LIGHTING-OPERATOR"),
		soundSupervisor("SOUND-SUPERVISOR"),
		soundEngineer("SOUND-ENGINEER"),
		visualEffectsSupervisor("VISUAL-EFFECTS-SUPERVISOR"),
		videoEngineer("VIDEO-ENGINEER"),
		transportationCaptain("TRANSPORTATION-CAPTAIN"),
		staff("STAFF"),
		disseminator("DISSEMINATOR"),
		publisher("PUBLISHER"),
		distributor("DISTRIBUTOR"),
		syndicator("SYNDICATOR"),
		aggregator("AGGREGATOR"),
		broadcaster("BROADCASTER"),
		webcaster("WEBCASTER"),
		unknown("UNKNOWN");
		

		private final String role;

		private final String CLASSIFICATION_SCHEME_URI = "urn:mpeg:mpeg7:cs:RoleCS:2001:";

		private CreatorRole(String role) {
			this.role = role;
		}

		public String getValue() {
			return CLASSIFICATION_SCHEME_URI + this.role;
		}

		public String getCLASSIFICATION_SCHEME_URI() {
			return CLASSIFICATION_SCHEME_URI;
		}
	
}
