/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the Chillout Project (http://chillout.dmpf.org)
 *
 * The Initial Developer of the Original Code is CEDEO.net
 * Portions created by the Initial Developer are Copyright (C) 2006-2008
 * All Rights Reserved.
 *
 * The Initial Developer: Filippo Chiariglione 
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */

package org.iso.mpeg.mxm.metadataTE.util;

public enum MPAAParentalRating {

	G("G"), 
	PG("PG"), 
	PG13("PG-13"), 
	R("R"), 
	NC17("NC-17"), 
	NR("NR");

	private final String rating;

	private final String CLASSIFICATION_SCHEME_URI = "urn:mpeg:mpeg7:cs:MPAAParentalRatingCS:2001:";

	private MPAAParentalRating(String rating) {
		this.rating = rating;
	}

	public String getValue() {
		return this.CLASSIFICATION_SCHEME_URI + this.rating;
	}

	public String getCLASSIFICATION_SCHEME_URI() {
		return CLASSIFICATION_SCHEME_URI;
	}

}
