/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the Chillout Project (http://chillout.dmpf.org)
 *
 * The Initial Developer of the Original Code is CEDEO.net
 * Portions created by the Initial Developer are Copyright (C) 2006-2008
 * All Rights Reserved.
 *
 * The Initial Developer: Filippo Chiariglione 
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */

package org.iso.mpeg.mxm.mpeg21ffTE;

import java.util.List;

import org.iso.mpeg.mxm.core.MXMAbstractEngine;
import org.iso.mpeg.mxm.core.MXMEngine;
import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.tEngine.mp21ffTE.MPEG21FileCreator;
import org.iso.mpeg.mxm.tEngine.mp21ffTE.MPEG21FileParser;

public class MPEG21FileEngine extends MXMAbstractEngine implements org.iso.mpeg.mxm.tEngine.mp21ffTE.MPEG21FileEngine {

	public String getEngineName() {
		return MXMEngineName.MPEG21FileTE.toString();
	}

	public MPEG21FileParser getMPEG21FileParser() {
		return new DCFParser();
	}

	public MPEG21FileCreator getMPEG21FileCreator() {
		return new DCFCreator();
	}

	@Override
	public void setDependencies(List<MXMEngine> engines)
			throws MXMEngineException {
		// TODO Auto-generated method stub
		
	}


}
