/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the Chillout Project (http://chillout.dmpf.org)
 *
 * The Initial Developer of the Original Code is Joint Digital Lab (China)
 * Portions created by the Initial Developer are Copyright (C) 2006-2008
 * All Rights Reserved.
 *
 * The Initial Developer: Xueqing Liu 
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */


package org.iso.mpeg.mxm.mpeg21ffTE.boxes;

/**
 * This interface specifies methods to perform operations on various Boxes.
 * 
 * @author Xueqing Liu
 * 
 */
public interface IBox 
{

	/**
	 * Caculates the full size of this box in bytes
	 * @return the box size
	 */
	int GetBoxSize();
	
	/**
	 * Put all the box data into a byte array
	 * @param bytes the byte array which is used to contain all the box data
	 * @return the bytes' number which has been put into the byte array
	 */
	int Serialize(byte[] bytes);
	
	/**
	 * Get box type
	 * @return Box type
	 */
	String GetBoxType();
}
