/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the Chillout Project (http://chillout.dmpf.org)
 *
 * The Initial Developer of the Original Code is Joint Digital Lab (China)
 * Portions created by the Initial Developer are Copyright (C) 2006-2008
 * All Rights Reserved.
 *
 * The Initial Developer: Xueqing Liu 
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */


package org.iso.mpeg.mxm.mpeg21ffTE.dcf;
import java.util.ArrayList;

import org.iso.mpeg.mxm.mpeg21ffTE.boxes.IBox;


/**
 * This class is a logic structure of the DCF, 
 * it contains various boxes which to be packed into a dmp content file.
 * It can be regarded as a box container.
 * 
 * @author Xueqing Liu
 *
 */
public class DCF implements IDCF 
{
	
	/**
	 * An arraylist which is used to contain the boxes which to be added into the DCF
	 */
	public ArrayList<IBox> boxes=new ArrayList<IBox>();
	
	/**
	 * Add various boxes in to DCF
	 * @param box  box which to be added into dcf
	 */
    public void AddBox(IBox box)
    {
        boxes.add(box);
    }
}
