import java.io.File;

import junit.framework.TestCase;

import org.iso.mpeg.mxm.core.MXM;
import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.configuration.MXMConfigurationException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineNotFoundException;
import org.iso.mpeg.mxm.orchestrator.identifycontent.IdentifyContentEngineOrchestrator;
import org.iso.mpeg.mxm.pEngine.identifycontentPE.IdentifyContentPE;
import org.iso.mpeg.mxm.pEngine.identifycontentPE.schemahandler.IdentifyContentRequest;
import org.iso.mpeg.mxm.pEngine.identifycontentPE.schemahandler.IdentifyContentResponse;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.DIEngine;




public class identorchtest {
	
	public void testIC() throws MXMException
	{
		System.out.println("PG1 - Introduction......................................");
		
		MXM mxm = MXM.getInstance(this);
		mxm.listEnginesAndProperties();
	
		System.out.println("PG2 - Introduction......................................");
		IdentifyContentPE icpEngine = (IdentifyContentPE) mxm.getDefaultEngine(MXMEngineName.IdentifyContentPE.toString());

		System.out.println("PG3 - Introduction......................................");
		IdentifyContentRequest icpR=icpEngine.getSchemaHandler().getIdentifyContentRequest();
		icpR.parse(new MXMAdapter(new File(getClass().getClassLoader().getResource("testICR.xml").getFile())));
	
		System.out.println("PG4 - Introduction......................................");
		IdentifyContentEngineOrchestrator ieo=new IdentifyContentEngineOrchestrator(icpEngine);
		
		IdentifyContentResponse icr=ieo.identifyContent(icpR);
		
		System.out.println("PG5 - Introduction......................................");
		icr.getIdentifyContentSuccess().getIdentifiedContent().getDIDL();
		
		System.out.println(icr.createObject((String.class.getCanonicalName())).getContent());
		
		
	}
}
