/** ***** BEGIN LICENSE BLOCK *****
 * 
 * The copyright in this software is being made available under the BSD License, 
 * included below. This software may be subject to other third party and contributor 
 * rights, including patent rights, and no such rights are granted under this license.
 *
 * Copyright (c) 2012, Cedeo.net
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 *
 *    - Redistributions of source code must retain the above copyright notice, 
 *    	this list of conditions and the following disclaimer.
 *    - Redistributions in binary form must reproduce the above copyright notice, 
 *    	this list of conditions and the following disclaimer in the documentation 
 *    	and/or other materials provided with the distribution.
 *    - Neither the name of the Cedeo.net nor the names of its contributors 
 *    	may be used to endorse or promote products derived from this software 
 *    	without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, 
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
***** END LICENSE BLOCK ***** */package org.iso.mpeg.mxm.orchestratorTE;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.UUID;

import javax.xml.namespace.QName;

import org.iso.mpeg.mxm.baseprotocol.schema.ContentEntityType;
import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.pEngine.basePE.schemahandler.ContentEntity;
import org.iso.mpeg.mxm.pEngine.identifycontentPE.exceptions.IdentifyContentEngineException;
import org.iso.mpeg.mxm.pEngine.identifycontentPE.technologyhandler.IdentifyContentProtocol;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.DIDL;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author Angelo Difino
 *
 */
public class IdentifyContentEngineOrchestrator {

	Logger logger = LoggerFactory.getLogger(this.getClass());

	private org.iso.mpeg.mxm.pEngine.identifycontentPE.IdentifyContentPE identifyContentEngine;
	//private org.iso.mpeg.mxm.tEngine.digitalitemTE.DIEngine diengine;
	private static IdentifyContentEngineOrchestrator identifyContentEngineOrchestrator;
	
	private URL serviceURL;
	private QName serviceName;

	private IdentifyContentEngineOrchestrator(org.iso.mpeg.mxm.pEngine.identifycontentPE.IdentifyContentPE identifyContentEngine/*, org.iso.mpeg.mxm.tEngine.digitalitemTE.DIEngine diengine*/) {
		this.identifyContentEngine = identifyContentEngine;
		//this.diengine = diengine;
		

		
		

	}

	public static IdentifyContentEngineOrchestrator getInstance(org.iso.mpeg.mxm.pEngine.identifycontentPE.IdentifyContentPE identifyContentEngine, org.iso.mpeg.mxm.tEngine.digitalitemTE.DIEngine diengine) {
		if (identifyContentEngineOrchestrator == null)
			identifyContentEngineOrchestrator = new IdentifyContentEngineOrchestrator(identifyContentEngine/*, diengine*/);
		return identifyContentEngineOrchestrator;
	}
	public DIDL identifyDI(DIDL didl) throws IdentifyContentEngineException {
		return identifyDI(didl, null);
	}
	
	public DIDL identifyDI(DIDL didl, Map map) throws IdentifyContentEngineException {
		
		try 
		{
			this.serviceURL = new URL(identifyContentEngine.getPropertyValue("SERVICE_URL"));
			this.serviceName = new QName(identifyContentEngine.getPropertyValue("SERVICE_NAME_NS"), identifyContentEngine.getPropertyValue("SERVICE_NAME"));
		} 
		catch (MalformedURLException e) 
		{
			e.printStackTrace();
		}
		
		String transactionID = UUID.randomUUID().toString();
		
		//here we use just the core interface 
		org.iso.mpeg.mxm.pEngine.identifycontentPE.schemahandler.IdentifyContentRequest identifyContentRequest;
		org.iso.mpeg.mxm.pEngine.identifycontentPE.schemahandler.IdentifyContentResponse identifyContentResponse;
		org.iso.mpeg.mxm.pEngine.basePE.schemahandler.ContentEntity contentEntity;
		
		try 
		{
			//here we get the ad-hoc implementation of the core interface
			identifyContentRequest = identifyContentEngine.getSchemaHandler().getIdentifyContentRequest();
			identifyContentResponse = identifyContentEngine.getSchemaHandler().getIdentifyContentResponse();
			contentEntity= identifyContentEngine.getBaseProtocolSchemaHandler().getContentEntity(/*diengine*/);
			if (map!= null) for (Iterator<String> i =(Iterator) map.keySet().iterator();i.hasNext();)
			{
				Object o=i.next();
				org.iso.mpeg.mxm.pEngine.basePE.schemahandler.KeyValueData kvd=identifyContentEngine.getBaseProtocolSchemaHandler().getKeyValueData();
				kvd.setKey((String)o);
				kvd.setValue((String)(map.get(o)));
				identifyContentRequest.addEntry(kvd);
			}
			
			identifyContentRequest.setTransactionIdentifier(transactionID);
			
			// let's deal with DIDL, wrapped in the ContentEntity
			//SUPERFIXME on DIDL
			//ContentEntityType cet_i=new ContentEntityType();
			//cet_i.setDIDL((DIDLType)((DIDL)didl).getLevel0());
			//contentEntity.parse(new MXMAdapter(cet_i));			//do we really need to create a new instance of ContentEntity before
			
			contentEntity.setDIDL(didl);
			
			identifyContentRequest.setContentEntity(contentEntity);
			
//			//TODO test me!!!
//			System.out.println("!!!TEST ME");
//
//			//TODO debug me
			
			IdentifyContentProtocol icp= this.identifyContentEngine.getTechnologyHandler().getRemoteIdentifyContentProtocol();
			icp.initServiceParams(serviceURL, serviceName);
			
			identifyContentResponse = icp.identifyContent(identifyContentRequest);
			
			if (identifyContentResponse == null)
			{
				logger.error("Did not receive any Response (is NULL)");
				throw new IdentifyContentEngineException("Did not receive any Response (is NULL)");
			}
			else
			{
				//here we use just the implementation
				
				logger.info("Received Response Transaction id: " + identifyContentResponse.getTransactionIdentifier());				
				ContentEntity cet_new=(ContentEntity)identifyContentResponse.getIdentifyContentSuccess().getIdentifiedContent();
				
				//FIXME here we need to retrieve the DIParser
				//SUPERFIXME
				//FIXME here we need to check if didl come from mpegm-didl or from mp21-didl
				//DIDL didlIdentified = (org.iso.mpeg.mxm.engine.digitalitemTE.schema.DIDL)cet.getDIDL();
				DIDL dip=(DIDL)cet_new.getDIDL();

				logger.info("The given content ID is: " + dip.getMPEGMItem().getIdentifier());

				return dip;
			}
		} catch (MXMEngineException e) {
			//e.printStackTrace();
			throw new IdentifyContentEngineException(e.getMessage(), e);
		} catch (Exception e) {
			//e.printStackTrace();
			throw new IdentifyContentEngineException(e.getMessage(), e);
		} 
	}
}