/**
 * 
 */
package org.iso.mpeg.mxm.orchestratorTE;

import java.net.MalformedURLException;
import java.net.URL;

import javax.xml.namespace.QName;

import org.iso.mpeg.mxm.core.MXMInvalidConfigurationException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author Angelos-Christos Anadiotis
 *
 */
public class IdentifyUserEngineOrchestrator
{
	private Logger logger = LoggerFactory.getLogger(this.getClass());
	
	private static IdentifyUserEngineOrchestrator IDENTIFY_USER_ENGINE_ORCHESTRATOR = null;
	private org.iso.mpeg.mxm.pEngine.identifyuserPE.IdentifyUserEngine identifyUserEngine = null;
	private org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine securityEngine = null;
	
	private URL serviceURL;
	private QName serviceName;
	
	private IdentifyUserEngineOrchestrator(org.iso.mpeg.mxm.pEngine.identifyuserPE.IdentifyUserEngine identifyUserEngine)
	{
		this.identifyUserEngine = identifyUserEngine;
		
		try
		{
			this.serviceURL = new URL(identifyUserEngine.getPropertyValue("SERVICE_URL"));
			this.serviceName = new QName(identifyUserEngine.getPropertyValue("SERVICE_NAME_NS"), 
													identifyUserEngine.getPropertyValue("SERVICE_NAME"));
		} 
		catch (MXMInvalidConfigurationException e)
		{
			e.printStackTrace();
		} catch (MalformedURLException e)
		{
			e.printStackTrace();
		}
		
		this.identifyUserEngine.getIdentifyUserTechnologyHandler().getRemoteIdentifyUserProtocol().initServiceParams(serviceURL, serviceName);
	}
	
	private IdentifyUserEngineOrchestrator(org.iso.mpeg.mxm.pEngine.identifyuserPE.IdentifyUserEngine identifyUserEngine,
			org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine securityEngine)
	{
		this.identifyUserEngine = identifyUserEngine;
		this.securityEngine = securityEngine;
		
		try
		{
			this.serviceURL = new URL(identifyUserEngine.getPropertyValue("SERVICE_URL"));
			this.serviceName = new QName(identifyUserEngine.getPropertyValue("SERVICE_NAME_NS"), 
													identifyUserEngine.getPropertyValue("SERVICE_NAME"));
		} 
		catch (MXMInvalidConfigurationException e)
		{
			e.printStackTrace();
		} catch (MalformedURLException e)
		{
			e.printStackTrace();
		}
		
		this.identifyUserEngine.getIdentifyUserTechnologyHandler().getRemoteIdentifyUserProtocol().initServiceParams(serviceURL, serviceName);
	}
	
	public static IdentifyUserEngineOrchestrator getInstance(org.iso.mpeg.mxm.pEngine.identifyuserPE.IdentifyUserEngine identifyUserEngine)
	{
		if (IDENTIFY_USER_ENGINE_ORCHESTRATOR == null)
		{
			IDENTIFY_USER_ENGINE_ORCHESTRATOR = new IdentifyUserEngineOrchestrator(identifyUserEngine);
		}
		return IDENTIFY_USER_ENGINE_ORCHESTRATOR;
	}
}
