package org.iso.mpeg.mxm.orchestratorTE;

import java.awt.Canvas;


import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.tEngine.mediaframeworkTE.MediaFrameworkEngine;
import org.iso.mpeg.mxm.tEngine.mediaframeworkTE.access.AccessMediaFramework;
import org.iso.mpeg.mxm.tEngine.mediaframeworkTE.exception.MediaFrameworkEngineException;

public class MFOrchestrator {

	AccessMediaFramework amf=null;
	private static MFOrchestrator mfOrchestrator = null;
	private MediaFrameworkEngine mfEngine;

	private MFOrchestrator(MediaFrameworkEngine mfEngine, Canvas canvas) throws MediaFrameworkEngineException {
		this.mfEngine = mfEngine;
		
		try {
			amf=mfEngine.getAccessMediaFramework(canvas);
		} catch (MediaFrameworkEngineException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			throw new MediaFrameworkEngineException(e.getMessage(),e);			
		}
	}

	public static MFOrchestrator getInstance(MediaFrameworkEngine mfEngine, Canvas canvas) throws MediaFrameworkEngineException {
		if (mfOrchestrator == null)
			mfOrchestrator = new MFOrchestrator(mfEngine, canvas);

		return mfOrchestrator;
	}
//	public static MFOrchestrator getInstance(MediaFrameworkEngine mfEngine) throws MediaFrameworkEngineException {
//		if (mfOrchestrator == null){
//create dummy canvas
//					Canvas canvas;
//				   JFrame frame = new JFrame("dummy jframe");
//				   canvas = new Canvas();
//				   canvas.setBackground(java.awt.Color.black);
//				   frame.add(canvas);
//				   frame.setLocation(100, 100);
//				   frame.setSize(1050, 600);
//				   frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
//				   frame.setVisible(true);
//		
//			
//			mfOrchestrator = new MFOrchestrator(mfEngine);
//		}
//
//		return mfOrchestrator;
//	}
//	
	
	public void openAndPlay(String URL) throws MediaFrameworkEngineException{
		try {
			//amf.resetCanvas(canvas);
			amf.open(new MXMAdapter(URL));
			amf.play();
			
		} catch (MediaFrameworkEngineException e) {

		}
	}
	
	public void play() throws MediaFrameworkEngineException{
		amf.play();
	}
	
	public void stop() throws MediaFrameworkEngineException{
		amf.stop();
	}
	
	public void pause() throws MediaFrameworkEngineException{
		amf.pause();
	}

	public void release() throws MediaFrameworkEngineException {
		amf.release();
	}

	public void setVolume(int volume) throws MediaFrameworkEngineException {
		amf.setVolume(volume);
	}
}
