package eu.convergence.middleware.orchestratorTE.test;

import java.io.File;

import junit.framework.TestCase;

import org.apache.log4j.Logger;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.orchestratorTE.OrchestratorTE;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.DIDL;


public class DIDOrchestratorTest extends TestCase  {

	private final String TEMP_FOLDER = System.getProperty("java.io.tmpdir") + File.separator;
	private Logger logger = Logger.getLogger(DIDOrchestratorTest.class);
	private final String OUTPUT_DCI_FILE_NAME = TEMP_FOLDER + "mytestDCI.xml";
			
	public void testBuildSimpleDI() throws MXMException{
		logger.info("\n\n---------- testBuildSimpleDI ----------");
		DIDL didl = OrchestratorTE.dealWithDIDEngine().buildSimpleDI("mimetype","resource","title","abs", "2006-12-31T23:59:59", "2006-01-01T00:00:00");
		didl.createFile(new File(OUTPUT_DCI_FILE_NAME));
	}
	public void testReadSimpleDI() throws MXMException{
		logger.info("\n\n---------- testReadeSimpleDI ----------");
		String url = OrchestratorTE.dealWithDIDEngine().readDI(OUTPUT_DCI_FILE_NAME);
		logger.info("resource url is"+url);
		logger.info("title is"+OrchestratorTE.dealWithDIDEngine().OUT_TITLE);
		logger.info("abs is"+OrchestratorTE.dealWithDIDEngine().OUT_ABS);
		logger.info("nvbf is"+OrchestratorTE.dealWithDIDEngine().OUT_NV_BEFORE);
		logger.info("nvaf is"+OrchestratorTE.dealWithDIDEngine().OUT_NV_AFTER);
	}
}
