package eu.convergence.middleware.orchestratorTE.test;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

import junit.framework.TestCase;

import org.apache.log4j.Logger;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;

import org.iso.mpeg.mxm.orchestratorTE.OrchestratorTE;
import org.iso.mpeg.mxm.pEngine.identifycontentPE.exceptions.IdentifyContentEngineException;
import org.iso.mpeg.mxm.tEngine.digitalitemTE.schemahandler.didl.DIDL;

public class IdentContOrchestratorTest extends TestCase  {

	private final String TEMP_FOLDER = System.getProperty("java.io.tmpdir") + File.separator;
	private Logger logger = Logger.getLogger(IdentContOrchestratorTest.class);
	private final String OUTPUT_ID_CON_FILE_NAME = TEMP_FOLDER + "idContOutput.xml";

	
	public void testIdentiCont() throws MXMEngineException{
		logger.info("===>> Entering test on Identify Content ES");
		try
		{
			Map maps=new HashMap();
			maps.put("PRINCIPAL", "PeerID");
			
			DIDL didl =(DIDL)OrchestratorTE.dealWithDIDEngine().buildDI("avi", "res_url", "title", "actor_gname", "actor_gname");
			DIDL newDIDL=OrchestratorTE.dealWithIdentifyContentEngine().identifyDI(didl, maps);// .dealWithIdentifyContentEngine().identifyDI(didl);
			
			newDIDL.createFile(new File(OUTPUT_ID_CON_FILE_NAME));
			logger.info("===>> The DI identifyied is avaialable on: " + OUTPUT_ID_CON_FILE_NAME);
		}
		catch (IdentifyContentEngineException e)
		{
			logger.warn("===>> The IdentifyContentService seems not available");
			e.printStackTrace();
		}
		catch (MXMException mxm)
		{
			logger.warn("===>> The IdentifyContentService seems not available");
			mxm.printStackTrace();
		}
	}
}
