/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the MPEG Multimedia Extensible Middleware (MXM) Project 
 *
 * The Initial Developer of the Original Code is CEDEO.net  
 * Portions created by the Initial Developer are Copyright (C) 2009
 * All Rights Reserved.
 *
 * The Initial Developer: Angelo Difino
 * Contributor(s): 
 *
 * ***** END LICENSE BLOCK ***** */

package org.iso.mpeg.mxm.packagecontentPE.schema;

import java.io.File;

import org.iso.mpeg.mxm.basePE.ProtocolResponse;
import org.iso.mpeg.mxm.baseprotocol.schema.ProtocolFailureType;
import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.protocol.SuperProtocolEngineAbstractLevel1;

import org.iso.mpeg.mxm.engine.protocol.packagecontentPE.schema.packagecontentprotocol.PackageContentResponseType;
import org.iso.mpeg.mxm.engine.protocol.packagecontentPE.schema.packagecontentprotocol.PackageContentSuccessType;

import org.iso.mpeg.mxm.pEngine.basePE.BaseProtocolEngine;
import org.iso.mpeg.mxm.pEngine.basePE.schemahandler.ProtocolFailure;
import org.iso.mpeg.mxm.pEngine.packagecontentPE.schemahandler.PackageContentSuccess;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;

/**
 * @author Angelo Difino
 * 
 */
public class PackageContentResponse extends ProtocolResponse
		implements
		org.iso.mpeg.mxm.pEngine.packagecontentPE.schemahandler.PackageContentResponse {
	private BaseProtocolEngine baseProtocolEngine;

	/**
	 * @throws MXMEngineException
	 */
	public PackageContentResponse(BaseProtocolEngine baseProtocolEngine,
			SecurityEngine securityEngine) throws MXMEngineException {
		super(new PackageContentResponseType(), securityEngine);
		this.baseProtocolEngine = baseProtocolEngine;
	}

	//
	// public IdentifyContentResponse(IdentifyContentResponseType
	// identifyContentResponseType) throws MXMEngineException
	// {
	// super(identifyContentResponseType);
	// }
	//
	// /* (non-Javadoc)
	// * @see
	// org.iso.mpeg.mxm.engine.basePE.ProtocolBase#setTransactionIdentifier(java.lang.String)
	// */
	// @Override
	// public void setTransactionIdentifier(String transactionID)
	// {
	// identifyContentResponseType.setTransactionIdentifier(transactionID);
	// }
	//
	// /* (non-Javadoc)
	// * @see
	// org.iso.mpeg.mxm.engine.basePE.ProtocolBase#getTransactionIdentifier()
	// */
	// @Override
	// public String getTransactionIdentifier()
	// {
	// return identifyContentResponseType.getTransactionIdentifier();
	// }
	//
	// /* (non-Javadoc)
	// * @see
	// org.iso.mpeg.mxm.engine.basePE.ProtocolBase#setTimestamp(java.util.Date)
	// */
	// @Override
	// public void setTimestamp(Date date)
	// {
	// GregorianCalendar c = new GregorianCalendar();
	// c.setTime(date);
	// XMLGregorianCalendar xmlGregorianCalendar = null;
	// try {
	// xmlGregorianCalendar =
	// DatatypeFactory.newInstance().newXMLGregorianCalendar(c);
	// } catch (DatatypeConfigurationException e) {
	// e.printStackTrace();
	// }
	//
	// identifyContentResponseType.setTimestamp(xmlGregorianCalendar);
	// }
	//
	// /* (non-Javadoc)
	// * @see org.iso.mpeg.mxm.engine.basePE.ProtocolBase#getTimestamp()
	// */
	// @Override
	// public Date getTimestamp()
	// {
	// XMLGregorianCalendar xmlGregorianCalendar =
	// identifyContentResponseType.getTimestamp();
	// return xmlGregorianCalendar.toGregorianCalendar().getTime();
	// }
	//
	// /* (non-Javadoc)
	// * @see
	// org.iso.mpeg.mxm.engine.basePE.ProtocolBase#addKeyValueData(org.iso.mpeg.mxm.engine.basePE.KeyValueData)
	// */
	// @Override
	// public void addKeyValueData(KeyValueData keyValueData)
	// {
	// try {
	// identifyContentResponseType.getEntry().add(
	// (KeyValueDataType)(keyValueData.createObject(KeyValueDataType.class.getName())).getContent());
	// } catch (MXMException e) {
	// e.printStackTrace();
	// }
	// }
	//
	// /* (non-Javadoc)
	// * @see org.iso.mpeg.mxm.engine.basePE.ProtocolBase#getKeyValueData()
	// */
	// @Override
	// public List<KeyValueData> getKeyValueData()
	// {
	// List<KeyValueData> keyValueDatas = new ArrayList<KeyValueData>();
	// List<KeyValueDataType> keyValueDataTypes =
	// identifyContentResponseType.getEntry();
	//
	// if (keyValueDataTypes != null)
	// {
	// for (KeyValueDataType keyValueDataType : keyValueDataTypes)
	// {
	// try {
	// keyValueDatas.add(new KeyValyueData(keyValueDataType));
	// } catch (MXMEngineException e) {
	// e.printStackTrace();
	// }
	// }
	// }
	//
	// return null;
	// }
	//
	// /* (non-Javadoc)
	// * @see
	// org.iso.mpeg.mxm.engine.basePE.ProtocolBase#addApplicationSpecificData(org.iso.mpeg.mxm.engine.basePE.ApplicationSpecificData)
	// */
	// @Override
	// public void addApplicationSpecificData(
	// ApplicationSpecificData applicationSpecificData)
	// {
	// try {
	// identifyContentResponseType.getApplicationSpecificData().add(
	// (ApplicationSpecificDataType)(applicationSpecificData.createObject(ApplicationSpecificDataType.class.getName())).getContent());
	// } catch (MXMException e) {
	// e.printStackTrace();
	// }
	// }
	//
	// /* (non-Javadoc)
	// * @see
	// org.iso.mpeg.mxm.engine.basePE.ProtocolBase#getApplicationSpecificData()
	// */
	// @Override
	// public ApplicationSpecificData getApplicationSpecificData()
	// {
	// List<ApplicationSpecificData> applicationSpecificDatas = new
	// ArrayList<ApplicationSpecificData>();
	// List<ApplicationSpecificDataType> applicationSpecificDataTypes =
	// identifyContentResponseType.getApplicationSpecificData();
	//
	// if (applicationSpecificDataTypes != null)
	// {
	// for (ApplicationSpecificDataType applicationSpecificDataType :
	// applicationSpecificDataTypes)
	// {
	// try {
	// applicationSpecificDatas.add(
	// new
	// org.iso.mpeg.mxm.basePE.ApplicationSpecificData(applicationSpecificDataType));
	// } catch (MXMEngineException e) {
	// e.printStackTrace();
	// }
	// }
	// }
	//
	// return null;
	// }
	//
	// /* (non-Javadoc)
	// * @see
	// org.iso.mpeg.mxm.engine.basePE.ProtocolBase#setSignature(org.iso.mpeg.mxm.engine.securityTE.data.Signature)
	// */
	// @Override
	// public void setSignature(Signature signature)
	// {
	// try {
	// identifyContentResponseType.setSignature((SignatureType)(signature.createObject(SignatureType.class.getName())).getContent());
	// } catch (MXMException e) {
	// e.printStackTrace();
	// }
	// }
	//
	// /* (non-Javadoc)
	// * @see org.iso.mpeg.mxm.engine.basePE.ProtocolBase#getSignature()
	// */
	// @Override
	// public Signature getSignature()
	// {
	// try {
	// return new
	// org.iso.mpeg.mxm.engine.securityTE.schema.Signature(identifyContentResponseType.getSignature());
	// } catch (MXMEngineException e) {
	// e.printStackTrace();
	// }
	// return null;
	// }
	//
	// /* (non-Javadoc)
	// * @see
	// org.iso.mpeg.mxm.engine.identifyuserPE.IdentifyUserResponse#setIdentifyUserSuccess(org.iso.mpeg.mxm.engine.identifyuserPE.IdentifyUserSuccess)
	// */
	// @Override
	// public void setIdentifyContentSuccess(IdentifyContentSuccess
	// identifyContentSuccess)
	// {
	// try
	// {
	// this.identifyContentResponseType.setIdentifyContentSuccess(
	// (IdentifyContentSuccessType)(identifyContentSuccess.createObject(IdentifyContentSuccessType.class.getName())).getContent());
	// } catch (MXMException e)
	// {
	// e.printStackTrace();
	// }
	// }
	//
	// /* (non-Javadoc)
	// * @see
	// org.iso.mpeg.mxm.engine.identifyuserPE.IdentifyUserResponse#getIdentifyUserSuccess()
	// */
	// @Override
	// public IdentifyContentSuccess getIdentifyContentSuccess()
	// {
	// try
	// {
	// return new
	// org.iso.mpeg.mxm.identifycontentPE.schema.IdentifyContentSuccess(this.identifyContentResponseType.getIdentifyContentSuccess());
	// } catch (MXMEngineException e)
	// {
	// e.printStackTrace();
	// }
	// return null;
	// }
	//
	// /* (non-Javadoc)
	// * @see
	// org.iso.mpeg.mxm.engine.identifyuserPE.IdentifyUserResponse#setProtocolFailure(org.iso.mpeg.mxm.engine.basePE.ProtocolFailure)
	// */
	// @Override
	// public void setProtocolFailure(ProtocolFailure protocolFailure)
	// {
	// try
	// {
	// this.identifyContentResponseType.setIdentifyContentFailure(
	// (ProtocolFailureType)(protocolFailure.createObject(ProtocolFailureType.class.getName())).getContent());
	// } catch (MXMException e)
	// {
	// e.printStackTrace();
	// }
	// }
	//
	// /* (non-Javadoc)
	// * @see
	// org.iso.mpeg.mxm.engine.identifyuserPE.IdentifyUserResponse#getProtocolFailure()
	// */
	// @Override
	// public ProtocolFailure getProtocolFailure()
	// {
	// try
	// {
	// return new
	// org.iso.mpeg.mxm.basePE.ProtocolFailure(this.identifyContentResponseType.getIdentifyContentFailure());
	// } catch (MXMEngineException e)
	// {
	// e.printStackTrace();
	// }
	// return null;
	// }

	@Override
	public void createFile(File f) throws MXMException {
		SuperProtocolEngineAbstractLevel1 level1 = new SuperProtocolEngineAbstractLevel1(
				(PackageContentResponseType) protocolBaseType);
		level1.createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException {
		SuperProtocolEngineAbstractLevel1 level1 = new SuperProtocolEngineAbstractLevel1(
				(PackageContentResponseType) protocolBaseType);
		return level1.createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException {
		SuperProtocolEngineAbstractLevel1 level1 = new SuperProtocolEngineAbstractLevel1(
				(PackageContentResponseType) protocolBaseType);
		MXMEngineResponse response = level1.parse(object);
		if (response.equals(MXMEngineResponse.SUCCESS)) {
			protocolBaseType = (PackageContentResponseType) level1
					.createObject(PackageContentResponseType.class.getName())
					.getContent();
		}
		return response;
	}

	public PackageContentSuccess getPackageContentSuccess()
			throws MXMEngineException {
		PackageContentSuccessType icSuccessType = ((PackageContentResponseType) protocolBaseType)
				.getPackageContentSuccess();
		PackageContentSuccess icSuccess = new org.iso.mpeg.mxm.packagecontentPE.schema.PackageContentSuccess(
				baseProtocolEngine);
		icSuccess.parse(new MXMAdapter(icSuccessType));
		return icSuccess;
	}

	public void setPackageContentSuccess(
			PackageContentSuccess packageContentSuccess) throws MXMException {
		PackageContentSuccessType icSuccessType = (PackageContentSuccessType) (packageContentSuccess
				.createObject(PackageContentSuccessType.class.getName())
				.getContent());
		((PackageContentResponseType) protocolBaseType)
				.setPackageContentSuccess(icSuccessType);
	}

	public ProtocolFailure getPackageContentFailure() throws MXMEngineException {
		ProtocolFailure protocolFailure = baseProtocolEngine
				.getBaseProtocolSchemaHandler().getProtocolFailure();
		ProtocolFailureType protocolFailureType = ((PackageContentResponseType) protocolBaseType)
				.getPackageContentFailure();
		protocolFailure.parse(new MXMAdapter(protocolFailureType));
		return protocolFailure;
	}

	public void setPackageContentFailure(ProtocolFailure protocolFailure)
			throws MXMException {
		ProtocolFailureType protocolFailureType = (ProtocolFailureType) (protocolFailure
				.createObject(ProtocolFailureType.class.getName()).getContent());
		((PackageContentResponseType) protocolBaseType)
				.setPackageContentFailure(protocolFailureType);
	}
}
