/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla  Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and  limitations under the
 * License.
 *
 * The Original Code is the Chillout Project (http://chillout.dmpf.org)
 *
 * The Initial Developer of the Original Code is CEDEO.net
 * Portions created by the Initial Developer are Copyright (C) 2006-2009
 * All Rights Reserved.
 *
 * The Initial Developer: Filippo Chiariglione 
 * Contributor(s): Edoardo Radica
 *
 * ***** END LICENSE BLOCK ***** */

package org.iso.mpeg.mxm.relTE;

import java.util.List;

import org.iso.mpeg.mxm.core.MXMAbstractEngine;
import org.iso.mpeg.mxm.core.MXMEngine;
import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.tEngine.relTE.RELEngineSchemaHandler;
import org.iso.mpeg.mxm.tEngine.relTE.RELEngineTechnologyHandler;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;

public class RELEngine extends MXMAbstractEngine implements org.iso.mpeg.mxm.tEngine.relTE.RELEngine 
{
	private SecurityEngine securityEngine;
	
	public RELEngine()
	{

	}
	
	public String getEngineName() {
		return MXMEngineName.RELTE.toString();
	}

	@Override
	public RELEngineSchemaHandler getRELEngineSchemaHandler()
			throws MXMEngineException
	{
		return new RELSchemaHandler(securityEngine);
	}

	@Override
	public RELEngineTechnologyHandler getRELEngineTechnologyHandler()
			throws MXMEngineException
	{
		return new RELTechnologyHandler();
	}

	@Override
	public void setDependencies(List<MXMEngine> engines)
			throws MXMEngineException
	{
		if (engines != null)
		{
			for (MXMEngine engine : engines)
			{
				String engineName = engine.getEngineName();
				
				if (engineName.equals(MXMEngineName.SecurityTE.value()))
				{
					this.securityEngine = (SecurityEngine)engine;
				}
			}
		}
	}
	
}
