package org.iso.mpeg.mxm.relTE.schemahandler;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBElement;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.LicensePart;

public class Inventory implements org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.Inventory
{
	private org.iso.mpeg.mxm.engine.relTE.schema.relr.Inventory inventoryType;
	
	public Inventory() 
	{
		this(new org.iso.mpeg.mxm.engine.relTE.schema.relr.Inventory());
	}
	
	public Inventory(org.iso.mpeg.mxm.engine.relTE.schema.relr.Inventory inventory)
	{
		this.inventoryType = inventory;
	}

	@Override
	public List<LicensePart> getLicenseParts()
	{
		List<LicensePart> licensePartList = new ArrayList<LicensePart>();
		
		for (JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.LicensePart> jaxbElement : inventoryType.getLicensePart())
		{
			licensePartList.add(new org.iso.mpeg.mxm.relTE.schemahandler.common.LicensePart(jaxbElement.getValue()));
		}
		
		return licensePartList;
	}

	@Override
	public void addLicensePart(LicensePart licensePart)
	{
		try
		{
			this.inventoryType.getLicensePart().add((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.LicensePart>) 
					licensePart.createObject(JAXBElement.class.getCanonicalName()).getContent());
		}
		catch (MXMException e)
		{
			e.printStackTrace();
		}
	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(inventoryType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperRelAbstractLevel1(inventoryType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperRelAbstractLevel1 superAbstract = new SuperRelAbstractLevel1(inventoryType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		inventoryType = (org.iso.mpeg.mxm.engine.relTE.schema.relr.Inventory) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relr.Inventory.class.getCanonicalName()).getContent();

		return repsonse;
	}
	
}
