package org.iso.mpeg.mxm.relTE.schemahandler;

import java.io.File;

import javax.xml.bind.JAXBElement;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;
import org.iso.mpeg.mxm.engine.relTE.schema.relm1x.IdentityHolder;
import org.iso.mpeg.mxm.engine.relTE.schema.relr.KeyHolder;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.IssuerDetails;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.Principal;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Signature;

public class Issuer implements org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.Issuer
{
	private  org.iso.mpeg.mxm.engine.relTE.schema.relr.Issuer issuerType;
	private SecurityEngine securityEngine;
	
	public Issuer(SecurityEngine securityEngine)
	{
		this(new org.iso.mpeg.mxm.engine.relTE.schema.relr.Issuer(), securityEngine);
	}
	
	public Issuer(org.iso.mpeg.mxm.engine.relTE.schema.relr.Issuer issuer,  SecurityEngine securityEngine)
	{
		this.issuerType = issuer;
		this.securityEngine=securityEngine;
	}

	@Override
	public Principal getPrincipal()
	{
		if (this.issuerType.getPrincipal() != null)
		{
			org.iso.mpeg.mxm.engine.relTE.schema.relr.Principal principalType = issuerType.getPrincipal().getValue();

			if (principalType instanceof  org.iso.mpeg.mxm.engine.relTE.schema.relr.KeyHolder)
			{
				return new org.iso.mpeg.mxm.relTE.schemahandler.resource.principal.KeyHolder((KeyHolder) principalType, securityEngine);
			}
			else if (principalType instanceof org.iso.mpeg.mxm.engine.relTE.schema.relm1x.IdentityHolder)
			{
				return new org.iso.mpeg.mxm.relTE.schemahandler.resource.principal.IdentityHolder((IdentityHolder) principalType);
			}
		}
		
		return null;
	}

	@Override
	public void setPrincipal(Principal principal)
	{
		try
		{
			issuerType.setPrincipal((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Principal>)
					principal.createObject(JAXBElement.class.getCanonicalName()).getContent());
		} 
		catch (MXMException e)
		{
			e.printStackTrace();
		}
	}

	@Override
	public void setSignature(Signature signature)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public IssuerDetails getDetails()
	{
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setDetails(IssuerDetails issuerDetails)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public Signature getSignature()
	{
		// TODO Auto-generated method stub
		return null;
	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(issuerType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperRelAbstractLevel1(issuerType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperRelAbstractLevel1 superAbstract = new SuperRelAbstractLevel1(issuerType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		issuerType = (org.iso.mpeg.mxm.engine.relTE.schema.relr.Issuer) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relr.Issuer.class.getCanonicalName()).getContent();

		return repsonse;
	}

}
