package org.iso.mpeg.mxm.relTE.schemahandler.common;

import java.io.File;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;

public class LicensePart implements org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.LicensePart
{
	protected org.iso.mpeg.mxm.engine.relTE.schema.relr.LicensePart licensePartType;

	public LicensePart()
	{
		this(new org.iso.mpeg.mxm.engine.relTE.schema.relr.LicensePart());
	}
	
	public LicensePart(org.iso.mpeg.mxm.engine.relTE.schema.relr.LicensePart licensePart)
	{
		this.licensePartType = licensePart;
	}

	@Override
	public String getLicensePartId()
	{
		return licensePartType.getLicensePartId();
	}

	@Override
	public void setLicensePartId(String string)
	{
		licensePartType.setLicensePartId(string);
	}

	@Override
	public String getLicensePartIdRef()
	{
		return licensePartType.getLicensePartIdRef();
	}

	@Override
	public void setLicensePartIdRef(String string)
	{
		licensePartType.setLicensePartIdRef(string);
	}

	@Override
	public String getVarRef()
	{
		return licensePartType.getVarRef();
	}

	@Override
	public void setVarRef(String string)
	{
		licensePartType.setVarRef(string);
	}
	
	// MXM CREATOR AND PARSER METHODS
	
	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(licensePartType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperRelAbstractLevel1(licensePartType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperRelAbstractLevel1 superAbstract = new SuperRelAbstractLevel1(licensePartType);
		
		MXMEngineResponse repsonse = superAbstract.parse(object);
		
		licensePartType = (org.iso.mpeg.mxm.engine.relTE.schema.relr.LicensePart) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relr.LicensePart.class.getCanonicalName()).getContent();
		
		return repsonse;
	}
}
