package org.iso.mpeg.mxm.relTE.schemahandler.common;

import java.io.File;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;

public class ServiceDescription extends LicensePart implements org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.ServiceDescription
{
	private org.iso.mpeg.mxm.engine.relTE.schema.relr.ServiceDescription serviceDescriptionType;

	public ServiceDescription()
	{
		this(new org.iso.mpeg.mxm.engine.relTE.schema.relr.ServiceDescription());
	}
	
	public ServiceDescription(org.iso.mpeg.mxm.engine.relTE.schema.relr.ServiceDescription serviceDescription)
	{
		this.serviceDescriptionType = serviceDescription;
	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(serviceDescriptionType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperRelAbstractLevel1(serviceDescriptionType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperRelAbstractLevel1 superAbstract = new SuperRelAbstractLevel1(serviceDescriptionType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		serviceDescriptionType = (org.iso.mpeg.mxm.engine.relTE.schema.relr.ServiceDescription) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relr.ServiceDescription.class.getCanonicalName()).getContent();
		
		super.parse(new MXMAdapter(serviceDescriptionType));

		return repsonse;
	}
}
