package org.iso.mpeg.mxm.relTE.schemahandler.common;

import java.io.File;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;

public class ServiceLocation extends ServiceDescription implements org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relm1x.ServiceLocation
{
	private org.iso.mpeg.mxm.engine.relTE.schema.relm1x.ServiceLocation serviceLocationType;

	public ServiceLocation()
	{
		this(new org.iso.mpeg.mxm.engine.relTE.schema.relm1x.ServiceLocation());
	}
	
	public ServiceLocation(org.iso.mpeg.mxm.engine.relTE.schema.relm1x.ServiceLocation serviceLocation)
	{
		this.serviceLocationType = serviceLocation;
	}
	
	@Override
	public String getUrl()
	{
		return serviceLocationType.getUrl();
	}

	@Override
	public void setUrl(String string)
	{
		serviceLocationType.setUrl(string);
	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(serviceLocationType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperRelAbstractLevel1(serviceLocationType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperRelAbstractLevel1 superAbstract = new SuperRelAbstractLevel1(serviceLocationType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		serviceLocationType = (org.iso.mpeg.mxm.engine.relTE.schema.relm1x.ServiceLocation) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relm1x.ServiceLocation.class.getCanonicalName()).getContent();
		
		super.parse(new MXMAdapter(serviceLocationType));

		return repsonse;
	}
	
}
