package org.iso.mpeg.mxm.relTE.schemahandler.condition;

import java.io.File;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;
import org.iso.mpeg.mxm.relTE.schemahandler.common.LicensePart;

public class Condition extends LicensePart implements org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.Condition
{
	private org.iso.mpeg.mxm.engine.relTE.schema.relr.Condition conditionType;
	
	public Condition()
	{
		this(new org.iso.mpeg.mxm.engine.relTE.schema.relr.Condition());
	}
	
	public Condition(org.iso.mpeg.mxm.engine.relTE.schema.relr.Condition condition)
	{
		super(condition);
		this.conditionType = condition;
	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(conditionType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperRelAbstractLevel1(conditionType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperRelAbstractLevel1 superAbstract = new SuperRelAbstractLevel1(conditionType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		conditionType = (org.iso.mpeg.mxm.engine.relTE.schema.relr.Condition) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relr.Condition.class.getCanonicalName()).getContent();

		return repsonse;
	}
}
