package org.iso.mpeg.mxm.relTE.schemahandler.condition;

import java.io.File;

import javax.xml.datatype.XMLGregorianCalendar;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;

public class ValidityInterval extends Condition implements org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.ValidityInterval
{
	private org.iso.mpeg.mxm.engine.relTE.schema.relr.ValidityInterval validityIntervalType;
	
	public ValidityInterval()
	{
		this(new org.iso.mpeg.mxm.engine.relTE.schema.relr.ValidityInterval());
	}
	
	public ValidityInterval(org.iso.mpeg.mxm.engine.relTE.schema.relr.ValidityInterval validityInterval)
	{
		super(validityInterval);
		this.validityIntervalType = validityInterval;
	}
	
	@Override
	public XMLGregorianCalendar getNotBefore()
	{
		return validityIntervalType.getNotBefore();
	}

	@Override
	public void setNotBefore(XMLGregorianCalendar xMLGregorianCalendar)
	{
		validityIntervalType.setNotBefore(xMLGregorianCalendar);
	}

	@Override
	public XMLGregorianCalendar getNotAfter()
	{
		return validityIntervalType.getNotAfter();
	}

	@Override
	public void setNotAfter(XMLGregorianCalendar xMLGregorianCalendar)
	{
		validityIntervalType.setNotAfter(xMLGregorianCalendar);
	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(validityIntervalType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperRelAbstractLevel1(validityIntervalType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperRelAbstractLevel1 superAbstract = new SuperRelAbstractLevel1(validityIntervalType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		validityIntervalType = (org.iso.mpeg.mxm.engine.relTE.schema.relr.ValidityInterval) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relr.ValidityInterval.class.getCanonicalName()).getContent();

		return repsonse;
	}

}
