package org.iso.mpeg.mxm.relTE.schemahandler.resource;

import java.io.File;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;

public class DiReference extends Resource implements org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relmx.DiReference
{
	private org.iso.mpeg.mxm.engine.relTE.schema.relmx.DiReference diReferenceType;
	
	public DiReference()
	{
		this(new org.iso.mpeg.mxm.engine.relTE.schema.relmx.DiReference());
	}
	
	public DiReference(org.iso.mpeg.mxm.engine.relTE.schema.relmx.DiReference diReference)
	{
		super(diReference);
		this.diReferenceType = diReference;
	}

	@Override
	public String getIdentifier()
	{
		return diReferenceType.getIdentifier();
	}

	@Override
	public void setIdentifier(String string)
	{
		diReferenceType.setIdentifier(string);
	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(diReferenceType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperRelAbstractLevel1(diReferenceType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperRelAbstractLevel1 superAbstract = new SuperRelAbstractLevel1(diReferenceType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		diReferenceType = (org.iso.mpeg.mxm.engine.relTE.schema.relmx.DiReference) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relmx.DiReference.class.getCanonicalName()).getContent();

		return repsonse;
	}
}
