package org.iso.mpeg.mxm.relTE.schemahandler.resource;

import java.io.File;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.DigitalResourceAnXml;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.NonSecureReference;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Reference;

public class DigitalResource extends Resource implements org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.DigitalResource
{
	private org.iso.mpeg.mxm.engine.relTE.schema.relr.DigitalResource digitalResourceType;
	
	public DigitalResource()
	{
		this(new org.iso.mpeg.mxm.engine.relTE.schema.relr.DigitalResource());
	}
	
	public DigitalResource(org.iso.mpeg.mxm.engine.relTE.schema.relr.DigitalResource digitalResource)
	{
		super(digitalResource);
		this.digitalResourceType = digitalResource;
	}
	
	@Override
	public Object getAny()
	{
		return digitalResourceType.getAny();
	}

	@Override
	public void setAny(Object object)
	{
		digitalResourceType.setAny(object);
	}

	@Override
	public NonSecureReference getNonSecureIndirect()
	{
		if (digitalResourceType.getNonSecureIndirect()!=null)
		{
			return new org.iso.mpeg.mxm.relTE.schemahandler.common.NonSecureReference(digitalResourceType.getNonSecureIndirect());
		}
		
		return null;
	}

	@Override
	public void setNonSecureIndirect(NonSecureReference nonSecureReference)
	{
		try
		{
			digitalResourceType.setNonSecureIndirect((org.iso.mpeg.mxm.engine.relTE.schema.relr.NonSecureReference) 
					nonSecureReference.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relr.NonSecureReference.class.getCanonicalName()).getContent());
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}

	@Override
	public Reference getSecureIndirect()
	{
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setSecureIndirect(Reference reference)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public byte[] getBinary()
	{
		return digitalResourceType.getBinary();
	}

	@Override
	public void setBinary(byte[] value)
	{
		digitalResourceType.setBinary(value);
	}

	@Override
	public DigitalResourceAnXml getAnXml()
	{
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setAnXml(DigitalResourceAnXml anXml)
	{
		// TODO Auto-generated method stub
		
	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(digitalResourceType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperRelAbstractLevel1(digitalResourceType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperRelAbstractLevel1 superAbstract = new SuperRelAbstractLevel1(digitalResourceType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		digitalResourceType = (org.iso.mpeg.mxm.engine.relTE.schema.relr.DigitalResource) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relr.DigitalResource.class.getCanonicalName()).getContent();

		return repsonse;
	}

}
