package org.iso.mpeg.mxm.relTE.schemahandler.resource;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBElement;

import org.iso.mpeg.mxm.baseprotocol.schema.SuperAbstractLevel1;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;
import org.iso.mpeg.mxm.engine.relTE.schema.relr.KeyHolder;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.Condition;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.DelegationControl;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.EncryptedContent;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.ForAll;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.LicensePart;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.Principal;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.Right;
import org.iso.mpeg.mxm.tEngine.relTE.technologyhandler.RELRight;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;

public class Grant extends Resource implements org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.Grant
{
	private org.iso.mpeg.mxm.engine.relTE.schema.relr.Grant grantType;
	private List<LicensePart> inventory;
	private SecurityEngine securityEngine;
	
	public Grant(SecurityEngine securityEngine)
	{
		this(new org.iso.mpeg.mxm.engine.relTE.schema.relr.Grant(),securityEngine);
	}
	
	public Grant(org.iso.mpeg.mxm.engine.relTE.schema.relr.Grant grant, SecurityEngine securityEngine)
	{
		super(grant);
		this.grantType = grant;
		this.securityEngine = securityEngine;
	}
	
	public void setInventory(org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.Inventory inventory)
	{
		this.inventory = inventory.getLicenseParts();
	}
	
	@Override
	public void setResource(org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.Resource resource)
	{
		try
		{
			grantType.setResource((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Resource>)
					resource.createObject(JAXBElement.class.getCanonicalName()).getContent());
		} 
		catch (MXMException e)
		{
			e.printStackTrace();
		}
	}
	
	@Override
	public org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.Resource getResource()
	{
		org.iso.mpeg.mxm.engine.relTE.schema.relr.Resource resource = grantType.getResource().getValue();
		
		// TODO add more types
		// TOO extract private method to search the inventory
		if (resource instanceof org.iso.mpeg.mxm.engine.relTE.schema.relr.Grant)
		{
			org.iso.mpeg.mxm.relTE.schemahandler.resource.Grant grantResource = 
					new org.iso.mpeg.mxm.relTE.schemahandler.resource.Grant((org.iso.mpeg.mxm.engine.relTE.schema.relr.Grant) resource, securityEngine);
			
			if (grantResource.getLicensePartIdRef()!=null && inventory!=null)
			{
				for (LicensePart licensePart : inventory)
				{
					if (grantResource.getLicensePartIdRef().equals(licensePart.getLicensePartIdRef())
							&& licensePart instanceof org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.Grant)
					{
						return (Grant) licensePart;
					}
				}
			}
			else
			{
				return grantResource;
			}
		}
		else if (resource instanceof org.iso.mpeg.mxm.engine.relTE.schema.relr.Principal)
		{
			return new org.iso.mpeg.mxm.relTE.schemahandler.resource.principal.Principal((org.iso.mpeg.mxm.engine.relTE.schema.relr.Principal) resource);
		}
//		else if (resource instanceof org.iso.mpeg.mxm.engine.relTE.schema.relr.AllPrincipals)
//		{
//			
//		}
		else if (resource instanceof org.iso.mpeg.mxm.engine.relTE.schema.relr.KeyHolder)
		{
			org.iso.mpeg.mxm.relTE.schemahandler.resource.principal.KeyHolder keyHolder = 
					new org.iso.mpeg.mxm.relTE.schemahandler.resource.principal.KeyHolder((org.iso.mpeg.mxm.engine.relTE.schema.relr.KeyHolder) resource, securityEngine);
			
			if (keyHolder.getLicensePartIdRef()!=null && inventory!=null)
			{
				for (LicensePart licensePart : inventory)
				{
					if (keyHolder.getLicensePartIdRef().equals(licensePart.getLicensePartIdRef())
							&& licensePart instanceof org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.KeyHolder)
					{
						return (org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.KeyHolder) licensePart;
					}
				}
			}
			else
			{
				return keyHolder;
			}
		}
		else if (resource instanceof org.iso.mpeg.mxm.engine.relTE.schema.relm1x.IdentityHolder)
		{
			org.iso.mpeg.mxm.relTE.schemahandler.resource.principal.IdentityHolder identityHolder = 
					new org.iso.mpeg.mxm.relTE.schemahandler.resource.principal.IdentityHolder(
							(org.iso.mpeg.mxm.engine.relTE.schema.relm1x.IdentityHolder) resource);
			
			if (identityHolder.getLicensePartIdRef()!=null && inventory!=null)
			{
				for (LicensePart licensePart : inventory)
				{
					if (identityHolder.getLicensePartIdRef().equals(licensePart.getLicensePartIdRef())
							&& licensePart instanceof org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relm1x.IdentityHolder)
					{
						return (Principal) licensePart;
					}
				}
			}
			else
			{
				return identityHolder;
			}
		}
//		else if (resource instanceof org.iso.mpeg.mxm.engine.relTE.schema.relr.PropertyPossessor)
//		{
//			
//		}
		else if (resource instanceof org.iso.mpeg.mxm.engine.relTE.schema.relr.DigitalResource)
		{
			org.iso.mpeg.mxm.relTE.schemahandler.resource.DigitalResource digitalResurce = 
					new org.iso.mpeg.mxm.relTE.schemahandler.resource.DigitalResource(
							(org.iso.mpeg.mxm.engine.relTE.schema.relr.DigitalResource) resource);
			
			if (digitalResurce.getLicensePartIdRef()!=null && inventory!=null)
			{
				for (LicensePart licensePart : inventory)
				{
					if (digitalResurce.getLicensePartIdRef().equals(licensePart.getLicensePartIdRef())
							&& licensePart instanceof org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.DigitalResource)
					{
						return (org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.DigitalResource) licensePart;
					}
				}
			}
			else
			{
				return digitalResurce;
			}
		}
		else if (resource instanceof org.iso.mpeg.mxm.engine.relTE.schema.relmx.DiReference)
		{
			org.iso.mpeg.mxm.relTE.schemahandler.resource.DiReference diReference = 
					new org.iso.mpeg.mxm.relTE.schemahandler.resource.DiReference((org.iso.mpeg.mxm.engine.relTE.schema.relmx.DiReference) resource);
			
			if (diReference.getLicensePartIdRef()!=null && inventory!=null)
			{
				for (LicensePart licensePart : inventory)
				{
					if (diReference.getLicensePartIdRef().equals(licensePart.getLicensePartIdRef())
							&& licensePart instanceof org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relmx.DiReference)
					{
						return (org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relmx.DiReference) licensePart;
					}
				}
			}
			else
			{
				return diReference;
			}
		}
		else if (resource instanceof org.iso.mpeg.mxm.engine.relTE.schema.relm1x.ProtectedResource)
		{
			org.iso.mpeg.mxm.relTE.schemahandler.resource.ProtectedResource protectedResource = 
					new org.iso.mpeg.mxm.relTE.schemahandler.resource.ProtectedResource(
							(org.iso.mpeg.mxm.engine.relTE.schema.relm1x.ProtectedResource) resource, securityEngine);
			
			if (protectedResource.getLicensePartIdRef()!=null && inventory!=null)
			{
				for (LicensePart licensePart : inventory)
				{
					if (protectedResource.getLicensePartIdRef().equals(licensePart.getLicensePartIdRef())
							&& licensePart instanceof org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relm1x.ProtectedResource)
					{
						return (org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relm1x.ProtectedResource) licensePart;
					}
				}
			}
			else
			{
				return protectedResource;
			}
		}
		
		return null;
	}

	@Override
	public List<ForAll> getForAll()
	{
		List<ForAll> forAllList = new ArrayList<ForAll>();
		
		for (org.iso.mpeg.mxm.engine.relTE.schema.relr.ForAll forAll : grantType.getForAll())
		{
			forAllList.add(new org.iso.mpeg.mxm.relTE.schemahandler.ForAll(forAll));
		}
		
		return forAllList;
	}

	@Override
	public DelegationControl getDelegationControl()
	{
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setDelegationControl(DelegationControl delegationControl)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public Principal getPrincipal()
	{
		org.iso.mpeg.mxm.engine.relTE.schema.relr.Principal principal = grantType.getPrincipal().getValue();
		
		if (principal instanceof org.iso.mpeg.mxm.engine.relTE.schema.relr.KeyHolder)
		{
			org.iso.mpeg.mxm.relTE.schemahandler.resource.principal.KeyHolder keyHolder = 
					new org.iso.mpeg.mxm.relTE.schemahandler.resource.principal.KeyHolder((KeyHolder) principal, securityEngine);
			
			if (keyHolder.getLicensePartIdRef()!=null && inventory!=null)
			{
				for (LicensePart licensePart : inventory)
				{
					if (keyHolder.getLicensePartIdRef().equals(licensePart.getLicensePartIdRef())
							&& licensePart instanceof org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.KeyHolder)
					{
						return (Principal) licensePart;
					}
				}
			}
			else
			{
				return keyHolder;
			}
		}
		else if (principal instanceof org.iso.mpeg.mxm.engine.relTE.schema.relm1x.IdentityHolder)
		{
			org.iso.mpeg.mxm.relTE.schemahandler.resource.principal.IdentityHolder identityHolder = 
					new org.iso.mpeg.mxm.relTE.schemahandler.resource.principal.IdentityHolder(
							(org.iso.mpeg.mxm.engine.relTE.schema.relm1x.IdentityHolder) principal);
			
			if (identityHolder.getLicensePartIdRef()!=null && inventory!=null)
			{
				for (LicensePart licensePart : inventory)
				{
					if (identityHolder.getLicensePartIdRef().equals(licensePart.getLicensePartIdRef())
							&& licensePart instanceof org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relm1x.IdentityHolder)
					{
						return (Principal) licensePart;
					}
				}
			}
			else
			{
				return identityHolder;
			}
		}
		else if (principal instanceof org.iso.mpeg.mxm.engine.relTE.schema.relr.Principal)
		{
			return new org.iso.mpeg.mxm.relTE.schemahandler.resource.principal.Principal(principal);
		}
		
		return null;
	}

	@Override
	public void setPrincipal(Principal principal)
	{
		try
		{
			grantType.setPrincipal((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Principal>)
					principal.createObject(JAXBElement.class.getCanonicalName()).getContent());
		} 
		catch (MXMException e)
		{
			e.printStackTrace();
		}
	}

	@Override
	public List<Condition> getConditions()
	{
		List<Condition> conditionsList = new ArrayList<Condition>();
		
		List<org.iso.mpeg.mxm.engine.relTE.schema.relr.Condition> conditionTypes = 
				new ArrayList<org.iso.mpeg.mxm.engine.relTE.schema.relr.Condition>();
		
		if (grantType.getCondition()!=null)
		{
			org.iso.mpeg.mxm.engine.relTE.schema.relr.Condition grantCondition = grantType.getCondition().getValue();
			
			if (grantCondition instanceof org.iso.mpeg.mxm.engine.relTE.schema.relr.AllConditions)
			{
				for (JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Condition> innerConditionJaxbElement : 
					((org.iso.mpeg.mxm.engine.relTE.schema.relr.AllConditions) grantCondition).getCondition())
				{
					conditionTypes.add(innerConditionJaxbElement.getValue());
				}
			}
			else
			{
				conditionTypes.add(grantCondition);
			}
			
			for (org.iso.mpeg.mxm.engine.relTE.schema.relr.Condition condition : conditionTypes)
			{
				// TODO make this return direct implementations
									
				if (condition instanceof org.iso.mpeg.mxm.engine.relTE.schema.relr.ValidityInterval)
				{
					conditionsList.add(new org.iso.mpeg.mxm.relTE.schemahandler.condition.ValidityInterval((org.iso.mpeg.mxm.engine.relTE.schema.relr.ValidityInterval)condition));
				}
				else
					conditionsList.add(new org.iso.mpeg.mxm.relTE.schemahandler.condition.Condition(condition));
			}
		}
		
		return conditionsList;
	}

	@Override
	public void setCondition(Condition condition)
	{
		try
		{
			grantType.setCondition((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Condition>)
					condition.createObject(JAXBElement.class.getCanonicalName()).getContent());
		} 
		catch (MXMException e)
		{
			e.printStackTrace();
		}
	}

	@Override
	public Right getRight()
	{
		// TODO make this return the complex right or just right.
		return new org.iso.mpeg.mxm.relTE.schemahandler.right.Right(grantType.getRight().getValue());
	}
	
	@Override
	public RELRight getRELRight()
	{
		org.iso.mpeg.mxm.engine.relTE.schema.relr.Right right = grantType.getRight().getValue();
		
		if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relmx.Adapt)
			return RELRight.adapt;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relm3x.Aggregate)
			return RELRight.aggregate;
//		else if (right.getClass().getCanonicalName().equalsIgnoreCase("eu.convergence.middleware.relTE.schema.rel_mx.Delete"))
//			return RELRight.delete;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relm1x.Delist)
			return RELRight.delist;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relmx.Diminish)
			return RELRight.diminish;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relm3x.Embed)
			return RELRight.embed;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relmx.Enhance)
			return RELRight.enhance;
//		else if (right.getClass().getCanonicalName().equalsIgnoreCase("eu.convergence.middleware.relTE.schema.rel_mx.Enlarge"))
//			return RELRight.enlarge;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relm1x.Enlist)
			return RELRight.enlist;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relmx.Execute)
			return RELRight.execute;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relm2x.Export)
			return RELRight.export;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relm2x.ExtendRights)
			return RELRight.extendRights;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relm3x.GovernedAdapt)
			return RELRight.governedAdapt;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relm3x.GovernedAggregate)
			return RELRight.governedAggregate;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relm1x.GovernedCopy)
			return RELRight.governedCopy;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relm3x.GovernedEmbed)
			return RELRight.governedEmbed;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relm1x.GovernedMove)
			return RELRight.governedMove;
//		else if (right.getClass().getCanonicalName().equalsIgnoreCase("eu.convergence.middleware.relTE.schema.rel_mx.Install"))
//			return RELRight.install;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relr.Issue)
			return RELRight.issue;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relmx.Modify)
			return RELRight.modify;
//		else if (right.getClass().getCanonicalName().equalsIgnoreCase("eu.convergence.middleware.relTE.schema.rel_mx.Move"))
//			return RELRight.move;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relr.Obtain)
			return RELRight.obtain;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relmx.Play)
			return RELRight.play;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relr.PossessProperty)
			return RELRight.possessProperty;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relmx.Print)
			return RELRight.print;
//		else if (right.getClass().getCanonicalName().equalsIgnoreCase("eu.convergence.middleware.relTE.schema.rel_mx.Reduce"))
//			return RELRight.reduce;
		else if (right instanceof org.iso.mpeg.mxm.engine.relTE.schema.relr.Revoke)
			return RELRight.revoke;
//		else if (right.getClass().getCanonicalName().equalsIgnoreCase("eu.convergence.middleware.relTE.schema.rel_mx.Uninstall"))
//			return RELRight.uninstall;
//		else
//			throw new RELEException("Unsupported right found.");
		
		return null;
	}
	
	@Override
	public void setRELRight(RELRight right)
	{
		try
		{
			if (right.equals(RELRight.adapt))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relmx.Adapt());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
			else if (right.equals(RELRight.aggregate))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relm3x.Aggregate());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
	//		else if (right.equals(RELRight.delete))
	//			return RELRight.delete;
			else if (right.equals(RELRight.delist))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relm1x.Delist());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
			else if (right.equals(RELRight.diminish))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relmx.Diminish());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
			else if (right.equals(RELRight.embed))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relm3x.Embed());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
			else if (right.equals(RELRight.enhance))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relmx.Enhance());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
	//		else if (right.equals(RELRight.Enlarge))
	//			return RELRight.enlarge;
			else if (right.equals(RELRight.enlist))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relm1x.Enlist());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
			else if (right.equals(RELRight.execute))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relmx.Execute());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
			else if (right.equals(RELRight.export))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relm2x.Export());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
			else if (right.equals(RELRight.extendRights))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relm2x.ExtendRights());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
			else if (right.equals(RELRight.governedAdapt))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relm3x.GovernedAdapt());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
			else if (right.equals(RELRight.governedAggregate))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relm3x.GovernedAggregate());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
			else if (right.equals(RELRight.governedCopy))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relm1x.GovernedCopy());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
			else if (right.equals(RELRight.governedEmbed))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relm3x.GovernedEmbed());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
			else if (right.equals(RELRight.governedMove))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relm1x.GovernedMove());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
	//		else if (right.equals(RELRight.install))
	//			return RELRight.install;
			else if (right.equals(RELRight.issue))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relr.Issue());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
			else if (right.equals(RELRight.modify))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relmx.Modify());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
	//		else if (right.equals(RELRight.move))
	//			return RELRight.move;
			else if (right.equals(RELRight.obtain))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relr.Obtain());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
			else if (right.equals(RELRight.play))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relmx.Play());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
			else if (right.equals(RELRight.possessProperty))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relr.PossessProperty());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
			else if (right.equals(RELRight.print))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relmx.Print());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
	//		else if (right.equals(RELRight.reduce))
	//			return RELRight.reduce;
			else if (right.equals(RELRight.revoke))
			{
				SuperRelAbstractLevel1 abstractLevel1 = new SuperRelAbstractLevel1(new org.iso.mpeg.mxm.engine.relTE.schema.relr.Revoke());
				grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>)
						abstractLevel1.createObject(JAXBElement.class.getCanonicalName()).getContent());
			}
	//		else if (right.equals(RELRight.uninstall))
	//			return RELRight.uninstall;
	//		else
	//			throw new RELEException("Unsupported right found.");
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}

	@Override
	public void setRight(Right right)
	{
		try
		{
			grantType.setRight((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.Right>) 
					right.createObject(JAXBElement.class.getCanonicalName()).getContent());
		} catch (MXMException e)
		{
			e.printStackTrace();
		}
	}

	@Override
	public EncryptedContent getEncryptedGrant()
	{
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setEncryptedGrant(EncryptedContent encryptedContent)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void addForAll(ForAll forAll)
	{
		try
		{
			grantType.getForAll().add((org.iso.mpeg.mxm.engine.relTE.schema.relr.ForAll)
					forAll.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relr.ForAll.class.getCanonicalName()).getContent());
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(grantType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperRelAbstractLevel1(grantType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperRelAbstractLevel1 superAbstract = new SuperRelAbstractLevel1(grantType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		grantType = (org.iso.mpeg.mxm.engine.relTE.schema.relr.Grant) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relr.Grant.class.getCanonicalName()).getContent();

		return repsonse;
	}

}
