package org.iso.mpeg.mxm.relTE.schemahandler.resource;

import java.io.File;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;
import org.iso.mpeg.mxm.relTE.schemahandler.common.LicensePart;

public class Resource extends LicensePart implements org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.Resource
{
	protected org.iso.mpeg.mxm.engine.relTE.schema.relr.Resource resourceType;
	
	public Resource()
	{
		this(new org.iso.mpeg.mxm.engine.relTE.schema.relr.Resource());
	}
	
	public Resource(org.iso.mpeg.mxm.engine.relTE.schema.relr.Resource resource)
	{
		super(resource);
		this.resourceType = resource;
	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(resourceType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperRelAbstractLevel1(resourceType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperRelAbstractLevel1 superAbstract = new SuperRelAbstractLevel1(resourceType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		resourceType = (org.iso.mpeg.mxm.engine.relTE.schema.relr.Resource) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relr.Resource.class.getCanonicalName()).getContent();

		super.parse(new MXMAdapter(resourceType));
		
		return repsonse;
	}
}
