package org.iso.mpeg.mxm.relTE.schemahandler.resource;

import java.io.File;

import javax.xml.bind.JAXBElement;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.ServiceDescription;
import org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.ServiceReferenceServiceParameters;

public class ServiceReference extends Resource implements org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.ServiceReference
{
	private org.iso.mpeg.mxm.engine.relTE.schema.relr.ServiceReference serviceReferenceType;
	
	public ServiceReference()
	{
		this(new org.iso.mpeg.mxm.engine.relTE.schema.relr.ServiceReference());
	}
	
	public ServiceReference(org.iso.mpeg.mxm.engine.relTE.schema.relr.ServiceReference serviceReference)
	{
		super(serviceReference);
		this.serviceReferenceType = serviceReference;
	}
	
	@Override
	public ServiceDescription getServiceDescription()
	{
		if (this.serviceReferenceType.getServiceDescription() != null)
		{
			org.iso.mpeg.mxm.engine.relTE.schema.relr.ServiceDescription serviceDescriptionType = serviceReferenceType.getServiceDescription().getValue();

			if (serviceDescriptionType instanceof  org.iso.mpeg.mxm.engine.relTE.schema.relm1x.ServiceLocation)
			{
				return new org.iso.mpeg.mxm.relTE.schemahandler.common.ServiceLocation((org.iso.mpeg.mxm.engine.relTE.schema.relm1x.ServiceLocation) serviceDescriptionType);
			}
			else if (serviceDescriptionType instanceof org.iso.mpeg.mxm.engine.relTE.schema.relr.ServiceDescription)
			{
				return new org.iso.mpeg.mxm.relTE.schemahandler.common.ServiceDescription(serviceDescriptionType);
			}
			// TODO add more service descriptions
		}
		
		return null;
	}

	@Override
	public void setServiceDescription(ServiceDescription serviceDescription)
	{
		try
		{
			serviceReferenceType.setServiceDescription(((JAXBElement<? extends org.iso.mpeg.mxm.engine.relTE.schema.relr.ServiceDescription>)
					serviceDescription.createObject(JAXBElement.class.getCanonicalName()).getContent()));
		} 
		catch (MXMException e)
		{
			e.printStackTrace();
		}
	}

	@Override
	public ServiceReferenceServiceParameters getServiceParameters()
	{
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setServiceParameters(ServiceReferenceServiceParameters serviceParameters)
	{
		// TODO Auto-generated method stub
		
	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(serviceReferenceType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperRelAbstractLevel1(serviceReferenceType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperRelAbstractLevel1 superAbstract = new SuperRelAbstractLevel1(serviceReferenceType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		serviceReferenceType = (org.iso.mpeg.mxm.engine.relTE.schema.relr.ServiceReference) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relr.ServiceReference.class.getCanonicalName()).getContent();

		super.parse(new MXMAdapter(serviceReferenceType));
		
		return repsonse;
	}

}
