package org.iso.mpeg.mxm.relTE.schemahandler.resource.principal;

import java.io.File;
import java.io.Serializable;
import java.util.List;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;
import org.iso.mpeg.mxm.engine.relTE.schema.relm1x.IdentityHolder.IdValue;

public class IdentityHolder extends Principal implements org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relm1x.IdentityHolder
{
	private org.iso.mpeg.mxm.engine.relTE.schema.relm1x.IdentityHolder identityHolderType;
	
	public IdentityHolder()
	{
		this(new org.iso.mpeg.mxm.engine.relTE.schema.relm1x.IdentityHolder());
	}
	
	public IdentityHolder(org.iso.mpeg.mxm.engine.relTE.schema.relm1x.IdentityHolder identityHolder)
	{
		super(identityHolder);
		this.identityHolderType = identityHolder;
	}
	
	@Override
	public List<Serializable> getIdValues()
	{
		if (identityHolderType.getIdValue()!=null)
		{
			return identityHolderType.getIdValue().getContent();
		}
		
		return null;
	}

	@Override
	public String getIdSystem()
	{
		return identityHolderType.getIdSystem();
	}

	@Override
	public void setIdSystem(String string)
	{
		identityHolderType.setIdSystem(string);
	}

	@Override
	public void addIdValue(Serializable idValue)
	{
		if (identityHolderType.getIdValue()==null)
		{
			identityHolderType.setIdValue(new IdValue());
		}
		
		identityHolderType.getIdValue().getContent().add(idValue);
	}
	
	public boolean equals(org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.Principal principal)
	{
		if (principal instanceof org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relm1x.IdentityHolder)
		{
			org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relm1x.IdentityHolder identityHolder = 
					(org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relm1x.IdentityHolder) principal;
			
			String myIDSys = getIdSystem();
			String myIDVal = (String) getIdValues().get(0); // TODO copied from MXM
	
			String otherIDSys = identityHolder.getIdSystem();
			String otherIDVal = (String) identityHolder.getIdValues().get(0);
		
			return compareId(myIDSys, otherIDSys) && compareId(myIDVal, otherIDVal);
		}
		
		return false;
	}
	
	private boolean compareId (String myID, String otherID)
	{
		return myID != null && otherID != null && myID.equals(otherID);
	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(identityHolderType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperRelAbstractLevel1(identityHolderType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperRelAbstractLevel1 superAbstract = new SuperRelAbstractLevel1(identityHolderType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		identityHolderType = (org.iso.mpeg.mxm.engine.relTE.schema.relm1x.IdentityHolder) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relm1x.IdentityHolder.class.getCanonicalName()).getContent();

		return repsonse;
	}
	
}
