package org.iso.mpeg.mxm.relTE.schemahandler.resource.principal;

import java.io.File;

import javax.xml.bind.JAXBElement;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;
import org.iso.mpeg.mxm.tEngine.relTE.exception.RELEngineException;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.KeyInfo;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Signature;


public class KeyHolder extends Principal implements org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.KeyHolder
{
	private org.iso.mpeg.mxm.engine.relTE.schema.relr.KeyHolder keyHolderType;
	
	SecurityEngine SECengine;
	
	public KeyHolder(SecurityEngine securityEngine)
	{
		this(new org.iso.mpeg.mxm.engine.relTE.schema.relr.KeyHolder(), securityEngine);		
		
		this.SECengine = securityEngine;
	}
	
	public KeyHolder(org.iso.mpeg.mxm.engine.relTE.schema.relr.KeyHolder keyHolder, SecurityEngine securityEngine)
	{
		super(keyHolder);
		this.keyHolderType = keyHolder;
		this.SECengine = securityEngine;
	}
	
	@Override
	public void setKeyInfo(KeyInfo keyInfo)
	{
		try
		{
			keyHolderType.setInfo((org.iso.mpeg.mxm.engine.securityTE.schema.dsig.KeyInfoType)
					keyInfo.createObject(org.iso.mpeg.mxm.engine.securityTE.schema.dsig.KeyInfoType.class.getCanonicalName()).getContent());
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
	}

	@Override
	public KeyInfo getKeyInfo() throws RELEngineException
	{
			KeyInfo ki;
			try {
				ki = SECengine.getSecurityEngineSchemaHandler().getKeyInfo();
				ki.parse(new MXMAdapter(keyHolderType.getInfo()));
			} catch (MXMEngineException e) {
				throw new RELEngineException(e.getMessage());
			}

			return ki;
	}
	
	public boolean equals(org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.Principal principal) throws MXMEngineException
	{
		if (principal instanceof org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.KeyHolder)
		{
			org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.KeyHolder keyHolder = 
					(org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.KeyHolder) principal;
			
			KeyInfo keyInfo1 = getKeyInfo();
			KeyInfo keyInfo2 = keyHolder.getKeyInfo();
				
			return keyInfo1!=null && keyInfo2!=null && keyInfo1.equals(keyInfo2);
		}
		
		return false;
	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(keyHolderType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperRelAbstractLevel1(keyHolderType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperRelAbstractLevel1 superAbstract = new SuperRelAbstractLevel1(keyHolderType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		keyHolderType = (org.iso.mpeg.mxm.engine.relTE.schema.relr.KeyHolder) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relr.KeyHolder.class.getCanonicalName()).getContent();

		return repsonse;
	}

}
