package org.iso.mpeg.mxm.relTE.schemahandler.right;

import java.io.File;

import javax.xml.namespace.QName;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;

public class GovernedCopy extends Right implements org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relm1x.GovernedCopy
{
	private org.iso.mpeg.mxm.engine.relTE.schema.relm1x.GovernedCopy governedCopyType;
	
	public GovernedCopy()
	{
		this(new org.iso.mpeg.mxm.engine.relTE.schema.relm1x.GovernedCopy());
	}
	
	public GovernedCopy(org.iso.mpeg.mxm.engine.relTE.schema.relm1x.GovernedCopy governedCopy)
	{
		super(governedCopy);
		this.governedCopyType = governedCopy;
	}
	
	@Override
	public QName getGovernanceRule()
	{
		return governedCopyType.getGovernanceRule();
	}

	@Override
	public void setGovernanceRule(QName qName)
	{
		governedCopyType.setGovernanceRule(qName);
	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(governedCopyType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperRelAbstractLevel1(governedCopyType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperRelAbstractLevel1 superAbstract = new SuperRelAbstractLevel1(governedCopyType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		governedCopyType = (org.iso.mpeg.mxm.engine.relTE.schema.relm1x.GovernedCopy) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relm1x.GovernedCopy.class.getCanonicalName()).getContent();

		return repsonse;
	}

}
