package org.iso.mpeg.mxm.relTE.schemahandler.right;

import java.io.File;

import javax.xml.namespace.QName;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;

public class GovernedMove extends Right implements org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relm1x.GovernedMove
{
	private org.iso.mpeg.mxm.engine.relTE.schema.relm1x.GovernedMove governedMoveType;
	
	public GovernedMove()
	{
		this(new org.iso.mpeg.mxm.engine.relTE.schema.relm1x.GovernedMove());
	}
	
	public GovernedMove(org.iso.mpeg.mxm.engine.relTE.schema.relm1x.GovernedMove governedMove)
	{
		super(governedMove);
		this.governedMoveType = governedMove;
	}
	
	@Override
	public QName getGovernanceRule()
	{
		return governedMoveType.getGovernanceRule();
	}

	@Override
	public void setGovernanceRule(QName qName)
	{
		governedMoveType.setGovernanceRule(qName);
	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(governedMoveType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperRelAbstractLevel1(governedMoveType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperRelAbstractLevel1 superAbstract = new SuperRelAbstractLevel1(governedMoveType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		governedMoveType = (org.iso.mpeg.mxm.engine.relTE.schema.relm1x.GovernedMove) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relm1x.GovernedMove.class.getCanonicalName()).getContent();

		return repsonse;
	}

}
