package org.iso.mpeg.mxm.relTE.schemahandler.right;

import java.io.File;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;
import org.iso.mpeg.mxm.relTE.schemahandler.common.LicensePart;

public class Right extends LicensePart implements org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relr.Right
{
	private org.iso.mpeg.mxm.engine.relTE.schema.relr.Right rightType;
	
	public Right()
	{
		this(new org.iso.mpeg.mxm.engine.relTE.schema.relr.Right());
	}
	
	public Right(org.iso.mpeg.mxm.engine.relTE.schema.relr.Right right)
	{
		super(right);
		this.rightType = right;
	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(rightType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperRelAbstractLevel1(rightType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperRelAbstractLevel1 superAbstract = new SuperRelAbstractLevel1(rightType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		rightType = (org.iso.mpeg.mxm.engine.relTE.schema.relr.Right) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relr.Right.class.getCanonicalName()).getContent();

		return repsonse;
	}
}