package org.iso.mpeg.mxm.relTE.schemahandler.right;

import java.io.File;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;

public class RightUri extends Right implements org.iso.mpeg.mxm.tEngine.relTE.schemahandler.relsx.RightUri
{
	private org.iso.mpeg.mxm.engine.relTE.schema.relsx.RightUri rightUriType;
	
	public RightUri()
	{
		this(new org.iso.mpeg.mxm.engine.relTE.schema.relsx.RightUri());
	}
	
	public RightUri(org.iso.mpeg.mxm.engine.relTE.schema.relsx.RightUri rightUri)
	{
		super(rightUri);
		this.rightUriType = rightUri;
	}
	
	@Override
	public String getDefinition()
	{
		return rightUriType.getDefinition();
	}

	@Override
	public void setDefinition(String string)
	{
		rightUriType.setDefinition(string);
	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(rightUriType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperRelAbstractLevel1(rightUriType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperRelAbstractLevel1 superAbstract = new SuperRelAbstractLevel1(rightUriType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		rightUriType = (org.iso.mpeg.mxm.engine.relTE.schema.relsx.RightUri) 
				superAbstract.createObject(org.iso.mpeg.mxm.engine.relTE.schema.relsx.RightUri.class.getCanonicalName()).getContent();

		return repsonse;
	}

}
