package org.iso.mpeg.mxm.searchTE.schemahandler;


import java.io.File;

import javax.xml.datatype.Duration;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;
import org.iso.mpeg.mxm.engine.searchTE.schema.SuperMpqfAbstractLevel1;
import org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.InputQueryType;
import org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.OutputDescriptionType;
import org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.QueryConditionType;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.OutputDescription;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.QFDeclaration;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.QueryCondition;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.ServiceSelection;

public class InputQuery implements org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.InputQuery
{
	private InputQueryType inputQueryType;
	
	public InputQuery() throws MXMEngineException
	{
		this(new InputQueryType());
	}

	public InputQuery(InputQueryType inputQueryType) throws MXMEngineException
	{
		this.inputQueryType = inputQueryType;
	}
	
	public OutputDescription getOutputDescription()
	{
		if (inputQueryType.getOutputDescription()!=null)
		{
			return new org.iso.mpeg.mxm.searchTE.schemahandler.OutputDescription(inputQueryType.getOutputDescription());
		}
		
		return null;
	}
	
	public QueryCondition getQueryCondition()
	{
		if (inputQueryType.getQueryCondition()!=null)
		{
			return new org.iso.mpeg.mxm.searchTE.schemahandler.QueryCondition(inputQueryType.getQueryCondition());
		}
		
		return null;
	}
	
//	public List<QFDeclarationPrefix> getPrefices()
//	{
//		if (inputQueryType.getQFDeclaration()!=null)
//		{
//			return inputQueryType.getQFDeclaration().getPrefix();
//		}
//		
//		return null;
//	}
//	
//	public void addPrefix(String name, String uri)
//	{
//		Prefix prefix = new Prefix();
//		prefix.setName(name);
//		prefix.setUri(uri);
//		
//		if (inputQueryType.getQFDeclaration()==null)
//		{
//			inputQueryType.setQFDeclaration(new QFDeclarationType());
//		}
//		
//		QFDeclarationType qfDeclaration = inputQueryType.getQFDeclaration();
//		
//		qfDeclaration.getPrefix().add(prefix);
//	}
	
	public void setOutputDescription(OutputDescription outputDescription)
	{
		try
		{
			inputQueryType.setOutputDescription((OutputDescriptionType)outputDescription.createObject(OutputDescriptionType.class.getCanonicalName()).getContent());
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
	}
	
	public void setQueryCondition(QueryCondition queryCondition)
	{
		try
		{
			inputQueryType.setQueryCondition((QueryConditionType)queryCondition.createObject(QueryConditionType.class.getCanonicalName()).getContent());
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
	}

	@Override
	public QFDeclaration getQFDeclaration()
	{
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setQFDeclaration(QFDeclaration qFDeclaration)
	{
		// TODO Auto-generated method stub
	
	}

	@Override
	public ServiceSelection getServiceSelection()
	{
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setServiceSelection(ServiceSelection serviceSelection)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public String getPreviousAnswerID()
	{
		return inputQueryType.getPreviousAnswerID();
	}

	@Override
	public void setPreviousAnswerID(String string)
	{
		inputQueryType.setPreviousAnswerID(string);
	}

	@Override
	public boolean isImmediateResponse()
	{
		return inputQueryType.isImmediateResponse();
	}

	@Override
	public void setImmediateResponse(Boolean b)
	{
		inputQueryType.setImmediateResponse(b);		
	}

	@Override
	public void setTimeout(Duration duration)
	{
		inputQueryType.setTimeout(duration);
	}

	@Override
	public Duration getTimeout()
	{
		return inputQueryType.getTimeout();
	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(inputQueryType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperMpqfAbstractLevel1(inputQueryType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperMpqfAbstractLevel1 superAbstract = new SuperMpqfAbstractLevel1(inputQueryType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		inputQueryType = (InputQueryType) 
				superAbstract.createObject(InputQueryType.class.getCanonicalName()).getContent();

		return repsonse;
	}

}
