package org.iso.mpeg.mxm.searchTE.schemahandler;

import java.io.File;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;
import org.iso.mpeg.mxm.engine.searchTE.schema.SuperMpqfAbstractLevel1;
import org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.FieldType;
import org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.OutputDescriptionType;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.AbstractSortBy;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.Field;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.OutputDescriptionGroupBy;


public class OutputDescription implements org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.OutputDescription
{
	private OutputDescriptionType outputDescriptionType;
	
	// Constructors //
	
	public OutputDescription()
	{
		this(new OutputDescriptionType());
	}
	
	public OutputDescription(OutputDescriptionType ouputDescriptionType)
	{
		this.outputDescriptionType = ouputDescriptionType;
	}
	
	@Override
	public void addRequestedField(Field field)
	{
		try
		{
			outputDescriptionType.getReqField().add((FieldType) field.createObject(FieldType.class.getCanonicalName()).getContent());
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}
	
	@Override
	public List<Field> getRequestedFieldList()
	{
		List<Field> reqField = new ArrayList<Field>();
		
		for (FieldType field : outputDescriptionType.getReqField())
		{
			reqField.add(new org.iso.mpeg.mxm.searchTE.schemahandler.common.Field(field));
		}
		
		return reqField;
	}
	
	@Override
	public void addRequestedSemanticField(String semanticField)
	{
		outputDescriptionType.getReqSemanticField().add(semanticField);
	}
	
	@Override
	public List<String> getRequestedSemanticFieldList()
	{
		return outputDescriptionType.getReqSemanticField();
	}
	
	@Override
	public OutputDescriptionGroupBy getGroupBy()
	{
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setGroupBy(OutputDescriptionGroupBy groupBy)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void addSortBy(AbstractSortBy sortBy)
	{
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public List<AbstractSortBy> getSortByList()
	{
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public BigInteger getMaxPageEntries()
	{
		return outputDescriptionType.getMaxPageEntries();
	}

	@Override
	public void setMaxPageEntries(BigInteger bigInteger)
	{
		outputDescriptionType.setMaxPageEntries(bigInteger);
	}

	@Override
	public void setMaxItemCount(BigInteger bigInteger)
	{
		outputDescriptionType.setMaxItemCount(bigInteger);
	}
	
	@Override
	public BigInteger getMaxItemCount()
	{
		return outputDescriptionType.getMaxItemCount();
	}

	@Override
	public Boolean isFreeTextUse()
	{
		return outputDescriptionType.isFreeTextUse();
	}

	@Override
	public void setFreeTextUse(Boolean b)
	{
		outputDescriptionType.setFreeTextUse(b);
	}

	@Override
	public Boolean isThumbnailUse()
	{
		return outputDescriptionType.isThumbnailUse();
	}

	@Override
	public void setThumbnailUse(Boolean b)
	{
		outputDescriptionType.setThumbnailUse(b);
	}

	@Override
	public Boolean isMediaResourceUse()
	{
		return outputDescriptionType.isMediaResourceUse();
	}

	@Override
	public void setMediaResourceUse(Boolean b)
	{
		outputDescriptionType.setMediaResourceUse(b);
	}

	@Override
	public String getOutputNameSpace()
	{
		return outputDescriptionType.getOutputNameSpace();
	}

	@Override
	public void setOutputNameSpace(String string)
	{
		outputDescriptionType.setOutputNameSpace(string);		
	}

	@Override
	public boolean isDistinct()
	{
		return outputDescriptionType.isDistinct();
	}

	@Override
	public void setDistinct(Boolean b)
	{
		outputDescriptionType.setDistinct(b);		
	}

	@Override
	public List<String> getReqAggregateIDList()
	{
		// TODO Auto-generated method stub
		return null;
	}
	
	@Override
	public void addReqAggregateID(String id)
	{
		// TODO Auto-generated method stub
		
	}
	
//	public List<SortByFieldType> getSortByFieldList()
//	{
//		if (outputDescriptionType.getSortBy()!=null)
//		{
//			List<SortByFieldType> sortByFieldTypeList = new ArrayList<SortByFieldType>();
//			for (AbstractSortByType sortBy : outputDescriptionType.getSortBy())
//			{
//				if (sortBy instanceof SortByFieldType)
//				{
//					sortByFieldTypeList.add((SortByFieldType)sortBy);
//				}
//			}
//			
//			return sortByFieldTypeList;
//		}
//		
//		return null;
//	}
//	
//	public void addSortByField(String fieldName, boolean ascending)
//	{
//		FieldType fieldType = factory.createFieldType();
//		fieldType.setValue(fieldName);
//		
//		SortByFieldType sortByFieldType = factory.createSortByFieldType();
//		sortByFieldType.setField(fieldType);
//
//		if (ascending)
//		{
//			sortByFieldType.setOrder("ascending");
//		}
//		else
//		{
//			sortByFieldType.setOrder("descending");
//		}
//		
//		outputDescriptionType.getSortBy().add(sortByFieldType);
//	}
//	
//	public void addSortBySemanticField(String var, boolean ascending)
//	{
//		SemanticFieldType semanticFieldType = factory.createSemanticFieldType();
//		semanticFieldType.setVar(var);
//		
//		SortByFieldType sortByFieldType = factory.createSortByFieldType();
//		sortByFieldType.setSemanticField(semanticFieldType);
//		
//		if (ascending)
//		{
//			sortByFieldType.setOrder("ascending");
//		}
//		else
//		{
//			sortByFieldType.setOrder("descending");
//		}
//		
//		outputDescriptionType.getSortBy().add(sortByFieldType);
//	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(outputDescriptionType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperMpqfAbstractLevel1(outputDescriptionType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperMpqfAbstractLevel1 superAbstract = new SuperMpqfAbstractLevel1(outputDescriptionType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		outputDescriptionType = (OutputDescriptionType) 
				superAbstract.createObject(OutputDescriptionType.class.getCanonicalName()).getContent();

		return repsonse;
	}

}
