package org.iso.mpeg.mxm.searchTE.schemahandler;

import java.io.File;
import java.util.List;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;
import org.iso.mpeg.mxm.engine.searchTE.schema.SuperMpqfAbstractLevel1;
import org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.BooleanExpressionType;
import org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.QueryConditionType;
import org.iso.mpeg.mxm.searchTE.schemahandler.expression.boollean.AND;
import org.iso.mpeg.mxm.searchTE.schemahandler.expression.boollean.OR;
import org.iso.mpeg.mxm.searchTE.schemahandler.expression.comparison.Equal;
import org.iso.mpeg.mxm.searchTE.schemahandler.expression.comparison.GreaterThan;
import org.iso.mpeg.mxm.searchTE.schemahandler.expression.comparison.LessThan;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.BooleanExpression;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.Join;


public class QueryCondition implements org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.QueryCondition
{
	private QueryConditionType queryConditionType;
	
	// Constructors //
	
	public QueryCondition()
	{
		this(new QueryConditionType());
	}

	public QueryCondition(QueryConditionType queryConditionType)
	{
		this.queryConditionType = queryConditionType;
	}
	
	public BooleanExpression getCondition()
	{
		try
		{
			if (queryConditionType.getCondition()!=null)
			{
				BooleanExpressionType booleanExpression = queryConditionType.getCondition();
				
				if (booleanExpression instanceof org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.AND)
				{
					return new AND((org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.AND)booleanExpression);
				}
				if (booleanExpression instanceof org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.OR)
				{
					return new OR((org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.OR)booleanExpression);
				}
				else if (booleanExpression instanceof org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.Equal)
				{
					return  new Equal((org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.Equal)booleanExpression);
				}
				else if (booleanExpression instanceof org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.GreaterThan)
				{
					return new GreaterThan((org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.GreaterThan)booleanExpression);
				}
				else if (booleanExpression instanceof org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.LessThan)
				{
					return  new LessThan((org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.LessThan)booleanExpression);
				}
	//			else if (booleanExpression instanceof org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.QueryByDescription)
	//			{
	//				return  new QueryByDescription((org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.QueryByDescription)booleanExpression);
	//			}
				else if (booleanExpression instanceof org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.QueryBySPARQL)
				{
					return  new QueryBySPARQL((org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.QueryBySPARQL)booleanExpression);
				}
			}
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
		
		return null;
	}
	
	public void setCondition(BooleanExpression booleanExpression)
	{
		try
		{
			queryConditionType.setCondition((BooleanExpressionType)booleanExpression.createObject(BooleanExpressionType.class.getCanonicalName()).getContent());
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}
	
	@Override
	public Join getJoin()
	{
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setJoin(Join join)
	{
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public String getEvaluationPath()
	{
		return queryConditionType.getEvaluationPath();
	}

	@Override
	public void setEvaluationPath(String string)
	{
		queryConditionType.setEvaluationPath(string);
	}

	@Override
	public List<String> getTargetMedia()
	{
		return queryConditionType.getTargetMediaType();
	}

	@Override
	public void addTargetMedia(String mimeType)
	{
		queryConditionType.getTargetMediaType().add(mimeType);
	}

	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(queryConditionType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperMpqfAbstractLevel1(queryConditionType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperMpqfAbstractLevel1 superAbstract = new SuperMpqfAbstractLevel1(queryConditionType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		queryConditionType = (QueryConditionType) 
				superAbstract.createObject(QueryConditionType.class.getCanonicalName()).getContent();

		return repsonse;
	}

}
