package org.iso.mpeg.mxm.searchTE.schemahandler.common;

import java.io.File;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;
import org.iso.mpeg.mxm.engine.searchTE.schema.SuperMpqfAbstractLevel1;
import org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.BooleanExpressionType;

public abstract class BooleanExpression implements org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.BooleanExpression
{
	protected BooleanExpressionType booleanExpressionType;

	public BooleanExpression(BooleanExpressionType booleanExpressionType)
	{
		this.booleanExpressionType = booleanExpressionType;
	}
	
	@Override
	public float getPreferenceValue()
	{
		return booleanExpressionType.getPreferenceValue();
	}

	@Override
	public void setPreferenceValue(Float f)
	{
		booleanExpressionType.setPreferenceValue(f);
	}

	@Override
	public Float getThresholdValue()
	{
		return booleanExpressionType.getThresholdValue();
	}

	@Override
	public void setThresholdValue(Float f)
	{
		booleanExpressionType.setThresholdValue(f);
	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(booleanExpressionType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperMpqfAbstractLevel1(booleanExpressionType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperMpqfAbstractLevel1 superAbstract = new SuperMpqfAbstractLevel1(booleanExpressionType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		booleanExpressionType = (BooleanExpressionType) 
				superAbstract.createObject(BooleanExpressionType.class.getCanonicalName()).getContent();

		return repsonse;
	}
}
