package org.iso.mpeg.mxm.searchTE.schemahandler.common;

import java.io.File;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.relTE.schema.SuperRelAbstractLevel1;
import org.iso.mpeg.mxm.engine.searchTE.schema.SuperMpqfAbstractLevel1;
import org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.FieldType;

public class Field implements org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.Field
{
	protected FieldType fieldType;

	public Field()
	{
		this(new FieldType());
	}
	
	public Field(FieldType fieldType)
	{
		this.fieldType = fieldType;
	}
	
	@Override
	public String getFromREF()
	{
		return fieldType.getFromREF().toString();
	}

	@Override
	public void setFromREF(String object)
	{
		fieldType.setFromREF(object);
	}

	@Override
	public void setTypeName(String string)
	{
		fieldType.setTypeName(string);
	}

	@Override
	public String getFieldREF()
	{
		return fieldType.getFieldREF().toString();
	}

	@Override
	public void setFieldREF(String object)
	{
		fieldType.setFieldREF(object);
	}

	@Override
	public String getResultMode()
	{
		return fieldType.getResultMode();
	}

	@Override
	public void setResultMode(String string)
	{
		fieldType.setResultMode(string);
	}

	@Override
	public String getValue()
	{
		return fieldType.getValue();
	}

	@Override
	public String getTypeName()
	{
		return fieldType.getTypeName();
	}

	@Override
	public void setValue(String string)
	{
		fieldType.setValue(string);
	}
	
	// MXM CREATOR AND PARSER METHODS

	@Override
	public void createFile(File f) throws MXMException
	{
		new SuperRelAbstractLevel1(fieldType).createFile(f);
	}

	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		return new SuperMpqfAbstractLevel1(fieldType).createObject(objectType);
	}

	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperMpqfAbstractLevel1 superAbstract = new SuperMpqfAbstractLevel1(fieldType);

		MXMEngineResponse repsonse = superAbstract.parse(object);

		fieldType = (FieldType) 
				superAbstract.createObject(FieldType.class.getCanonicalName()).getContent();

		return repsonse;
	}
	
}
