package org.iso.mpeg.mxm.searchTE.schemahandler.expression.comparison;

import java.util.List;

import javax.xml.bind.JAXBElement;
import javax.xml.datatype.Duration;
import javax.xml.datatype.XMLGregorianCalendar;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.ArithmeticExpressionType;
import org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.FieldType;
import org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.ObjectFactory;
import org.iso.mpeg.mxm.searchTE.schemahandler.common.ComparisonExpression;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.ArithmeticExpression;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.BooleanExpression;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.Field;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.StringExpression;

public class Equal extends ComparisonExpression implements org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.Equal
{
	// Constructors //
	
	public Equal()
	{
		this(new org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.Equal());
	}

	public Equal(org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.Equal equalType)
	{
		super(equalType);
	}
	
	// Getters //
	
	@Override
	public Field getField()
	{
		try
		{
			org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.Equal equalType = 
					(org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.Equal) booleanExpressionType;
			
			List objectList = null;
			
			if (equalType.getArithmeticOperands().size()>0)
			{
				objectList = equalType.getArithmeticOperands();
			}
			else if (equalType.getBooleanOperands().size()>0)
			{
				objectList = equalType.getBooleanOperands();
			}
			else if (equalType.getDateTimeOperands().size()>0)
			{
				objectList = equalType.getDateTimeOperands();
			}
			else if (equalType.getDurationOperands().size()>0)
			{
				objectList = equalType.getDurationOperands();
			}
			else if (equalType.getStringOperands().size()>0)
			{
				objectList = equalType.getStringOperands();
			}
			
			for (Object object : objectList)
			{
				if (object instanceof FieldType)
				{
					Field field = new org.iso.mpeg.mxm.searchTE.schemahandler.common.Field();
					field.parse(new MXMAdapter(object));
					
					return field;
				}
			}
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		
		return null;
	}
	
	public Object getValue()
	{
		org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.Equal equalType = 
				(org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.Equal) booleanExpressionType;
		
		if (equalType.getDateTimeOperands().size()>0)
		{
			for (JAXBElement jaxbElement : equalType.getDateTimeOperands())
			{
				if (jaxbElement.getValue() instanceof XMLGregorianCalendar)
				{
					return (XMLGregorianCalendar) jaxbElement.getValue();
				}
			}
		}
		else if (equalType.getArithmeticOperands().size()>0)
		{
			for (Object object : equalType.getArithmeticOperands())
			{
				if (object instanceof Double)
				{
					return object;
				}
				else if (object instanceof Long)
				{
					return object;
				}
				else if (object instanceof ArithmeticExpressionType)
				{
					// TODO add Arithemetic Expression
				}
			}
		}
		else if (equalType.getStringOperands().size()>0)
		{
			for (Object object : equalType.getStringOperands())
			{
				if (object instanceof String)
				{
					return object;
				}
			}
		}
		else if (equalType.getBooleanOperands().size()>0)
		{
			// TODO
		}
		else if (equalType.getDurationOperands().size()>0)
		{
			// TODO
		}
		
		return null;
	}
	
	// Setters //
	
	@Override
	public void setComparisonExpression(Field field, Object value)
	{
		try
		{
			org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.Equal equalType = 
					(org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.Equal) booleanExpressionType;
			
			if (value instanceof Long)
			{
				equalType.getArithmeticOperands().add(field.createObject((FieldType.class.getCanonicalName())).getContent());
				equalType.getArithmeticOperands().add(value);
			}
			else if (value instanceof Double)
			{
				equalType.getArithmeticOperands().add(field.createObject((FieldType.class.getCanonicalName())).getContent());
				equalType.getArithmeticOperands().add(value);
			}
			else if (value instanceof XMLGregorianCalendar)
			{
				ObjectFactory objectFactory = new ObjectFactory();
				JAXBElement fieldElement = objectFactory.createEqualDateTimeField((FieldType)field.createObject((FieldType.class.getCanonicalName())).getContent());
				JAXBElement dateTimeElement = objectFactory.createEqualDateTimeValue((XMLGregorianCalendar) value);
				
				equalType.getDateTimeOperands().add(fieldElement);
				equalType.getDateTimeOperands().add(dateTimeElement);
			}
			else if (value instanceof Boolean)
			{
				equalType.getBooleanOperands().add(field.createObject((FieldType.class.getCanonicalName())).getContent());
				equalType.getBooleanOperands().add(value);
			}
			else if (value instanceof String)
			{
				equalType.getStringOperands().add(field.createObject((FieldType.class.getCanonicalName())).getContent());
				equalType.getStringOperands().add(value);
			}
			else if (value instanceof Duration)
			{
				equalType.getDurationOperands().add(field.createObject((FieldType.class.getCanonicalName())).getContent());
				equalType.getDurationOperands().add(value);
			}
			else if (value instanceof StringExpression)
			{
				// TODO Auto-generated method stub
			}
			else if (value instanceof ArithmeticExpression)
			{
				// TODO Auto-generated method stub
			}
			else if (value instanceof BooleanExpression)
			{
				// TODO Auto-generated method stub
			}
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}
	
}
