package org.iso.mpeg.mxm.searchTE.schemahandler.expression.comparison;

import java.util.List;

import javax.xml.bind.JAXBElement;
import javax.xml.datatype.Duration;
import javax.xml.datatype.XMLGregorianCalendar;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.ArithmeticExpressionType;
import org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.FieldType;
import org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.ObjectFactory;
import org.iso.mpeg.mxm.searchTE.schemahandler.common.ComparisonExpression;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.ArithmeticExpression;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.Field;

public class GreaterThan extends ComparisonExpression implements org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.GreaterThan
{
	// Constructors //
	
	public GreaterThan()
	{
		this(new org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.GreaterThan());
	}

	public GreaterThan(org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.GreaterThan greaterThanType)
	{
		super(greaterThanType);
	}
	
	// Getters //
	
	@Override
	public Field getField()
	{
		try
		{
			org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.GreaterThan equalType = 
					(org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.GreaterThan) booleanExpressionType;
			
			List objectList = null;
			
			if (equalType.getArithmeticOperands().size()>0)
			{
				objectList = equalType.getArithmeticOperands();
			}
			else if (equalType.getDateTimeOperands().size()>0)
			{
				objectList = equalType.getDateTimeOperands();
			}
			else if (equalType.getDurationOperands().size()>0)
			{
				objectList = equalType.getDurationOperands();
			}
			
			for (Object object : objectList)
			{
				if (object instanceof FieldType)
				{
					Field field = new org.iso.mpeg.mxm.searchTE.schemahandler.common.Field();
					field.parse(new MXMAdapter(object));
					
					return field;
				}
			}
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		
		return null;
	}
	
	public Object getValue()
	{
		org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.GreaterThan greaterThanType = 
				(org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.GreaterThan) booleanExpressionType;
		
		if (greaterThanType.getDateTimeOperands().size()>0)
		{
			for (JAXBElement jaxbElement : greaterThanType.getDateTimeOperands())
			{
				if (jaxbElement.getValue() instanceof XMLGregorianCalendar)
				{
					return (XMLGregorianCalendar) jaxbElement.getValue();
				}
			}
		}
		else if (greaterThanType.getArithmeticOperands().size()>0)
		{
			for (Object object : greaterThanType.getArithmeticOperands())
			{
				if (object instanceof Double)
				{
					return object;
				}
				else if (object instanceof Long)
				{
					return object;
				}
				else if (object instanceof ArithmeticExpressionType)
				{
					// TODO add Arithemetic Expression
				}
			}
		}
		else if (greaterThanType.getDurationOperands().size()>0)
		{
			// TODO
		}
		
		return null;
	}
	
	// Setters //
	
	@Override
	public void setComparisonExpression(Field field, Object value)
	{
		try
		{
			org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.GreaterThan greaterThanType = 
					(org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.GreaterThan) booleanExpressionType;
			
			if (value instanceof Long)
			{
				greaterThanType.getArithmeticOperands().add(field.createObject((FieldType.class.getCanonicalName())).getContent());
				greaterThanType.getArithmeticOperands().add(value);
			}
			else if (value instanceof Double)
			{
				greaterThanType.getArithmeticOperands().add(field.createObject((FieldType.class.getCanonicalName())).getContent());
				greaterThanType.getArithmeticOperands().add(value);
			}
			else if (value instanceof XMLGregorianCalendar)
			{
				ObjectFactory objectFactory = new ObjectFactory();
				JAXBElement fieldElement = objectFactory.createGreaterThanDateTimeField((FieldType)field.createObject((FieldType.class.getCanonicalName())).getContent());
				JAXBElement dateTimeElement = objectFactory.createGreaterThanDateTimeValue((XMLGregorianCalendar) value);
				
				greaterThanType.getDateTimeOperands().add(fieldElement);
				greaterThanType.getDateTimeOperands().add(dateTimeElement);
			}
			else if (value instanceof Duration)
			{
				greaterThanType.getDurationOperands().add(field.createObject((FieldType.class.getCanonicalName())).getContent());
				greaterThanType.getDurationOperands().add(value);
			}
			else if (value instanceof ArithmeticExpression)
			{
				// TODO Auto-generated method stub
			}
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}
}
