package org.iso.mpeg.mxm.searchTE.schemahandler.expression.comparison;

import java.util.List;

import javax.xml.bind.JAXBElement;
import javax.xml.datatype.Duration;
import javax.xml.datatype.XMLGregorianCalendar;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.ArithmeticExpressionType;
import org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.FieldType;
import org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.ObjectFactory;
import org.iso.mpeg.mxm.searchTE.schemahandler.common.ComparisonExpression;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.ArithmeticExpression;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.Field;

public class LessThan extends ComparisonExpression implements org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.LessThan
{
	// Constructors //
	
	public LessThan()
	{
		this(new org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.LessThan());
	}

	public LessThan(org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.LessThan lessThanType)
	{
		super(lessThanType);
	}
	
	// Getters //
	
	@Override
	public Field getField()
	{
		try
		{
			org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.LessThan equalType = 
					(org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.LessThan) booleanExpressionType;
			
			List objectList = null;
			
			if (equalType.getArithmeticOperands().size()>0)
			{
				objectList = equalType.getArithmeticOperands();
			}
			else if (equalType.getDateTimeOperands().size()>0)
			{
				objectList = equalType.getDateTimeOperands();
			}
			else if (equalType.getDurationOperands().size()>0)
			{
				objectList = equalType.getDurationOperands();
			}
			
			for (Object object : objectList)
			{
				if (object instanceof FieldType)
				{
					Field field = new org.iso.mpeg.mxm.searchTE.schemahandler.common.Field();
					field.parse(new MXMAdapter(object));
					
					return field;
				}
			}
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		
		return null;
	}
	
	public Object getValue()
	{
		org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.LessThan lessThanType = 
				(org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.LessThan) booleanExpressionType;
		
		if (lessThanType.getDateTimeOperands().size()>0)
		{
			for (JAXBElement jaxbElement : lessThanType.getDateTimeOperands())
			{
				if (jaxbElement.getValue() instanceof XMLGregorianCalendar)
				{
					return (XMLGregorianCalendar) jaxbElement.getValue();
				}
			}
		}
		else if (lessThanType.getArithmeticOperands().size()>0)
		{
			for (Object object : lessThanType.getArithmeticOperands())
			{
				if (object instanceof Double)
				{
					return object;
				}
				else if (object instanceof Long)
				{
					return object;
				}
				else if (object instanceof ArithmeticExpressionType)
				{
					// TODO add Arithemetic Expression
				}
			}
		}
		else if (lessThanType.getDurationOperands().size()>0)
		{
			// TODO
		}
		
		return null;
	}
	
	// Setters //
	
	@Override
	public void setComparisonExpression(Field field, Object value)
	{
		try
		{
			org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.LessThan lessThanType = 
					(org.iso.mpeg.mxm.engine.searchTE.schema.mpqf.LessThan) booleanExpressionType;
			
			if (value instanceof Long)
			{
				lessThanType.getArithmeticOperands().add(field.createObject((FieldType.class.getCanonicalName())).getContent());
				lessThanType.getArithmeticOperands().add(value);
			}
			else if (value instanceof Double)
			{
				lessThanType.getArithmeticOperands().add(field.createObject((FieldType.class.getCanonicalName())).getContent());
				lessThanType.getArithmeticOperands().add(value);
			}
			else if (value instanceof XMLGregorianCalendar)
			{
				ObjectFactory objectFactory = new ObjectFactory();
				JAXBElement fieldElement = objectFactory.createLessThanDateTimeField((FieldType)field.createObject((FieldType.class.getCanonicalName())).getContent());
				JAXBElement dateTimeElement = objectFactory.createLessThanDateTimeValue((XMLGregorianCalendar) value);
				
				lessThanType.getDateTimeOperands().add(fieldElement);
				lessThanType.getDateTimeOperands().add(dateTimeElement);
			}
			else if (value instanceof Duration)
			{
				lessThanType.getDurationOperands().add(field.createObject((FieldType.class.getCanonicalName())).getContent());
				lessThanType.getDurationOperands().add(value);
			}
			else if (value instanceof ArithmeticExpression)
			{
				// TODO Auto-generated method stub
			}
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}

}
