/** ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The entitys of this file are subject to the Mozilla  Public Entity Version
 * 1.1 (the "Entity"); you may not use this file except in compliance with
 * the Entity. You may obtain a copy of the Entity at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the Entity is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the Entity
 * for the specific language governing rights and  limitations under the
 * Entity.
 *
 * The Original Code is the MPEG Multimedia Extensible Middleware (MXM) Project 
 *
 * The Initial Developer of the Original Code is CEDEO.net  
 * Portions created by the Initial Developer are Copyright (C) 2009
 * All Rights Reserved.
 *
 * The Initial Developer: Angelo Difino
 * Contributor(s): 
 *
 * ***** END LICENSE BLOCK ***** */

package org.iso.mpeg.mxm.searchentityPE.schema;

import java.io.File;

import org.iso.mpeg.mxm.basePE.ProtocolSuccess;
import org.iso.mpeg.mxm.baseprotocol.schema.SuperBaseProtocolAbstractLevel1;
import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.protocol.SuperProtocolEngineAbstractLevel1;
import org.iso.mpeg.mxm.engine.protocol.searchentityPE.schema.searchentityprotocol.SearchEntityRequestType;
import org.iso.mpeg.mxm.engine.protocol.searchentityPE.schema.searchentityprotocol.SearchEntityResponseType;
import org.iso.mpeg.mxm.engine.protocol.searchentityPE.schema.searchentityprotocol.SearchEntitySuccessType;
import org.iso.mpeg.mxm.tEngine.metadataTE.MetadataEngine;
import org.iso.mpeg.mxm.tEngine.relTE.RELEngine;
import org.iso.mpeg.mxm.tEngine.searchTE.schemahandler.mpqf.OutputQuery;

/**
 * @author Jonathan Florido, DMAG-UPC <jflorido@ac.upc.edu>
 *
 */
public class SearchEntitySuccess extends ProtocolSuccess implements org.iso.mpeg.mxm.pEngine.searchentityPE.schemahandler.SearchEntitySuccess
{
	//private BaseProtocolEngine baseProtocolEngine;
	private RELEngine relEngine;
	private MetadataEngine metadataEngine;
	
	public SearchEntitySuccess(RELEngine relEngine, MetadataEngine metadataEngine) {
		super(new SearchEntitySuccessType());
		this.relEngine = relEngine;
		this.metadataEngine = metadataEngine;
	}

	@Override
	public void createFile(File f) throws MXMException
	{
		SuperBaseProtocolAbstractLevel1 level1 = new SuperBaseProtocolAbstractLevel1((SearchEntitySuccessType)protocolSuccessType);
		level1.createFile(f);
	}
	
	@Override
	public MXMObject createObject(String objectType) throws MXMException
	{
		SuperBaseProtocolAbstractLevel1 level1 = new SuperBaseProtocolAbstractLevel1((SearchEntitySuccessType)protocolSuccessType);
		return level1.createObject(objectType);
	}
	
	@Override
	public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
	{
		SuperProtocolEngineAbstractLevel1 level1 = new SuperProtocolEngineAbstractLevel1((SearchEntitySuccessType)protocolSuccessType);
		MXMEngineResponse response = level1.parse(object);
		if (response.equals(MXMEngineResponse.SUCCESS))
		{
			protocolSuccessType = 
					(SearchEntitySuccessType)(level1.createObject(SearchEntitySuccessType.class.getName()).getContent());
		}
		return response;
	}

	@Override
	public OutputQuery getOutputQuery() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setOutputQuery(OutputQuery outputQuery) {
		// TODO Auto-generated method stub
		
	}
}
