package org.iso.mpeg.mxm.securityTE;


import java.util.List;

import org.iso.mpeg.mxm.core.MXMEngine;
import org.iso.mpeg.mxm.core.MXMEngineName;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.CanonicalizationMethod;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.DSAKeyValue;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.DigestMethod;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.KeyInfo;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.KeyValue;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Manifest;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Object;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.PGPData;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.RSAKeyValue;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Reference;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.RetrievalMethod;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.SPKIData;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Signature;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.SignatureMethod;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.SignatureProperties;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.SignatureProperty;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.SignatureValue;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.SignedInfo;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Transform;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Transforms;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.X509Data;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.X509IssuerSerial;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.Action;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.Advice;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.Assertion;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.Attribute;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.AttributeStatement;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.AudienceRestriction;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.AuthnContext;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.AuthnStatement;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.AuthzDecisionStatement;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.BaseIDAbstract;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.ConditionAbstract;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.Conditions;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.Decision;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.EncryptedElement;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.Evidence;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.KeyInfoConfirmationData;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.NameID;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.OneTimeUse;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.ProxyRestriction;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.StatementAbstract;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.Subject;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.SubjectConfirmation;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.SubjectConfirmationData;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.SubjectLocality;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.ArtifactResolve;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.ArtifactResponse;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.AssertionIDRequest;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.AttributeQuery;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.AuthnContextComparison;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.AuthnQuery;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.AuthnRequest;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.AuthzDecisionQuery;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.Extensions;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.IDPEntry;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.IDPList;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.LogoutRequest;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.ManageNameIDRequest;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.NameIDMappingRequest;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.NameIDMappingResponse;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.NameIDPolicy;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.RequestAbstract;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.RequestedAuthnContext;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.Response;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.Scoping;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.Status;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.StatusCode;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.StatusDetail;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.StatusResponse;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.SubjectQueryAbstract;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.Terminate;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.xenc.AgreementMethod;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.xenc.CipherData;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.xenc.CipherReference;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.xenc.Encrypted;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.xenc.EncryptedData;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.xenc.EncryptedKey;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.xenc.EncryptionMethod;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.xenc.EncryptionProperties;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.xenc.EncryptionProperty;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.xenc.ReferenceList;


public class SecurityEngineSchemaHandler implements
    org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngineSchemaHandler
{
    private SecurityEngine securityEngine;

    public SecurityEngineSchemaHandler(final List<MXMEngine> engines)
        throws MXMEngineException
    {
        for (int i = 0; i < engines.size(); i++)
        {
            final MXMEngine engine = engines.get(i);
            if (engine.getEngineName().equals(MXMEngineName.SecurityTE.toString()))
            {
                this.securityEngine = (SecurityEngine)engine;
            }
        }
    }

    @Override
    public Action getAction() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Advice getAdvice() throws MXMEngineException
    {
        return new org.iso.mpeg.mxm.securityTE.schemahandler.saml.Advice();
    }

    @Override
    public AgreementMethod getAgreementMethod() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public ArtifactResolve getArtifactResolve() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public ArtifactResponse getArtifactResponse() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Assertion getAssertion() throws MXMEngineException
    {
        return new org.iso.mpeg.mxm.securityTE.schemahandler.saml.Assertion(this);
    }

    @Override
    public AssertionIDRequest getAssertionIDRequest() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Attribute getAttribute() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public AttributeQuery getAttributeQuery() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public AttributeStatement getAttributeStatement() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public AudienceRestriction getAudienceRestriction() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public AuthnContext getAuthnContext() throws MXMEngineException
    {
        return new org.iso.mpeg.mxm.securityTE.schemahandler.saml.AuthnContext();
    }

    @Override
    public AuthnContextComparison getAuthnContextComparison() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public AuthnQuery getAuthnQuery() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public AuthnRequest getAuthnRequest() throws MXMEngineException
    {
        return new org.iso.mpeg.mxm.securityTE.schemahandler.saml.AuthnRequest(this);
    }

    @Override
    public AuthnStatement getAuthnStatement() throws MXMEngineException
    {
        return new org.iso.mpeg.mxm.securityTE.schemahandler.saml.AuthnStatement(
            this.securityEngine);
    }

    @Override
    public AuthzDecisionQuery getAuthzDecisionQuery() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public AuthzDecisionStatement getAuthzDecisionStatement() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public BaseIDAbstract getBaseIDAbstract() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public CanonicalizationMethod getCanonicalizationMethod() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public CipherData getCipherData() throws MXMEngineException
    {
        return new org.iso.mpeg.mxm.securityTE.schemahandler.CipherData();
    }

    @Override
    public CipherReference getCipherReference() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public ConditionAbstract getConditionAbstract() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Conditions getConditions() throws MXMEngineException
    {
        return new org.iso.mpeg.mxm.securityTE.schemahandler.saml.Conditions();
    }

    @Override
    public Decision getDecision() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public DigestMethod getDigestMethod() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public DSAKeyValue getDSAKeyValue() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Encrypted getEncrypted() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public EncryptedData getEncryptedData() throws MXMEngineException
    {
        return new org.iso.mpeg.mxm.securityTE.schemahandler.EncryptedData();
    }

    @Override
    public EncryptedElement getEncryptedElement() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public EncryptedKey getEncryptedKey() throws MXMEngineException
    {
        return new org.iso.mpeg.mxm.securityTE.schemahandler.EncryptedKey();
    }

    @Override
    public EncryptionMethod getEncryptionMethod() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public EncryptionProperties getEncryptionProperties() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public EncryptionProperty getEncryptionProperty() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Evidence getEvidence() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Extensions getExtensions() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public IDPEntry getIDPEntry() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public IDPList getIDPList() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public KeyInfo getKeyInfo() throws MXMEngineException
    {
        return new org.iso.mpeg.mxm.securityTE.schemahandler.dsig.KeyInfo(this);
    }

    @Override
    public KeyInfoConfirmationData getKeyInfoConfirmationData() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public KeyValue getKeyValue() throws MXMEngineException
    {
        return new org.iso.mpeg.mxm.securityTE.schemahandler.KeyValue();
    }

    @Override
    public LogoutRequest getLogoutRequest() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public ManageNameIDRequest getManageNameIDRequest() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Manifest getManifest() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public NameID getNameID() throws MXMEngineException
    {
        return new org.iso.mpeg.mxm.securityTE.schemahandler.saml.NameID();
    }

    @Override
    public NameIDMappingRequest getNameIDMappingRequest() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public NameIDMappingResponse getNameIDMappingResponse() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public NameIDPolicy getNameIDPolicy() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Object getObject() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public OneTimeUse getOneTimeUse() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public PGPData getPGPData() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public ProxyRestriction getProxyRestriction() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Reference getReferenceDSig() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public ReferenceList getReferenceList() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.xenc.Reference getReferenceXEnc()
        throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public RequestAbstract getRequestAbstract() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public RequestedAuthnContext getRequestedAuthnContext() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Response getResponse() throws MXMEngineException
    {
        return new org.iso.mpeg.mxm.securityTE.schemahandler.saml.Response(this);
    }

    @Override
    public RetrievalMethod getRetrievalMethod() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public RSAKeyValue getRSAKeyValue() throws MXMEngineException
    {
        return new org.iso.mpeg.mxm.securityTE.schemahandler.RSAKeyValue();
    }

    @Override
    public Scoping getScoping() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Signature getSignature() throws MXMEngineException
    {
        return new org.iso.mpeg.mxm.securityTE.schemahandler.dsig.Signature(this);
    }

    @Override
    public SignatureMethod getSignatureMethod() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public SignatureProperties getSignatureProperties() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public SignatureProperty getSignatureProperty() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public SignatureValue getSignatureValue() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public SignedInfo getSignedInfo() throws MXMEngineException
    {
        return new org.iso.mpeg.mxm.securityTE.schemahandler.SignedInfo();
    }

    @Override
    public SPKIData getSPKIData() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public StatementAbstract getStatementAbstract() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Status getStatus() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public StatusCode getStatusCode() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public StatusDetail getStatusDetail() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public StatusResponse getStatusResponse() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Subject getSubject() throws MXMEngineException
    {
        return new org.iso.mpeg.mxm.securityTE.schemahandler.saml.Subject();
    }

    @Override
    public SubjectConfirmation getSubjectConfirmation() throws MXMEngineException
    {
        return new org.iso.mpeg.mxm.securityTE.schemahandler.saml.SubjectConfirmation();
    }

    @Override
    public SubjectConfirmationData getSubjectConfirmationData() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public SubjectLocality getSubjectLocality() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public SubjectQueryAbstract getSubjectQueryAbstract() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Terminate getTerminate() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Transform getTransform() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Transforms getTransformsDSig() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.xenc.Transforms getTransformsXEnc()
        throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public X509Data getX509Data() throws MXMEngineException
    {
        return new org.iso.mpeg.mxm.securityTE.schemahandler.X509Data();
    }

    @Override
    public X509IssuerSerial getX509IssuerSerial() throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }
}
