package org.iso.mpeg.mxm.securityTE.schemahandler;


import java.io.File;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.securityTE.schema.xenc.CipherDataType;
import org.iso.mpeg.mxm.engine.securityTE.schema.xenc.SuperXencAbstractLevel1;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.xenc.CipherReference;


public class CipherData implements
    org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.xenc.CipherData
{
    private CipherDataType cipherDataType;

    public CipherData()
    {
        this(new CipherDataType());
    }

    public CipherData(final CipherDataType cipherDataType)
    {
        this.cipherDataType = cipherDataType;
    }

    @Override
    public void createFile(final File f) throws MXMException
    {
        new SuperXencAbstractLevel1(this.cipherDataType).createFile(f);
    }

    @Override
    public MXMObject createObject(final String objectType) throws MXMException
    {
        return new SuperXencAbstractLevel1(this.cipherDataType).createObject(objectType);
    }

    @Override
    public CipherReference getCipherReference()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public byte[] getCipherValue()
    {
        return this.cipherDataType.getCipherValue();
    }

    // MXM CREATOR AND PARSER METHODS
    @Override
    public MXMEngineResponse parse(final MXMObject object) throws MXMEngineException
    {
        final SuperXencAbstractLevel1 level1 = new SuperXencAbstractLevel1(
            this.cipherDataType);
        final MXMEngineResponse response = level1.parse(object);
        this.cipherDataType = (CipherDataType)level1.createObject(
            CipherDataType.class.getCanonicalName()).getContent();
        return response;
    }

    @Override
    public void setCipherReference(final CipherReference cipherReference)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setCipherValue(final byte[] b)
    {
        this.cipherDataType.setCipherValue(b);
    }
}
