package org.iso.mpeg.mxm.securityTE.schemahandler;


import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.engine.securityTE.schema.xenc.CipherDataType;
import org.iso.mpeg.mxm.engine.securityTE.schema.xenc.EncryptedType;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.KeyInfo;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.xenc.CipherData;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.xenc.EncryptionMethod;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.xenc.EncryptionProperties;


public abstract class Encrypted implements
    org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.xenc.Encrypted
{
    protected EncryptedType encryptedType;

    public Encrypted(final EncryptedType encrypted)
    {
        this.encryptedType = encrypted;
    }

    @Override
    public CipherData getCipherData()
    {
        return new org.iso.mpeg.mxm.securityTE.schemahandler.CipherData(
            this.encryptedType.getCipherData());
    }

    @Override
    public String getEncoding()
    {
        return this.encryptedType.getEncoding();
    }

    @Override
    public EncryptionMethod getEncryptionMethod()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public EncryptionProperties getEncryptionProperties()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public String getId()
    {
        return this.encryptedType.getId();
    }

    @Override
    public KeyInfo getKeyInfo()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public String getMime()
    {
        return this.encryptedType.getMimeType();
    }

    @Override
    public String getType()
    {
        return this.encryptedType.getType();
    }

    @Override
    public void setCipherData(final CipherData cipherData)
    {
        try
        {
            this.encryptedType.setCipherData((CipherDataType)cipherData.createObject(
                CipherDataType.class.getCanonicalName()).getContent());
        }
        catch (final MXMException e)
        {
            e.printStackTrace();
        }
    }

    @Override
    public void setEncoding(final String string)
    {
        this.encryptedType.setEncoding(string);
    }

    @Override
    public void setEncryptionMethod(final EncryptionMethod encryptionMethod)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setEncryptionProperties(final EncryptionProperties encryptionProperties)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setId(final String string)
    {
        this.encryptedType.setId(string);
    }

    @Override
    public void setKeyInfo(final KeyInfo keyInfo)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setMime(final String string)
    {
        this.encryptedType.setMimeType(string);
    }

    @Override
    public void setType(final String string)
    {
        this.encryptedType.setType(string);
    }
}
