package org.iso.mpeg.mxm.securityTE.schemahandler;


import java.io.File;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.securityTE.schema.xenc.EncryptedKeyType;
import org.iso.mpeg.mxm.engine.securityTE.schema.xenc.SuperXencAbstractLevel1;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.xenc.ReferenceList;


public class EncryptedKey extends Encrypted implements
    org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.xenc.EncryptedKey
{
    public EncryptedKey()
    {
        this(new EncryptedKeyType());
    }

    public EncryptedKey(final EncryptedKeyType encrypted)
    {
        super(encrypted);
    }

    @Override
    public void createFile(final File f) throws MXMException
    {
        new SuperXencAbstractLevel1(this.encryptedType).createFile(f);
    }

    @Override
    public MXMObject createObject(final String objectType) throws MXMException
    {
        return new SuperXencAbstractLevel1(this.encryptedType).createObject(objectType);
    }

    @Override
    public String getCarriedKeyName()
    {
        return ((EncryptedKeyType)this.encryptedType).getCarriedKeyName();
    }

    @Override
    public String getRecipient()
    {
        return ((EncryptedKeyType)this.encryptedType).getRecipient();
    }

    @Override
    public ReferenceList getReferenceList()
    {
        // TODO Auto-generated method stub
        return null;
    }

    // MXM CREATOR AND PARSER METHODS
    @Override
    public MXMEngineResponse parse(final MXMObject object) throws MXMEngineException
    {
        final SuperXencAbstractLevel1 level1 = new SuperXencAbstractLevel1(
            this.encryptedType);
        final MXMEngineResponse response = level1.parse(object);
        this.encryptedType = (EncryptedKeyType)level1.createObject(
            EncryptedKeyType.class.getCanonicalName()).getContent();
        return response;
    }

    @Override
    public void setCarriedKeyName(final String string)
    {
        ((EncryptedKeyType)this.encryptedType).setCarriedKeyName(string);
    }

    @Override
    public void setRecipient(final String string)
    {
        ((EncryptedKeyType)this.encryptedType).setRecipient(string);
    }

    @Override
    public void setReferenceList(final ReferenceList referenceList)
    {
        // TODO Auto-generated method stub
    }
}
