package org.iso.mpeg.mxm.securityTE.schemahandler;


import java.io.File;
import java.io.Serializable;
import java.util.List;

import javax.xml.bind.JAXBElement;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.KeyValueType;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.RSAKeyValueType;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.SuperDsigAbstractLevel1;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.DSAKeyValue;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Object;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.RSAKeyValue;


public class KeyValue implements
    org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.KeyValue
{
    private KeyValueType keyValueType;

    public KeyValue()
    {
        this(new KeyValueType());
    }

    public KeyValue(final KeyValueType keyValue)
    {
        this.keyValueType = keyValue;
    }

    @Override
    public void createFile(final File f) throws MXMException
    {
        new SuperDsigAbstractLevel1(this.keyValueType).createFile(f);
    }

    @Override
    public MXMObject createObject(final String objectType) throws MXMException
    {
        return new SuperDsigAbstractLevel1(this.keyValueType).createObject(objectType);
    }

    @Override
    public DSAKeyValue getDSAKeyValue()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Object getOther()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public RSAKeyValue getRSAKeyValue()
    {
        final List<Serializable> contents = this.keyValueType.getContent();
        for (final Serializable content : contents)
        {
            if (content instanceof JAXBElement)
            {
                final java.lang.Object contentType = ((JAXBElement)content).getValue();
                if (contentType instanceof RSAKeyValueType)
                {
                    return new org.iso.mpeg.mxm.securityTE.schemahandler.RSAKeyValue(
                        (RSAKeyValueType)contentType);
                }
            }
        }
        return null;
    }

    @Override
    public MXMEngineResponse parse(final MXMObject object) throws MXMEngineException
    {
        final SuperDsigAbstractLevel1 level1 = new SuperDsigAbstractLevel1(
            this.keyValueType);
        final MXMEngineResponse response = level1.parse(object);
        this.keyValueType = (KeyValueType)level1.createObject(
            KeyValueType.class.getCanonicalName()).getContent();
        return response;
    }

    // MXM CREATOR AND PARSER METHODS
    @Override
    public void setDSAKeyValue(final DSAKeyValue dsaKeyValue)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setOther(final Object other)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setRSAKeyValue(final RSAKeyValue rsaKeyValue)
    {
        try
        {
            // keyValueType.getContent().add((KeyValueType)rsaKeyValue.createObject(KeyValueType.class.getCanonicalName()).getContent());
            // keyValueType.getContent().add((RSAKeyValueType)rsaKeyValue.createObject(RSAKeyValueType.class.getCanonicalName()).getContent());
            this.keyValueType.getContent().add(
                (JAXBElement)rsaKeyValue.createObject(
                    JAXBElement.class.getCanonicalName()).getContent());
        }
        catch (final MXMException e)
        {
            e.printStackTrace();
        }
    }
}
