package org.iso.mpeg.mxm.securityTE.schemahandler;


import java.io.File;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.SignatureValueType;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.SuperDsigAbstractLevel1;


public class SignatureValue implements
    org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.SignatureValue
{
    private SignatureValueType signatureValueType;

    public SignatureValue()
    {
        this(new SignatureValueType());
    }

    public SignatureValue(final SignatureValueType signatureValueType)
    {
        this.signatureValueType = signatureValueType;
    }

    @Override
    public void createFile(final File f) throws MXMException
    {
        new SuperDsigAbstractLevel1(this.signatureValueType).createFile(f);
    }

    @Override
    public MXMObject createObject(final String objectType) throws MXMException
    {
        return new SuperDsigAbstractLevel1(this.signatureValueType)
            .createObject(objectType);
    }

    @Override
    public String getId()
    {
        return this.signatureValueType.getId();
    }

    @Override
    public byte[] getValue()
    {
        return this.signatureValueType.getValue();
    }

    // MXM CREATOR AND PARSER METHODS
    @Override
    public MXMEngineResponse parse(final MXMObject object) throws MXMEngineException
    {
        final SuperDsigAbstractLevel1 level1 = new SuperDsigAbstractLevel1(
            this.signatureValueType);
        final MXMEngineResponse response = level1.parse(object);
        this.signatureValueType = (SignatureValueType)level1.createObject(
            SignatureValueType.class.getCanonicalName()).getContent();
        return response;
    }

    @Override
    public void setId(final String string)
    {
        this.signatureValueType.setId(string);
    }

    @Override
    public void setValue(final byte[] b)
    {
        this.signatureValueType.setValue(b);
    }
}
