package org.iso.mpeg.mxm.securityTE.schemahandler;


import java.io.File;
import java.util.ArrayList;
import java.util.List;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.SignedInfoType;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.SuperDsigAbstractLevel1;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.CanonicalizationMethod;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Reference;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.SignatureMethod;


public class SignedInfo implements
    org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.SignedInfo
{
    private final List<Reference> references = new ArrayList<Reference>();
    private SignedInfoType        signedInfoType;

    public SignedInfo()
    {
        this.signedInfoType = new SignedInfoType();
    }

    @Override
    public void createFile(final File f) throws MXMException
    {
        new SuperDsigAbstractLevel1(this.signedInfoType).createFile(f);
    }

    @Override
    public MXMObject createObject(final String objectType) throws MXMException
    {
        return new SuperDsigAbstractLevel1(this.signedInfoType).createObject(objectType);
    }

    @Override
    public CanonicalizationMethod getCanonicalizationMethod()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public String getId()
    {
        return this.signedInfoType.getId();
    }

    @Override
    public List<Reference> getReference()
    {
        return this.references;
    }

    @Override
    public SignatureMethod getSignatureMethod()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public MXMEngineResponse parse(final MXMObject object) throws MXMEngineException
    {
        final SuperDsigAbstractLevel1 level1 = new SuperDsigAbstractLevel1(
            this.signedInfoType);
        final MXMEngineResponse response = level1.parse(object);
        this.signedInfoType = (SignedInfoType)level1.createObject(
            SignedInfoType.class.getCanonicalName()).getContent();
        return response;
    }

    // MXM CREATOR AND PARSER METHODS
    @Override
    public void setCanonicalizationMethod(
        final CanonicalizationMethod canonicalizationMethod)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setId(final String string)
    {
        this.signedInfoType.setId(string);
    }

    @Override
    public void setSignatureMethod(final SignatureMethod signatureMethod)
    {
        // TODO Auto-generated method stub
    }
}
