package org.iso.mpeg.mxm.securityTE.schemahandler;


import java.io.File;

import javax.xml.bind.JAXBElement;

import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.ObjectFactory;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.SuperDsigAbstractLevel1;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.X509DataType;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Object;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.X509IssuerSerial;


public class X509Data implements
    org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.X509Data
{
    private final ObjectFactory factory;
    private X509DataType        x509dataType;

    public X509Data()
    {
        this.x509dataType = new X509DataType();
        this.factory = new ObjectFactory();
    }

    @Override
    public void createFile(final File f) throws MXMException
    {
        new SuperDsigAbstractLevel1(this.x509dataType).createFile(f);
    }

    @Override
    public MXMObject createObject(final String objectType) throws MXMException
    {
        return new SuperDsigAbstractLevel1(this.x509dataType).createObject(objectType);
    }

    @Override
    public Object getOther()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public byte[] getX509Certificate()
    {
        // return this.DERencodedRepresentation;
        for (final java.lang.Object element : this.x509dataType
            .getX509IssuerSerialOrX509SKIOrX509SubjectName())
        {
            element.getClass().getCanonicalName();
            if (element.getClass().getCanonicalName()
                .equals(JAXBElement.class.getCanonicalName()))
            {
                final JAXBElement ele = (JAXBElement)element;
                if (ele.getName().getLocalPart().equals("X509Certificate"))
                {
                    return (byte[])ele.getValue();
                }
            }
        }
        return null;
    }

    @Override
    public byte[] getX509CRL()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public X509IssuerSerial getX509IssuerSerial()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public byte[] getX509SKI()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public String getX509SubjectName()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public MXMEngineResponse parse(final MXMObject object) throws MXMEngineException
    {
        final SuperDsigAbstractLevel1 level1 = new SuperDsigAbstractLevel1(
            this.x509dataType);
        final MXMEngineResponse response = level1.parse(object);
        this.x509dataType = (X509DataType)level1.createObject(
            X509DataType.class.getCanonicalName()).getContent();
        return response;
    }

    @Override
    public void setOther(final Object other)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setX509Certificate(final byte[] x509Certificate)
    {
        final JAXBElement jaxb = this.factory
            .createX509DataTypeX509Certificate(x509Certificate);
        this.x509dataType.getX509IssuerSerialOrX509SKIOrX509SubjectName().add(jaxb);
    }

    @Override
    public void setX509CRL(final byte[] x509crl)
    {
        // TODO Auto-generated method stub
    }

    // MXM CREATOR AND PARSER METHODS
    @Override
    public void setX509IssuerSerial(final X509IssuerSerial x509issuerSerial)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setX509SKI(final byte[] x509ski)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setX509SubjectName(final String x509subjectName)
    {
        // TODO Auto-generated method stub
    }
}
