package org.iso.mpeg.mxm.securityTE.schemahandler.dsig;


import java.io.File;
import java.io.Serializable;

import javax.xml.bind.JAXBElement;

import morpho.util.Converter;

import org.iso.mpeg.mxm.baseprotocol.schema.SuperBaseProtocolAbstractLevel1;
import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.KeyInfoType;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.KeyValueType;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.RetrievalMethodType;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.SignatureType;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.X509DataType;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.ObjectFactory;
import org.iso.mpeg.mxm.securityTE.SecurityEngineSchemaHandler;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.KeyValue;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Object;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.PGPData;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.RetrievalMethod;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.SPKIData;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.X509Data;


public class KeyInfo implements
    org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.KeyInfo
{
    private ObjectFactory                                                   factory;
    private KeyInfoType                                                     keyInfoType;
    private org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngineSchemaHandler securityEngineSchemaHandler;

    public KeyInfo(final KeyInfoType keyInfo)
    {
        this.keyInfoType = keyInfo;
    }

    public KeyInfo(
        final org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngineSchemaHandler securityEngineSchemaHandler)
    {
        this.keyInfoType = new KeyInfoType();
        this.securityEngineSchemaHandler = securityEngineSchemaHandler;
        this.factory = new ObjectFactory();
    }

    @Override
    public void createFile(final File f) throws MXMException
    {
        new SuperBaseProtocolAbstractLevel1(this.keyInfoType).createFile(f);
    }

    @Override
    public MXMObject createObject(final String objectType) throws MXMException
    {
        return new SuperBaseProtocolAbstractLevel1(this.keyInfoType)
            .createObject(objectType);
    }

    @Override
    public boolean equals(
        final org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.KeyInfo keyInfo) throws MXMEngineException
    {
        // TODO Auto-generated method stub
    	
    	if  ((this.getKeyValue()!= null) && (keyInfo.getKeyValue()!=null) &&
    		 (this.getKeyValue().getRSAKeyValue()!= null) && (keyInfo.getKeyValue().getRSAKeyValue()!=null) &&
    		 (this.getKeyValue().getRSAKeyValue().getExponent()!= null) && (keyInfo.getKeyValue().getRSAKeyValue().getExponent()!=null) &&
    		 (this.getKeyValue().getRSAKeyValue().getModulus()!= null) && (keyInfo.getKeyValue().getRSAKeyValue().getModulus()!=null)
    		)
    	{
    		
//    		System.out.println(Converter.toHex(this.getKeyValue().getRSAKeyValue().getExponent()));
//    		System.out.println(Converter.toHex(keyInfo.getKeyValue().getRSAKeyValue().getExponent()));
//    		System.out.println(Converter.toHex(this.getKeyValue().getRSAKeyValue().getModulus()));
//    		System.out.println(Converter.toHex(keyInfo.getKeyValue().getRSAKeyValue().getModulus()));
//    		java.util.Arrays.equals(this.getKeyValue().getRSAKeyValue().getExponent(), keyInfo.getKeyValue().getRSAKeyValue().getExponent());
//    		java.util.Arrays.equals(this.getKeyValue().getRSAKeyValue().getModulus(), keyInfo.getKeyValue().getRSAKeyValue().getModulus());
    	
    		return 	(java.util.Arrays.equals(this.getKeyValue().getRSAKeyValue().getExponent(), keyInfo.getKeyValue().getRSAKeyValue().getExponent())&&java.util.Arrays.equals(this.getKeyValue().getRSAKeyValue().getModulus(), keyInfo.getKeyValue().getRSAKeyValue().getModulus()));
    	}	   	
    	else return false;
    }

    @Override
    public String getId()
    {
        return this.getId();
    }

    @Override
    public String getKeyName()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public KeyValue getKeyValue() throws MXMEngineException
    {
        for (final Serializable element : this.keyInfoType.getContent())
        {
            element.getClass().getCanonicalName();
            if (element.getClass().getCanonicalName()
                .equals(JAXBElement.class.getCanonicalName()))
            {
                final JAXBElement elem = (JAXBElement)element;
                final KeyValue keyValue = new org.iso.mpeg.mxm.securityTE.schemahandler.KeyValue(
                    (KeyValueType)elem.getValue());
                return keyValue;
            }
        }
        return null;
    }

    @Override
    public String getMgmtData()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Object getOther()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public PGPData getPGPData()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public RetrievalMethod getRetrievalMethod() throws MXMEngineException
    {
        final RetrievalMethod val = this.getRetrievalMethod();
        // TODO: need RetrievalMethod():: RetrievalMethodType
        // val.parse(new MXMAdapter(this.keyInfoType.getRetrievalMethod()));
        return val;
    }

    @Override
    public SPKIData getSPKIData()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public X509Data getX509Data() throws MXMEngineException
    {
        final X509Data val = this.securityEngineSchemaHandler.getX509Data();
        // TODO: need getX509Data():: X509DataType
        // val.parse(new MXMAdapter(this.keyInfoType.getX509Data()));
        return val;
    }

    @Override
    public MXMEngineResponse parse(final MXMObject object) throws MXMEngineException
    {
        final SuperBaseProtocolAbstractLevel1 superAbstract = new SuperBaseProtocolAbstractLevel1(
            this.keyInfoType);
        final MXMEngineResponse repsonse = superAbstract.parse(object);
        this.keyInfoType = (KeyInfoType)superAbstract.createObject(
            KeyInfoType.class.getCanonicalName()).getContent();
        return repsonse;
    }

    @Override
    public void setId(final String string)
    {
        this.keyInfoType.setId(string);
    }

    @Override
    public void setKeyName(final String keyName)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setKeyValue(final KeyValue keyValue) throws MXMException
    {
        KeyValueType keyValueType = null;
        keyValueType = (KeyValueType)(keyValue.createObject(KeyValueType.class.getName()))
            .getContent();
        final JAXBElement jaxb = this.factory.createKeyValue(keyValueType);
        this.keyInfoType.getContent().add(jaxb);
    }

    @Override
    public void setMgmtData(final String mgmtData)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setOther(final Object other)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setPGPData(final PGPData pgpData)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setRetrievalMethod(final RetrievalMethod retrievalMethod)
        throws MXMException
    {
        RetrievalMethodType val = null;
        val = (RetrievalMethodType)(retrievalMethod
            .createObject(RetrievalMethodType.class.getName())).getContent();
        final JAXBElement jaxb = this.factory.createRetrievalMethod(val);
        this.keyInfoType.getContent().add(jaxb);
    }

    @Override
    public void setSPKIData(final SPKIData pgpData)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setX509Data(X509Data x509data) throws MXMException
    {
        X509DataType val = null;
        val = (X509DataType)(x509data.createObject(X509DataType.class.getName()))
            .getContent();
        // TODO: need setX509Data method
        // this.keyInfoType.setX509Data(val);
    }
}
