package org.iso.mpeg.mxm.securityTE.schemahandler.saml;


import java.io.File;
import java.util.List;

import org.iso.mpeg.mxm.baseprotocol.schema.SuperBaseProtocolAbstractLevel1;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.securityTE.schema.saml.assertion.AdviceType;


public class Advice implements
    org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.Advice
{
    private AdviceType adviceType;

    public Advice()
    {
        this.adviceType = new AdviceType();
    }

    @Override
    public void createFile(final File f) throws MXMException
    {
        new SuperBaseProtocolAbstractLevel1(this.adviceType).createFile(f);
    }

    @Override
    public MXMObject createObject(final String objectType) throws MXMException
    {
        return new SuperBaseProtocolAbstractLevel1(this.adviceType)
            .createObject(objectType);
    }

    @Override
    public List<Object> getAssertionIDRefOrAssertionURIRefOrAssertion()
    {
        return this.adviceType.getAssertionIDRefOrAssertionURIRefOrAssertion();
    }

    @Override
    public MXMEngineResponse parse(final MXMObject object) throws MXMEngineException
    {
        final SuperBaseProtocolAbstractLevel1 superAbstract = new SuperBaseProtocolAbstractLevel1(
            this.adviceType);
        final MXMEngineResponse repsonse = superAbstract.parse(object);
        this.adviceType = (AdviceType)superAbstract.createObject(
            AdviceType.class.getCanonicalName()).getContent();
        return repsonse;
    }
}
