package org.iso.mpeg.mxm.securityTE.schemahandler.saml;


import java.io.File;
import java.util.List;

import javax.xml.bind.JAXBElement;

import org.iso.mpeg.mxm.baseprotocol.schema.SuperBaseProtocolAbstractLevel1;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.securityTE.schema.saml.assertion.AuthnContextType;
import org.iso.mpeg.mxm.engine.securityTE.schema.saml.assertion.ObjectFactory;


public class AuthnContext implements
    org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.AuthnContext
{
    private AuthnContextType    authContextType;
    private final ObjectFactory factory;

    public AuthnContext()
    {
        this.factory = new ObjectFactory();
        this.authContextType = new AuthnContextType();
    }

    @Override
    public void addAuthnContextDecl(final Object value)
    {
        final JAXBElement jaxb = this.factory.createAuthnContextDecl(value);
        this.getContent().add(jaxb);
    }

    @Override
    public void createFile(final File f) throws MXMException
    {
        new SuperBaseProtocolAbstractLevel1(this.authContextType).createFile(f);
    }

    @Override
    public MXMObject createObject(final String objectType) throws MXMException
    {
        return new SuperBaseProtocolAbstractLevel1(this.authContextType)
            .createObject(objectType);
    }

    @Override
    public String getAuthnContextDecl()
    {
        for (final JAXBElement element : this.authContextType.getContent())
        {
            // if (element.getName().equals("AuthnContextDecl"))
            if (element.getName().getLocalPart().equals("AuthnContextDecl"))
            {
                return element.getValue().toString();
            }
        }
        return "";
    }

    @Override
    public List<JAXBElement<?>> getContent()
    {
        return this.authContextType.getContent();
    }

    @Override
    public MXMEngineResponse parse(final MXMObject object) throws MXMEngineException
    {
        final SuperBaseProtocolAbstractLevel1 superAbstract = new SuperBaseProtocolAbstractLevel1(
            this.authContextType);
        final MXMEngineResponse repsonse = superAbstract.parse(object);
        this.authContextType = (AuthnContextType)superAbstract.createObject(
            AuthnContextType.class.getCanonicalName()).getContent();
        return repsonse;
    }
}
