package org.iso.mpeg.mxm.securityTE.schemahandler.saml;

import java.io.File;

import javax.xml.datatype.XMLGregorianCalendar;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.SignatureType;
import org.iso.mpeg.mxm.engine.securityTE.schema.saml.protocol.AuthnRequestType;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Signature;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.Conditions;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.NameID;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.Subject;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.Extensions;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.NameIDPolicy;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.RequestedAuthnContext;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.Scoping;

public class AuthnRequest implements
    org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.AuthnRequest
{
    private AuthnRequestType authnRequestType;
    private final org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngineSchemaHandler securityEngineSchemaHandler;
    
    
    public AuthnRequest(org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngineSchemaHandler securityEngineSchemaHandler) {
        this.authnRequestType = new AuthnRequestType();
        this.securityEngineSchemaHandler = securityEngineSchemaHandler;
    }
    @Override
    public void setVersion(String string)
    {
        
    }

    @Override
    public NameID getIssuer()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void setSignature(Signature signature)
    {
        SignatureType sigType = null;
        try
        {
            sigType = (SignatureType)signature.createObject(
                SignatureType.class.getCanonicalName()).getContent();
        }
        catch (MXMException e)
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        this.authnRequestType.setSignature(sigType);
    }

    @Override
    public void setIssuer(NameID nameID)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public XMLGregorianCalendar getIssueInstant()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void setIssueInstant(XMLGregorianCalendar xMLGregorianCalendar)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setDestination(String string)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public String getConsent()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void setConsent(String string)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public Signature getSignature()
    {
        Signature signature = null;
        try
        {
            signature = this.securityEngineSchemaHandler.getSignature();
            signature.parse(new MXMAdapter(this.authnRequestType.getSignature()));
        }
        catch (MXMEngineException e)
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return signature;
    }

    @Override
    public String getID()
    {
       return this.authnRequestType.getID();
    }

    @Override
    public String getDestination()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public String getVersion()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void setID(String string)
    {
        this.authnRequestType.setID(string);
    }

    @Override
    public Extensions getExtensions()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void setExtensions(Extensions extensions)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void createFile(File f) throws MXMException
    {
        // TODO Auto-generated method stub
    }

    @Override
    public MXMObject createObject(String objectType) throws MXMException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public MXMEngineResponse parse(MXMObject object) throws MXMEngineException
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Subject getSubject()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void setSubject(Subject subject)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public Conditions getConditions()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void setConditions(Conditions conditions)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public NameIDPolicy getNameIDPolicy()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void setNameIDPolicy(NameIDPolicy nameIDPolicy)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public RequestedAuthnContext getRequestedAuthnContext()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void setRequestedAuthnContext(RequestedAuthnContext requestedAuthnContext)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public Scoping getScoping()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void setScoping(Scoping scoping)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public Boolean isForceAuthn()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void setForceAuthn(Boolean b)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public Boolean isIsPassive()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void setIsPassive(Boolean b)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public String getProtocolBinding()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void setProtocolBinding(String string)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public Integer getAssertionConsumerServiceIndex()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void setAssertionConsumerServiceIndex(Integer integer)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public String getAssertionConsumerServiceURL()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void setAssertionConsumerServiceURL(String string)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public Integer getAttributeConsumingServiceIndex()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void setAttributeConsumingServiceIndex(Integer integer)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public String getProviderName()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void setProviderName(String string)
    {
        // TODO Auto-generated method stub
    }
}
