package org.iso.mpeg.mxm.securityTE.schemahandler.saml;


import java.io.File;
import java.util.List;

import javax.xml.datatype.XMLGregorianCalendar;

import org.iso.mpeg.mxm.baseprotocol.schema.SuperBaseProtocolAbstractLevel1;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.securityTE.schema.saml.assertion.ConditionsType;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.ConditionAbstract;


public class Conditions implements
    org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.Conditions
{
    private ConditionsType conditionsType;

    public Conditions()
    {
        this.conditionsType = new ConditionsType();
    }

    @Override
    public void createFile(final File f) throws MXMException
    {
        new SuperBaseProtocolAbstractLevel1(this.conditionsType).createFile(f);
    }

    @Override
    public MXMObject createObject(final String objectType) throws MXMException
    {
        return new SuperBaseProtocolAbstractLevel1(this.conditionsType)
            .createObject(objectType);
    }

    @Override
    public List<ConditionAbstract> getConditionOrAudienceRestrictionOrOneTimeUse()
    {
        // TODO:
        // List<OneTime> getOneTimeList();
        // List<AudienceRestriction> getAudienceRestrictionList();
        // void addCondition(ConditionAbstract conditionAbstract);
        return null;// this.conditionsType.getConditionOrAudienceRestrictionOrOneTimeUse();
    }

    @Override
    public XMLGregorianCalendar getNotBefore()
    {
        return this.conditionsType.getNotBefore();
    }

    @Override
    public XMLGregorianCalendar getNotOnOrAfter()
    {
        return this.conditionsType.getNotOnOrAfter();
    }

    @Override
    public MXMEngineResponse parse(final MXMObject object) throws MXMEngineException
    {
        final SuperBaseProtocolAbstractLevel1 superAbstract = new SuperBaseProtocolAbstractLevel1(
            this.conditionsType);
        final MXMEngineResponse repsonse = superAbstract.parse(object);
        this.conditionsType = (ConditionsType)superAbstract.createObject(
            ConditionsType.class.getCanonicalName()).getContent();
        return repsonse;
    }

    @Override
    public void setNotBefore(final XMLGregorianCalendar xMLGregorianCalendar)
    {
        this.conditionsType.setNotBefore(xMLGregorianCalendar);
    }

    @Override
    public void setNotOnOrAfter(final XMLGregorianCalendar xMLGregorianCalendar)
    {
        this.conditionsType.setNotOnOrAfter(xMLGregorianCalendar);
    }
}
