package org.iso.mpeg.mxm.securityTE.schemahandler.saml;


import java.io.File;

import org.iso.mpeg.mxm.baseprotocol.schema.SuperBaseProtocolAbstractLevel1;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.securityTE.schema.saml.assertion.NameIDType;


public class NameID implements
    org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.NameID
{
    private NameIDType nameIdType;

    public NameID()
    {
        this.nameIdType = new NameIDType();
    }

    public NameID(final NameIDType nameIdType)
    {
        this.nameIdType = nameIdType;
    }

    @Override
    public void createFile(final File f) throws MXMException
    {
        new SuperBaseProtocolAbstractLevel1(this.nameIdType).createFile(f);
    }

    @Override
    public MXMObject createObject(final String objectType) throws MXMException
    {
        return new SuperBaseProtocolAbstractLevel1(this.nameIdType)
            .createObject(objectType);
    }

    @Override
    public String getFormat()
    {
        return this.nameIdType.getFormat();
    }

    @Override
    public String getNameQualifier()
    {
        return this.nameIdType.getNameQualifier();
    }

    @Override
    public String getSPNameQualifier()
    {
        return this.nameIdType.getSPNameQualifier();
    }

    @Override
    public String getSPProvidedID()
    {
        return this.nameIdType.getSPProvidedID();
    }

    @Override
    public String getValue()
    {
        return this.nameIdType.getValue();
    }

    @Override
    public MXMEngineResponse parse(final MXMObject object) throws MXMEngineException
    {
        final SuperBaseProtocolAbstractLevel1 superAbstract = new SuperBaseProtocolAbstractLevel1(
            this.nameIdType);
        final MXMEngineResponse repsonse = superAbstract.parse(object);
        this.nameIdType = (NameIDType)superAbstract.createObject(
            NameIDType.class.getCanonicalName()).getContent();
        return repsonse;
    }

    @Override
    public void setFormat(final String string)
    {
        this.nameIdType.setFormat(string);
    }

    @Override
    public void setNameQualifier(final String string)
    {
        this.nameIdType.setNameQualifier(string);
    }

    @Override
    public void setSPNameQualifier(final String string)
    {
        this.nameIdType.setNameQualifier(string);
    }

    @Override
    public void setSPProvidedID(final String string)
    {
        this.nameIdType.setSPProvidedID(string);
    }

    @Override
    public void setValue(final String string)
    {
        this.nameIdType.setValue(string);
    }
}
