package org.iso.mpeg.mxm.securityTE.schemahandler.saml;


import java.io.File;
import java.util.List;

import javax.xml.datatype.XMLGregorianCalendar;

import org.iso.mpeg.mxm.baseprotocol.schema.SuperBaseProtocolAbstractLevel1;
import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.SignatureType;
import org.iso.mpeg.mxm.engine.securityTE.schema.saml.assertion.NameIDType;
import org.iso.mpeg.mxm.engine.securityTE.schema.saml.protocol.ResponseType;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Signature;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.NameID;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.Extensions;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.Status;


public class Response implements
    org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.protocol.Response
{
    private ResponseType responseType;
    private final org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngineSchemaHandler securityEngineSchemaHandler;

    public Response(final org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngineSchemaHandler securityEngineSchemaHandler)
    {
        this.responseType = new ResponseType();
        this.securityEngineSchemaHandler = securityEngineSchemaHandler;
    }

    public Response(final ResponseType responseType,final org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngineSchemaHandler securityEngineSchemaHandler)
    {
        this.responseType = responseType;
        this.securityEngineSchemaHandler = securityEngineSchemaHandler;
    }

    @Override
    public void createFile(final File f) throws MXMException
    {
        new SuperBaseProtocolAbstractLevel1(this.responseType).createFile(f);
    }

    @Override
    public MXMObject createObject(final String objectType) throws MXMException
    {
        return new SuperBaseProtocolAbstractLevel1(this.responseType)
            .createObject(objectType);
    }

    @Override
    public List<Object> getAssertionOrEncryptedAssertion()
    {
        return this.responseType.getAssertionOrEncryptedAssertion();
    }

    @Override
    public String getConsent()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public String getDestination()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Extensions getExtensions()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public String getID()
    {
        return this.responseType.getID();
    }

    @Override
    public String getInResponseTo()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public XMLGregorianCalendar getIssueInstant()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public NameID getIssuer()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public Signature getSignature()
    {
        Signature signature = null;
        try
        {
            signature = this.securityEngineSchemaHandler.getSignature();
            signature.parse(new MXMAdapter(this.responseType.getSignature()));
        }
        catch (MXMEngineException e)
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return signature;
    }

    @Override
    public Status getStatus()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public String getVersion()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public MXMEngineResponse parse(final MXMObject object) throws MXMEngineException
    {
        final SuperBaseProtocolAbstractLevel1 superAbstract = new SuperBaseProtocolAbstractLevel1(
            this.responseType);
        final MXMEngineResponse repsonse = superAbstract.parse(object);
        this.responseType = (ResponseType)superAbstract.createObject(
            ResponseType.class.getCanonicalName()).getContent();
        return repsonse;
    }

    @Override
    public void setConsent(final String string)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setDestination(final String string)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setExtensions(final Extensions extensions)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setID(final String string)
    {
        this.responseType.setID(string);
    }

    @Override
    public void setInResponseTo(final String string)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setIssueInstant(final XMLGregorianCalendar xMLGregorianCalendar)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setIssuer(final NameID nameID)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setSignature(final Signature signature)
    {
        SignatureType sigType = null;
        try
        {
            sigType = (SignatureType)signature.createObject(
                SignatureType.class.getCanonicalName()).getContent();
        }
        catch (MXMException e)
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        this.responseType.setSignature(sigType);
    }

    @Override
    public void setStatus(final Status status)
    {
        // TODO Auto-generated method stub
    }

    @Override
    public void setVersion(final String string)
    {
        // TODO Auto-generated method stub
    }
}
