package org.iso.mpeg.mxm.securityTE.schemahandler.saml;


import java.io.File;

import org.iso.mpeg.mxm.baseprotocol.schema.SuperBaseProtocolAbstractLevel1;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.SignatureValueType;


public class SignatureValue implements
    org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.SignatureValue
{
    private SignatureValueType signatureValueType;

    public SignatureValue()
    {
        this.signatureValueType = new SignatureValueType();
    }

    @Override
    public void createFile(final File f) throws MXMException
    {
        new SuperBaseProtocolAbstractLevel1(this.signatureValueType).createFile(f);
    }

    @Override
    public MXMObject createObject(final String objectType) throws MXMException
    {
        return new SuperBaseProtocolAbstractLevel1(this.signatureValueType)
            .createObject(objectType);
    }

    @Override
    public String getId()
    {
        return this.signatureValueType.getId();
    }

    @Override
    public byte[] getValue()
    {
        return this.signatureValueType.getValue();
    }

    @Override
    public MXMEngineResponse parse(final MXMObject object) throws MXMEngineException
    {
        final SuperBaseProtocolAbstractLevel1 superAbstract = new SuperBaseProtocolAbstractLevel1(
            this.signatureValueType);
        final MXMEngineResponse repsonse = superAbstract.parse(object);
        this.signatureValueType = (SignatureValueType)superAbstract.createObject(
            SignatureValueType.class.getCanonicalName()).getContent();
        return repsonse;
    }

    @Override
    public void setId(final String string)
    {
        this.signatureValueType.setId(string);
    }

    @Override
    public void setValue(final byte[] b)
    {
        this.signatureValueType.getValue();
    }
}
