package org.iso.mpeg.mxm.securityTE.schemahandler.saml;


import java.io.File;
import java.util.List;

import org.iso.mpeg.mxm.baseprotocol.schema.SuperBaseProtocolAbstractLevel1;
import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.securityTE.schema.dsig.SignedInfoType;
import org.iso.mpeg.mxm.tEngine.securityTE.SecurityEngine;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.CanonicalizationMethod;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.Reference;
import org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.SignatureMethod;


public class SignedInfo implements
    org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.dsig.SignedInfo
{
    private final SecurityEngine securityEngine;
    private SignedInfoType       signedInfoType;

    public SignedInfo(final SecurityEngine securityEngine)
    {
        this.signedInfoType = new SignedInfoType();
        this.securityEngine = securityEngine;
    }

    @Override
    public void createFile(final File f) throws MXMException
    {
        new SuperBaseProtocolAbstractLevel1(this.signedInfoType).createFile(f);
    }

    @Override
    public MXMObject createObject(final String objectType) throws MXMException
    {
        return new SuperBaseProtocolAbstractLevel1(this.signedInfoType)
            .createObject(objectType);
    }

    @Override
    public CanonicalizationMethod getCanonicalizationMethod() throws MXMEngineException
    {
        final CanonicalizationMethod method = this.securityEngine
            .getSecurityEngineSchemaHandler().getCanonicalizationMethod();
        method.parse(new MXMAdapter(this.signedInfoType.getCanonicalizationMethod()));
        return method;
    }

    @Override
    public String getId()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public List<Reference> getReference()
    {
        // TODO: List<ReferenceType> => List <Reference>
        return null;// this.signedInfoType.getReference();
    }

    @Override
    public SignatureMethod getSignatureMethod()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public MXMEngineResponse parse(final MXMObject object) throws MXMEngineException
    {
        final SuperBaseProtocolAbstractLevel1 superAbstract = new SuperBaseProtocolAbstractLevel1(
            this.signedInfoType);
        final MXMEngineResponse repsonse = superAbstract.parse(object);
        this.signedInfoType = (SignedInfoType)superAbstract.createObject(
            SignedInfoType.class.getCanonicalName()).getContent();
        return repsonse;
    }

    @Override
    public void setCanonicalizationMethod(
        final CanonicalizationMethod canonicalizationMethod)
    {
    }

    @Override
    public void setId(final String string)
    {
        this.signedInfoType.setId(string);
    }

    @Override
    public void setSignatureMethod(final SignatureMethod signatureMethod)
    {
        // TODO Auto-generated method stub
    }
}
