package org.iso.mpeg.mxm.securityTE.schemahandler.saml;


import java.io.File;
import java.util.List;

import javax.xml.bind.JAXBElement;

import org.iso.mpeg.mxm.baseprotocol.schema.SuperBaseProtocolAbstractLevel1;
import org.iso.mpeg.mxm.core.MXMEngineResponse;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.MXMObject;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.engine.securityTE.schema.saml.assertion.NameIDType;
import org.iso.mpeg.mxm.engine.securityTE.schema.saml.assertion.ObjectFactory;
import org.iso.mpeg.mxm.engine.securityTE.schema.saml.assertion.SubjectConfirmationType;
import org.iso.mpeg.mxm.engine.securityTE.schema.saml.assertion.SubjectType;


public class Subject implements
    org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.Subject
{
    private final ObjectFactory factory;
    private SubjectType         subjectType;

    public Subject()
    {
        this.subjectType = new SubjectType();
        this.factory = new ObjectFactory();
    }

    @Override
    public void addNameID(
        final org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.NameID nameId)
        throws MXMException
    {
        NameIDType val = null;
        val = (NameIDType)(nameId.createObject(NameIDType.class.getName())).getContent();
        final JAXBElement jaxb = this.factory.createNameID(val);
        this.subjectType.getContent().add(jaxb);
    }

    @Override
    public void addSubjectConfirmation(
        final org.iso.mpeg.mxm.tEngine.securityTE.schemahandler.saml.assertion.SubjectConfirmation subjectConfirmation)
        throws MXMException
    {
        SubjectConfirmationType val = null;
        val = (SubjectConfirmationType)(subjectConfirmation
            .createObject(SubjectConfirmationType.class.getName())).getContent();
        final JAXBElement jaxb = this.factory.createSubjectConfirmation(val);
        this.subjectType.getContent().add(jaxb);
    }

    @Override
    public void createFile(final File f) throws MXMException
    {
        new SuperBaseProtocolAbstractLevel1(this.subjectType).createFile(f);
    }

    @Override
    public MXMObject createObject(final String objectType) throws MXMException
    {
        return new SuperBaseProtocolAbstractLevel1(this.subjectType)
            .createObject(objectType);
    }

    @Override
    public List<JAXBElement<?>> getContent()
    {
        return this.subjectType.getContent();
    }

    @Override
    public MXMEngineResponse parse(final MXMObject object) throws MXMEngineException
    {
        final SuperBaseProtocolAbstractLevel1 superAbstract = new SuperBaseProtocolAbstractLevel1(
            this.subjectType);
        final MXMEngineResponse repsonse = superAbstract.parse(object);
        this.subjectType = (SubjectType)superAbstract.createObject(
            SubjectType.class.getCanonicalName()).getContent();
        return repsonse;
    }
}
