package org.iso.mpeg.mxm.securityTE.technologyhandler.util;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

import org.apache.xerces.impl.dv.util.Base64;
import org.iso.mpeg.mxm.core.configuration.MXMGenericParameters;
import org.iso.mpeg.mxm.core.configuration.MXMParameters;
import org.iso.mpeg.mxm.securityTE.technologyhandler.obj.CertificateStoreDataObject;
import org.iso.mpeg.mxm.securityTE.technologyhandler.obj.KeyStoreDataObject;
import org.iso.mpeg.mxm.tEngine.securityTE.exceptions.SecurityEngineException;

public class FileSystemStorage
{
    
    private static FileSystemStorage instance;
    private KeyStoreDataObject    dataObject; 
    private CertificateStoreDataObject certificateObject;
    private String path = "secureStorage.bin";
    private String path1 = "secureStorage1.bin";
    private static MXMGenericParameters  parms = null;
    
    
    private FileSystemStorage() {
        if(parms.getProperty("keyStorage") != null && !parms.getProperty("keyStorage").equals("")) {
            path = parms.getProperty("keyStorage");
        }
        if(parms.getProperty("certificateStorage") != null && !parms.getProperty("certificateStorage").equals("")) {
            path1 = parms.getProperty("certificateStorage");
        }
        File file = new File(path);
        if(file.exists()) {
            try
            {
                dataObject = (KeyStoreDataObject)FileAndObjectHandler.readObjectFromFile(path);
                if(dataObject == null) {
                    dataObject = new KeyStoreDataObject();
                }
            }
            catch (SecurityEngineException e)
            {
                e.printStackTrace();
            }
        }else {
            dataObject = new KeyStoreDataObject();
            
        }
        
        File file1 = new File(path1);
        if(file1.exists()) {
            try
            {
                certificateObject = (CertificateStoreDataObject)FileAndObjectHandler.readObjectFromFile(path1);
                if(certificateObject == null) {
                    certificateObject = new CertificateStoreDataObject();
                }
            }
            catch (SecurityEngineException e)
            {
                e.printStackTrace();
            }
        }else {
            certificateObject = new CertificateStoreDataObject();
            
        }
    }
    
   
    
    public void save() throws SecurityEngineException {
        FileAndObjectHandler.writeObjectToFile(this.path, this.dataObject);
        FileAndObjectHandler.writeObjectToFile(this.path1, this.certificateObject);
    }
    
    
    
    public KeyStoreDataObject getKeyStoreDataObject() {
        return this.dataObject;
    }
    
    public CertificateStoreDataObject getCertificateStoreDataObject() {
        return this.certificateObject;
    }

    
    
    public static FileSystemStorage getInstance(MXMGenericParameters parm) {
        if(instance == null) {
            parms = parm;
            instance = new FileSystemStorage();
            
        }
        return instance;
    }
    
 
    
    
}
