/**
 * 
 */
package org.iso.mpeg.es.IdentifyUserES.service;

import javax.ejb.Stateless;
import javax.jws.WebService;

import org.iso.mpeg.mxm.core.MXMAdapter;
import org.iso.mpeg.mxm.core.MXMException;
import org.iso.mpeg.mxm.core.engine.management.MXMEngineException;
import org.iso.mpeg.mxm.orchestratorEngine.OrchestratorEngine;
import org.iso.mpeg.mxm.pEngine.identifyuserPE.IdentifyUserEngine;
import org.iso.mpeg.mxm.pEngine.identifyuserPE.schemahandler.IdentifyUserRequest;
import org.iso.mpeg.mxm.pEngine.identifyuserPE.schemahandler.IdentifyUserResponse;
import org.iso.mpeg.mxm.pEngine.identifyuserPE.technologyhandler.IdentifyUserProtocol;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

/**
 * @author Angelos-Christos Anadiotis
 *
 */

@Stateless
@WebService(endpointInterface = "org.iso.mpeg.mxm.es.identifyuserES.IdentifyUserProtocolRemote")
public class IdentifyUserES
{
	public String identifyUser(String request)
	{
		String response = new String();
		
		ApplicationContext applicationContext = new ClassPathXmlApplicationContext("beans.xml");
		OrchestratorEngine orchestratorEngine = (OrchestratorEngine) applicationContext.getBean("OrchestratorEngine");
		
		IdentifyUserEngine identifyUserEngine = orchestratorEngine.getIdentifyUserEngineOrchestrator().getIdentifyUserEngine();
		IdentifyUserRequest identifyUserRequest = identifyUserEngine.getIdentifyUserSchemaHandler().getIdentifyUserRequest();
				
		try
		{
			identifyUserRequest.parse(new MXMAdapter(request));
		} catch (MXMEngineException e)
		{
			e.printStackTrace();
		}
		
		IdentifyUserProtocol identifyUserProtocol = identifyUserEngine.getIdentifyUserTechnologyHandler().getLocalIdentifyUserProtocol();
		IdentifyUserResponse identifyUserResponse = identifyUserProtocol.identifyUser(identifyUserRequest);
				
		try
		{
			response = (String)(identifyUserResponse.createObject(String.class.getCanonicalName()).getContent());
		} catch (MXMException e)
		{
			e.printStackTrace();
		}
		
		return response;
	}
}
